/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

/**
 * Search for Contacts in different Addressbooks
 * makes a liveGrid for Searchresult, an append the selected to a LiveGrid or
 * in a Input field
 * @param {String} searchstring for pattern in the database
 * @param {String} Id of the main search dialog div
 * @param {String} Id of the div for the Livegrid, in the search dialog
 * @param {String} optional: for appending the Contacts in a LiveGrid of the page
 * @param {String} Id from div, for the selected Contacts in the search dialog
 * @param {String} Id from div, for clearing the search string in the search dialog
 * @param {Array} optional: if suffix of each Inputfield (example: 'to' and 'cc' for newmail_btn_add_to, newmail_btn_add_cc)
 * 
 * the DOM Event as parameter.
 */

function SearchListAddressBook(searchstring, floatingpopupdiv, liveGridDivSearch, liveGridDivResult, divAddContact, searchField, moreFields)
{
	var Self = this;
	this.emptySearchText = _("Please enter your search");
	this.searchField = searchField;
	this.blurTimer;
	addressbookFolderPath();
	this.divAddContact = divAddContact;
	this.liveGridDivResult = liveGridDivResult;
	this.liveGridDivSearch = liveGridDivSearch;
	this.floatingpopupdiv = floatingpopupdiv;
	this.searchstring = searchstring;
	this.resulObject = {};
	this.arrayWhithDistrContact = new Array();
	this.numberOfSelection = 0;
	this.findContactForDistrList = null;
	this.buildContactForDistrList = new Array();
	this.tmpIdsForSave = new Array();
	this.contactsForBigGrid = {};
	this.tmpCountAppendet = 0;
	this.tmpCountSearchAppendet = 0;
	this.contactsForBigGrid.data = new Array();
	this.internalStorage = new Storage(0, []);
	this.internalResultStorage = new Storage(0, []);
	//this.internalResultStorage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0] + "." + x[1];});
	this.setAdding = "";
	this.distrids = new Array();
	this.myAddedContacts = new AddedSearchContacts();
	this.updateList = false;
	this.tmpDistId = 210000000;
	this.moreFields = new Array();
	
	if(moreFields)
	this.moreFields = moreFields;
	this.method = "";
	this.aFindedAddressboks = new Array();
	this.recipientType = "to";	
	$(this.searchField).value = this.emptySearchText;
	this.enabled = false;
	
    Self.clickOnCombobox = function (e) {
    	if (Self.blurTimer != undefined) {
            clearTimeout(Self.blurTimer);
            delete(Self.blurTimer);
        }
        if ($(searchField).value == Self.emptySearchText) {
            $(searchField).value="";
            $(Self.searchField).style.color="";
        } else if (e.keyCode == 13) {
            Self.searchstring = $(searchField).value;            
            Self.getResult();
            //$(liveGridDivResult).focus();
        }
    }
    Self.enterInput = function(e) {
    	Self.blurTimer = setTimeout(function() {
	        if (trimStr($(searchField).value).length == 0) {
	            $(searchField).value=Self.emptySearchText;
	            $(Self.searchField).style.color="silver";
	        }
        }, 100);
    } 
    
    addDOMEvent($(this.searchField), "keypress", Self.clickOnCombobox); 
    addDOMEvent($(this.searchField), "click", Self.clickOnCombobox);
    addDOMEvent($(this.searchField), "blur", Self.enterInput); 
	
	register("searchContacts", function(){ if(Self.enabled) Self.getResult(); });
}

SearchListAddressBook.prototype = {

    setAllFolders: function(checkbox, folder_button) {
        if (configGetKey("modules.contacts.singleFolderSearch")) return;
        var setDisabled = classNameSetter("font-color-disabled");
        checkbox.parentNode.parentNode.parentNode.style.display = "";
        checkbox.checked = true;
        setDisabled(folder_button, true);
        checkbox.onclick = function() {
            setDisabled(folder_button, checkbox.checked);
        };
        this.allFoldersCheckbox = checkbox;
    },

	displayError: function(msg) {
        $(this.floatingpopupdiv+"SearchError").style.display="";
        $(this.floatingpopupdiv+"SearchError").getElementsByTagName("DIV")[0].firstChild.data=msg;
    },
	getResult: function() {	        
		var Self = this;
        this.searchstring="";
        var inVal=$(this.searchField).value;
        if (trimStr(inVal).length == 0 ||
            inVal == this.emptySearchText) {
            $(this.searchField).value=this.emptySearchText;
            setTimeout(function() {
                $(Self.searchField).style.color="silver";
            },0);
            if (configContainsKey("modules.contacts.mailAddressAutoSearch") &&
                configGetKey("modules.contacts.mailAddressAutoSearch") == false) {
            	this.searchstring = "";
                if(this.enabled) this.resetGrid();
                return;	
            } else if (configContainsKey("minimumSearchCharacters") &&
                configGetKey("minimumSearchCharacters") != 0) {
                this.displayError(
                   format(_("The search pattern requires at least %s characters."), 
                       configGetKey("minimumSearchCharacters")));
                return;
            } else {
            	this.searchstring="";
            }
        } else if (configContainsKey("minimumSearchCharacters") &&
            trimStr(inVal).length < configGetKey("minimumSearchCharacters")) {
            this.displayError(
                format(_("The search pattern requires at least %s characters."), 
                    configGetKey("minimumSearchCharacters")));
            return;
        } else {
    	   $(Self.searchField).style.color="";
    	   this.searchstring=inVal;
        }
		var pattern = trimStr(this.searchstring) ? this.searchstring : "*";
        this.searchObject = {
            display_name: pattern, first_name: pattern, last_name: pattern,
            email1: pattern, email2: pattern, email3: pattern, orSearch: true
        };
        if (!this.allFoldersCheckbox || !this.allFoldersCheckbox.checked) { 
            this.searchObject.folder = clickedItem;
        }
		
		if(!json)
		var json = new JSON();
		this.distrids = [];
		json.put(AjaxRoot + "/contacts?action=search&session=" + refToMain.session + "&columns=1,500,555,556,557,524,602,592",
			Self.searchObject,
			null,
			function(findContactForDistrList) {	
				/*
		         * 0 = id               (1)
		         * 1 = display_name     (500)
				 * 2 = email1           (555)
				 * 3 = email2           (556)
				 * 4 = email3           (557)
				 * 5 = internal_userid  (524)
				 * 6 = mark_as_distri.  (602)
				 * 7 = distribution_l.  (592)
				 */
				
				/* click on "Go" for search in the Addressbook */
				Self.findContactForDistrList = findContactForDistrList;
				Self.findContactForDistrList.events = new Events();	
				Self.buildContactForDistrList = [];
				var tmpLaufIndex = Self.findContactForDistrList.data.length;
				for(i=0; i<tmpLaufIndex; i++) {	
					(function() {
						if(Self.findContactForDistrList.data[i][6]) {
							/* the finded "contact" is a distribution list */
							if((Self.method && Self.method == "mail") || (Self.moreFields && Self.moreFields.length > 0)) {
								var tmpDistArray = new Array();
								tmpDistArray[0] = Self.findContactForDistrList.data[i][0]
								tmpDistArray[1] = Self.findContactForDistrList.data[i][1]
								tmpDistArray[2] = ""
								tmpDistArray[3] = "true";
								var tmpString = "";
								if(Self.findContactForDistrList.data[i][7]) {
									for(var t=0; t<Self.findContactForDistrList.data[i][7].length;t++) {
										if(t==0) {
											tmpString = Self.findContactForDistrList.data[i][7][t].mail;
										} else {
											tmpString += ", "+Self.findContactForDistrList.data[i][7][t].mail;
										}
									}
									tmpDistArray[4] = tmpString;
									Self.buildContactForDistrList.push(tmpDistArray);
									Self.myAddedContacts.setAllFinded(
													tmpDistArray[0],
													tmpDistArray[4]
										);	
								}
							}
						} else {
							/* the flag in [index 6] is false, so this contact is not a distribution list  */
							var displayName = Self.findContactForDistrList.data[i][1] || "";
							
							if(Self.findContactForDistrList.data[i][2]) {
								var tmpDistArray = new Array();
								tmpDistArray[0] = Self.findContactForDistrList.data[i][0]
								tmpDistArray[1] = displayName;
								tmpDistArray[2] = Self.findContactForDistrList.data[i][2]
								Self.buildContactForDistrList.push(tmpDistArray);
								findEmails = 1;		
								Self.distrids.push(tmpDistArray[0]);
								Self.myAddedContacts.setAllFinded(tmpDistArray[0], tmpDistArray[2]);				
							}
							
							if(Self.findContactForDistrList.data[i][3]) {
								var tmpDistArray = new Array();
								tmpDistArray[1] = displayName;
								tmpDistArray[2] = Self.findContactForDistrList.data[i][3]
								
								Self.buildContactForDistrList.push(tmpDistArray);
								if(findEmails == 0) {
									tmpDistArray[0] = Self.findContactForDistrList.data[i][0];
								} else {
									tmpDistArray[0] = Self.tmpDistId;
									Self.findContactForDistrList.data.push(tmpDistArray)
									Self.tmpDistId++;
								}
								findEmails = 1;		
								
								Self.distrids.push(tmpDistArray[0]);
								Self.myAddedContacts.setAllFinded(tmpDistArray[0], tmpDistArray[2]);					
							}
							
							if(Self.findContactForDistrList.data[i][4]) {
								var tmpDistArray = new Array();
								tmpDistArray[1] = displayName;
								tmpDistArray[2] = Self.findContactForDistrList.data[i][4]
								if(findEmails == 0) {
									tmpDistArray[0] = Self.findContactForDistrList.data[i][0];
								} else {
									tmpDistArray[0] = Self.tmpDistId;
									Self.findContactForDistrList.data.push(tmpDistArray)
									Self.tmpDistId++;
								}
								
								Self.distrids.push(tmpDistArray[0]);
								Self.buildContactForDistrList.push(tmpDistArray);
								findEmails = 1;		
								
								Self.myAddedContacts.setAllFinded(tmpDistArray[0], tmpDistArray[2]);					
							}
						}
					})();
				}
				Self.internalStorage.remove(0,Self.tmpCountSearchAppendet);
				Self.internalStorage.append(Self.buildContactForDistrList);	
				Self.aFindedAddressboks.push(Self.buildContactForDistrList);
				/* 
				 * Self.buildContactForDistrList 
				 * is an array with Object with the ids and tmpIds
				 * all finded valid Contact are inside 
				 * */
				distruGrid.enable(Self.internalStorage); 
				Self.tmpCountSearchAppendet = Self.buildContactForDistrList.length;
			}
		);
	},
	
	/*
	 * result view for Modules with Livegrid
	 */   	
	showResult: function(insertDistribution) {		
		this.insertDistribution = insertDistribution;
		
		if (this.insertDistribution == "extern" && myDistrListExternEmails.storage.ids.length != 0) { //external email
		  	for (i = 0; i < myDistrListExternEmails.storage.ids.length; i++) {		  		
		  		var extObj = myDistrListExternEmails.storage.data.data[i];
		  		if (!this.myAddedContacts.exist(extObj.displayName + extObj.email)) {
		  			this.contactsForBigGrid.data[this.contactsForBigGrid.data.length] = [ this.tmpDistId++, extObj.displayName, extObj.email ] ;
		  			this.myAddedContacts.set(extObj.displayName + extObj.email, true);
                    this.updateList = true;
		  		}
		  	}
		
		} else if (this.insertDistribution == "db") {
			if(this.findContactForDistrList) { //internal email
			    /* this is the function after clicking to "Ok" in the bottom, to accept the selected data or contacts */
					for(i=0; i< this.findContactForDistrList.data.length; i++){
						for(j=0; j< this.tmpIdsForSave.length; j++) {
							if(this.tmpIdsForSave[j] == this.findContactForDistrList.data[i][0]) {
								
								if(this.findContactForDistrList.data[i][0] == 0 || typeof this.findContactForDistrList.data[i][0] == "undefined") {
									this.findContactForDistrList.data[i][0] = this.tmpDistId;
									this.tmpDistId++;
								}
								if(!this.myAddedContacts.exist(this.findContactForDistrList.data[i][2]+this.findContactForDistrList.data[i][3])) {
									this.contactsForBigGrid.data[this.contactsForBigGrid.data.length] = 
																			this.findContactForDistrList.data[i];
									
				
									this.myAddedContacts.set(
										this.findContactForDistrList.data[i][2]+this.findContactForDistrList.data[i][3],
										true
									);										
								}						
							}			
						}
					}
					
					this.tmpIdsForSave = [];
				}
			} else {
				if(this.aFindedAddressboks) { //internal email
			    /* this is the function after clicking to "Ok" in the bottom, to accept the selected data or contacts */
					for(i=0; i< this.aFindedAddressboks.length; i++){
						/* through each addressbook from the search result  */
						for(k=0; k< this.aFindedAddressboks[i].length; k++){
							/* the arrays in the addressbook (index 0 = id, index 1 = display name, index 2 = mail address)  */
							for(j=0; j< this.tmpIdsForSave.length; j++) {
								if(this.tmpIdsForSave[j] == this.aFindedAddressboks[i][k][0]) {
									
									if(this.aFindedAddressboks[i][k][0] == 0 || typeof this.aFindedAddressboks[i][k][0] == "undefined") {
										this.aFindedAddressboks[i][k][0] = this.tmpDistId;
										this.tmpDistId++;
									}
									if(!this.myAddedContacts.exist(this.aFindedAddressboks[i][k][1]+this.aFindedAddressboks[i][k][2])) {
										this.contactsForBigGrid.data[this.contactsForBigGrid.data.length] = 
																				this.aFindedAddressboks[i][k];
										
										this.myAddedContacts.set(
													this.aFindedAddressboks[i][k][1]+this.aFindedAddressboks[i][k][2],
													true
										);										
									}						
								}			
							}
						}
					}
					
					this.tmpIdsForSave = [];
				}
			}
			
			
			var Self = this;
			Self.internalResultStorage.remove(0,Self.tmpCountAppendet);
			Self.internalResultStorage.append(Self.contactsForBigGrid.data);
			
			if(Self.internalResultStorage.ids.length > 0)
			distruBigGrid.enable(Self.internalResultStorage);
			
			
			/*if(this.arrayWhithDistrContact.length != 0) {
				distruBigGrid.enable(this.internalResultStorage);
				
			} else {
				//distruBigGrid.disable();
			}*/
			this.tmpCountAppendet = this.contactsForBigGrid.data.length;
	},
	
	showResultInInput: function(insertDistribution) {	
		/*
		 * result view for Mail Module
		 * */
		if(this.moreFields && this.moreFields.length > 0) {
			var valueToInputArray = new Array();
			for (var i = 0; i < this.moreFields.length; i++) {
				valueToInputArray[i] = $(this.divAddContact + "_" + this.moreFields[i]).value;
				if (!valueToInputArray[i] || valueToInputArray[i].length == 0) continue;
				$(this.moreFields[i]).value += this.setSemicolon(valueToInputArray[i], this.moreFields[i]);
				oMailFunctionsNew.showAdditionalHeaderField(this.moreFields[i], true);
			}
		} else {
			var valueToInput = $(this.divAddContact).value;
			if(valueToInput != '') {
				$(this.recipientAs).value += this.setSemicolon(valueToInput, this.recipientAs);
			}
		}		
		this.closeDiv();	
	},
	
	setSemicolon: function(value, divRecipientId) {
		if(value == "") return "";
		var valueToInput = value;
		var valueInitToInput = $(divRecipientId).value;
		var indexOfSemicolon = valueInitToInput.lastIndexOf(',');
		var lengthOfString = valueInitToInput.length - 2;
		if(valueInitToInput != '' && indexOfSemicolon == (lengthOfString + 1 )) {
			//the last char is a semicolon, whitout space
			valueToInput = " " + valueToInput;
		} else if(valueInitToInput != '' && indexOfSemicolon < lengthOfString) {
			//the last char is not a semicolon
			valueToInput = ", " + valueToInput;			
		} else {
			//input field is empty
		}
		return valueToInput;
	}, 
	
	addToList: function(setAdding, fieldSuffix){
		this.setAdding = setAdding;
				
		//mySelectedDistrContacts = 3405.name, 3333.name
		if(distruGrid.storage) {			
			var mySelectedDistrContacts = distruGrid.selection.getSelected();
			if((mySelectedDistrContacts.length > 0 && this.setAdding == "bySelection") || this.setAdding == "all") {	
				var myTmpArray = new Array();
				if(this.setAdding == "bySelection") {
					mySelectedDistrContacts = mySelectedDistrContacts.toString();
					myTmpArray = mySelectedDistrContacts.split(",");	
				} else {
					myTmpArray = distruGrid.storage.ids;
				}				
				
				for(i=0; i<myTmpArray.length;i++) {
					if(myTmpArray[i] in this.arrayWhithDistrContact) {
						//alert("already in list");
					} else {							
						this.updateList = true;
						this.arrayWhithDistrContact[myTmpArray[i]] = this.myAddedContacts.getFromAll(myTmpArray[i]);
					}	
				}
				
				if(fieldSuffix) {
					var tmpArrayWhithNames = $(this.divAddContact + '_' + fieldSuffix).value;
					this.recipientType = fieldSuffix;
				} else {
					var tmpArrayWhithNames = "";
				}
				for(i in this.arrayWhithDistrContact) {
					if(tmpArrayWhithNames == "") {
						tmpArrayWhithNames = this.arrayWhithDistrContact[i];
					}
					else {
						tmpArrayWhithNames += ", " + this.arrayWhithDistrContact[i];
					}
					this.tmpIdsForSave[this.tmpIdsForSave.length] = i;
				}
				if(fieldSuffix) {
					$(this.divAddContact + '_' + fieldSuffix).value = tmpArrayWhithNames;
					this.arrayWhithDistrContact = [];
				} else {
					$(this.divAddContact).value = tmpArrayWhithNames;
				}
				
				
			} else {
				newConfirm(_("Select a contact"),_("Please select a contact to add"),AlertPopup.OK,null,null,null,null);		
			} 
		} /* else {
			triggerEvent("OX_New_Error", 4, "Please search to add Contact");
		}*/
	},
	deleteSelected: function(callbak) {	
		var mySelectedDistrContacts = distruBigGrid.selection.getSelected(distruBigGrid.storage);
		for (i=0; i< mySelectedDistrContacts.length; i++) {
			for(t=0; t< this.contactsForBigGrid.data.length; t++) {
				if(this.contactsForBigGrid.data[t][0] == mySelectedDistrContacts[i]) {
					var hashKey = this.contactsForBigGrid.data[t][1]+this.contactsForBigGrid.data[t][2];
					for(value in this.myAddedContacts.addContacts) {
						if(value == hashKey)
							this.myAddedContacts.addContacts[value] = false;
					}
					this.contactsForBigGrid.data.splice(t,1);	
					this.updateList = true;		
				}
			}
		}	
		if(callbak) callbak();
		//distruBigGrid.deleteSelected();	
	},
	clearList: function(){
		this.arrayWhithDistrContact = [];	
		this.tmpIdsForSave = [];
		if(this.moreFields && this.moreFields.length > 0) {
			for(var i = 0; i < this.moreFields.length; i++) {
				$(this.divAddContact + "_" + this.moreFields[i]).value = "";
			}
		} else {
			$(this.divAddContact).value = "";
		}
	},
	resetView: function() {
		this.clearList();
		this.tmpIdsForSave = [];
		if(distruGrid.storage) {
			distruGrid.storage.remove(0,this.tmpCountSearchAppendet);
		}
		//$(this.searchField).value = "";
	},
	resetGrid: function() {		
        if(distruGrid && distruGrid.storage) {
        	distruGrid.disable();        	
            this.internalStorage = new Storage(0, []);            
            this.makeGrid();
        }
	},	
	makeGrid: function() {
		var list = $(this.liveGridDivSearch);
		var listHeader = $(this.liveGridDivSearch + "Header");
		if (distruGrid) 
		{
			removeChildNodes(listHeader);
			list.innerHTML = "";
			distruGrid = null;
		}
		
		distruGrid = new LiveGrid([
			{
				text: "&#xa0;",
				sortable: true,
				width: "20px",
				style: {padding: 0},
				set: function(div,text) {
					var divIcons = "";
					if (div) {
						if (text) {
							divIcons = "<img src='"+getFullImgSrc("img/menu/distributionlist.gif")+"' alt='Distribution List' />"; 
						} else {
							divIcons = "<img src='"+getFullImgSrc("img/folder/contacts.gif")+"' alt='Contact' />"; 
						}
						
					}
						div.innerHTML = divIcons;
				},
				clear: LiveGrid.makeClear("..."),
				index:3
			},{	
				text: _("Name"),
				sortable: true,
				width: "40%",
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:1
			}, {
				text: _("E-Mail"),
				sortable: true,
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:2
			}
		], new Selection());
		listHeader.appendChild(distruGrid.getHeader());
		distruGrid.getTable(list);
		
		var Self = this;
		distruGrid.events.register("Activated", 
			function(ids){
				if(Self.moreFields && Self.moreFields.length > 0)
					Self.addToList('bySelection', Self.recipientType);		
				else
					Self.addToList('bySelection');				
			}
		);	
	},
	makeBigGrid: function() {
		var list = $(this.liveGridDivResult);
		var listHeader = $(this.liveGridDivResult + "Header");
		if (distruBigGrid) 
		{
			list.innerHTML = "";
			distruBigGrid = null;
		}
		
		distruBigGrid = new LiveGrid([
			{	
				text: _("Name"),
				sortable: true,
				width: "50%",
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:1
			}, {
				text: _("E-Mail"),
				sortable: true,
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:2
			}
		], new Selection());
		
		distruBigGrid.emptylivegridtext = "No recipients have been added";/*i18n*/
		
		listHeader.appendChild(distruBigGrid.getHeader());
		distruBigGrid.getTable(list);
		
		
		distruBigGrid.events.register("Selected", 
			function(ids){
				triggerEvent("SubSelected",distruBigGrid.getSelectedIDs().length);				
			}
		);		
			
	},
	
	buildFloatingDiv: function(style) {
		this.enabled = true;
		$(this.floatingpopupdiv).style.display = style;
		this.makeGrid();
		
		//clear values
		this.arrayWhithDistrContact = [];
		if(this.moreFields && this.moreFields.length > 0) {
			for(var i = 0; i < this.moreFields.length; i++) {
				$(this.divAddContact + "_" + this.moreFields[i]).value = "";
			}
		} else {
			$(this.divAddContact).value = "";
		} 		
	},
	
	closeDiv: function() {
		this.disableActiveGrids();
		$(this.floatingpopupdiv).style.display = 'none';
	},
	
	disableActiveGrids : function() {		
		if(distruGrid && distruGrid.storage) {
			distruGrid.storage.remove(0,this.tmpCountSearchAppendet);
			window.setTimeout(function() {
					distruGrid.disable();
			}, 0);
		}
	}
}


function AddedSearchContacts() {
	this.addContacts = new Array();
	this.allFindedContacts = new Array();
}

AddedSearchContacts.prototype = {
	
	set : function(key,value) {
		this.addContacts[key] = value;
	},
	
	setAllFinded : function(key,value) {
		this.allFindedContacts[key] = value;
	},
	
	getFromAll : function(key) {
		var myItem = this.allFindedContacts[key];
		return (myItem) ? myItem : false;
	},
	
	exist: function(key) {
		var tmpItem = this.addContacts[key];
		return (tmpItem) ? true : false;
	}
	
}

var contactAddressbookTreeLoaded = false;
var treeAddressbookVisible = false;
var newAddressbookFolderTree = null;
var clickedItem = "";
var currentDivIdForAddressbook = "";

function addressbookFolderPath() {
	//clickedItem = window.opener.configGetKey("folder.contacts");
	clickedItem = 6;
	session = window.opener.session;
	var folderViewSettingsNewContact = new Object();
	var folderViewSettingsNewContactById = new Object();
	//Disable Email... 
	folderViewSettingsNewContactById["default"] = 4;
	folderViewSettingsNewContact["contacts"] = 8;
	folderViewSettingsNewContact["calendar"] = 4;
	folderViewSettingsNewContact["tasks"] = 4;
	folderViewSettingsNewContact["infostore"] = 4;
	if(window.opener)
		var oLocalState = window.opener.optFolderState.getState('folderAddressbook_tree_info');
	else
		var oLocalState = new Object();	
	if(!contactAddressbookTreeLoaded){
	/*		
			var LocalFolderCache = new ox_folder_cache();
			LocalFolderCache.folders = window.opener.oMainFolderTree.cache.folders;		
			LocalFolderCache.fast_access = window.opener.oMainFolderTree.cache.fast_access;		
			LocalFolderCache.timestamp = window.opener.oMainFolderTree.cache.timestamp;
*/
			newAddressbookFolderTree = new cFolderTree(	$('folderAddressbook_tree_info'),
									folderAction,
									false,	
									window.opener.oMainFolderTree.cache,								
									oLocalState);
			newAddressbookFolderTree.enabled_modules = {contacts:true};	
			newAddressbookFolderTree.load();
			
			contactAddressbookTreeLoaded = true;
	}
								
	if(window.opener)									
		newAddressbookFolderTree.setSaveConfiguration(window.opener.optFolderState);		


	newAddressbookFolderTree.cache.get_folder(clickedItem, cb_AddressbookGetpath);
}
	

function cb_AddressbookGetpath(sPath)
{
	/*
	var tmpSlash = sPath.substr(sPath.length-1);
	
	if(tmpSlash == "/")
		sPath = sPath.substr(0, sPath.length-1);
	
	var tmpIndex = sPath.lastIndexOf("/") + 1;
	var finalFolderName = sPath.substr(tmpIndex);
	*/
	var vb = document.getElementsByName('newcontact_folder')[0].value = sPath.oxfolder.data.title;
}

function folderAction(ofolder) {
	hideAddressbookTree(currentDivIdForAddressbook);
	clickedItem = ofolder.oxfolder.data.id;
	newAddressbookFolderTree.cache.get_folder(clickedItem, cb_AddressbookGetpath);
    triggerEvent('searchContacts');
}

/*
function showAddressbookTree(divId){
	$(divId).style.display = "block";
	if(!contactAddressbookTreeLoaded){
		newAddressbookFolderTree.load();
		contactAddressbookTreeLoaded = true;
	}
}
*/

function hideAddressbookTree(divId){
	$(divId).style.display = "none";	
	treeAddressbookVisible = false;
}

function toggleAddressbookTree(divId){
	currentDivIdForAddressbook = divId;
	if(!treeAddressbookVisible){
		$(divId).style.display = "block";
		treeAddressbookVisible = true;
	}
	else{
		$(divId).style.display = "none";
		treeAddressbookVisible = false;
	}
}
var init={IE6workaround:{"d1e36":{dir:55,padding:"0 4px 0 4px"},
"d1e43":{dir:206,padding:"0 4px 0 4px"},
"d1e45":{dir:6,padding:"0 4px 0 4px"}},movable:["alert_window-h",
"create_window-h",
"conflict_window-h",
"error_popup-h",
"attachPopupTemplate-h",
"contact_upload_image-h"],help:{"d3e59":"Select the functions for the dynamic field",
"menu_options_arrow_down":"Expand the panel",
"menu_options_arrow_up":"Collapse the panel",
"panelContact1":"Enter business data",
"panelContact2":"Enter personal data",
"panelContact3":"Enter additional data",
"newcontact_but_categories":"Set contact categories",
"d1e423":"Enter a comment",
"image1":"Upload a picture"},min:{},max:{},hide:{},size:[
		{id:"mainarea",
		 align:"stretch",
		 margin:"0px 10px 0px 10px",
		 children:[
		{id:"all_of_menu",
		 align:"top",
		 size:"11em",resize:"static",
		 children:[]},
	
		{id:"contentarea",
		 align:"stretch",
		 margin:"0px 0px 0px 0px",
		 children:[
		{id:"d1e36",
		 align:"top",
		 size:"2em",padding:"0px 4px 0px 4px",
		 children:[
		{id:"d1e37",
		 align:"stretch",
		 
		 children:[]},
	]},
	
		{id:"d1e43",
		 align:"bottom",
		 size:"1.6em",padding:"0px 4px 8px 4px",
		 children:[]},
	
		{id:"d1e45",
		 align:"stretch",
		 padding:"0px 4px 0px 4px",
		 children:[
		{id:"tabPanels",
		 align:"top",
		 size:"2.2em",margin:"0px 0px 1px 0px",
		 children:[]},
	
		{id:"d1e74",
		 align:"stretch",
		 
		 children:[
		{id:"tabContact4",
		 align:"stretch",
		 
		 children:[]},
	
		{id:"tabContact5",
		 align:"stretch",
		 
		 children:[
		{id:"attachmentsNewContactGridHeader",
		 align:"top",
		 size:"1.6em",
		 children:[]},
	
		{id:"attachmentsNewContactGrid",
		 align:"stretch",
		 
		 children:[]},
	]},
	
		{id:"tabContact6",
		 align:"stretch",
		 
		 children:[]},
	]},
	]},
	]},
	]},
	],split:{},i18n:{"d1e28":"",
"menu_save_save_text":"",
"d5e8":"",
"d5e17":"title",
"d5e19":"",
"d5e24":"title",
"d5e26":"",
"d5e31":"title",
"d5e33":"",
"d5e38":"title",
"d5e40":"",
"d5e45":"title",
"d5e47":"",
"d5e52":"title",
"d5e54":"",
"d5e67":"",
"d5e78":"",
"d5e85":"",
"d5e92":"",
"d5e99":"",
"d5e113":"",
"d5e124":"",
"d5e131":"",
"d5e138":"",
"d5e145":"",
"d10e8":"",
"d10e19":"",
"d10e26":"",
"d10e33":"",
"d10e40":"",
"d3e45":"",
"d3e50":"",
"menu_options_arrow_down":"title",
"menu_options_arrow_up":"title",
"d1e41":"",
"d1e50":"",
"d1e55":"",
"d1e60":"",
"panelContact4":"",
"d1e67":"",
"d1e85":"",
"d1e92":"",
"d1e98":"",
"d1e102":"",
"d1e107":"",
"d1e111":"",
"d1e119":"",
"d1e123":"",
"d1e128":"",
"d1e132":"",
"d1e137":"",
"d1e141":"",
"d1e146":"",
"d1e150":"",
"d1e159":"",
"d1e163":"",
"d1e168":"",
"d1e172":"",
"d1e177":"",
"d1e183":"",
"d1e188":"",
"d1e192":"",
"d1e197":"",
"newcontact_but_categories-button":"title,",
"d1e214":"",
"d1e223-button":"",
"addNewInfoListButton-button":"",
"but_folder-button":"",
"d1e237":"",
"cancelNewAppointmentTreeButton-button":"",
"d1e251":"",
"d1e256":"",
"d1e270":"",
"d1e275":"",
"d1e286":"",
"d1e307-button":"",
"d1e312":"",
"d1e319":"",
"d1e323":"",
"d1e330":"",
"d1e334":"",
"d1e341":"",
"d1e345":"",
"d1e355":"",
"d1e359":"",
"d1e366":"",
"d1e370":"",
"d1e391-button":"",
"d1e398":"",
"d1e402":"",
"d1e409":"",
"d1e413":"",
"d1e423":"",
"d1e437":"",
"d1e441":"",
"d1e446":"",
"d1e452":"",
"d1e457":"",
"d1e461":"",
"d1e466":"",
"d1e470":"",
"d1e475":"",
"d1e479":"",
"d1e484":"",
"d1e488":"",
"d1e493":"",
"d1e497":"",
"d1e502":"",
"d1e506":"",
"d1e511":"",
"d1e515":"",
"d1e523":"",
"d1e527":"",
"d1e532":"",
"d1e536":"",
"d1e541":"",
"d1e545":"",
"d1e550":"",
"d1e554":"",
"d1e559":"",
"d1e563":"",
"d1e568":"",
"d1e572":"",
"d1e577":"",
"d1e581":"",
"d1e586":"",
"d1e590":"",
"d1e595":"",
"d1e599":"",
"d1e604":"",
"d1e608":"",
"alert_window-h-i":"alt,title",
"alert_window-h-c":"",
"alert_window_cancel-button":"",
"alert_window_nocomment-button":"",
"alert_window_no-button":"",
"alert_window_yes-button":"",
"alert_window_ok-button":"",
"alert_window_appointment-button":"",
"alert_window_series-button":"",
"alert_window_edit-button":"",
"alert_window_continue-button":"",
"create_window-h-i":"alt,title",
"create_window-h-c":"",
"create_window_cancel-button":"",
"create_window_nocomment-button":"",
"create_window_advanced-button":"",
"create_window_ok-button":"",
"conflict_window-h-i":"alt,title",
"conflict_window-h-c":"",
"d11e67":"",
"d11e83":"",
"d11e86":"",
"d11e89":"",
"d11e92":"",
"d11e100-button":"",
"conflict_window_ignore-button":"",
"error_popup-h-i":"alt,title",
"error_popup-h-c":"",
"error_popup_ok-button":"",
"attachPopupTemplate-h-i":"alt,title",
"attachPopupTemplate-h-c":"",
"d13e13":"",
"d13e18":"",
"d13e21-button":"",
"d13e28-button":"",
"d13e33-button":"",
"d13e35-button":"",
"contact_upload_image-h-i":"alt,title",
"contact_upload_image-h-c":"",
"d1e637-button":"",
"d1e639-button":""},images:{"menu_big_save":"themes/default/img/dummy.gif",
"d4e27":"themes/default/img/dummy.gif",
"d5e17":"themes/default/img/menu/distributionlist_intcontact.gif",
"d5e24":"themes/default/img/menu/distributionlist_intcont_d.gif",
"d5e31":"themes/default/img/menu/distributionlist_extcontact.gif",
"d5e38":"themes/default/img/menu/distributionlist_extcont_d.gif",
"d5e45":"themes/default/img/menu/distributionlist_remove.gif",
"d5e52":"themes/default/img/menu/distributionlist_remove_d.gif",
"d5e76":"themes/default/img/mail/add_attachment.gif",
"d5e83":"themes/default/img/mail/add_attachment_d.gif",
"d5e90":"themes/default/img/mail/remove_attachment.gif",
"d5e97":"themes/default/img/mail/remove_attachment_d.gif",
"d5e122":"themes/default/img/menu/add_picture.gif",
"d5e129":"themes/default/img/menu/add_picture_d.gif",
"d5e136":"themes/default/img/menu/remove_picture.gif",
"d5e143":"themes/default/img/menu/remove_picture_d.gif",
"d6e10":"themes/default/img/menu/section_scroll_left.gif",
"d6e16":"themes/default/img/dummy.gif",
"d6e25":"themes/default/img/menu/section_scroll_left_dis.gif",
"d6e31":"themes/default/img/dummy.gif",
"d9e10":"themes/default/img/menu/section_scroll_right.gif",
"d9e24":"themes/default/img/menu/section_scroll_right_dis.gif",
"d10e17":"themes/default/img/menu/cancel_clear.gif",
"d10e24":"themes/default/img/menu/cancel_clear_d.gif",
"d10e31":"themes/default/img/menu/cancel_clear.gif",
"d10e38":"themes/default/img/menu/cancel_clear_d.gif",
"menu_new_options_menu_img":"themes/default/img/arrows/arrow_gray_down.gif",
"menu_options_arrow_down":"themes/default/img/arrows/arrow_double_gray_down.gif",
"menu_options_arrow_up":"themes/default/img/arrows/arrow_double_gray_up.gif",
"d3e78":"themes/default/img/dummy.gif"}};
if(window.opener)
var corewindow=window.opener.corewindow;
else corewindow = null;
function ErrorPopup() {}
ErrorPopup.ok = function () {
	ErrorPopup.closeWindow();
}
ErrorPopup.openWindow = function () {
	showNode("disable_background_window");
	$("disable_background_window").style.display="block";
	showNode("error_popup");
	centerPopupWindow($("error_popup"));
	$("error_popup").style.display="block";
}
ErrorPopup.closeWindow = function () {
	hideNode("error_popup");
	$("error_popup").style.display="none";	
	hideNode("disable_background_window");
	$("disable_background_window").style.display="none";
}
register("Loaded",function() {
	addOnClose($("error_popup"),function() { ErrorPopup.closeWindow() }); 
	appendNode("everything");
});
function addHideTreeNode(node,parent,index) {
}
function appendNode(id,cd) {
	var node=document.getElementById(id);
	if(!cd && (node.style.display=="none" || node.style.display=="NONE")) {
		if(node.tagName == "DIV") { node.style.display = "block"; }
		else { node.style.display = ""; }
	}
}
function removeNode(id,cd) {
	var node=document.getElementById(id);
	if(!cd && (node.style.display!="none" || node.style.display!="NONE")) {
		node.style.display = "none";
	}	
}
function refillImages(id) {
    if($ALL(id)) {
        var elements=$ALL(id).getElementsByTagName("img");
        for(var i=0;i<elements.length;i++) {
            //if(init.images[elements[i].id] && init.images[elements[i].id] != elements[i].src && (!elements[i].src || elements[i].src.match(/img\/dummy.gif/))) {
            if(init.images[elements[i].id] && init.images[elements[i].id] != elements[i].src) {
                elements[i].src=init.images[elements[i].id];
            }
        }
    }
}
function showNode(id,changedisplay) {
	appendNode(id,changedisplay);
	refillImages(id);
}

function hideNode(id,changedisplay) {
	removeNode(id,changedisplay);
}
var fileloaded=function() {};

function autorefill() {
	var effectsarray1=["menu_global_attachments","menu_mail","menu_mail2","menu_task_new_participant","menu_calendar_new_attachment","menu_dyn_window","menu_contact_new_picture","menu_new_contact_distributionlist","menu_calendar_new_participant","menu_new_mail","menu_mail_new_attachment","menu_new_mail_view"];
	var effectsarray2=["menu_global_tags"];
	var singlearray1=[];
	var singlearray2=["menu_small_mail","menu_small_calendar","menu_small_contacts",
				      "menu_small_distributionlist","menu_small_tasks","menu_small_infostore"];
	var singlearray3=["menu_big_portal","menu_big_mail","menu_big_calendar","menu_big_contacts","menu_big_tasks","menu_big_infostore","menu_big_save","menu_mail_save"];
						  
	if(configGetKey("gui.effects.global")) {
		for(var zaehler=0;zaehler<effectsarray1.length;zaehler++) {
			makeButtonElement1($ALL(effectsarray1[zaehler]));
		}
		for(var zaehler=0;zaehler<effectsarray2.length;zaehler++) {
			makeButtonElement2($ALL(effectsarray2[zaehler]));
		}
		for(var zaehler=0;zaehler<singlearray1.length;zaehler++) {
			setDOMMenuElement1($ALL(singlearray1[zaehler]));
		}
		for(var zaehler=0;zaehler<singlearray2.length;zaehler++) {
			setDOMMenuElement2($ALL(singlearray2[zaehler]));
		}
		for(var zaehler=0;zaehler<singlearray3.length;zaehler++) {
			setDOMMenuElement3($ALL(singlearray3[zaehler]));
		}
	}
	refillImages("menu_options_menu");
	if($("contentarea")) { refillImages("contentarea"); }
}

register("Loaded",autorefill);
register("Loaded",menuLoad);
function menuLoad() {
	setTimeout(function() {
		menuiteration=configGetKey("gui.menu.menuiteration") || 4;
		triggerEvent("OX_menu_Change_Height",true);
	},0);
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

/**
 * Creates a categories widget inside the specified DOM element.
 * @class A basic categories class.
 * @param {Array} Array filled with entries fo selection box
 * @param {Object} id of the DOM element to which the categories will be attached
 * @param {Object] id of the DOM Input text element which be filled with categorie strings
 * @param {Object] id of the DOM Input button which be clicked
 * {@link getState}.
 * will be added.
 */

function Categories(globalList,privateList,sDomElementId,DOMInput,sDomButtonId, divForOverflow)
{
	this.aGlobal = (globalList.length>0)?globalList.split(','):new Array();
	this.aPrivate = (privateList.length>0)?privateList.split(','):new Array();	
	this.aObjectReferItems = new Array();

	this.aRefDiv = new Array();
	
	this.aSelected = new Object();
		
	this.aIdAssoc = new Object();
		
	this.sContainerId = sDomElementId;
	this.sButtonId = sDomButtonId;
	this.mainDiv = null;
	this.inputField = DOMInput;
	this.divForOverflow = divForOverflow;
}

Categories.prototype = {
	getList : function ()
	{
		return this.aGlobal;
	},
	getHTML : function ()
	{		
		var thisSelf = this;	
		thisSelf.createMenu();
		function openDialog()
		{			
			var sString = thisSelf.inputField.value;
			var aEntries = sString.split(',');

			//trim blanks and match entries in main list
			for(var ind=0;ind < aEntries.length;ind++)
			{
				aEntries[ind]= trimStr(aEntries[ind]);		
				var bMatch = false;				
				for(var nMatchInd=0;nMatchInd<thisSelf.aGlobal.length;nMatchInd++)
				{
					if(aEntries[ind] == thisSelf.aGlobal[nMatchInd])
					{			
						var sId = 'sel_'+nMatchInd;
						thisSelf.aSelected[sId] = true;
						document.getElementById(sId).className += ' background-color-PMG-selection-elements';
						bMatch = true;
						break;
					}
				}
				for(var nMatchInd=0;nMatchInd<thisSelf.aPrivate.length;nMatchInd++)
				{
					if(aEntries[ind] == thisSelf.aPrivate[nMatchInd])
					{			
						var sId = 'sel_'+(nMatchInd + thisSelf.aGlobal.length);
						thisSelf.aSelected[sId] = true;
						document.getElementById(sId).className += ' background-color-PMG-selection-elements';
						bMatch = true;
						break;
					}
				}
				if(!bMatch && aEntries[ind].length>0 && !inArray(aEntries[ind],thisSelf.aObjectReferItems))
				{					
					var addTR = thisSelf.getTR (aEntries[ind],(thisSelf.aObjectReferItems.length + thisSelf.aGlobal.length + thisSelf.aPrivate.length),'background-color-PMG-selection-elements');
					var sNewId = 'sel_'+(thisSelf.aObjectReferItems.length + thisSelf.aGlobal.length + thisSelf.aPrivate.length);
					thisSelf.aObjectReferItems.push(aEntries[ind]);					
					thisSelf.tableSt.appendChild(addTR);	
					thisSelf.aSelected[sNewId] = true;	
				}
				else if(!bMatch && aEntries[ind].length>0)
				{
					for(nIndx=0;nIndx<thisSelf.aObjectReferItems.length;nIndx++)
					{						
						var sId = 'sel_' + (nIndx + thisSelf.aGlobal.length + thisSelf.aPrivate.length);
						if(aEntries[ind] == thisSelf.aObjectReferItems[nIndx])
						{																											
							thisSelf.aSelected[sId] = true;
							document.getElementById(sId).className += ' background-color-PMG-selection-elements';							
							break;							
						}			
					}
				}				
			}							
			document.getElementById(thisSelf.sContainerId).style.display = 'block';
			document.getElementById(thisSelf.divForOverflow).className = 'listDialogueDivOverflow background-color-content';
			var posDif = 18*pxPerEm - document.getElementById(thisSelf.sContainerId).offsetTop;
			if(posDif < 0)
			{
				document.getElementById(thisSelf.sContainerId).style.top = 
							(document.getElementById(thisSelf.sContainerId).offsetTop - 18*pxPerEm) + "px";
			}
		}		
		var bButton = document.getElementById(this.sButtonId);
		addDOMEvent(bButton, "click", openDialog);		
	},
	createMenu: function ()
	{
		var oTableMain = document.getElementById("categoryTbody");
		this.tableSt = oTableMain;
		for(var nIndex=0;nIndex<this.aGlobal.length;nIndex++)
		{
			oCurrentTR = this.getTR(this.aGlobal[nIndex],nIndex,'');
			oTableMain.appendChild(oCurrentTR);								
		}
		for(var nIndex=0;nIndex<this.aPrivate.length;nIndex++)
		{
			oCurrentTR = this.getTR(this.aPrivate[nIndex],nIndex+this.aGlobal.length,'');
			oTableMain.appendChild(oCurrentTR);								
		}
		var thisSelf = this;		
		function addItems()
		{		
			var sDisplayCatString = '';
			for(key in thisSelf.aSelected)
			{
				if(thisSelf.aSelected[key])
					sDisplayCatString += thisSelf.getEntryById(key) + ', ';	
			}			

			thisSelf.inputField.value = sDisplayCatString.slice(0,sDisplayCatString.length-2);
			document.getElementById(thisSelf.sContainerId).style.display = 'none';
			thisSelf.inputField.focus();
			thisSelf.resetSelection();
		}
		addDOMEvent(document.getElementById("addNewInfoListButton"), "click", addItems);			
	},
	getTR : function (sLabel,nIndex,CSSClass)
	{
		var thisSelf = this;
		var oCurrentDIV = newnode('div',{cursor: "pointer"},{className: ' '+ CSSClass,id:sId});		
		var oCurrentTR = newnode('tr');		
		var sTRId = 'seltr_'+nIndex;		
		oCurrentTR.id = sTRId;
		var oCurrentTD = newnode('td');					
		var sId = 'sel_'+nIndex;
		oCurrentDIV.id = sId;		
		this.aIdAssoc[sId] = sLabel;
		function handleItem(e)
		{
			var DOMTarget = (e.target)?e.target:e.srcElement;		
			if(!thisSelf.aSelected[DOMTarget.id])
			{
				thisSelf.aSelected[DOMTarget.id] = true;			
				DOMTarget.className += ' background-color-PMG-selection-elements';
			}
			else							
			{							
				DOMTarget.className = removeClass(DOMTarget.className,'background-color-PMG-selection-elements');
				thisSelf.aSelected[DOMTarget.id] = false;
			}				
		}		
		addDOMEvent(oCurrentDIV, "click", handleItem);						
		oCurrentDIV.innerHTML = sLabel;
		oCurrentTD.appendChild(oCurrentDIV);
		oCurrentTR.appendChild(oCurrentTD);
		this.aRefDiv.push(oCurrentDIV);
		return oCurrentTR;
	},
	resetSelection: function ()
	{
		this.aSelected = new Object();	
		for(nIndex=0;nIndex<this.aRefDiv.length;nIndex++)
		{
			this.aRefDiv[nIndex].className = removeClass(this.aRefDiv[nIndex].className,'background-color-PMG-selection-elements');
		}
	},
	getEntryById: function (sId)
	{
		return this.aIdAssoc[sId];
	}
}
function inArray(value, array)
{
	for(var i=0;i<array.length;i++)
	{
		if(array[i] == value)
			return true;
	}
	return false;
}

function getCatArrayFromString(sString)
{
	var aEntries = sString.split(',');
	var aNew = new Array();
	for(var ind=0;ind < aEntries.length;ind++)
	{
		var sStr = trimStr(aEntries[ind]);
		if(sStr.length > 0)
			aNew[aNew.length]= sStr;	
	}
	return aNew;
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var ExecAfterUpload =  function (){};
var ExecErrorAfterUpload = null;

function attachmentDialog(sDialogNum, fkt_On_OK)
{
	this.template_id = 'attachPopupTemplate';
	this.popup = $('attachPopupTemplate');
	this.popup.id = this.template_id + '_' + this.dialog_num;
	this.dialog_num = sDialogNum;
	this.att_server_rem = new Array();;
	
	this.callOnOK = fkt_On_OK;
	
	this.form_name = 'attFile_' + this.dialog_num;
	this.form =  document.attFile;
	this.form.name = this.form_name;
	
	//this.sel_files_area = $("selectedFilesArea");
	this.files_area_id = "selectedFilesArea" + '_' + this.dialog_num;
	//this.sel_files_area.id = this.files_area_id;
	this.live_grid_container = $("sel_files_area");
	this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];});
		
	this.file_input_count = 0; 
	
	var Self = this;
	register("OX_Attachment_Dialog_Cancel", function(){Self.closePopup();});
	addOnClose (this.popup,function(){
		  triggerEvent("OX_Attachment_Dialog_Cancel");
		});
	register("OX_Object_Add_Attachment", function(){Self.openPopup();});
	register("OX_Attachments_Add_File", function(){Self.addFile();});
	register("OX_Attachments_Remove_File", function(){Self.removeFile();});
	register("OX_Attachment_Dialog_OK", function(){Self.commitPopup();});
	
	this.all_input_fields = new Array();
	this.file_name_list = new Array();
	this.temp_list = new Array();
	
	this.last_input = null;
	
	this.curr_file_input_id;
	
	this.open = false;	
}

attachmentDialog.prototype = {
	attach_changed:function ()
	{
		return (this.att_server_rem.length > 0 || this.file_input_count > 0);
	},
	do_post: function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload)
	{
		if(this.att_server_rem.length > 0)
		{
			var aAttIds = new Array();

			for(var indx2=0;indx2<this.att_server_rem.length;indx2++)
			{
				aAttIds.push(this.att_server_rem[indx2].attid);
			}

			var sAction = AjaxRoot + "/attachment?action=detach" + "&session="+session + "&attached=" 
						+ this.att_server_rem[0].item_id + "&module=" 
								+ this.att_server_rem[0].module + "&folder=" + (this.att_server_rem[0].folder || this.att_server_rem[0].folder_id);												
			this.att_server_rem = new Array();								
			var attJson = new JSON();
			var Self = this;
			function cb_deleted(arg)
			{
				if(arg && arg.error)
					alert(arg.error);			
				else			
				{
					Self.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
				}				
			}
			attJson.put(sAction,aAttIds,null,cb_deleted);
		}
		else
		{
			this.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
		}
		return;
	},
	post_new:function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload)
	{
		ExecAfterUpload = fn_exec_afterupload;
		ExecErrorAfterUpload = fn_error_exec_afterupload;
		if(sActionParam)
		{
			this.form.action = sActionParam;
		}
		else				
			this.form.action = AjaxRoot + "/attachment?action=attach&session=" + session;
		if(sTargetParam)
			this.form.target = sTargetParam;
		var  sObj = JSON.serialize(obj);
		if(this.file_input_count == 0)
		{
			var oNodeJson;
			if(this.form["json_0"] == undefined)
			{
				oNodeJson = newnode('input',0,{
										type:"hidden",
										name:'json_0'
										});								
				this.form.appendChild(oNodeJson);
			}
			else
			{
				oNodeJson = this.form["json_0"];
			}
			oNodeJson.value = sObj;
		}		
		else
		{
			for(var nCount=0;nCount<this.file_input_count;nCount++)
			{
				if(this.form['json_'+nCount])
					this.form['json_'+nCount].value = sObj;
			}
		}
		this.form.submit();
	},
	createFileInput: function()
	{
		var sId = 'file_' + (this.file_input_count);
		var oNode = newnode('input',0,{
										type:"file",
										size:"40",
										name:sId,
										id:sId,
										className:"inputElementAttachment"
										});
		var oNodeJson = newnode('input',0,{
										type:"hidden",
										name:'json_'+(this.file_input_count),
										id:'json_'+(this.file_input_count)
										});						
		this.last_input = oNode;
		var outerDiv1 = newnode("div",{overflow:"auto"});
		var outerDiv2 = newnode("div",{overflow:"auto"});		
		outerDiv1.appendChild(oNode);
		outerDiv2.appendChild(oNodeJson);
		this.form.appendChild(outerDiv1);
		this.form.appendChild(outerDiv2);
		this.all_input_fields.push(oNode);
		this.all_input_fields.push(oNodeJson);		
		return sId;
	},
	openPopup:function ()
	{
		if(!this.open)
			this.curr_file_input_id = this.createFileInput();	
		this.open = true;			
		this.temp_list = new Array();
		if ($("disable_background_window")) {
            showNode("disable_background_window");
            $("disable_background_window").style.display = "block";
        }
        centerPopupWindow(this.popup);
		this.popup.style.display = 'block';		
		//create
		if(this.live_grid == null)
		{
			this.live_grid = new LiveGrid([ 
				{
					text:" ",				
					index: 1,	
					style: {overflowX:"auto"},
					set: function(div, text) {
						text = text || "\u00a0";
						if (div.firstChild)
							div.firstChild.data = text;
						else
							div.appendChild(document.createTextNode(text));
					},					
					clear: LiveGrid.makeClear("")
				}
			],new Selection());			
	
			this.live_grid.emptylivegridtext ="";
			this.live_grid.getHeader();		
			this.live_grid.getTable(this.live_grid_container);
			this.live_grid_container.style.overflowX = "auto";
			//this.live_grid_container.firstChild.style.width = "";			
			//this.live_grid_container.firstChild.style.overflowX = "auto";			
		}
		else
			this.live_grid.enable(this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];}));

	},
	closePopup:function ()
	{
		//this.form.reset();
		//var oNode;
		//empty lg
		//removeChildren(this.sel_files_area);		
		/*
		while(oNode = this.all_input_fields.pop())
		{
			if(oNode)
			{
				this.form.removeChild(oNode);
			}
		}*/
		if ($("disable_background_window")) {
            hideNode("disable_background_window");
            $("disable_background_window").style.display = "none";
        }
		this.popup.style.display = 'none';	
		/*
		this.file_input_count = 0;	
		*/
		this.open = false;
		var aToDel = new Array();
		for (var indxTd in this.temp_list)
		{
			aToDel.push(this.temp_list[indxTd].id);
		}
		this.removeFiles(aToDel);
		this.temp_list = new Array();		
		this.live_grid.disable();
		if(this.last_input != null)
			this.form.removeChild(this.last_input.parentNode);
		this.last_input = null;
		this.file_input_count++;
	},	
	commitPopup:function ()
	{
		if ($("disable_background_window")) {
            hideNode("disable_background_window");
            $("disable_background_window").style.display = "none";
        }
		this.popup.style.display = 'none';	
		this.file_name_list = this.file_name_list.concat(this.temp_list);
		this.callOnOK(this.file_name_list);	
		this.live_grid.disable();
	},
	showAttachedFiles: function ()
	{
		return this.file_name_list;
	},
	addFile:function ()
	{	
		//ie7 bugfix
		//var currFileInput = this.form.elements[this.curr_file_input_id];
		
		var currFileInput = document.getElementById(this.curr_file_input_id);
		
		if(currFileInput.value.length == 0)
			return;		
		var fileName = separateFilenameFromPath(currFileInput.value);		
		var file = {id:fileName+'_'+this.file_input_count,filename:fileName};
		this.temp_list.push(file);
		
		//add file to lg
		var aFileObjects =  [[file.id,fileName]];
		this.file_storage.append(aFileObjects);
		this.live_grid.enable(this.file_storage);
		
		//update styles here (IE BUG FIX horizontal scroll bar)
		this.live_grid.rowTemplate.style.tableLayout = "auto";
		
		//this.sel_files_area.appendChild(newnode("option", 0,
		//	{value: file.id}, [document.createTextNode(fileName)]));

		currFileInput.style.display = "none";
		
		this.file_input_count++;
		this.curr_file_input_id = this.createFileInput();			
	},
	removeFile: function() {	
		//var files = this.sel_files_area.childNodes;
//		var len = files.length;
//		var selected = [];
//		for (var i = 0; i < len; i++)
//			if (files[i].selected) selected.push(files[i].value);
		var aSelItems = this.live_grid.selection.getSelected();
		if(aSelItems.length > 0)
			this.removeFiles(aSelItems);
//		removSelected;
	},
	getLocalPath:function (sId)
	{
			sFileName = sId.split('_')[0]; 
			for(var nField=0;nField<this.all_input_fields.length;nField++)
			{
				if((this.all_input_fields[nField].name == 'file_' + sId.split('_')[1]))
				{					
					return this.all_input_fields[nField];
				}
			}
	},
	removeFiles:function (aFiles)
	{
		function removeFileNameFromString(sStr,sFileName)
		{
			sFileName += '; ';
			var sReturnStr = sStr.replace(sFileName,'');
			return sReturnStr;
		}
		var Self = this;
		function removeFileNameFromList(sId)
		{
			for(var indx in Self.file_name_list)
			{
				if(Self.file_name_list[indx].id == sId)
				{
					Self.file_name_list.splice(indx,1);
					break;
				}
			}
			for(var indx in Self.temp_list)
			{
				if(Self.temp_list[indx].id == sId)
				{
					Self.temp_list.splice(indx,1);
					break;
				}
			}
		}
		//aFiles
		//get files from lg
		//var options = this.sel_files_area.childNodes;
		if(this.live_grid && this.live_grid.storage != null)
			this.live_grid.deleteIDs(aFiles);
		for(var nIndex=0;nIndex<aFiles.length;nIndex++)
		{
			var filename = aFiles[nIndex];
			//var len = options.length;
			//remove fildes from lg
			/*
			for (var i = 0; i < len; i++)
				if (options[i].value == filename) {
					//this.sel_files_area.removeChild(options[i]);
					break;
				}
*/
			var sFileName = expandFileNames(filename);
			removeFileNameFromList(filename);
			var aToRemoveArray = new Array();
			for(var nField in this.all_input_fields)
			{
				if(((this.all_input_fields[nField].name == 'file_' + expandIDS(filename))
							|| (this.all_input_fields[nField].name == 'json_' + expandIDS(filename))) 
											&& this.all_input_fields[nField].name != 'json_0')
				{
					this.form.removeChild(this.all_input_fields[nField].parentNode);
					aToRemoveArray.push(nField);
				}
			}
			for(var nRemItem in aToRemoveArray)
			{
				this.all_input_fields.splice(aToRemoveArray[nRemItem],1);							
			}
		}
	}
}

function expandIDS(sFileWithId)
{
	var aTempArray = sFileWithId.split('_');	
	return aTempArray[(aTempArray.length-1)];
}
function expandFileNames(sFileWithId)
{
	var aTempArray = sFileWithId.split('_');
	var sFileName = "";
	for(var nIndxx=0;nIndxx<aTempArray.length-1;nIndxx++)
	{
		sFileName += aTempArray[nIndxx];
		if(nIndxx < aTempArray.length-2)
			sFileName += "_";
	}
	return sFileName;
}

/*
 * remove is possible in new/edit window only
 * */
function attachmentGrid(sContainerId,nId,nFolder,sModule,oDialog)
{
	this.container = $(sContainerId);
	this.containerHeader = $(sContainerId + "Header");
	this.module  = sModule;
	this.nItemId = nId;
	this.folder = nFolder;	
	this.liveGrid = null;
	this.viewGrid();
	this.attachmentStorage;// = new Storage(0, []);
	this.bDetailAttachmentsLoaded = false;
	
	this.selection_dialog = (oDialog)?oDialog:false;
	
	this.timestamp = 0;
	
	this.addData = new Array();
	this.selectedRtfFlag = false;
	this.selectedId = null;
	this.selectedFilename = null;	
	
	this.numberOfAttachments = 0;
	
	Self = this;
	this.openAttachedFile = function() {
				if(Self.selectedRtfFlag)
					return;
				var sURL = 
				AjaxRoot + "/attachment/" + Self.selectedFilename + "?action=document&session="
					+ session + "&attached=" + Self.nItemId  + "&module=1&folder="
					+ activefolder + "&id=" + Self.selectedId;
				newWindow(sURL, getWindowOptions());
	};
	this.saveAttachedFile = function() {

				if(Self.selectedRtfFlag)
					return;		
				var sContentType = 'application%2Foctet-stream';	
				var sURL = 
				AjaxRoot + "/attachment/" + Self.selectedFilename + "?action=document&session="
					+ session + "&attached=" + Self.nItemId  + "&module=1&folder="
					+ activefolder + "&id=" + Self.selectedId + '&content_type=' +sContentType;
				if (IE6) {
					newWindow(sURL, getWindowOptions());
				} else {
					var frame = $ALL("dlIframe") ? getFrameElement('dlIframe') : parent.frames['dlIframe'];
					frame.location.href = sURL;
				}
	};
	this.saveAttachInInfoStore = function() {
		if (Self.selectedRtfFlag) return;
		if (activemodule == "mail") return;
		var nNumModule = -1;
		switch (activemodule) {
			case "calendar": 	nNumModule = 1;
								break;
			case "tasks": 	nNumModule = 4;
								break;
			case "contacts": 	nNumModule = 7;
								break;																
		}
		propertiesPopUp = newWindow(
		      "newInfoItemMain.html#attachmodule=" + nNumModule+ "&edit_id=" + -1
		      + "&filename=" + encodeURIComponent(Self.selectedFilename)
              + "&attid=" + encodeURIComponent(Self.selectedId)
              + "&attobjid=" + encodeURIComponent(Self.nItemId)                        
              + "&attobjfolder=" + encodeURIComponent((Self.folder || Self.folder_id))      
              + "&folder=" + encodeURIComponent(configGetKey("folder.infostore")), 
		      getWindowOptions(), 
		      [ Self.selectedId, Self.nItemId, (Self.folder || Self.folder_id)]);	
		propertiesPopUp.focus();			
	}
	
	var Self = this;
	this.remAttachedFile  = function() {
		if(Self.selectedRtfFlag) return;		
		function cbyes() {
			Self.remove(Self.selectedId,function() {
				Self.updateGrid(Self.selection_dialog.file_name_list);
			});										
		}
		newConfirm(_("Delete Attachment"),_('Are you sure you want to delete the selected attachment?'),AlertPopup.YESNO,null,null,cbyes,null);
										
	};
										
	register("OX_Attachment_Open", this.openAttachedFile);		
	register("OX_Attachment_Save", this.saveAttachedFile);		
	register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);	
	
	if(this.selection_dialog)
		register("OX_Object_Attachment_Delete", this.remAttachedFile);	
}

attachmentGrid.prototype = {
updateGrid:function (data)
{	
	var aNewData = new Array();
	for(var indx in data)
	{
		var bFound = false;
		for(var indx2=0;indx2<this.addData.length;indx2++)
		{	
			if(data[indx].id == this.addData[indx2].id)
			{
				bFound = true;
				break;
			}
		}
		if(!bFound)
			aNewData.push(data[indx]);
	}	
	for(var indx2=0;indx2<this.addData.length;indx2++)
	{	
		var bFound = false;
		for(var indx in data)
		{
			if(data[indx].id == this.addData[indx2].id)		
			{
				bFound = true;
				break;				
			}
		}
		if(!bFound)
		{
			//IE7 bugfix
			//this.attachmentStorage.remove(this.attachmentStorage.ids.indexOf(this.addData[indx2].id));
			var indexToDelete = -1;
			var aIds = this.attachmentStorage.ids;
			for (var i = 0; i < aIds.length; i++) {
				if(aIds[i] == this.addData[indx2].id)
				{
					this.liveGrid.deleteIDs([this.addData[indx2].id]);
					indexToDelete = i; 
				}
			}
//			if(indexToDelete != -1)
//				this.attachmentStorage.remove(indexToDelete);
			this.addData.splice(indx2,1);
		}
	}
	this.addData = this.addData.concat(aNewData);
	var aNewObj =  new Array();
	for(var i in aNewData)
	{
		sFileName = aNewData[i].filename;
		aNewObj.push(new Array(aNewData[i].id,sFileName,'','',''));
		this.numberOfAttachments++;
		triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
	}
	if(aNewObj.length == 0)
		triggerEvent("SubSelected", 0);
	else
		this.attachmentStorage.append(aNewObj);
	this.enableGrid();

},
remove:function (id,fn_opt_after_remove)
{
	if(typeof(id) == 'string')
		var aSplited = id.split('_');
	else
	{
		var aSplited = new Array();
		aSplited[0] = id;
	}		
	if(aSplited[1])
	{
		//remove from grid
		
		//remove from dialog
		var aFileToDel = new Array();
		aFileToDel[0] = id;
		this.selection_dialog.removeFiles(aFileToDel);
		if(fn_opt_after_remove)
		{
			fn_opt_after_remove();
		}
		this.numberOfAttachments--;		
		triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
	}
	else
	{
		var Self = this;
		Self.selection_dialog.att_server_rem.push({attid:id,item_id:this.nItemId,module:this.module,
																						folder:this.folder || this.folder_id});

		var aData = new Array();
		delete Self.attachmentStorage.data.data[id];
		for (var indx in Self.attachmentStorage.data.data)
		{			
			aData.push(Self.attachmentStorage.data.data[indx]);
		}
		this.attachmentStorage = new Storage(0, []);
		Self.attachmentStorage.append(aData);
		Self.liveGrid.enable(Self.attachmentStorage);
		this.numberOfAttachments--;		
		triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
	}
},
enableGrid:function ()
{
	this.liveGrid.enable(this.attachmentStorage);		
	register("OX_Attachment_Open", this.openAttachedFile);		
	register("OX_Attachment_Save", this.saveAttachedFile);	
	register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);		
},
disableGrid:function()
{
		this.liveGrid.disable();
		unregister("OX_Attachment_Open", this.openAttachedFile);		
		unregister("OX_Attachment_Save", this.saveAttachedFile);
		unregister("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);
},
getAttachments:function(nId,nFolder,fn_update_opt)
{
	var  Self = this;	
	this.attachmentStorage = new Storage(0, []);
	if(this.nItemId === false)
		return;		
	function cb_attachments(arg)
	{
		var aData = new Array();
		Self.numberOfAttachments = 0;
		//check rtf_flags here
		for (var indx in arg.data)
		{			
			aData.push(arg.data[indx]);
			Self.numberOfAttachments++;		
		}
		
		triggerEvent("OX_Attachments_Changed_InGrid",Self.numberOfAttachments);
		Self.attachmentStorage.append(aData);
		Self.attachmentStorage.timestamp = arg.timestamp;
		Self.liveGrid.enable(Self.attachmentStorage);
		Self.bDetailAttachmentsLoaded = true; 
		if(fn_update_opt)
			fn_update_opt();			
	}
	if(nId != 0 && nId != undefined && 
						nFolder != 0 && nFolder != undefined)
	{
		this.nItemId = nId;
		this.folder = nFolder;		
	}		
	this.doAjaxFetchAllAttachments(cb_attachments);
},
viewGrid: function ()
{	
		var Self = this;
		var clear = LiveGrid.makeClear("...");
		function setAttachmentsTest1 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			div.appendChild(document.createTextNode(text[1]));		
		}
		function setAttachmentsTest2 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			div.appendChild(document.createTextNode(text[2]));		
		}	
		function setAttachmentsTest3 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";	
			div.appendChild(document.createTextNode( text[3] && text[3].length != 0 ? bytesToString(text[3]) : "") );		
		}			
		function setAttachmentsTest4 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			if(text[4].length==0)
				div.appendChild(document.createTextNode(""));		
			else				
				div.appendChild(document.createTextNode(formatDate(text[4], "date")));		
		}								
		this.liveGrid = new LiveGrid([ 
			{
				text: "File name", /*i18n*/
				i18n: true,
				sortable: true,
				set: setAttachmentsTest1,
				clear: clear
			}, {
				text: "Mime type", /*i18n*/
				i18n: true,				
				sortable: true,
				width: "20%",
				set: setAttachmentsTest2,
				clear: clear
			}, {
				text: "Size", /*i18n*/
				i18n: true,				
				sortable: true,
				width: "15%",
				set: setAttachmentsTest3,
				clear: clear
			}, {
				text: "Last modified", /*i18n*/
				i18n: true,					
				sortable: true,
				width: "15%",
				set: setAttachmentsTest4,
				clear: clear
			}
		], new Selection());
		this.liveGrid.emptylivegridtext="No Attachments available";/*i18n*/
		this.containerHeader.appendChild(this.liveGrid.getHeader());
		this.liveGrid.getTable(this.container);
				
		this.liveGrid.events.register("Activated", function(ids){
			if (!ids || ids == 0) return;
			(menucheckRight("WRITE")) ? triggerEvent("OX_Object_Delete_Attachment") :
				triggerEvent("OX_New_Error", 4, _("You're not allowed to delete this attachment!"));
		});
	
		var aIds = Self.liveGrid.selection.getSelected();
		var Self = this;		
		function fn_triggerSubSel(ids){
			triggerEvent("SelectedAttachment",ids);
			if (ids == 1) {				
				var aIDS = Self.liveGrid.getSelectedIDs();
				Self.selectedId = aIDS[0];
				Self.selectedFilename = Self.liveGrid.storage.data.get(Self.selectedId)[1];		
				Self.selectedRtfFlag = !(Self.liveGrid.storage.data.get(Self.selectedId)[5] == false);
				if(Self.liveGrid.storage.data.get(Self.selectedId)[5] == undefined)
				{
					Self.selectedRtfFlag = false;
				}
				triggerEvent("SubSelected", ids,Self.selectedRtfFlag);				
			} 		 

		}
		this.liveGrid.events.register("Selected", fn_triggerSubSel);
},
doAjaxFetchAllAttachments:function (cb)
{
	json.get(AjaxRoot + "/attachment?action=all&session=" + session + "&folder=" +
			(this.folder || this.folder_id) + "&attached=" + this.nItemId + "&module="+this.module+"&" + 
			"columns=1%2C803%2C805%2C804%2C4%2C806&sort=803&order=asc", null,cb);		
}
}

function callback_attach(cb) {
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if (!cb.error)
	{
		ExecAfterUpload();	
	}
	else {
		//triggerEvent("OX_New_Error", 4, cb.toString());
	}
}

function callback_document(cb) {
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if (cb.error)
	{
		newServerError(cb);
	}
	
}
function callback_error(arg)
{
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if(ExecErrorAfterUpload && typeof ExecErrorAfterUpload != "undefined") 
		ExecErrorAfterUpload(arg);
	else 
		newServerError(arg);
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */
 
registerView("contact_new",
	function() {
	 	register("OX_Picture_Add",myNewContactFunctions.addPicutre);
	 	register("OX_Picture_Remove",myNewContactFunctions.deletePicture);
	 	registerContext($('imageContactTd'),"contact_new_picture");
	},
	null, 
	null,
	null
);

registerView("contact_new/business",
	function() { 
		$("tabContact1").style.display="block";
		$("panelContact1").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";	
	},
    function() {
        try {
            setTimeout(function() {
                if ($("last_name")) $("last_name").focus();
            },0);
        } catch (e) {
            
        }
    }, 
    null,
	function() {
		$("tabContact1").style.display="none";
		$("panelContact1").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		
	},
	function() {
		try {
			setTimeout(function() {
				if ($("last_name")) $("last_name").focus();
			},0);
		} catch (e) {
			
		}
	}
);

registerView("contact_new/personal",
	function() { 
		$("tabContact2").style.display="block";
		$("panelContact2").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";
		try {
            setTimeout(function() {	
            	$("contactForm").profession.focus();
            },0);
        } catch (e) {
            
        }     	
		if(!birthdayCalendar && !anniversaryCalendar)
			createMiniCalendar();
		enableBirthdayAppointment();
	},
	null, 
	 null,
	function() {
		$("tabContact2").style.display="none";
		$("panelContact2").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";	
	}
);

registerView("contact_new/additional",
	function() { 
		$("tabContact3").style.display="block";
		$("panelContact3").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";	
        try {
            setTimeout(function() { 		
            	$("contactForm").street_other.focus();
            },0);
        } catch (e) {
            
        }             	
	},
	null, 
	 null,
	function() {
		$("tabContact3").style.display="none";
		$("panelContact3").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		
	}
);
registerView("contact_new/attachment",
	function() { 
		$("tabContact5").style.display="block";
		$("panelContact5").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";	
	},
	function() {
		
		if(!bAttachmentGridCreated)
		{
			initAttachmentsGrid();
			bAttachmentGridCreated = true;
			tmp_attachment.getAttachments();
		}
		else		{

			tmp_attachment.enableGrid();			
		}
		register("OX_Attachments_Changed_InGrid",setContactsNewNumberOfAtt);
		register("OX_Timestamp_Changed_By_Attach",setContactsNewTimeStampByAtt);
		
	}, 
	 function() {
	 	unregister("OX_Attachments_Changed_InGrid",setContactsNewNumberOfAtt);
		register("OX_Timestamp_Changed_By_Attach",setContactsNewTimeStampByAtt);
		if(bAttachmentGridCreated)
			tmp_attachment.disableGrid();
	 },
	function() {
		$("tabContact5").style.display="none";
		$("panelContact5").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		
	}
);



var refToMain;
var json = new JSON();
var contactDetailId = 0;
var activefolderLocal = "";
var session = null;
var lastTimestamp = 0;
var modulPopup = "new";
var contact_object = {};
var dataFromDb = null;
var dateAction = new Array();
var myNewContactFunctions = null;
var clickedItemForSave = "";
var contactTreeLoaded = false;
var tmp_attachment = null;
var treeVisible = false;
var miniBirthdayVisible = false;
var miniAnniversaryVisible = false;
var configGetKey = window.opener.configGetKey;
var configSetKey = window.opener.configSetKey;
var configContainsKey = window.opener.configContainsKey;
var optFolderState = corewindow.optFolderState;
var bAttachmentGridCreated = false;
var contactCategories = false;
var newContactId = 0;
var messageOnCancel = false;
var birthdayCalendar = null;
var anniversaryCalendar = null;
var savePending = false;
var newContactFolderTree = null;

var tmp_attachmentDialog = null;
var messageCloseWindow = _("Do you really want to discard your changes and close the window?");

function setContactsNewTimeStampByAtt(arg)
{
	lastTimestamp = arg;
}
/********************************** before on unload *****************************************************************/
function unloadMessage(){
    return messageCloseWindow;
}

function setBeforeUnload(on){
    window.onbeforeunload = (on) ? unloadMessage : null;
    messageOnCancel = on;
}

/********************************** Init *****************************************************************/
function initAttachmentsGrid()
{
	var nId = (url['modul'] && url['modul'] == "edit")?url["id"]:false;
	var nFolder = clickedItemForSave;	 //fukel
	tmp_attachment = new attachmentGrid("attachmentsNewContactGrid",nId,nFolder,7,tmp_attachmentDialog);	
}
function NewContactFunctions()
{
	this.salutationComboBox = null;
	this.cardColumns = (Math.min(Math.ceil(corewindow.countContactCards / 4)));
	this.oCategories = null;
	this.imageExist = false;
	this.deleteImageOnServer = false;
	this.searchPath = "";
	this.searchAlreadyActivated = false;
}
NewContactFunctions.prototype = {
	deletePicture: function() {		
		if(myNewContactFunctions.imageExist) {
			removeChildNodes($('imageContactTd'));	
			$('imageContactTd').appendChild(newnode("div", 0, {className : "contactDummyImage border-color-design"}, [newnode("img", 0, {src : getFullImgSrc("img/contacts/dummypicture.gif")})]));
			contact_object.image1 = "";
			this.deleteImageOnServer = true;
		} else {
			$("contactUploadImage").reset();
		}
	},	
	applyUploadImage: function() {		
		$('contact_upload_image').style.display = "none";
		hideNode("disable_background_window");
        $("disable_background_window").style.display="none"; 
		if(document.getElementById("image1").value != "" && document.getElementById("image1").value != myNewContactFunctions.searchPath) 
			triggerEvent("OX_New_Info",4,_("Your selected picture will be displayed after saving"));
	},	
	cancelUploadImage: function() {
		if(document.getElementById("image1").value != "" && document.getElementById("image1").value != myNewContactFunctions.searchPath) {
			document.getElementById("image1").value = "";
			$("contactUploadImage").reset();
		}
		$('contact_upload_image').style.display = "none";
		hideNode("disable_background_window");
        $("disable_background_window").style.display="none";
	},
	addPicutre: function() {
		showNode("disable_background_window");
		$('disable_background_window').style.display = "block";        
		centerPopupWindow($('contact_upload_image'));
		$('contact_upload_image').style.display = "block";
		if(document.getElementById("image1").value != "") {
			myNewContactFunctions.searchPath = document.getElementById("image1").value;
			myNewContactFunctions.searchAlreadyActivated = true;
		} else {
			myNewContactFunctions.searchAlreadyActivated = false;
		}
	},	
	closeWindow : function() {
		function cbyes() {
			window.onbeforeunload=null;
			window.close();			
		}
		if(messageOnCancel)
			newConfirm(_("Close Window"),_(messageCloseWindow),AlertPopup.YESNO,null,null,cbyes,null);	
		else
			cbyes();
	},
	initCategories : function() {
		if(!contactCategories) {
				this.oCategories = 	new Categories(	configGetKey("global_categories"),
													configGetKey("gui.private_categories"),
													'newcontact_div_cat',
													document.forms.contactForm.categories,
													'newcontact_but_categories', 
													"newcontact_categories_divContent"
												);
				this.oCategories.getHTML();
				contactCategories = true;
			} else {
				$("newcontact_div_cat").style.display = "block";
			}	
	},
	addCategoriesToObject: function() {
		if(document.forms.contactForm.categories.value != "") {
			contact_object.categories = document.forms.contactForm.categories.value;
		} else {
			contact_object.categories = "";
		}
		
	},
	folderPath : function() {
		if(!clickedItemForSave || clickedItemForSave=="null")
				clickedItemForSave = window.opener.configGetKey("folder.contacts");
		oMainFolderTree.cache.get_folder(clickedItemForSave,function (ofolder){			
			if(ofolder.oxfolder.data.type != 1){
				$("newcontact_personal_tr").style.visibility = "hidden";
			} else {
				$("newcontact_personal_tr").style.visibility = "visible";
			}
			
			
			var nPermission = checkPermission(ofolder);
			
			oMainFolderTree.get_folder_path(clickedItemForSave, cb_getpath);
			var folderViewSettingsNewContact = new Object();
			var folderViewSettingsNewContactById = new Object();
			//Disable Email... 
			folderViewSettingsNewContact["mail"] = 4;
			folderViewSettingsNewContactById["default"] = 4;
			folderViewSettingsNewContact["contacts"] = 8;
			folderViewSettingsNewContact["calendar"] = 4;
			folderViewSettingsNewContact["tasks"] = 4;
			folderViewSettingsNewContact["infostore"] = 4;
			if(!contactTreeLoaded){
				newContactFolderTree = new cFolderTree(	$('folder_tree_info'),
												folderAction,										
												false,
												oMainFolderTree.cache,
												optFolderState.getState('folder_tree_info'));
				newContactFolderTree.enabled_modules = {contacts:true};										
	
				newContactFolderTree.load();
				contactTreeLoaded = true;
				newContactFolderTree.setSaveConfiguration(optFolderState);				
			}									
		});
	}
}
function checkPermission(oFolderPermissions) {
	var oPermissions = oFolderPermissions.oxfolder.data.own_rights;
	var nPermission = getPermAsString(true, oPermissions, 0).bit;
	return nPermission;
}

function cb_getpath(sPath)
{
	document.getElementsByName('newcontact_folder')[0].value = sPath;
}	

function folderAction(ofolder) {
	toggleTree();
	clickedItemForSave = ofolder.oxfolder.data.id;
	newContactFolderTree.get_folder_path(clickedItemForSave, cb_getpath);

}

function showTree(){
	$("treeDialogNewContact").style.display = "block";

}
function hideTree(){
	$("treeDialogNewContact").style.display = "none";	
}

function toggleTree(){
	if(newContactFolderTree == null)
	{
		myNewContactFunctions.folderPath();
	}
	if(!treeVisible){
		$("treeDialogNewContact").style.display = "block";
		treeVisible = true;

	}
	else{
		$("treeDialogNewContact").style.display = "none";
		treeVisible = false;
	}
}

/**
 * init() onLoad
 */
function newContactOnload()
{
	activemodule="contact_new";	
	initContents("contact_new");
	initAll();
	
	var themeStyle = corewindow.oxThemeStyle || { name: "Default", path: "default" };
	loadCSSFileForNewWindow("themes/"+themeStyle.path+"/css/global.css");
	loadCSSFileForNewWindow("themes/"+themeStyle.path+"/css/popup.css");
	loadCSSFileForNewWindow("themes/"+themeStyle.path+"/css/bgimages.css");
	
	window.setTimeout(function() {
		initContactContent();
	},0);
}
//register("Loaded",initContactContent);
var internalCache = corewindow.internalCache;
var configContainsKey = corewindow.configContainsKey;
var	configGetKey = corewindow.configGetKey;
var	configSetKey = corewindow.configSetKey;
var oMainFolderTree = corewindow.oMainFolderTree;

function initContactContent() {	
	if(url["folder"]){
		clickedItemForSave = url["folder"];
	} else {
		clickedItemForSave = configGetKey("folder.contacts");
	}
	session = corewindow.session;
	activemoduleLocal = corewindow.activemodule;
	if(window.location.hash != "")
	{
		setModulPopup();	
	}
	activefolderLocal =	url['folder'];
		
	myNewContactFunctions = new NewContactFunctions();
	myNewContactFunctions.initCategories();
	
	addOnClose($("contact_upload_image"),myNewContactFunctions.cancelUploadImage);
		
	register("OX_SAVE_OBJECT", saveContact);	
	register("OX_Cancel_Object", function() {myNewContactFunctions.closeWindow()});	
		
	loadingComplete();
	
	function callMeOnOK(parameter)
	{
		tmp_attachment.updateGrid(parameter);
	}
	tmp_attachmentDialog = new attachmentDialog(0,callMeOnOK); 
	triggerEvent("OX_menu_Change_Height",true);
	
	// register keydown and mouseover for the autfill of the display name
	addDOMEvent($("last_name"), "keyup", autofillDN);
	addDOMEvent($("first_name"), "keyup", autofillDN);			
	addDOMEvent($("last_name"), "mouseout", autofillDN);
	addDOMEvent($("first_name"), "mouseout", autofillDN);	
	window.setTimeout(function() {
		  oMainFolderTree.get_folder_path(clickedItemForSave, cb_getpath);		
	   },0);
	
    setTabLists(tabsList, panelsList, eventList);
    window.setTimeout(function() {
            triggerEvent("OX_Switch_View","contact_new/business");
        },0); 
}

function callback_new(arg) {
	if(savePending) savePending = false;
	if(arg.error)
	{
		document.getElementById("contactUploadImage").reset();
		newServerError(arg);
	}
	else
	{
		newContactId = arg.data.id;
		if(document.getElementById('image1')) {
            myNewContactFunctions.new_contains_image1 = $("image1").value ? 1 : 0;
            document.getElementById('image1').value = "";
        }
		if (tmp_attachmentDialog.attach_changed()) 
		{
			var obj = new Object();
			obj['attached'] = newContactId;
			obj['module'] = 7; 				
			obj['folder'] = clickedItemForSave;
			tmp_attachmentDialog.do_post(obj,finalFunction);
		} else
			finalFunction();
	}	
}

function callback_update(arg)
{
	if(savePending) savePending = false;
	if(arg.error)
	{
		document.getElementById("contactUploadImage").reset();
		newServerError(arg);
	}
	else
	{
		if(document.getElementById('image1')) {
            myNewContactFunctions.new_contains_image1 = $("image1").value ? 1 : 0;
			document.getElementById('image1').value = "";
        }
		if (tmp_attachmentDialog.attach_changed()) 
		{
			var obj = new Object();
			obj['attached'] = contactDetailId;
			obj['module'] = 7; 				
			obj['folder'] = clickedItemForSave;
			tmp_attachmentDialog.do_post(obj,finalFunction);
		} else
			finalFunction();
	}
}

/********************************** Datepicker *****************************************************************/

function createMiniCalendar(){
	birthdayCalendar = new cMiniCalendar(	$("birthday_header"), 
										$("birthday_container"), 
										setBirthday,
										false,
										"id_birthday",
										$("birthday_header_month"),
										$("birthday_header_year"));
										
	anniversaryCalendar = new cMiniCalendar(	$("anniversary_header"), 
										$("anniversary_container"), 
										setAnniversary,
										false,
										"id_anniversary",
										$("anniversary_header_month"),
										$("anniversary_header_year"));
}

function setBirthday() {
	var tmp = $("contactForm");
	birthdayCalendar.setSelected(this.id);
	tmp.birthday.value = formatDate(birthdayCalendar.selectedTime, "date");
	$("mini_birthday").style.display = "none";
	miniBirthdayVisible = false;
	enableBirthdayAppointment();
}

function showMiniBirthday(){
	var tmp = $("mini_birthday");
	tmp.style.display = "block";
	tmp.left = 0;
	tmp.top = "1.6em";	
}

function toggleMiniBirthday(){
	var tmp = $("mini_birthday");
	tmp.left = 0;
	tmp.top = "1.6em";	
	if(!miniBirthdayVisible){
		if(miniAnniversaryVisible){
			$("mini_anniversary").style.display = "none";
			miniAnniversaryVisible = false;
		}
		var birthday_date = parseDateString($("birthday").value, "date");
		if(birthday_date) {
			birthdayCalendar.setSelectedByDate(birthday_date.getUTCFullYear(),
											birthday_date.getUTCMonth(),
											birthday_date.getUTCDate());
		} else {
			birthdayCalendar.setUnselected();
		}
		tmp.style.display = "block";
		miniBirthdayVisible = true;
	} else {
		tmp.style.display = "none";
		miniBirthdayVisible = false;
	}
}

var bDayObj = new Object();
var bDaySubmit = false;
/**
 * checks if we have all information and enables/disables the create birthday
 * appointment button/image
 */
function enableBirthdayAppointment() {
	var img = getFullImgSrc("img/menu/add_appointment_d.gif");
	var cursor = "default";
	if (parseDateString($("birthday").value, "date") != null
	    && trimStr($("display_name").value).length != 0) {
	   img=getFullImgSrc("img/menu/add_appointment.gif");
	   cursor = "pointer";
	}
	if ($("mini_calender_add_appointment_img").src != img) {
		$("mini_calender_add_appointment_img").src=img;
		$("mini_calender_add_appointment_img").style.cursor=cursor;
	}
}

/**
 * handles the birthday appointment dialog
 */
function createBirthdayAppointment() {
	var bday = parseDateString($("birthday").value, "date");
	if (!bday || bDaySubmit) return;
	bday.setUTCFullYear(new Date().getFullYear());
	bday.setUTCHours(bday.getUTCHours());
    bday.setUTCMinutes(bday.getUTCMinutes());    
	
    var jparam = "?action=new";
	if (bDayObj["id"]) {
		jparam = "?action=update";
		jparam += "&id=" + bDayObj["id"];		
		jparam += "&timestamp=" + bDayObj["timestamp"];		
	}
	jparam+="&folder=" + configGetKey("folder.calendar");

    bDayObj["folder_id"] = configGetKey("folder.calendar");
	bDayObj["start_date"] = Date.UTC(bday.getUTCFullYear(), bday.getUTCMonth(), bday.getUTCDate(), 0, 0, 0);
	bDayObj["end_date"] = Date.UTC(bday.getUTCFullYear(), bday.getUTCMonth(), bday.getUTCDate(), 0, 0, 0);
	//#. New contact window: Used to create a pre-filled title at the new birthday appointment dialog  
	//#. %s will be replaced with the display name of the contact
	bDayObj["title"] = format(_("Birthday of %s."), $("display_name").value);
	bDayObj["full_time"] = true;
	if (bDayObj["private_flag"] == undefined) bDayObj["private_flag"] = true;
	bDayObj["shown_as"] = 4;
	bDayObj["alarm"] = 1440;
	bDayObj["recurrence_type"] = 4;
	bDayObj["day_in_month"] = bday.getDate();
	bDayObj["month"] = bday.getMonth();
	bDayObj["interval"] = 1;
	
	var ap_titleInp = newnode("input", { width:"75%" }, { type:"text", value:bDayObj["title"] });
	var ap_privCbk  = newnode("input", { paddingRight:"15px" }, { type:"checkbox", checked:bDayObj["private_flag"], className:"noborder" });
		
	var myDiv = newnode("div", { lineHeight:"1.8em", verticalAlign:"middle" }, null,
           [ newnode("span", null, null, [ 
                    document.createTextNode(_("Would you like to create the following birthday series appointment?"))]),
             newnode("div", { width:"98%"  }, null, [ 
                    newnode("span", { paddingRight:"15px" }, null, [ document.createTextNode(pgettext("description", "Title:")) ]),
                    ap_titleInp]), 
             newnode("div", { width:"98%" }, null, [ ap_privCbk, 
                    newnode("span", { paddingLeft:"10px" }, null, [ document.createTextNode(_("Private appointment")) ])
                    ])           
           ]);
	
	function cb_Ok() {
		bDayObj["title"] = ap_titleInp.value;
		bDayObj["private_flag"] = ap_privCbk.checked;
	    bDaySubmit = true;
	    new JSON().put(AjaxRoot + "/calendar" + jparam + "&session=" + session, bDayObj, null, function(cb) {     
	        if (cb.data && !cb.error) {
	            var resp = _("Birthday appointment has been created."); /*i18n*/
	            if (bDayObj["id"])
	                 resp = _("Birthday appointment has been changed."); /*i18n*/
	            bDayObj["id"]=cb.data.id;
	            bDayObj["timestamp"]=cb.timestamp;
	            triggerEvent("OX_New_Info",4,resp);         
	        }
	        bDaySubmit = false;
	    }); 
	}
	
	newConfirm(_("Birthday Appointment") /*i18n*/, null, AlertPopup.OKCANCEL, 
	       cb_Ok, function() { return; }, null, null, null, null, null, 
	       null, null, myDiv);

	if (IE6) setTimeout(function() { ap_privCbk.checked=bDayObj["private_flag"]; }, 0);
	
}

function setAnniversary(){
	var tmp = $("contactForm");
	anniversaryCalendar.setSelected(this.id);

	tmp.anniversary.value = formatDate(anniversaryCalendar.selectedTime, "date");
	$("mini_anniversary").style.display = "none";
	miniAnniversaryVisible = false;
}

function showMiniAnniversary(){
	var tmp = $("mini_anniversary");
	tmp.style.display = "block";
	tmp.left = 0;
	tmp.top = "1.6em";	
}

function toggleMiniAnniversary(){
	var tmp = $("mini_anniversary");
	tmp.left = 0;
	tmp.top = "1.6em";	
	if(!miniAnniversaryVisible){
		if(miniBirthdayVisible){
			$("mini_birthday").style.display = "none";
			miniBirthdayVisible = false;
		}
		var anniversary_date = parseDateString($("anniversary").value, "date");
		if(anniversary_date) {
			anniversaryCalendar.setSelectedByDate(anniversary_date.getUTCFullYear(),
											anniversary_date.getUTCMonth(),
											anniversary_date.getUTCDate());
		} else {
			anniversaryCalendar.setUnselected();
		}
		tmp.style.display = "block";
		miniAnniversaryVisible = true;
	} else {
		tmp.style.display = "none";
		miniAnniversaryVisible = false;
	}
}

var autofillmatch = true;
function autofillDN() {
	var dn = $("display_name");
	var ln = $("last_name").value;
	var fn = $("first_name").value;
	if (dn.value == "" || autofillmatch) {
		dn.value = ln + (fn && ln ? ", " : "") + fn;
		editContact(dn);
	}
}


/********************************** Save Contact *****************************************************************/
/**
 * triggerEvent -> save Button
 * switch: new, edit, dublicate, newmember
 */
function saveContact()
{
	if(savePending) return;
	else savePending = true;
	
	if(modulPopup == "new" || modulPopup == "duplicate") {
		writeNewContact();
	} else if(modulPopup == "edit") {
        /********************************** update Contact ********************************************************/	
		var ct = $("contactForm");
		//check if Birthday changed
		if(!checkDateFormat("birthday") || !checkDateFormat("anniversary")) {
			savePending = false;
			return;
		}
			
		var birthdayData = $("birthday").value;
		if(birthdayData != "" || typeof dataFromDb.data.birthday != "undefined") 
		{
			state = compareDate(birthdayData, dataFromDb.data.birthday, "birthday");
			if(state[0] == "save") {
				contact_object.birthday = dateAction[1];				
			} 
			else if(state[0] == "clear") {
				contact_object.birthday = "";
			}
		}
		
		//check if anniversary changed
		anniversaryData = $("anniversary").value;
		if(anniversaryData != "" || typeof dataFromDb.data.anniversary != "undefined") {
			stateAnn = compareDate(anniversaryData, dataFromDb.data.anniversary, "anniversary");
			
			if(stateAnn[0] == "save") {
				contact_object.anniversary = dateAction[1];
			} 
			else if(stateAnn[0] == "clear") {
					contact_object.anniversary = "";
			}
		}
		
		for (i=0; i<ct.elements.length; i++) {
			if(ct.elements[i].value != "" && ct.elements[i].name != "")	{
				if(ct.elements[i].name != "anniversary" && ct.elements[i].name != "birthday" && ct.elements[i].name.indexOf("newcontact_") == -1)
					contact_object[ct.elements[i].name] = ct.elements[i].value;
			}				
		}
				
		if(activefolderLocal != clickedItemForSave) {
			contact_object.folder_id = clickedItemForSave;
		}
		
		if($('newcontact_personal').checked && ($("newcontact_personal_tr").style.visibility == "visible" || $("newcontact_personal_tr").style.visibility == "")) 
		{
			contact_object.private_flag = true;
		} else {
			contact_object.private_flag = false;
		}
		
		checkModified(dataFromDb.data, contact_object)
		
		if($("image1").value != "" || myNewContactFunctions.deleteImageOnServer) {
				with 	($('contactUploadImage')) 
				{					
						action = AjaxRoot + "/contacts?action=update&session=" + session + "&id="+contactDetailId+"&folder="+activefolderLocal+"&timestamp="+lastTimestamp+ "&time=" + new Date().getTime();		
						json.value = JSON.serialize(contact_object);		
						submit();
				}
			}
		else {
			json.put(AjaxRoot + "/contacts?action=update&session=" + session + "&id="+contactDetailId+"&folder="+activefolderLocal+"&timestamp="+lastTimestamp, 
				contact_object, 
				null, 
				function(updatedFields)
				{	
					if(updatedFields) {
						if(updatedFields.error) {
							//error
						} else {

							if (tmp_attachmentDialog.attach_changed()) 
							{
								var obj = new Object();
								obj['attached'] = contactDetailId;
								obj['module'] = 7; 				
								obj['folder'] = clickedItemForSave;
								tmp_attachmentDialog.do_post(obj,finalFunction);
							}
							else {
								finalFunction();
							}
						}
					}
				}
			);
		}
		
	}
}


/*
 * use the global function to get a Date Object
 * returns the long from this dateobject
 * */

function formatDateToUTC(formDate) {
	var longTime = parseDateString(formDate);
	if(longTime == null)
		return longTime
	else
		return longTime.getTime();
}


/**
 * Help function for compare two Dates in m/d/y 
 * @param {string} Date in m/d/y  
 * @param {string} Date in m/d/y  
 * @param {string} name of the field  
 */
function compareDate(formDate, dbDate, labelDate)
{
	dateAction[0] = "";
	dateAction[1] = "";
	
	if(formDate != "") {
		
		var UTCformated = formatDateToUTC(formDate);
		if (UTCformated == 0) UTCformated = 1; // 0 -> fix for 01.01.1970
		dateAction[1] = UTCformated;	
		if(!UTCformated || UTCformated == "") { 
			dateAction[0] = "error";
		}
		else if(UTCformated != dbDate) {
			dateAction[0] = "save";
		} 
		else if(contact_object[labelDate]) {
			dateAction[0] = "save";
		}
	} 
	else if(dbDate != "") {
		dateAction[0] = "clear";
	}
	return dateAction;
}

/********************************** Contact Obj for Update *****************************************************************/
/**
 * If Modus is 'edit', the json objekt (contact_object) will be created for Update DB, whith changed fields
 */
var myKeyTimeout = null;
function editContact(field) {	
	if(myKeyTimeout) {
		clearTimeout(myKeyTimeout);
	}
	myKeyTimeout = setTimeout(
		function() {
			switch(modulPopup) {
			
				case "edit" 		:		if(dataFromDb && document.getElementsByName(field.name)[0] && document.getElementsByName(field.name)[0].value != dataFromDb.data[field.name]) {	
												contact_object[field.name] = document.getElementsByName(field.name)[0].value || "";
												setBeforeUnload(true);
											}
											break;
							
				case "duplicate" 	:		if(dataFromDb && document.getElementsByName(field.name)[0] && document.getElementsByName(field.name)[0].value != dataFromDb.data[field.name]) {	
												setBeforeUnload(true);
											}
											break;
											
				case "new" 	:		if(document.getElementsByName(field.name)[0] && document.getElementsByName(field.name)[0].value != "") {	
												setBeforeUnload(true);
											}
											break;
				
			}
		},200
	)
}

function checkDateFormat(field) {
	var valueDate = $(field).value;
	if(valueDate != "") {
		var checkedDate = formatDateToUTC(valueDate);
		if((!checkedDate || checkedDate == "") && checkedDate != 0) { // !=0 -> fix for 01.01.1970
			triggerEvent("OX_New_Error", 4, _("Invalid date format. The valid format is dd.mm.yyyy"));		
			$(field).className = $(field).className + "borderColorError"; 
			return checkedDate;
		} else {
			$(field).className = $(field).className + "border-color-default";
			return true;
		}
	} else {
		$(field).className = $(field).className + "border-color-default";
		return true;
	}
}

/********************************** set var Module *****************************************************************/
/**
 * Init Popup for setting the Modul
 * @param {String} parameters from the url 
 */
function setModulPopup(params) {
	/////////
	// Modul New
	// do nothing
	if (url["modul"] && url["modul"] == "new") {
		if (url['folder'] && url['folder'] != ""){
			clickedItemForSave = url['folder'];
		} else {
			clickedItemForSave = configGetKey("folder.contacts");
		}
		if (url["email1"]) {
			document.getElementsByName("email1")[0].value=url["email1"]
		}
		if (url["last_name"]) {
            document.getElementsByName("last_name")[0].value=url["last_name"]
        }
        if (url["first_name"]) {
            document.getElementsByName("first_name")[0].value=url["first_name"]
        }
		if (url["display_name"]) {
            document.getElementsByName("display_name")[0].value=url["display_name"]
        }
        autofillDN();
        
        // disable loading screen
        $("loading_data_bg").style.display="none";
	}
	/////////
	// Modul Edit or Duplicate
	if(url['modul'] && url['modul'] == "edit") 	{
			modulPopup = "edit";
			contactDetailId = url['id'];
			clickedItemForSave= url['folder'];
			activefolder = url['folder'];
			session = url['session'];
			currentView = url['currentView'];
			fillFieldById();		
		} 
	else if(url['modul'] && url['modul'] == "duplicate") {
			modulPopup = "duplicate";
			clickedItemForSave= url['folder'];
			contactDetailId = url['id'];
			activefolder = url['folder'];
			session = url['session'];
			currentView = url['currentView'];
			fillFieldById();		
	}
	
}

/********************************** get ContactById *****************************************************************/

/**
 * fill the Fields which comes from DB 
 * id is a Param in the url, see {@link setModulPopup}
 */
function fillFieldById()
{
	new JSON().get(AjaxRoot + "/contacts?action=get&session=" + session +"&id="+contactDetailId+"&folder="+clickedItemForSave+"&"
		,
		null,
			function(reply) {
				dataFromDb = reply;
				for (field in reply.data) {													
					if(document.getElementsByName(field)[0] && reply.data[field] != "") {								
						document.getElementsByName(field)[0].value = reply.data[field];
					}
					//$('newcontact_distr_list').disabled = true;
					
					if(field=="birthday")
					{
						$("birthday").value = formatDate(reply.data[field],"date");								
					}
					if(field=="anniversary")
					{
						$("anniversary").value = formatDate(reply.data[field],"date");
					}
					
					if(field=="number_of_attachments")
					{
						if(url['modul'] == "duplicate")
							setContactsNewNumberOfAtt(0);
						else
							setContactsNewNumberOfAtt(reply.data.number_of_attachments);
					}
					
					if(field=="private_flag" && reply.data[field] == true) {
						$("newcontact_personal").checked = "checked";					
					}
					
					if(field=="disribution_list")
					{
						if(reply.data[field] && reply.data[field].length > 0) {
							
							if(myDistrListAdressBook) {
								
								myDistrListAdressBook.findContactForDistrList 		= {};
								myDistrListAdressBook.findContactForDistrList.data 	= new Array();
								
								for(i=0; i<reply.data[field].length;i++){
									
									myDistrListAdressBook.findContactForDistrList.data[i] 	= new Array();
									
									myDistrListAdressBook.findContactForDistrList.data[i][0] =
																		reply.data[field][i].id; //ID
																		
									myDistrListAdressBook.tmpIdsForSave[i] = 
																		reply.data[field][i].id; //ID
															
									myDistrListAdressBook.findContactForDistrList.data[i][1] =
																		reply.data[field][i].display_name; //DISPLAYNAME
																																			
									myDistrListAdressBook.findContactForDistrList.data[i][2] =
																		reply.data[field][i].mail; //Mail
								}		
							}									
						}										
					}
					/* if an image is existing */
					if(field == "contains_image1" && reply.data[field] > 0 && url['modul'] != "duplicate") {
						myNewContactFunctions.imageExist = true;
						removeChildNodes($('imageContactTd'));
							$('imageContactTd').appendChild(newnode("img", 0, {src: reply.data.image1_url, alt: ""}));
					}
				}
				lastTimestamp = reply.timestamp;
				
				try {
					// dn autofill: check if the dn still matches						
					var fn = reply.data.first_name || "";
					var ln = reply.data.last_name || "";
					var dn = reply.data.display_name || "";
					autofillmatch = (dn == (ln + (fn && ln ? ", " : "") + fn));
				} catch (e) { }
				
				// disable loading screen
                $("loading_data_bg").style.display="none";
			}
		); 		
}
function setContactsNewNumberOfAtt(nNumAttParam) {
	$('contact_number_of_attachments').firstChild.nodeValue = nNumAttParam;
}

/**
 * Validation email
 * @param {string} email for validation
 * @return {boolean} true if is valid
 */
function checkEmailAdr(feld) {
	var supported = 0;
	if (window.RegExp) {
		var tempStr = "a";
		var tempReg = new RegExp(tempStr);
		if (tempReg.test(tempStr)) supported = 1;
	}
	if (!supported)
		return (feld.indexOf(".") > 2) && (feld.indexOf("@") > 0);
		
		var r1 = new RegExp("(@.*@)|(\\.\\.)|(@\\.)|(^\\.)");
		var r2 = new RegExp("^.+\\@(\\[?)[a-zA-Z0-9\\-\\.]+\\.([a-zA-Z]{2,4}|[0-9]{1,3})(\\]?)$");
		return (!r1.test(feld) && r2.test(feld));
}

/********************************** Write new Contact *****************************************************************/
/**
 * Write all filled fields in DB
 * json.put -> contact_object
 */
 
function writeNewContact()
{
	var ct = $("contactForm");	
	contact_object = {};
	//Convert Date to UTC
	var datepart = "";
	
	var birthdayData = $("birthday").value;
	
	var birthdayUTC = "";
	
	if(birthdayData != "") {
		birthdayUTC = formatDateToUTC(birthdayData);
		if(!birthdayUTC || birthdayUTC != "") {
			contact_object.birthday = birthdayUTC;
		}		
	}
	
	var anniversaryData = $("anniversary").value;
	var anniversaryUTC = "";
	if(anniversaryData != "") 
	{
		anniversaryUTC = formatDateToUTC(anniversaryData);
		
		if(!anniversaryUTC || anniversaryUTC != "") {
			contact_object.anniversary = anniversaryUTC;
		}		
	}
	
	var privatEmailData = ct.email1.value;
		
	for (i=0; i<ct.elements.length; i++) {
		if(ct.elements[i].value != "" && ct.elements[i].name != "")	{
			if(ct.elements[i].name != "anniversary" && ct.elements[i].name != "birthday" && ct.elements[i].name.indexOf("newcontact_") == -1)
				contact_object[ct.elements[i].name] = ct.elements[i].value;
		}				
	}
	contact_object.folder_id = activefolderLocal;

	if(activefolderLocal != clickedItemForSave) {
		contact_object.folder_id = clickedItemForSave;
	}
	
	if($('newcontact_personal').checked && ($("newcontact_personal_tr").style.visibility == "visible" || $("newcontact_personal_tr").style.visibility == "")) {
		contact_object.private_flag = true;
	} else {
		contact_object.private_flag = false;
	}
	
	if(document.getElementById("image1").value != "") {	
		with (document.getElementById('contactUploadImage')) {					
			action = AjaxRoot + "/contacts?action=new&session=" + session + "&folder="+clickedItemForSave+"&timestamp="+lastTimestamp;		
			json.value = JSON.serialize(contact_object);		
			submit();
		}				
	} else {
		json.put(AjaxRoot + "/contacts?action=new&session=" + session +"&folder="+clickedItemForSave+ "&" , contact_object, null, 
		function(idObj){
			if(idObj) {	
				newContactId = idObj.data.id;
				if (tmp_attachmentDialog.attach_changed()) {
					var obj = new Object();
					obj['attached'] = idObj.data.id;
					obj['module'] = 7; 				
					obj['folder'] = clickedItemForSave;
					tmp_attachmentDialog.do_post(obj,finalFunction);
				} else finalFunction();
			}
		});
	}

}


function finalFunction(myObject)
{	
    if ("new_contains_image1" in myNewContactFunctions) {
        contact_object.contains_image1 =
            myNewContactFunctions.new_contains_image1;
    }
    if (tmp_attachmentDialog.attach_changed()) {
        contact_object.number_of_attachments =
            tmp_attachmentDialog.file_storage.ids.length;
    }
	if(modulPopup == "new" || modulPopup == "duplicate") {
       setBeforeUnload(false);
       corewindow.OXContactMapping.createObject(contact_object);
       corewindow.closeContactPopUp(window, clickedItemForSave);
    } else if(modulPopup = "edit") {
       setBeforeUnload(false);
       corewindow.OXContactMapping.editObjects([dataFromDb.data],contact_object);
       corewindow.closeContactPopUp(window, clickedItemForSave);
    }
	
}

/********************************** Tabs *****************************************************************/
register("OX_Contact_New_Switch",function(param) { menuswitchContactNew(param) });
/**
 * global vars for new Contact
 */
var tabsList   =	new Array('tabContact1','tabContact2', 'tabContact3', 'tabContact4', 'tabContact5', 'tabContact6' );
var panelsList = 	new Array('panelContact1','panelContact2', 'panelContact3', 'panelContact4', 'panelContact5', 'panelContact6' );
//var eventList  =	null;
var eventList =
		new Array(	['OX_Contact_New_Switch','business'],
					['OX_Contact_New_Switch','personal'],
					['OX_Contact_New_Switch','additional'],
					['OX_Contact_New_Switch','distributionlist'],
					['OX_Contact_New_Switch','attachment'],
					['OX_Contact_New_Switch','links']);
									
