/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var infostoreSelection = new Selection2();
var infoSplitTabsList;
var infoSplitPanelsList;
var infoSplitEventList;
var oLastSelectedInfoObject = -1;
var propertiesPopUp;
var bLoadedDetailViewOverView = false;
var aPrintDetailInfoStore;
var infostoreFolderPath;

registerPrintView("infostore/list");
registerPrintView("infostore/split/overview");
registerModule("infostore", "InfoStore",60); /*i18n*/
registerModuleView("infostore","InfoStore",5,{x:0,y:1,ww:1,hw:1});

register("Loaded", function() {	
	infostoreFolderPath = new FolderPath("infostore");
    register("OX_Switch_InfoStore_Detail",function(param) { menuswitchInfoStoreDetail(param) }); 
	infoSplitTabsList = new Array('tab_infodetail1','tab_infodetail2','tab_infodetail3');
    infoSplitPanelsList = new Array('panel_infodetail1','panel_infodetail2','panel_infodetail3');
    infoSplitEventList = new Array(
            ['OX_Switch_InfoStore_Detail','overview'],
            ['OX_Switch_InfoStore_Detail','version'],               
            ['OX_Switch_InfoStore_Detail','links']
    );
	
    registerContext($("arrowForInfostoreListOptions"),"infostoreOptions",null,null,null,"click");
    registerContext($("arrowForInfostoreSplitOptions"),"infostoreOptions",null,null,null,"click");    
    
    addContextNode(contextmenu_createImgDiv("Options",/*i18n*/
        getFullImgSrc("img/folder/settings.gif"), getFullImgSrc("img/folder/settings.gif")), ["infostoreOptions"],
        function() { 
            var elem=currentpath2.join("/");
            if(elem.indexOf("infostore") == 0) {
                triggerEvent("OX_Switch_View", "configuration/infostore/preferences");
            }   
        },null,null,contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
});

registerView("infostore",
        null,
        null,       
        function() {
            triggerEvent("Selected",[]);        
        }, 
        function() {
            if (infostoreRequest) {
                OXCache.unregister(infostoreRequest.uniqueName);
                infostoreRequest=null;
            }
            menuclearSearch();
        },
        null        
);

registerView("infostore/list",
        function() { 
			showNode("infostore_list"); 
			$("infostore_list").style.display=""; 
		}, 
		function() { 
			loadLiveGridInfo();
			infostoreFolderPath.drawDOMNode("infostoreListHeaderOwner", activefolder);
			if (gridInfoList) {				
				infostore_setFocus(gridInfoList);
			}
			
			register('OX_InfoStore_Delete', deleteItems);
            register('OX_InfoStore_Edit', editItem);
            register('OX_InfoStore_Lock', lockItem);
            register('OX_InfoStore_Unlock', lockItem);
			register('OX_Add_Flag',setTagInfoStore);			
			register("OX_New_Search",searchInfoItem);
			register("OX_Delete_Search",deleteSearchInfoItem);			
			register("OX_Print",infostore_print);
			register("OX_InfoStore_Send_Attachment",infostore_sendAttachment);
			register("OX_InfoStore_Send_Link",infostore_sendLink);
			register("OX_InfoStore_Open_Attachment",openFileinInfoStore);
        }, 
        function() {
			unLoadLiveGridInfoList();
			menuclearSearch();
			infostoreFolderPath.clear();
			unregister('OX_InfoStore_Delete', deleteItems);
            unregister('OX_InfoStore_Edit', editItem);
            unregister('OX_InfoStore_Lock', lockItem);
            unregister('OX_InfoStore_Unlock', lockItem);
			unregister('OX_Add_Flag',setTagInfoStore);		
			unregister("OX_New_Search",searchInfoItem); 
			unregister("OX_Delete_Search",deleteSearchInfoItem);									
			unregister("OX_Print",infostore_print);	
			unregister("OX_InfoStore_Send_Attachment",infostore_sendAttachment);
			unregister("OX_InfoStore_Send_Link",infostore_sendLink);
			unregister("OX_InfoStore_Open_Attachment",openFileinInfoStore);
        },
        function() {
			hideNode("infostore_list"); 
			$("infostore_list").style.display="none";
		},
        function(changedFolder) {
        	if (changedFolder != undefined) {
        		 menuclearSearch();
        		 loadLiveGridInfo();
                 infostoreFolderPath.drawDOMNode("infostoreListHeaderOwner", activefolder);
        		 if (gridInfoList) {
        		    infostore_setFocus(gridInfoList); 				    
        		 }
        	}	
        }
);

registerView("infostore/split",
        function() { 
            showNode("infostore_split"); 
            $("infostore_split").style.display=""; }, 
        function() {
            loadLiveGridInfoSplit();                      
            setTabLists(infoSplitTabsList, infoSplitPanelsList, infoSplitEventList);
            infostoreFolderPath.drawDOMNode("infostoreHsplitHeaderOwner", activefolder); 
            if (gridInfoSplit) {            	
                infostore_setFocus(gridInfoSplit);
            }           

            // re-select id, if it's a direct link for example
            if (oLastSelectedInfoObject.length && oLastSelectedInfoObject[0].directLink &&
                oLastSelectedInfoObject[0].id) {
                delete(oLastSelectedInfoObject[0].directLink);
                gridInfoSplit.selection.selectIDs([ Key.createfromObject(oLastSelectedInfoObject[0]) ])                    
            }
            expandInfostoreSplitHeader(configGetKey("gui.infostore.fullsplitheader"));
            
            register('OX_InfoStore_Delete', deleteItems);
            register('OX_InfoStore_Edit', editItem);
            register('OX_InfoStore_Lock', lockItem);
            register('OX_InfoStore_Unlock', lockItem);  
            register('OX_Add_Flag', setTagInfoStore);
            register("OX_New_Search", searchInfoItem);
            register("OX_Delete_Search", deleteSearchInfoItem); 
            register("OX_Print",infostore_print);     
            register("OX_InfoStore_Send_Attachment", infostore_sendAttachment);
            register("OX_InfoStore_Send_Link", infostore_sendLink);
            register("OX_InfoStore_Open_Attachment", openFileinInfoStore);  
        }, 
        function() {
            if (infostoreRequest) {
                OXCache.unregister(infostoreRequest.uniqueName);
                infostoreRequest=null;
            }
            if (bInfoSplitLoaded) { 
		        gridInfoSplit.disable();
		        bInfoSplitLoaded = false;
		    }
            menuclearSearch();
            infostoreFolderPath.clear();
            unregister('OX_InfoStore_Delete', deleteItems);
            unregister('OX_InfoStore_Edit', editItem);
            unregister('OX_InfoStore_Lock', lockItem);
            unregister('OX_InfoStore_Unlock', lockItem); 
            unregister('OX_Add_Flag', setTagInfoStore);
            unregister("OX_New_Search", searchInfoItem);
            unregister("OX_Delete_Search", deleteSearchInfoItem);
            unregister("OX_Print",infostore_print);
            unregister("OX_InfoStore_Send_Attachment", infostore_sendAttachment);
            unregister("OX_InfoStore_Send_Link", infostore_sendLink);
            unregister("OX_InfoStore_Open_Attachment", openFileinInfoStore);
        },
        function() {
            hideNode("infostore_split"); 
            $("infostore_split").style.display="none";
        },
        function(changeFolder) {  	
        	if (changeFolder != undefined) {
        		menuclearSearch();
        		loadLiveGridInfoSplit();
                infostoreFolderPath.drawDOMNode("infostoreHsplitHeaderOwner", activefolder);
        		if (gridInfoSplit) {
                    infostore_setFocus(gridInfoSplit);                    
                }                
        	}   
        }
);
  
registerView("infostore/split/overview",
        function() {
            $("tab_infodetail1").style.display="block";
            $("panel_infodetail1").className="tabbing_tab_active";
        }, 
        null,
        null,
        function() {    
            $("tab_infodetail1").style.display="none";
            $("panel_infodetail1").className="tabbing_tab_inactive";
        }
);

registerView("infostore/split/version",
		function() {
			$("tab_infodetail2").style.display="block";
			$("panel_infodetail2").className="tabbing_tab_active";
		}, 
		function() { 
			function clickVersionInformation() {				
				if(gridVersionsInfoSplit && gridVersionsInfoSplit.selection && gridVersionsInfoSplit.selection.count == 1)			
					gridVersionsInfoSplit.selection.click(gridVersionsInfoSplit.selection.anchor);	
			}
			loadDetailDocumentVersions("version", clickVersionInformation);
			if (bDetailVersionLoaded) {
				getVersions();
			}				
			register('OX_InfoStore_Version_Delete', deleteDetailVersion);
			register('OX_InfoStore_Version_Current', setCurrentVersion);	
			register('OX_Refresh', getVersions);				
		},
		function() {
			if (bDetailVersionLoaded) {   
                gridVersionsInfoSplit.disable();
                bDetailVersionLoaded = false;
            }
			unregister('OX_InfoStore_Version_Delete', deleteDetailVersion);
			unregister('OX_InfoStore_Version_Current', setCurrentVersion);		
			unregister('OX_Refresh', getVersions);							
		},
		function() {
			$("tab_infodetail2").style.display="none";
			$("panel_infodetail2").className="tabbing_tab_inactive";
		}
);
	
registerView("infostore/split/links",
		function() {
			$("tab_infodetail3").style.display="block";
			$("panel_infodetail3").className="tabbing_tab_active";			
		}, 
		function() {
			if (infostoreLinkingObject) {
			    infostoreLinkingObject.enableLinkingLivegrid();
			}
			register("OX_Link_deleted",reloadInfoStoretDetailView);
		},
		function() {
			if (infostoreLinkingObject) {
				infostoreLinkingObject.disableLinkingLivegrid();
			}
			unregister("OX_Link_deleted",reloadInfoStoretDetailView);
		},
		function() {
			$("tab_infodetail3").style.display="none";
			$("panel_infodetail3").className="tabbing_tab_inactive";			
		}
);

function infostore_setFocus(grid) {
    if (grid && grid.collection && infostoreSelection.count.length) {
        var index = grid.collection.getIndex(infostoreSelection.getSelected()[0]);
        grid.focus = index ? index-1 : 0;
        grid.showFocus();
    }
}
	
function openFileinInfoStore(objects) {     
    for(var i in objects) { 
        var sContentType = 'application/octet-stream';
        var sURL = AjaxRoot + "/infostore/" + encodeURIComponent(objects[i].filename) 
                    + "?action=document&session=" + session
                    + '&content_type=' + encodeURIComponent(sContentType)
                    + '&id=' + encodeURIComponent(objects[i].id);
        newWindow(sURL, getWindowOptions());
    }
}

function jumpToInfoStoreConfiguration(divId) {
	if(divId && $(divId))
		$(divId).style.display = 'none';
	triggerEvent("OX_Switch_View","configuration/infostore/preferences");
}

function infostore_sendLink(obj) {
	function cb_openWindow(arg) {
		var editorEnabled = (!configGetKey("gui.mail.formatmessage").match(/text\/plain/i));
		var oInfoMailObj = new Object();	
		var content = "";
		for (var indx=0;indx < arg.length;indx++) {
			var obj = arg[indx].data;
			oMainFolderTree.get_folder_path(obj.folder_id || obj.folder, function(fName) { 
				var dLink = getDirectLinkLocal(obj);
				if (!obj.id) {
					dLink = dLink.replace(/[#&]i=([^#&]+)/, "");
				}
				if (obj.title) {
				    content += pgettext("description", "Title") + ": " + obj.title + "<br/>";	
				}				
				content += _("Folder") + ": " + fName + "<br/>";
                content += _("Direct link") + ": " + (editorEnabled ? "<a href=\""+dLink+"\">"+dLink+"</a>" : dLink) + "<br/>";
                if (indx < arg.length) content += "<br/>";
			});		
		}
		oInfoMailObj["content"] = content;
		oInfoMailObj["content_type"] = "text/plain";
		var newMail = newWindow("newMail.html", getWindowOptions());

		if (newMail) {
			newMail.window.aInfoMailAttachmentLink = new Array(oInfoMailObj);
		}
	}
	if (obj) {
		cb_openWindow(obj);
	} else { 
		doAjaxGetInfoItemMulti(oLastSelectedInfoObject,cb_openWindow);
	}
}

function infostore_sendAttachment(bSendAsLink) {	
	function cb_openWindow(arg) {	
		var aInfoMailObj = new Array();
		var hasLink = false;
		for(var indx=0;indx < arg.length;indx++) {
			var obj = arg[indx].data;
			if (obj.file_size <= 0) {
				hasLink=true;
			}
			var oInfoMailObj = new Object();
			oInfoMailObj["filename"] = obj.filename;			
			oInfoMailObj["size"]= obj.file_size;		
			oInfoMailObj["content_type"]= obj.file_mimetype;			
			oInfoMailObj["content"]= null;
			oInfoMailObj["disk"]= null;
			oInfoMailObj["id"] = obj.id;
			oInfoMailObj["selected"] = false;
			oInfoMailObj["msgref"] = null;
			oInfoMailObj["infostore"] = true;
			oInfoMailObj["aslink"] = (bSendAsLink!=undefined && bSendAsLink);	
			aInfoMailObj.push(oInfoMailObj);
		}
		
		function cbyes() {
			var newMail = newWindow("newMail.html", getWindowOptions());
			if (newMail) {
			    newMail.window.aInfoMailAttachmentFile = aInfoMailObj;
			}
		}
		
		if (hasLink) {
			newConfirm(_("Send Attachment"),
				_("This object does not contain a file, would you like to send link?"),
				AlertPopup.YESNO,null,null, function() { infostore_sendLink(arg) },
				null);
		} else {
			cbyes();
		}
	}
	doAjaxGetInfoItemMulti(oLastSelectedInfoObject,cb_openWindow);
}

function doAjaxGetInfoItemMulti(aItems, callback) {
	var aRequestes = new Array();
	for (var nindx=0;nindx<aItems.length;nindx++) {
		var oReqObj = new Object();
		oReqObj["module"] = "infostore";
		oReqObj["action"] = "get";
		oReqObj["folder"] = aItems[nindx].folder;
		oReqObj["id"] = aItems[nindx].id;		
		aRequestes.push(oReqObj);
	}
	var multJSON = new JSON();
	multJSON.put(AjaxRoot + "/multiple?session=" + session,aRequestes,null,callback);
}

function reloadInfoStoretDetailView() {
	/* when deleting a link */
	if (infostoreLinkingObject) {		
		infostoreLinkingObject.getStorage();
		infostoreLinkingObject.disableLinkingLivegrid();
	}
	triggerEvent("OX_Switch_View", "infostore/split/overview");
}

function infostore_print() {	
    if (!infostoreSelection || activemodule != "infostore") {
        return;
        
    } else if (infostoreSelection.count > 1) {    	
        if (currentpath2[1] == "split" && gridInfoSplit) {
            globalprint.printLiveGrid(gridInfoSplit)
        } else if (gridInfoList) {
            globalprint.printLiveGrid(gridInfoList);
        }
        
    } else {
    	if (!aPrintDetailInfoStore) return;
        
        /* detail print */
        var aPrintData = new Array();
        var detailInfoPrint = new Print(aPrintDetailInfoStore.title);
        
        aPrintData.push(Print.createTitle(aPrintDetailInfoStore.title || ""));
        aPrintData.push(Print.createLine("5px"));
        aPrintData.push(Print.createEmpty(true));
        
        if (aPrintDetailInfoStore.filename && aPrintDetailInfoStore.filename.length > 0) {
            aPrintData.push(Print.createContent(_("Document:"), aPrintDetailInfoStore.filename));
        }
        
        if (aPrintDetailInfoStore.created_by) {
	        var aTMPusrArray2 = new Array();
	        aTMPusrArray2[0]  = aPrintDetailInfoStore.created_by;
	        internalCache.getUsers(aTMPusrArray2, function (oparam){
	            aPrintData.push(Print.createContent(_("Created By:"), oparam[aTMPusrArray2[0]].display_name));        
	        });
	    }
	    
	    if (aPrintDetailInfoStore.creation_date) {                               
	        aPrintData.push(Print.createContent(_("Created on:"), formatDate(aPrintDetailInfoStore.creation_date, "datetime")));
        }
        
        if (aPrintDetailInfoStore.modified_by) {
	        var aTMPusrArray = new Array();
	        aTMPusrArray[0]  = aPrintDetailInfoStore.modified_by;
	        internalCache.getUsers(aTMPusrArray, function (oparam) {
	            aPrintData.push(Print.createContent(_("Modified By:"), oparam[aTMPusrArray[0]].display_name));     
	        });
	    }
	    
	    if (aPrintDetailInfoStore.last_modified) {                               
	        aPrintData.push(Print.createContent(_("Last modified:"), formatDate(aPrintDetailInfoStore.last_modified, "datetime")));
	    }
        
        aPrintData.push(Print.createEmpty(true));        
	    if (aPrintDetailInfoStore.description) {
	        aPrintData.push(Print.createContent(_("Comment:"), aPrintDetailInfoStore.description));
	    }
        
        detailInfoPrint.printDetail(aPrintData);
    }	
}

function checkLockUnLock(selected) {
	var countlocked    = 0;
	var countunlocked  = 0;	
	var counteditlocked= 0;
	var uid = configGetKey("identifier");

	triggerEvent("OX_Lockable",0,0,0);
	setTimeout(function() {		
		var collection = { objects : selected , columns : ["created_by","modified_by","locked_until"] };
		if (infostoreRequest) {
	        OXCache.unregister(infostoreRequest.uniqueName);
	        infostoreRequest = null;
	    }
		infostoreRequest=OXCache.newRequest(null,"infostore",collection,null,function(daten) {
		     for (var i=0;i<daten.objects.length;i++) {
		         if (daten.objects[i]["locked_until"] != 0) { 
	                if (daten.objects[i]["modified_by"] == uid) {
	                    countunlocked ++;
	                    counteditlocked ++;
	                } else if (daten.objects[i]["created_by"] == uid) {
	                    countunlocked ++;
	                }
	             } else {
                    countlocked++;
	             }
			 }
	         triggerEvent("OX_Lockable", countlocked, countunlocked, counteditlocked);
	    }, false);
	}, 100);
}

function openNewInfoPopup(module,folder) {
	if (module != "infostore")
		return;
		
	if(editInfoItemId != -1)
		propertiesPopUp = newWindow("newInfoItemMain.html#edit_id="+editInfoItemId.id + "&folder="+editInfoItemId.folder_id, getWindowOptions(), editInfoItemId);
	else
		propertiesPopUp = newWindow("newInfoItemMain.html#edit_id=" + -1 + "&folder="+folder, getWindowOptions());	
	
	editInfoItemId = -1;	
	propertiesPopUp.focus();
}

function closeInfoPopUp() {
	propertiesPopUp.close();
}

function callback_error(arg) {
	newServerError(arg);
}

fileloaded();