/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

var refToMain = window.opener.getRefToMainForMailPopup();
var session = window.opener.session;
var config = window.opener.config;
var getPermAsString = refToMain.getPermAsString;
var oMainFolderTree = refToMain.oMainFolderTree;
var isPrintableView = refToMain.isPrintableView;
var registerPrintView = refToMain.registerPrintView;
var OXMailMapping = refToMain.OXMailMapping, OXCache = refToMain.OXCache;
var oSel = -1, nested_msgs = "", detailmessage, propertiesPopUp;
var attachExists=false, mailFetchTimestamp, detailrequest, message = new Object();
var smilies = {
	";-)": "wink.gif",
	";)": "wink.gif",
	":-D": "big_smile.gif",
	":D": "big_smile.gif",
	":-)": "smile.gif",
	":)": "smile.gif",
	":-(": "sad.gif",
	":(": "sad.gif",
	"=(": "sad.gif",
	":|": "neutral.gif",
	":-|": "neutral.gif",
	":/": "hmm.gif",
	":-/": "hmm.gif"
};

var regexps = [];
for (var i in smilies) regexps.push(i.replace(/([$^\\.*+?()[\]{}|])/, "\\$1"));
var regexpstr = "(^| |\\n|<br>)(" + regexps.join("|") + ")";
var regexp = new RegExp(regexpstr, "g");
var sortVsplitHeader;

function replaceSmilies(text) {
	return text.replace(regexp, function(_, space, match) {
		return space + "<img src=\"" + getFullImgSrc("img/smilies/" + smilies[match]) + "\">";
	});
}

function replaceLeadingSpaces(text) {
	return text.replace(/(^|<br>)([ \t]+)|([ \t]{2,}|\t)/g,
		function(_, prefix, m1, m2) {
			var match = (m1 || m2).replace(/\t/g, "        "); // TODO: real tabs
			var retval = new Array((match.length + 3) >> 1);
			retval[0] = prefix || "";
			var max = match.length >> 1;
			for (var i = 1; i <= max; i++) retval[i] = "&nbsp; ";
			if (match.length & 1) retval[retval.length - 1] = "&nbsp;";
			return retval.join("");
		});
}

function getMailDetailObject() {
	var myarray=new Array();
	var myobject=new Object();
	myobject.id=url["id"];
	myobject.folder_id=url["folder"] || url["folder_id"]; 
	return myobject;
}

var menucheckRight=function(right) {
	return refToMain.menuhasRight([getMailDetailObject()],right);	
}

registerPrintView("mail_detail");

//var oNestedMessage = null;
function loadDetailMail() {	
	activemodule="mail_detail";
	initContents("mail_detail");
	initAll();
}

function getRefToMainForMailPopup() {	
	return refToMain || window.opener;
}

function triggerEventInOpener(eventToTrigger) {
	refToMain.triggerEvent(eventToTrigger);
}

function isStdFolder(folder) {
    return (url["folder"] == corewindow.configGetKey("mail.folder." + folder));
}

register("Loaded", initMailDetail);
register("OX_Attachment_Open", function() { openAttachment("OPEN"); });
register("OX_Attachment_Open_Nested", function(){ openNestedMessage() });
register("OX_Attachment_Save", function() { openAttachment("SAVE"); });
register("OX_Attachment_SaveInfoStore", mail_saveAttachmentInDocStore);
register("OX_Add_Flag", setFlagInMailView);
register("OX_Mail_Close", function() {	window.close(); });
register("OX_Cancel_Object", function() {	window.close(); });
register("OX_Mail_Delete", 
		function() {
			deleteMails(url["folder"], 
                    [ OXMailMapping.createKeyFromObject(
                        { module: "mail", 
                          folder_id: url["folder"], 
                          id: url["id"] }) 
                    ]);
		}
	);
register("OX_NEW_MAIL", function(){ newMail(""); });
register("OX_Mail_Reply", function(){ newMail("reply"); });
register("OX_Mail_ReplyAll", function(){ newMail("replyall"); });
register("OX_Mail_Forward", function(){ newMail("forward"); });
register("OX_Mail_Edit_Draft", function(){ newMail("draft"); });
register("OX_Mail_Mark", mail_mark);
register("OX_Mail_Flag", markAsMail);
register("OX_Mail_Spam", markAsSpam);
registerView("mail_detail",
	null,
	function() { 
		register("OX_Print", mail_printDetailMail);
		register("OX_Mail_Show_Source", mail_showMailSource);
		triggerEvent("OX_Selected_Draft", isStdFolder("drafts"));
	}, 
	function () {
		unregister("OX_Print", mail_printDetailMail);
		unregister("OX_Mail_Show_Source", mail_showMailSource);
        triggerEvent("OX_Selected_Draft", false);
	},
	function () {
		menuclearSearchMail();
        triggerEvent("OX_Selected_Draft", false);
	},
	null
);

function mail_saveAttachmentInDocStore() {
	propertiesPopUp = corewindow.newWindow("newInfoItemMain.html#attachmail=" + selAttachment.id + "&edit_id=" + -1
			+ "&filename=" + encodeURIComponent(selAttachment.filename)
			+ "&mailid=" + encodeURIComponent(url["id"])
			+ "&mailfolder=" + encodeURIComponent(url["folder"])
			, getWindowOptions(), 
			{ "folder": encodeURIComponent(message.folder_id), "id": encodeURIComponent(message.id), "attach_id": encodeURIComponent(selAttachment.id) });	
	if (propertiesPopUp) propertiesPopUp.focus();
	corewindow.propertiesPopUp = propertiesPopUp;
}
	
/**
 * Delete messages
 */ 
function deleteMails(folder, ids) {         
    // return if ids is empty or a delete is still in progress
    if (!ids || ids.length == 0) return;
    function cb() {
        if (corewindow.currentpath.join("/").match(/^mail\//) && corewindow.grid) {
            var focusPos = corewindow.grid.focus;
            var obj = corewindow.grid.collection.objects[focusPos];
            if(corewindow.grid.collection.objects.length) {
                corewindow.grid.selection.click(obj ? focusPos : 0);  
            }            
        }
        setTimeout(function() { 
        	window.close(); 
        }, 0);
    }
    if (configGetKey("mail.deletemail") || configGetKey("mail.folder.trash") == url["folder"]) {
        newConfirm(_("Delete E-Mails"),_('Are you sure you want to delete the selected E-Mails?'),AlertPopup.YESNO,null,null,
        function () {
            corewindow.OXMailMapping.deleteObjects(ids,true,cb)
        }, null);
    } else {
        corewindow.OXMailMapping.deleteObjects(ids,false,cb);
    }
}

/**
 * updates the flag image
 * @param - {int} new flag bitmask
 */
function setFlagImage(flagsMessage) {
    var fimg = "unread.gif";
    if (flagsMessage & 2) {
       fimg = "deleted.gif";
    } else if (flagsMessage & 1) {
        fimg = "reply.gif";
    } else if (flagsMessage & 256) {
        fimg = "forward.gif";
    } else if (flagsMessage & 32) {
        fimg = "read.gif";
    }   
    $('mail.detail.pop.detail.mailflag').src = getFullImgSrc("img/mail/" + fimg);
}

function mail_mark() {
	$("menu_mail_flags").style.display="block";
	if(refToMain.menucheckRight("READ")) {
		$("menu_mail_flags_seen").style.display="";
		$("menu_mail_flags_unseen").style.display="";
	} else {
		$("menu_mail_flags_seen").style.display="none";
		$("menu_mail_flags_unseen").style.display="none";
	}
	if(refToMain.menucheckRight("DELETE")) {
		$("menu_mail_flags_delete").style.display="";
		$("menu_mail_flags_undelete").style.display="";
	} else {
		$("menu_mail_flags_delete").style.display="none";
		$("menu_mail_flags_undelete").style.display="none";
	}
	if(refToMain.menucheckRight("WRITE")) {
		$("menu_mail_flags_answer").style.display="";
		$("menu_mail_flags_unanswer").style.display="";
	} else {
		$("menu_mail_flags_answer").style.display="none";
		$("menu_mail_flags_unanswer").style.display="none";
	}
}

/**
 * Marks message as Spam 
 */
function markAsSpam() {
    corewindow.oMailFunctions.markAsSpam({ module: "mail", folder_id: url["folder"], id: url["id"] });
    triggerEvent("OX_Mail_Close");
}

/**
 * Marks message as 'Answered, Read, Deleted, ...' 
 * @param - mailFlag
 */
function markAsMail(mailFlag) {
	OXMailMapping.setMailFlags(mailFlag, [ 
		       OXMailMapping.createKeyFromObject({ 
	       	       module: "mail", folder_id: url["folder"], id: url["id"] 
	           }) 
           ]); 
}

/**
 * Sets message color tag
 * @param - tag
 */
function setFlagInMailView(tag){
    OXMailMapping.setTag(tag, [ 
               OXMailMapping.createKeyFromObject({ 
                   module: "mail", folder_id: url["folder"], id: url["id"] 
               }) 
           ]);
}

/**
 * Open a new message window
 */
function newMail(action) {
	var newMail = corewindow.newWindow("newMail.html#folder=" 
		+ encodeURIComponent(url["folder"])
		+ "&id=" + encodeURIComponent(url["id"])
		+ "&action=" + action, getWindowOptions());
	newMail.focus;
}
	
function initMailDetail() {
	session = refToMain.session;
	
	var themeStyle = corewindow.oxThemeStyle || { name: "Default", path: "default" };
	loadCSSFileForNewWindow("themes/"+themeStyle.path+"/css/global.css");
	loadCSSFileForNewWindow("themes/"+themeStyle.path+"/css/popup.css");
	loadCSSFileForNewWindow("themes/"+themeStyle.path+"/css/bgimages.css");
	
	var detailedMail = new Object();
	detailedMail.id = url["id"];
	detailedMail.folder_id = url["folder"];
	detailedMail.type = url["type"];
	var aObjectMail = new Array(detailedMail);
	
	 setTimeout(function() { 
        triggerEvent("OX_Switch_View","mail_detail");
        initMessageContent(corewindow.loadblockedimages);
        triggerEvent("Selected", aObjectMail); 
    }, 0);
}

var loadBlockedImages = function() {
    initMessageContent(true);
    // corewindow only needs to force upodate if the same 
    // message is still selected
    if (corewindow.mail_lastSelectedId.id == message.id) {
        setTimeout(corewindow.loadBlockedImages,0);
    }
}

function initMessageContent(loadblockedimages) {	
	if ("oNestedMessage" in window && oNestedMessage && oNestedMessage.length) {
		message.id = oNestedMessage[0].id;
		message.folder_id = message.folder_id || url["folder"];
		oNestedMessage[0].folder_id = message.folder_id;
		fillContentsFromJson(oNestedMessage[0], message.folder_id);
	} else {
		message.id = url["id"]
		message.folder_id = url["folder"];
				
		var collection={};
        collection.objects=[OXMailMapping.createKeyFromObject(
	              { module: "mail", 
	                folder_id: message.folder_id, 
	                id: message.id }
              )];
        if(configGetKey("mail.inlineattachments")) {
            if(configGetKey("modules.mail.allowhtmlimages") || loadblockedimages) {
                collection.columns=OXMailMapping.GETHTML;       
            } else {
                collection.columns=OXMailMapping.GETHTMLNOIMAGE;
            }
        } else {
            collection.columns=OXMailMapping.GETPLAIN;
        }
		
		if (detailrequest) { OXCache.unregister(detailrequest.uniqueName); }
		detailrequest = OXCache.newRequest(null,"mail",collection,
		    function(daten) {
                if(daten.objects[0]) {
                    mailFetchTimestamp = daten.timestamp;
                    fillContentsFromJson(daten.objects[0], message.folder_id);
                }           
            },			
	        function(daten) {
	            if(daten.objects[0]) {
	                mailFetchTimestamp = daten.timestamp;
	                fillContentsFromJson(daten.objects[0], message.folder_id);
	            }           
	        });
	}
}

function fillContentsFromJson(message, folder) {
	nested_msgs = "";
	if(message["nested_msgs"] && message["nested_msgs"].length) {
		nested_msgs = message["nested_msgs"];
		attachExists = true;
	}
	detailmessage=new Object();
	detailmessage["whole_message"]=message;
	if(message["from"])
		detailmessage["from"]=refToMain.getAdressString(message["from"], false);
	if(message["to"])  
		detailmessage["to"]=refToMain.getAdressString(message["to"], false);
	if(message["cc"])  
		detailmessage["cc"]=refToMain.getAdressString(message["cc"], false);
	if(message["bcc"])  
		detailmessage["bcc"]=refToMain.getAdressString(message["bcc"], false);
	detailmessage["date"]=message["sent_date"];
	detailmessage["subject"]=message["subject"];
	detailmessage["priority"]=message["priority"];
	detailmessage["color-label"]=message["color_label"];
	
	$("mail.detail.pop.detail.row.organization").style.display="none";
	if (message["headers"] && message["headers"]["Organization"]) {
		$("mail.detail.pop.detail.header.organization").firstChild.data=message["headers"]["Organization"];
		$("mail.detail.pop.detail.row.organization").style.display="";
	}
	
	setAdressHeader("from", message["from"]);
	setAdressHeader("to", message["to"]);
	setAdressHeader("cc", message["cc"]);
	setAdressHeader("bcc", message["bcc"]);
	
	setColor_label(message["color_label"]);
	setSubject(message["subject"]);
	setPriority(message["priority"]);
	setDate(message["received_date"] || message["sent_date"]);
	setMessageText(message);
	msgref = message["msgref"];
	setFlagImage(message["flags"]);
	
	// disable loading screen
    $("loading_data_bg").style.display="none";
}

function setColor_label(colorlabel) {
    $("mail.detail.pop.detail.flag").src = getFullImgSrc("img/menu/tag_"+(colorlabel||0)+".gif");
}

function setHeightOfEmailDiv(oDiv){
    oDiv.style.height = 1.6 + "em"; 
    if (oDiv.scrollHeight > 22) {
        oDiv.style.height = oDiv.clientHeight *2 + "px";
    }
}

function setAdressHeader(fType, address) {
    var oDivEmails = $("mail.detail.pop.detail.header." + fType);
    var rDivEmails = $("mail.detail.pop.detail.row." + fType);
    if (rDivEmails && address && address == "") {
        rDivEmails.style.display ="none";
        oDivEmails.firstChild.nodeValue = "";
    } else if (oDivEmails && address && address != "") {
        removeChildNodes(oDivEmails);
        if (rDivEmails != undefined) rDivEmails.style.display="";
        getAdressStringLinked(oDivEmails, address, false);
    }
    setTimeout(function() { 
        setHeightOfEmailDiv(oDivEmails); 
	}, 0);    
}

function setPriority(priority) {
    if ("mail.detail.pop.detail.header.prority") {
        var divPrio = $("mail.detail.pop.detail.header.prority");
        divPrio.style.display = "";
        if (priority < 3) {
            divPrio.src = getFullImgSrc("img/mail/email_priohigh.gif");      
        } else if (priority > 3) {
            divPrio.src = getFullImgSrc("img/mail/email_priolow.gif");
        } else {
            divPrio.style.display = "none";
        }
    }
}

function setSubject(subject) {
    if (subject)
        $("mail.detail.pop.detail.header.subject").firstChild.nodeValue = subject;  
}

function setDate(date) {
    if (date) {
        date = refToMain.formatDate(date, "datetime");
        $("mail.detail.pop.detail.header.received_date").firstChild.nodeValue = date;   
    }
}

var detailNestedMessage = null;
function setMessageText(message) {
	var mda = $("mail.detail.pop.detail.attachments");
	removeChildNodes(mda);
	
	var cnn = "", mdac = "";
    var attachmentParam=null;
    var newMessageTextType=null;
    var attachments = [];    
    if(message["attachments_plain"] && !configGetKey("mail.inlineattachments")) { 
        attachmentParam=message["attachments_plain"]; 
        newMessageTextType="attachments_plain"; 
    } else if (message["attachments_html"] && configGetKey("mail.inlineattachments")) { 
        attachmentParam=message["attachments_html"]; 
        newMessageTextType="attachments_html"; 
    } else if (message["attachments_html_noimage"] && configGetKey("mail.inlineattachments")) { 
        attachmentParam=message["attachments_html_noimage"]; 
        newMessageTextType="attachments_html_noimage"; 
    } else if (message["attachments"]) {
        attachmentParam=message["attachments"]; 
        newMessageTextType="attachments";     	
    }
    
	for (idfield in attachmentParam) {
		var conArr = attachmentParam[idfield];
		var ct = conArr["content_type"].toLowerCase();
		var con = conArr["content"];
		if (ct.search(/text\//) != -1 && con != null) {
			if (ct.search(/text\/plain/) != -1) {
				var tmpcnn=(configGetKey("mail.emoticons") ? replaceSmilies(con) : con);
				tmpcnn=replaceLeadingSpaces(tmpcnn);
				cnn += "<div class=\"plainTextContent\">" + tmpcnn + "</div>";
			} else { 
				cnn += "<div>" + con + "</div>";
			}			
		} else {	
			if(conArr["filename"]) {
				attachments.push(conArr);
				var aimg = getMimeImage(ct).match(/empty.png/g) ? getFullImgSrc("img/mail/attachment.gif") : getMimeImage(ct);
				attachExists = true;
				var oDOMDiv = newnode("div", 0, { className: "mailDetailAttachmentsCont" },
					[ newnode("img",0,{src: aimg, align: "absmiddle", padding: "3px"}),
					  	newnode("span",0,{className: "nixo"},
					  		[ document.createTextNode(format(_(" %1$s (%2$s); "),
					  			conArr["filename"], bytesToString(conArr["size"]))) ]
					  	)
					]
				);	
				
				addDOMEvent(oDOMDiv, "mousedown", (function(oDOMDiv, selAttach) {
					return function(e) {	
						cancelDefault(e);	
						selectAttachment(oDOMDiv, selAttach);
					};
				})(oDOMDiv, conArr));			
				registerContext(oDOMDiv,"attachment");
														
				addDOMEvent(oDOMDiv, "dblclick", (function(oDOMDiv, selAttach) {
					return function(e) {
						stopEvent(e);		
						selectAttachment(oDOMDiv, selAttach);
						openAttachment("OPEN");	
					};
				})(oDOMDiv, conArr));

				mda.appendChild(oDOMDiv);
			} else {
				removeChildNodes(mda);
			}
		}		
	}
	detailmessage["message_text"]=cnn;
	
	if(nested_msgs && nested_msgs != "") {	
		for(var nMessage = 0; nMessage < nested_msgs.length; nMessage++) {
			(function(o) {
				var oNestedMessage = new Array(nested_msgs[o]);
				attachments.push({ filename: nested_msgs[o].filename || nested_msgs[o].subject, content_type: "message/rfc822", size: nested_msgs[o].size });
				var textAttachment = addTranslated(nested_msgs[o].filename || nested_msgs[o].subject || "message/rfc822 Part");
				var blank = document.createTextNode(" ");
				var oDOMDiv = newnode("div", 0, { className: "mailDetailAttachmentsCont" },
					[ newnode("img",0,{src: getFullImgSrc("img/mail/unread.gif"), align: "top", title: textAttachment.data, padding: "3px"}),
					  	newnode("span",0,{className: "ox_none"},
					  		[ blank ]
					  	),
					  	newnode("span",0,{className: "ox_none", title: textAttachment.data },
					  		[ textAttachment ]
					  	),
					]
				);
				
				addDOMEvent(oDOMDiv, "mousedown", (function(oDOMDiv, selNested_msgs, nMessage) {
					return function(e) {	
						cancelDefault(e);	
						selectAttachment(oDOMDiv, selNested_msgs.length ? selNested_msgs[0] : selNested_msgs);
						detailNestedMessage = selNested_msgs;
						if (!detailNestedMessage.sid) 
							detailNestedMessage.sid = !isNaN(url["sid"]) ? url["sid"] + nMessage : nMessage;
					};
				})(oDOMDiv, oNestedMessage, o));
				
				registerContext(oDOMDiv,"attachment");
				
				addDOMEvent(oDOMDiv, "dblclick", (function(oDOMDiv, selNested_msgs, nMessage) {
					return function(e) {
						stopEvent(e);		
						detailNestedMessage = selNested_msgs;
						if (!detailNestedMessage.sid) 
							detailNestedMessage.sid = !isNaN(url["sid"]) ? url["sid"] + nMessage : nMessage;
						openNestedMessage();
					};
				})(oDOMDiv, oNestedMessage, o));
				
				mda.appendChild(oDOMDiv);
			})(nMessage)
		}
	}
	
	detailmessage["message_attachments"] = attachments;
    
    // do we have to enable pishing protection?
    $("mail.detail.pop.header.phishing_protection").style.display="none";
    if (configContainsKey("modules.mail.phishingheaders") && message["headers"]) {
        var psa = configGetKey("modules.mail.phishingheaders");
        for (ba in psa) {
            if (message["headers"][psa[ba]]) {
                $("mail.detail.pop.header.phishing_protection").style.display="";
                break;
            }
        }           
    }
    
    // do we have to enable image protection?
    if (message["attachments_html_noimage"] && !message["attachments_html"] && message["blocked_images"]) {
        //TODO CHECK IF EXISTS IMAGE WHICH ARE REMOVED IN NOIMAGE-ATTACHMENTS
        $("mail.detail.pop.header.image_protection").style.display="";
    } else {
        $("mail.detail.pop.header.image_protection").style.display="none";
    }  	
		
	var ih = getFrameElement("mail.detail.pop.detail.content");
    if (ih && ih.document) {
        ih = ih.document;
        ih.open();
        ih.writeln(cnn);
        ih.close();
        setTimeout(function(){                                      
            var head = ih.getElementsByTagName("head");
            if (head && head.length) {
                head[0].appendChild(
                   newnode("link",null,{type : "text/css",  rel:"stylesheet", href : "themes/"+configGetKey("gui.theme").path+"/css/iframe.css" },null,ih));
            }
            parseDirectLinksInMails(ih);
        }, 0);
    }
    setTimeout(function () { 
    	resizeSplit(mda.id, attachExists ? "3.19em" : "0em"); 
    }, 0);
}

function selectAttachment(attachCon, selAttach) {
	if (oSel != -1)
		oSel.className = "mailDetailAttachmentsCont";
	attachCon.className = "mailDetailAttachmentsContSel background-color-PMG-selection-elements";
	selAttachment = selAttach;
	oSel = attachCon;
	triggerEvent("OX_Selected_Nested",false);
	triggerEvent("SubSelected", 1);	
}

function openNestedMessage() {
	var detailMail=corewindow.newWindow("detailMail.html#type=isNestedMessage&id="
		+ encodeURIComponent(url["id"])
		+ "&folder="+ encodeURIComponent(url["folder"])
		+ "&sid=" + encodeURIComponent(detailNestedMessage.sid), getWindowOptions(), 
		{ "folder": encodeURIComponent(url["folder"]), "id": encodeURIComponent(detailNestedMessage.sid) });
	detailMail.window.oNestedMessage = detailNestedMessage;
	detailMail.oNestedMessage = detailNestedMessage;
	if (detailMail) {
		detailMail.focus();
	}
}
	
function openAttachment(action) {
	var tF = parent.frames["mail.detail.pop.attachment.save"];
	var n_url = AjaxRoot + '/mail?action=attachment'
		 + '&session=' + session + '&folder=' + encodeURIComponent(url["folder"])
		 + '&id=' + encodeURIComponent(url["id"])
		 + '&attachment=' + encodeURIComponent(selAttachment.id);
	if (action == "OPEN") {
		var attachWin = corewindow.newWindow(n_url + "&save=0&filter=1", getWindowOptions(),
			{ "folder": encodeURIComponent(message.folder_id), "id": encodeURIComponent(message.id), "attach_id": encodeURIComponent(selAttachment.id) },
			window);		
		attachWin.focus();
		try{
			attachWin.document.title = selAttachment.filename;
		} catch (e) { }
	} else if (action == "SAVE" && tF && tF.location) {
		tF.location.href=n_url+"&save=1";
	} else {
		//#. %s will be replaced with an internal error code
		triggerEvent("OX_New_Error", 4, format(_("Internal Error: Unable to open the Attachment (%s)."), "MA01"));
	}
}
	
function mail_printDetailMail() {
	corewindow.mail_printDetailMail(detailmessage);
}

function mail_showMailSource() {
	corewindow.oMailFunctions.showMailSource(getMailDetailObject());
}

function callback_error(arg) {
	newServerError(arg);
}

/**
 * unregister from object cache before the window closes
 */
window.onbeforeunload = function() {
	if (detailrequest) { 
		OXCache.unregister(detailrequest.uniqueName);
		detailrequest=null; 
	}
}