/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

/* 
 * Main class to handle all the mail stuff
 * 
 * @todo: Make functions like delete, move, copy, etc. more abstract so they can
 * be used from outside! Remove any local references like grid. Such things must
 * be added to seperate functions. Code cleanup!!!
 */
var detailmessage;	 
var mail_lastSelectedId;
var mailFetchTimestamp;
var detailrequest;
var deleteMailIDs = emptyFunction;
var switchMailHeaderView, initVsplitSortMenu, loadBlockedImages, oMailFunctions;

(function() {
	var mailSelection = new Selection2();
		
	var smilies = {
		";-)": "wink.gif",
		";)": "wink.gif",
		":-D": "big_smile.gif",
		":D": "big_smile.gif",
		":-)": "smile.gif",
		":)": "smile.gif",
		":-(": "sad.gif",
		":(": "sad.gif",
		"=(": "sad.gif",
		":|": "neutral.gif",
		":-|": "neutral.gif",
		":/": "hmm.gif",
		":-/": "hmm.gif"
	};
	
	var sortType;
	var mail_folderPath;
	register("Loaded", function() {
		sortType = {
			"from" : addTranslated("From"),
			"to" : addTranslated("To"),
			"subject" : addTranslated("Subject"),
			"size" : addTranslated("Size"),
			"sent_date" : addTranslated("Sent"),
			"received_date" : addTranslated("Received"),
			"flags_sort" : addTranslated("Read/Unread")
		};	
		mail_folderPath = new FolderPath("mail");
		
		/* register import context node for ical/vcard attachments */
		setTimeout(function() {
			addContextNode(contextmenu_createImgDiv("Import",getFullImgSrc("img/dummy.gif"),getFullImgSrc("img/dummy.gif")),["attachment"],
			    function() { 
	                var isIcal = true;
	                var dsIdent = "com.openexchange.mail.ical";
	                var dhIdent = { 
	                         "identifier": "com.openexchange.ical",
	                         "args":
	                              [{ "com.openexchange.groupware.task.folder": configGetKey("folder.tasks") },
	                               { "com.openexchange.groupware.calendar.folder": configGetKey("folder.calendar") }] };
	
	                if (selAttachment.content_type.match(/text\/(x\-)?vcard/i)) {
	                	dsIdent = "com.openexchange.mail.vcard";
	                    dhIdent = { 
	                    	"identifier": "com.openexchange.contact",
							 "args":
							      [{ "com.openexchange.groupware.contact.folder": configGetKey("folder.contacts") }] };
					    isIcal = false;
	                }
	                var myObject = {
	                	"datasource": 
	                    { "args":
	                        [ {"com.openexchange.mail.conversion.fullname": message.folder_id},
	                          {"com.openexchange.mail.conversion.mailid": message.id},
	                          {"com.openexchange.mail.conversion.sequenceid": selAttachment.id} 
	                        ], "identifier": dsIdent},
						  "datahandler": dhIdent };
	
	                new JSON().put(AjaxRoot + "/conversion?action=convert&session=" + session, myObject, null, 
	                    function (cb) {     
		                    if (cb.data && cb.data.length) {
		                        if (!isIcal) {
		                           openContactPopup("modul=edit&id="+cb.data[0].id+"&folder="+cb.data[0].folder_id+"&session="+session, 'newContact.html', {id:cb.data[0].id, folder:cb.data[0].folder_id});
		                        } else {
		                           newWindow("newAppointment.html#modul=edit&id="+cb.data[0].id+"&recurrence_position=0&folder_id="+cb.data[0].folder_id,"width=780px,height=655px,left=50,top=50,resizable=yes,menubar=no,toolbar=no,status=no", {id:cb.data[0].id, folder:cb.data[0].folder_id});
		                        }      
		                    }
	                    }
	                );
			    },
		        function(entryobject) {
		           return (activemodule == "mail" && selAttachment && selAttachment.content_type  && selAttachment.content_type.match(/text\/(x\-)?(vcard|calendar|ical)/i));
		        },
		        function(entryobject) {
		            return (activemodule == "mail" && selAttachment && selAttachment.content_type && selAttachment.content_type.match(/text\/(x\-)?(vcard|calendar|ical)/i));
		        },contextmenu_setDisabled,null,null,null,contextmenu_setEnabled
	        );
		},0);

	});
	
	var regexps = [];
	for (var i in smilies) regexps.push(i.replace(/([$^\\.*+?()[\]{}|])/, "\\$1"));
	var regexpstr = "(^| |\\n|<br>)(" + regexps.join("|") + ")";
	var regexp = new RegExp(regexpstr, "g");	
	
	function replaceSmilies(text) {
		return text.replace(regexp, function(_, space, match) {
			return space + "<img src=\"" + getFullImgSrc("img/smilies/" + smilies[match]) + "\">";
		});
	}
	
	function replaceLeadingSpaces(text) {
		return text.replace(/(^|<br>)([ \t]+)|([ \t]{2,}|\t)/g,
			function(_, prefix, m1, m2) {
				var match = (m1 || m2).replace(/\t/g, "        "); // TODO: real tabs
				var retval = new Array((match.length + 3) >> 1);
				retval[0] = prefix || "";
				var max = match.length >> 1;
				for (var i = 1; i <= max; i++) retval[i] = "&nbsp; ";
				if (match.length & 1) retval[retval.length - 1] = "&nbsp;";
				return retval.join("");
			});
	}

	deleteMailIDs = function(ids, nView) {
		var myView = nView || view;
		if (myView.grid && myView.grid.storage) { 
			myView.grid.deleteIDs(ids);
		}
	};
	
	/*
	 * Notes:
	 * selection.getSelectedIDs(storageCache.current)
	 */
	var json = new JSON();
	function setAttachments(present) {
			resizeSplit("mail." + this.name + ".detail.attachments",
			            present ? "3.19em" : "0em");
	}
	var hsplit = {name: "hsplit", grid: null, attachments: false, setAttachments: setAttachments};
	var vsplit = {name: "vsplit", grid: null, attachments: false, setAttachments: setAttachments};
	var list = {name: "list", grid: null};
	var oSel = -1, nSelId = -1, message, selAttachment, nested_msgs, old_focus;
	var clear = LiveGrid.makeClear("");
	var view = hsplit;
	var mailFetchTimestamp;
	var sort_id = "received_date";
	var sort_order = "desc";
    var numberOfMailsinFolder = [0,0];
    var finalFolderName = "";
	
	/******************* REGISTER EVENTS **********************/
	registerModule("mail", "E-Mail",20); /*i18n*/
	registerModuleView("mail","E-Mail",5,{x:1,y:0,ww:1,hw:1});
	registerPrintView("mail/list/unthreaded");
	registerPrintView("mail/list/threaded");
	registerPrintView("mail/vsplit/unthreaded");
	registerPrintView("mail/vsplit/threaded");
	registerPrintView("mail/hsplit/unthreaded");
	registerPrintView("mail/hsplit/threaded");
	
	register("OX_NEW_MAIL", function(){ newMail(""); });
	register("OX_Mail_Reply", function(){ newMail("reply"); });
	register("OX_Mail_ReplyAll", function(){ newMail("replyall"); });
	register("OX_Mail_Forward", function(){ newMail("forward"); });
	register("OX_Mail_Edit_Draft", function(){ newMail("draft"); });
	register("OX_Mail_Change_Structure", function(what){ } );
	register("updateAllNewMailNumbers_Created", function() {
		oUnreadCounterStorage.events.register("Count_Changed",newMailCounterChanged);
	});
	
	function newMailCounterChanged(folderId, numberOfMails) {
		if (activemodule == "mail" && activefolder == folderId) {
			numberOfMailsinFolder[1] = numberOfMails;
			setMailHeaderLabel();
		}
	}
	register("OX_Mail_Delete", 
		function() {
			deleteMails(activefolder, view.grid.getSelectedIDs());
		}
	);
	register("OX_Attachment_Open", function(){ if (activemodule == "mail") openAttachment("OPEN"); });
	register("OX_Attachment_Open_Nested", function(){ if (activemodule == "mail") openNestedMessage(); });
	register("OX_Attachment_Save", function(){ if (activemodule == "mail") openAttachment("SAVE"); });
	register("OX_Mail_Mark",mail_mark);
	
	function mail_mark() {
		popup($("menu_mail_flags"));
		if(menucheckRight("READ")) {
			$("menu_mail_flags_seen").style.display="";
			$("menu_mail_flags_unseen").style.display="";
		} else {
			$("menu_mail_flags_seen").style.display="none";
			$("menu_mail_flags_unseen").style.display="none";
		}
	    if(menucheckRight("DELETE")) {
	        $("menu_mail_flags_delete").style.display="";
	        $("menu_mail_flags_undelete").style.display="";
	    } else {
	        $("menu_mail_flags_delete").style.display="none";
	        $("menu_mail_flags_undelete").style.display="none";
	    }
		if(menucheckRight("WRITE")) {
			$("menu_mail_flags_answer").style.display="";
			$("menu_mail_flags_unanswer").style.display="";
		} else {
			$("menu_mail_flags_answer").style.display="none";
			$("menu_mail_flags_unanswer").style.display="none";
		}
	}

	function setFlagInMailView(tag){
		if(activemodule=="mail") {
		    if(view == "detail") {
		        OXMailMapping.setTag(tag,[mail_lastSelectedId]);	
		    } else {
			    OXMailMapping.setTag(tag,view.grid.selection.getSelected());
		    }
		}
	}
	
	registerView("mail",
		null,
		function() {
			register("OX_Add_Flag", setFlagInMailView);	
			register("OX_Mail_Flag", oMailFunctions.markAsFlag);
		    register("OX_Mail_Spam", oMailFunctions.markAsSpam);
            register("OX_Mail_Ham", oMailFunctions.markAsHam);
            register("OX_Mail_Show_Source", oMailFunctions.showMailSource);
		},
		function() {
			if(detailrequest) {
                OXCache.unregister(detailrequest.uniqueName);
                detailrequest=null;
            }
			unregister("OX_Add_Flag", setFlagInMailView);
			unregister("OX_Mail_Flag", oMailFunctions.markAsFlag);
	        unregister("OX_Mail_Spam", oMailFunctions.markAsSpam);
            unregister("OX_Mail_Ham", oMailFunctions.markAsFlag);
			triggerEvent("Selected",[]);
		},
		null,
		null
	);

	/*
	 * The callback when reset the search
	 * @todo: needs to be optimized
	 */
	function updateAfterDeleteSearch() {
		view.grid.searchActive=false;
		if(currentpath[2] == "threaded")
			updateMailStorage("thread", null, "samefolder"); 
		else
			updateMailStorage(null, null, "samefolder");
	};

	registerList("mail/list/unthreaded", list);
	registerList("mail/list/threaded", list, "thread");
	registerList("mail/vsplit/unthreaded", vsplit);
	registerList("mail/vsplit/threaded", vsplit, "thread");
	registerList("mail/hsplit/unthreaded", hsplit);
	registerList("mail/hsplit/threaded", hsplit, "thread");
			   
	function registerList(name, viewObj, param) {
		registerView(name,
			function() {
				showNode("mail."+viewObj.name);
			},
			function(type) {
				view = viewObj;
				if (!view.grid) {
					view.grid = initLiveGrid(view);
				}
				switchGridHeaders(view.grid);                
				if (viewObj == vsplit) {
					setVsplitSortEntry();
				} else {
					view.grid.setSort(sort_id, sort_order);
				}
				
				register("OX_New_Search",searchMail);
				menu_setSearchField(isStdFolder("sent") ? "to" : "from");
				register("OX_Delete_Search",updateAfterDeleteSearch);
				register("OX_Print",mail_printList);
				if (viewObj != list) {
					register("OX_Attachment_SaveInfoStore",mail_saveAttachmentInDocStore);
					switchMailHeaderView(configGetKey("gui.mail.fullmailheader"));
				}
				
		        if (mail_lastSelectedId && mail_lastSelectedId.directLink &&
		            mail_lastSelectedId.id) {
		            delete(mail_lastSelectedId.directLink);
		            view.grid.selection.selectIDs([ Key.createfromObject(mail_lastSelectedId) ]);                  
		        }				
				updateMailStorage(param, undefined, type);				
			}, 
			function() {
				if(detailrequest) {
                    OXCache.unregister(detailrequest.uniqueName);
                    detailrequest=null;
                }    
				if (viewObj !== list) {
					clearMailSplitDetail(view.name);
					unregister("OX_Attachment_SaveInfoStore",mail_saveAttachmentInDocStore);
				}
				unregister("OX_Print",mail_printList);
				unregister("OX_New_Search",searchMail);
				unregister("OX_Delete_Search",updateAfterDeleteSearch);				
				if (view.grid && view.grid.storage) {
					old_focus = grid.focus;
                    view.grid.disable();
				} else if(view.grid && view.grid.collection) {
				    old_focus = view.grid.focus;
                    view.grid.disable();
				} 
				// reset iframe container to blank src
			    if ($("mail." + view.name + ".attachment.save")) {
				   $("mail." + view.name + ".attachment.save").src="newInfoItemHidden.html";
				}				
			},
			function() {
				menuclearSearchMail();				
				hideNode("mail." + viewObj.name);
			},
			function(type) {
                if(detailrequest) {
                    OXCache.unregister(detailrequest.uniqueName);
                    detailrequest=null;
                }    
				switchGridHeaders(view.grid);				
                // note: do NOT user grid.setSort here as this results in 
                // useless request on the previous selected folder if grid
                // columns changed (eg. Inbox != Sent). The grid.enable followed
                // in updateMailStorage will do the rest! 
				if (sort_order != view.grid.sort_order || sort_id != view.grid.sort_id) {
					view.grid.sort_order = sort_order;
					view.grid.sort_id = sort_id;
				}				
				menuclearSearchMail();
				menu_setSearchField(isStdFolder("sent") ? "to" : "from");
				updateMailStorage(param, undefined, type);
			}
		);
	}
	
	/**
	 * in folder 'Sent' and 'Drafts' we have to use other fields then the
	 * default once. this function switch between these headers and sort parameter 
	 * within the given livegrid. combinations are: folder sent and
	 * drafts -> 'To' and 'Reveived Date', otherwise 'From' and 'Sent Date'
	 * @param grid - {LiveGrid} - the current livegrid 
	 */
	function switchGridHeaders(grid) {
		if (grid.ids["from"]) { 
			grid.ids["to"] = grid.ids["from"]; 
		}
        if (grid.ids["received_date"]) { 
        	grid.ids["sent_date"] = grid.ids["received_date"]; 
        }
        
		if (isStdFolder("sent") || isStdFolder("drafts")) {
			var sHeadline = _("To");	
			var dateHeadline = _("Sent");	
			if (sort_id == "from") {
				sort_id = "to";
			} else if (sort_id == "received_date") {
				sort_id = "sent_date";
			}
			
			if(grid.ids["from"]) { 
				grid.columns[grid.ids["to"]].sort = "to"; 
				grid.columns[grid.ids["to"]].name[0] = "to";
			}
			if (grid.ids["received_date"]) { 
				grid.columns[grid.ids["sent_date"]].sort = "sent_date";
				grid.columns[grid.ids["sent_date"]].name[0] = "sent_date";
			}
						
			for (var ia=0; ia<grid.columns.length; ia++) {
			    for (var ib=0; ib<grid.columns[ia]["name"].length; ib++) {
			    	if (grid.columns[ia]["name"][ib] == "from") {
			    		grid.columns[ia]["name"][ib] = "to";
			    	} else if (grid.columns[ia]["name"][ib] == "received_date") {
			    		grid.columns[ia]["name"][ib] = "sent_date";
			    	}
			    }	
			}
			
		} else {
			var sHeadline = _("From");
			var dateHeadline = _("Received");
			if (sort_id == "to") {
				sort_id = "from";
			} else if (sort_id == "sent_date") {
				sort_id = "received_date";
			}
			
			if (grid.ids["to"]) { 
				grid.columns[grid.ids["from"]].sort = "from";
			}
			if (grid.ids["sent_date"]) { 
				grid.columns[grid.ids["received_date"]].sort = "received_date"; 
			}
			
			for (var ia=0; ia<grid.columns.length; ia++) {
                for (var ib=0; ib<grid.columns[ia]["name"].length; ib++) {
                    if (grid.columns[ia]["name"][ib] == "to") {
                        grid.columns[ia]["name"][ib] = "from";
                    } else if (grid.columns[ia]["name"][ib] == "sent_date") {
                        grid.columns[ia]["name"][ib] = "received_date";
                    }
                }   
            }
		}
		
		if (grid && grid.headers) {
			if (view !== vsplit) {
				grid.headers[3].firstChild.data = sHeadline;
				grid.headers[3].title = sHeadline;				
				grid.headers[5].firstChild.data = dateHeadline;
				grid.headers[5].title = dateHeadline;
			} else {
				if (grid.headers[3] && grid.headers[3].firstChild && grid.headers[3].firstChild.firstChild)
					grid.headers[3].firstChild.firstChild.data = sHeadline;
			}
		}

        // update folder name and unread count information for grid header
        //setMailHeaderLabel();
        view.grid.searchActive=false; // set search to inactive, not sure if 
	}
	
	function mail_saveAttachmentInDocStore() {
		propertiesPopUp = newWindow("newInfoItemMain.html#attachmail=" 
                + encodeURIComponent(selAttachment.id) + "&edit_id=" + -1
                + "&filename=" + encodeURIComponent(selAttachment.filename)
                + "&mailid=" + encodeURIComponent(message.id)
                + "&mailfolder=" + encodeURIComponent(message.folder || message.folder_id),
                getWindowOptions());
        if (propertiesPopUp) propertiesPopUp.focus();		
	}	
	
	function mail_printList() {
		var attachments = [];
		// if only one object has been selected, print the detail message, otherwise the list
		if (view.grid.selection.getSelected().length == 1) {
			var omsg = OXCache.cachedObjects.get(view.grid.selection.getSelected()[0]);
	        var cnn = "", attachmentParam=null;
	        if(omsg["attachments_plain"] && !configGetKey("mail.inlineattachments")) { 
	            attachmentParam = omsg["attachments_plain"]; 
	        } else if (omsg["attachments_html"] && configGetKey("mail.inlineattachments")) { 
	            attachmentParam = omsg["attachments_html"]; 
	        } else if (omsg["attachments_html_noimage"] && configGetKey("mail.inlineattachments")) { 
	            attachmentParam = omsg["attachments_html_noimage"];
	        }
            for (idfield in attachmentParam) {
                var conArr = attachmentParam[idfield];
                var ct = conArr["content_type"].toLowerCase();
                var con = conArr["content"];
                if (ct.search(/text\//) != -1 && con != null) {
                    if (ct.search(/text\/plain/) != -1) {
                        var tmpcnn=(configGetKey("mail.emoticons") ? replaceSmilies(con) : con);
                        tmpcnn=replaceLeadingSpaces(tmpcnn);
                        cnn += "<div style=\"font-family: monospace; line-height: 1.5em;\">" + tmpcnn + "</div>";
                    } else { 
                        cnn += "<div>" + con + "</div>";
                    }           
                } else if(conArr["filename"]) {
                	attachments.push(conArr);
                }        
            }
            
            if (omsg["nested_msgs"] && omsg["nested_msgs"].length) {
	            for (var nMessage = 0; nMessage < omsg["nested_msgs"].length; nMessage++) {
	            	var nmg = omsg["nested_msgs"][nMessage];
	            	attachments.push({ filename: nmg.filename || nmg.subject, content_type: "message/rfc822", size: nmg.size });	            
	            }
            }
	        var tmsg = new Object();
	        //tmsg["whole_message"] = omsg;
	        tmsg["message_text"] = cnn;
	        tmsg["message_attachments"] = attachments;
	        if (omsg.from) tmsg["from"] = getAdressString(omsg.from, false);
	        if (omsg.to)  tmsg["to"] = getAdressString(omsg.to, false);
	        if (omsg.cc)  tmsg["cc"] = getAdressString(omsg.cc, false);
	        if (omsg.bcc) tmsg["bcc"] = getAdressString(omsg.bcc, false);
	        tmsg["date"] = omsg.sent_date;
	        tmsg["subject"] = omsg.subject;
	        tmsg["priority"] = omsg.priority;
	        tmsg["color-label"] = omsg.color_label;			
	        mail_printDetailMail(tmsg);
		} else { 
			globalprint.printLiveGrid(view.grid);
		}		
	}
	
	function clearMailSplitDetail(cview) {	
		$("mail." + view.name + ".detail.header.image_protection").style.display = "none";
		$("mail." + view.name + ".detail.header.phishing_protection").style.display = "none";
		$("mail." + view.name + ".detail.row.organization").style.display = "none";
		
		if($('mail.' + cview + '.detail.header.from'))
			removeChildNodes($('mail.' + cview + '.detail.header.from'));
			
		if($('mail.' + cview + '.detail.header.from_small'))
			removeChildNodes($('mail.' + cview + '.detail.header.from_small'));
	
		if($('mail.' + cview + '.detail.header.to'))
			removeChildNodes($('mail.' + cview + '.detail.header.to'));
				
		if($('mail.' + cview + '.detail.header.cc'))
			removeChildNodes($('mail.' + cview + '.detail.header.cc'));
			
		if($('mail.' + cview + '.detail.header.bcc'))
			removeChildNodes($('mail.' + cview + '.detail.header.bcc'));
	
		$('mail.' + cview + '.detail.header.subject').firstChild.data = "";
		$('mail.' + cview + '.detail.header.subject_small').firstChild.data = "";
		$('mail.' + cview + '.detail.content').src = "newInfoItemHidden.html";
		$('mail.' + cview + '.detail.header.received_date').firstChild.data = "";
		$('mail.' + cview + '.detail.header.received_date_small').firstChild.data = "";
		var mda = $("mail." + cview + ".detail.attachments");
		removeChildNodes(mda);
		view.setAttachments(false);
		oldMessage = null;
        oldMessageTextType=null;
	}
			
	/**
	 * Update the storage
	 * @param id either "thread" for threaded sorting, or column id for sort
	 * (optional)
	 * @param order either "asc" or "desc" (optional)
	 * @param type type of event which caused the update.
	 * Can be "samefolder", "newfolder" or undefined.
	 */
	function updateMailStorage(id, order, type) {
		sort_id = id || sort_id;
		sort_order = order || sort_order;
		
		var folder = activefolder;
		var grid = view.grid;
						
     	var criteria= { "folder_id" : activefolder };
        grid.disablehover=!configGetKey("gui.effects.hover.mail");
        
        mailSelection.selectedIndex = configGetKey("gui.mail.select_first_message") ? 0 : undefined;
        
        //grid.enable(criteria,null,true); // forces an update each time you change the folder        
        grid.enable(criteria);        
	}
	
	function searchMail(sModule,sPattern,field) {		
		var criteria= { "folder_id" : activefolder };
		var search = {}; 
		search[field]=sPattern;
		view.grid.searchActive=true;
		view.grid.enable(criteria,search,false);
		mail_folderPath.drawSearch(sModule, sPattern);
	}

	function setMailHeaderLabel() {		
		if (view.grid && view.grid.searchActive) {
			return;
		}
		numberOfMailsinFolder[1] = 0;
        if (oUnreadCounterStorage.count_hashmap[activefolder] != undefined) {
            numberOfMailsinFolder[1] = oUnreadCounterStorage.count_hashmap[activefolder];
        }
        var panelText = " (";
        if (numberOfMailsinFolder[1] != 0) {
            //#. Number of unread mails in the header of the mail view
            //#. %1$s is the number of unread mails
            //#. %2$s is the total number of mails
            panelText += format(_("%1$s of %2$s unread"), [numberOfMailsinFolder[1], numberOfMailsinFolder[0]]);
        } else {
            panelText += numberOfMailsinFolder[0] || 0;
        }
        panelText += ")";
		mail_folderPath.additionalNode=document.createTextNode(panelText);
		mail_folderPath.drawDOMNode("mail."+view.name+".foldername", activefolder);
	}
	
    function mailHeaderLabelUpdate(data) {
        numberOfMailsinFolder[0] = data.objects.length;
        setMailHeaderLabel();       
    }
    
    function mail_setFocus(data, changed) {
    	if (view.grid && view.grid.collection) {
    		setFocus($("mail." + view.name + ".grid"));
    		if (mailSelection && mailSelection.count) {
	            var index = view.grid.collection.getIndex(mailSelection.getSelected()[0]);
	            view.grid.focus = index ? index-1 : 0;	            
	        } else if (changed) {
	        	var index = view.grid.focus || 0;
	        	view.grid.selection.click(index);
	        }
	        view.grid.showFocus();
    	}
    }
	
	/**
	 * Initiate LiveGrid
	 * @param view
	 * @return grid
	 */
	function initLiveGrid(view) {
		var grid;
		if (view === vsplit) {
			grid = initGridHeaderVSplit();
			grid.lineHeight = 3.2;
			grid.getHeader();
			$("mail." + view.name + ".grid.header").appendChild($("mail.vsplit.sortOrderHead"));
		} else {
			grid = initGridHeader();
			$("mail." + view.name + ".grid.header").appendChild(grid.getHeader());
		}
		grid.sort = updateMailStorage;
        grid.getTable($("mail." + view.name + ".grid"));
		var hovercontent = createHoverContent();
		hovercontent.node.style.display="none";
		body.appendChild(hovercontent.node);
		var hv = grid.addHover(OXMailHover.getContent().node, function(id) {
			OXMailHover.accordion.setHover(hv);
			OXMailHover.refillContent(id.id,id.folder_id);
		});
		hv.setSize(OXMailHover.contentobject.node);
		grid.events.register("Activated", function(ids) {
			if (ids && ids.length > 0) {
				var detailMail = newWindow("detailMail.html#"
				    + "id="	+ encodeURIComponent(ids[0].id) 
					+ "&folder=" + encodeURIComponent(ids[0].folder || ids[0].folder_id),
					getWindowOptions(), 
					[ ids[0].id, (ids[0].folder || ids[0].folder_id)]);
				if (detailMail) detailMail.focus();
			} else {
				triggerEvent("OX_NEW_MAIL");
			}
		});
		
		grid.events.register("Delete", function(ids){
			deleteMails(activefolder, ids) 
		});
		
		grid.events.register("Changed",mailHeaderLabelUpdate);
		grid.events.register("Changed",mail_setFocus);
		
		// livegrid single click or selection
		grid.events.register("Selected", updateDetailView);
		
		mailSelection.selectedIndex = configGetKey("gui.mail.select_first_message") ? 0 : undefined;
		
		return grid;
	}
	
	function getMailText(mail) {
		for (var i = 0; i < mail.attachments.length; i++) {
			var part = mail.attachments[i];
			if (part.disp == "attachment") continue;
			switch (part.content_type.toLowerCase()) {
				case "text/plain": return part.content;
				case "text/html":  return _("HTML-only mail");
			}
		}
		return _("No text");
	}
	
	function updateDetailView(count, viewObj) {		
		if (!viewObj) viewObj = view;
		var ids = viewObj.grid.selection.getSelected();
		triggerEvent("Selected", ids);
        triggerEvent("SubSelected", 0); //disable attachments first
		if (count != 0) {
			mail_lastSelectedId = ids[0];
			if (viewObj !== list) {
				if(count == 1) {
					fetchMessage(viewObj, mail_lastSelectedId);
				} else
					clearMailSplitDetail(viewObj.name);
			} else {
				message = mail_lastSelectedId;
			}
		} else if (viewObj !== list)
			clearMailSplitDetail(viewObj.name);
		
        triggerEvent("OX_Selected_Draft", isStdFolder("drafts"));
	}
	
	/**
	 * init grid for normal views
	 */
	function initGridHeader() {
		var grid = new LiveGrid2([
			{
				text: "&#x00a0;",
				sortable: false,
				name : ["priority"],
				width: "20px",
				style: { padding:0, textAlign:"center" },
				set: function(div, content) {
					var src;
					switch (content) {
						case 1:
						case 2:
							src = getFullImgSrc("img/mail/email_priohigh.gif");
							break;
						case 4:
						case 5:
							src = getFullImgSrc("img/mail/email_priolow.gif");
							break;
						default:
							src = getFullImgSrc("img/mail/noattachment.gif");
					}
					if (!div.firstChild) {
						div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle"}));
					}
					div.firstChild.src = src;
				},
				clear: function(div) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle"}));
					} else {
						div.firstChild.src = getFullImgSrc("img/mail/noattachment.gif");
					}
				}

			},{
				name : ["attachment"],
				text: "&#x00a0;",
				sortable: false,
				width: "20px",
				style: { padding:0, textAlign:"center" },
				set: function(div, content) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle"}));
					}
					div.firstChild.src = getFullImgSrc("img/mail/" + (content ? "attachment.gif" : "noattachment.gif"));
				},
				clear: function(div) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", 0, { src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle"}));
					} else {
						div.firstChild.src = getFullImgSrc("img/mail/noattachment.gif");
					}
				}
			},{
				text: "&#x00a0;",
				sortable: true,
				name : ["flags"],
				sort : "flags_sort",
				width: "26px",
				style: { padding:0, textAlign:"center" },
				set: function(div, content) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/mail/read.gif"), align: "absmiddle"}));
					}
					div.firstChild.src = getFullImgSrc("img/mail/" + getMailFlagImage(content));
				},
				clear: function(div) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", null, {src: getFullImgSrc("img/mail/read.gif"), align: "absmiddle"}));
					} else {
						div.firstChild.src = getFullImgSrc("img/mail/read.gif");
					}
				}
			}, {
				text: "From",  /*i18n*/
				name : ["from","level","flags"],
				sort : "from",
				i18n: true,
				sortable: true,
				width: "25%",
				set: function(div, content) {
					if(isStdFolder("sent") || isStdFolder("drafts")) {
						var aAddressToShow = content["to"] || [];
					} else {						
						var aAddressToShow = content["from"] || [];
					}					
					// div.style.paddingLeft = content.level + "em";
					var padding = "";
					for (var i = 0; i < 20 && i < content["level"]; i++)
						padding += "\u00a0\u00a0\u00a0";
					if (div.firstChild)
						div.firstChild.data = padding 
							+ getAdressString(aAddressToShow, true);
					else
						div.appendChild(
							document.createTextNode(
								padding + getAdressString(aAddressToShow, true)));
					
					//deleted													
					div.style.textDecoration =	content["flags"] & 2 ? "line-through" : "none";
					//unread
					div.parentNode.style.fontWeight = content["flags"] & 32 ? "normal" : "bold";
				},
				clear: clear
			}, {
			    text: "Subject", /*i18n*/
				i18n: true,
				name : ["subject","flags"],
				sort : "subject",
				sortable: true,
				set: function(div, content) {
					if (!div.firstChild)
						div.appendChild(div.ownerDocument.createTextNode(content["subject"] || "\u00a0"));
					else
						div.firstChild.data = content["subject"] || "\u00A0";		
					//deleted		
					div.style.textDecoration =	content["flags"] & 2 ? "line-through" : "none";
				},
				clear: clear
			}, {				
				text: "Received", /*i18n*/
				i18n: true,
				sortable: true,
				name : ["received_date","flags"],
				sort : "received_date",
				width: "11em",
				set: function(div, content) {
					var dateToShow = content["received_date"];
					if (isStdFolder("sent") || isStdFolder("drafts")) {
						dateToShow = content["sent_date"];
					}
                    dateToShow = dateToShow ? formatDate(dateToShow, isToday(dateToShow) ? "time" : "datetime") : "";
                    if (!div.firstChild) {
                        div.appendChild(div.ownerDocument.createTextNode(dateToShow));
                    } else {
                        div.firstChild.data = dateToShow;
                    }
					//deleted		
					div.style.textDecoration =	content["flags"] & 2 ? "line-through" : "none";
				},
				clear: clear
			}, {
				text: "Size", /*i18n*/
				i18n: true,
				sortable: true,
				name : ["size","flags"],
				sort : "size",
				width: "6em",
				style: {textAlign: "right"},
				set: function(div, content) {
					var text = bytesToString(content["size"]);
					if (!div.firstChild)
						div.appendChild(div.ownerDocument.createTextNode(text));
					else
						div.firstChild.data = text;
					//deleted		
					div.style.textDecoration =	content["flags"] & 2 ? "line-through" : "none";
				},
				clear: clear
			},{
				text: "Flag", /*i18n*/
				i18n: true,
				name : ["color_label"],
				sort : "color_label",
				sortable: true, 
				width: "4.5em",
				style: {textAlign: "center"},
				set: function(div, text) {
					if (!div.firstChild)
						div.appendChild(newnode("img", {height : "16px", width : "16px"},
							{ src: getFullImgSrc("img/menu/tag_" + (text || 0) + ".gif") }));
					else
						div.firstChild.src = getFullImgSrc("img/menu/tag_" + (text || 0) + ".gif");
				},
				clear: function(div) {
					if (!div.firstChild)
						div.appendChild(newnode("img", { height : "16px", width : "16px" },
							{ src: getFullImgSrc("img/menu/tag_0.gif"), align: "absmiddle" }));
					else
						div.firstChild.src = getFullImgSrc("img/menu/tag_0.gif");
				}
			}
		], mailSelection, "mail");
		
		return grid;
	}
		
	function initGridHeaderVSplit() {
		var grid = new LiveGrid2([
			{		
				text: "",
				name: ["level","attachment","from","subject","received_date","size","flags","priority","color_label"],
				sortable: false,
				height: "3.2em",
				style: { borderBottom: "1px solid silver" },
				set: function(div, content) {
					if (!div.firstChild) {
						var td = $("mail.vsplit.row").cloneNode(true);
						td.id="";
						td.style.display="";
						div.appendChild(td);
						
					}
					//div.className += " mailVSplitSepLine";
					// attachment
					var img = getFullImgSrc("img/mail/"+getMailFlagImage(content["flags"]));
					if (div.getElementsByTagName("td")[0].firstChild.src != img)
						div.getElementsByTagName("td")[0].firstChild.src=img;

					// to / from
					if(isStdFolder("sent") || isStdFolder("drafts")) {
						var aAddressToShow = content["to"] || [];
					} else {						
						var aAddressToShow = content["from"] || [];
					}
					div.getElementsByTagName("td")[2].firstChild.data=getAdressString(aAddressToShow,true);	
					//deleted
					div.getElementsByTagName("td")[2].style.textDecoration = content["flags"] & 2 ? "line-through" : "none";					

					// date
					if(isStdFolder("sent") || isStdFolder("drafts")) {
						var dateToShow = content["sent_date"];
					} else {						
						var dateToShow = content["received_date"];
					}
					if (dateToShow && isToday(dateToShow)) {
						div.getElementsByTagName("td")[3].className="vsplitDateShort"
					} else if (div.getElementsByTagName("td")[3].className != "vsplitDate") {
						div.getElementsByTagName("td")[3].className="vsplitDate";
					}
					div.getElementsByTagName("td")[3].firstChild.data=dateToShow ? formatDate(dateToShow, isToday(dateToShow) ? "time" : "date") : "";
					div.getElementsByTagName("td")[3].style.textDecoration = content["flags"] & 2 ? "line-through" : "none";
					
					//subject
					if (div.getElementsByTagName("td")[5].firstChild.data != content["subject"]) {
						div.getElementsByTagName("td")[5].firstChild.data=content["subject"];
						div.getElementsByTagName("td")[5].style.textDecoration = content["flags"] & 2 ? "line-through" : "none";
					}
					
					// priority
					if (content["priority"] && (content["priority"] != 0 && content["priority"] != 3)) {
						div.getElementsByTagName("td")[6].firstChild.src=getFullImgSrc("img/mail/email_prio" + (content["priority"] <= 3 ? "high" : "low") + ".gif");
						div.getElementsByTagName("td")[6].style.width="12px";
						
					} else if (div.getElementsByTagName("td")[6].firstChild.src != getFullImgSrc("img/dummy.gif")) {
						div.getElementsByTagName("td")[6].firstChild.src=getFullImgSrc("img/dummy.gif");
						div.getElementsByTagName("td")[6].style.width="0px";
					}

					// attachment
					if (content["attachment"] && div.getElementsByTagName("td")[7].firstChild.src != getFullImgSrc("img/mail/attachment.gif")) {
						div.getElementsByTagName("td")[7].firstChild.src=getFullImgSrc("img/mail/attachment.gif");
						div.getElementsByTagName("td")[7].style.width="12px";
						
					} else if (div.getElementsByTagName("td")[7].firstChild.src != getFullImgSrc("img/dummy.gif")) {
						div.getElementsByTagName("td")[7].firstChild.src=getFullImgSrc("img/dummy.gif");
						div.getElementsByTagName("td")[7].style.width="0px";
					}
					
					// tags
					if (content["color_label"] && div.getElementsByTagName("td")[8].firstChild.src != getFullImgSrc("img/menu/tag_" + (content["color_label"] || 0) + ".gif")) {
						div.getElementsByTagName("td")[8].firstChild.src=getFullImgSrc("img/menu/tag_" + (content["color_label"] || 0) + ".gif");
						div.getElementsByTagName("td")[8].style.width="20px";
						
					} else if (div.getElementsByTagName("td")[8].firstChild.src != getFullImgSrc("img/dummy.gif")) {
						div.getElementsByTagName("td")[8].firstChild.src=getFullImgSrc("img/dummy.gif");
						div.getElementsByTagName("td")[8].style.width="0px";
					}
										
					div.parentNode.style.fontWeight = (content["flags"] & 32) ? "normal" : "bold";									
					
				},
				clear: function(div) {
					if (!div.firstChild) {
						var td = $("mail.vsplit.row").cloneNode(true);
						td.id="";
						td.style.display="";
						div.appendChild(td);
					}
					
					if (div.getElementsByTagName("td")[0].firstChild.src != getFullImgSrc("img/dummy.gif"))
						div.getElementsByTagName("td")[0].firstChild.src=getFullImgSrc("img/dummy.gif");
						
					if (div.getElementsByTagName("td")[2].firstChild.data != "")
						div.getElementsByTagName("td")[2].firstChild.data="";
						
					if (div.getElementsByTagName("td")[3].firstChild.data != "")
						div.getElementsByTagName("td")[3].firstChild.data="";

					if (div.getElementsByTagName("td")[5].firstChild.data != "")
						div.getElementsByTagName("td")[5].firstChild.data="";

					if (div.getElementsByTagName("td")[6].firstChild.src != getFullImgSrc("img/dummy.gif")) {
						div.getElementsByTagName("td")[6].firstChild.src=getFullImgSrc("img/dummy.gif");
						div.getElementsByTagName("td")[6].style.width="0px";
					}
					
					if (div.getElementsByTagName("td")[7].firstChild.src != getFullImgSrc("img/dummy.gif")) {
						div.getElementsByTagName("td")[7].firstChild.src=getFullImgSrc("img/dummy.gif");
						div.getElementsByTagName("td")[7].style.width="0px";
					}
					
					if (div.getElementsByTagName("td")[8].firstChild.src != getFullImgSrc("img/dummy.gif")) {
						div.getElementsByTagName("td")[8].firstChild.src=getFullImgSrc("img/dummy.gif");
						div.getElementsByTagName("td")[8].style.width="0px";
					}
				}
			}			
		], mailSelection, "mail");
		
		return grid;
	}
	
	function getMailFlagImage(flag) {    
        if (flag == 16 || flag == 0) {
            return "unread.gif";
        } else if (flag >= 289) {
            return "reply_forward.gif";
        } else if (flag >= 256) {
            return "forward.gif";
        } else if (flag == 34) {
            return "deleted.gif"
        } else if (flag == 33) {
            return "reply.gif";
        } else if (flag >= 32) {
            return "read.gif"
        }
        return "read.gif"
    }
	
	/**
	 * Open a new message window
	 */
	function newMail(action) {				
		var newMail = newWindow("newMail.html#"
		    + "folder="	+ (message ? encodeURIComponent(message.folder_id) : "") 
			+ "&id=" + (message ? encodeURIComponent(message.id) : "")
			+ "&action=" + action,
			getWindowOptions());
		newMail.focus;
		
		// fill object for multiple selected messages, eg. on a forward
        if (newMail && mailSelection.getSelected().length > 1) {
	        var selected = mailSelection.getSelected();
	        var fObj = new newMail.Array();
	        for (var i in selected) {           
	            fObj.push({"folder": selected[i].folder_id, "id": selected[i].id });
	        }        	
            newMail.multiForward = fObj;
        }
	}

	/**
	 * Delete messages
	 */	
	function deleteMails(folder, ids, harddelete) {			
        // return if ids is empty or a delete is still in progress
        if (!ids || ids.length == 0) return;
        var index = view.grid.collection.getIndex(ids[0]) || 0;
        var cb = (function(index) {
        	return function() {
        		if (!view.grid.collection.objects.length) return;
        		view.grid.focus = index;
        		view.grid.selection.click(index);
        		//view.grid.showFocus();
        	}
        })(index-1);
		
		if (harddelete || configGetKey("mail.deletemail") || configGetKey("mail.folder.trash") == folder) {
            newConfirm(_("Delete E-Mails"),_('Are you sure you want to delete the selected E-Mails?'),AlertPopup.YESNO,null,null,
            function () {
                OXMailMapping.deleteObjects(ids,true,cb)
            }, null);
		} else {
            OXMailMapping.deleteObjects(ids,false,cb);
		}
	}
	
	function callbackMailStyle(index, updatedData) {
		if(!(updatedData[8] & 32)) {
			updatedData[8] = updatedData[8] + 32;
			return updatedData;
		} else
			return null;
	}
	
	var fetchJSON = new JSON();
	var lastID = null, lastRequest = null;
	function fetchMessage(view, id,loadblockedimages) {	
	    message = id;
        triggerEvent("SubSelected", 0); //disable attachments first
	    var collection={};
		collection.objects=[id];
		if (configGetKey("mail.inlineattachments")) {
			if(configGetKey("modules.mail.allowhtmlimages") || loadblockedimages) {
		        collection.columns=OXMailMapping.GETHTML;		
			} else {
				collection.columns=OXMailMapping.GETHTMLNOIMAGE;
			}
		} else {
			collection.columns=OXMailMapping.GETPLAIN;
		}
		
		/* fixed bug #11462 */
		function markRead(object) {
			if (view.name != "list" && !(object["flags"] & 32) && message != lastID) {
			     OXMailMapping.setMailFlags("seen",[object]);
			}
		}
		
		if (detailrequest) { OXCache.unregister(detailrequest.uniqueName); }
		detailrequest=OXCache.newRequest(null,"mail",collection,
		function(daten) {
			if (daten.objects.length) {
				mailFetchTimestamp = daten.timestamp;
                showMessage(view, daten.objects[0],id.folder_id);
                lastID = id;
                //markRead(daten.objects[0]);
            }
		},
		function(daten) {
            if (daten.objects.length) {
				mailFetchTimestamp = daten.timestamp;
                showMessage(view, daten.objects[0],id.folder_id);
                markRead(daten.objects[0]);
                lastID = id;
            }			
		});
	}
	var detailNestedMessage = null;
	var oldMessage = null;
    var oldMessageTextType=null;
	var oldView=null;
	function showMessage(view, message, folder) {
        var attachExists = false, nested_msgs = "";		
		if (view != oldView) {
            oldMessage=null, oldMessageTextType=null;
        }
        for (idfield in message) {
			var newField=message[idfield];
			var oldField=(oldMessage) ? oldMessage[idfield] : null;
			if(newField == null && idfield != "subject") { continue; }
			if(newField == oldField) { continue; }
			if(equals(newField,oldField)) { continue; }
						
			var oDivEmails = $("mail." + view.name + ".detail.header." + idfield);          
            var oDivEmailsSmall = $("mail." + view.name + ".detail.header." + idfield + "_small");
			switch(idfield) {
				case "cc":
                case "bcc":
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
				    if (newField == "") { 
				    	$("mail." + view.name + ".detail.row." + idfield).style.display = "none"; 
				    } else if(newField != "") { 
				    	$("mail." + view.name + ".detail.row." + idfield).style.display = ""; 
				    }
				case "to":
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
				case "from":
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
				    removeChildNodes(oDivEmails);
                    getAdressStringLinked(oDivEmails, newField, false);
                    if (oDivEmails) {
                        oDivEmails.style.height = 1.6 + "em";
                        if (oDivEmails.scrollHeight > 22) { 
                            oDivEmails.style.height = oDivEmails.clientHeight *2 + "px"; 
                        }                                                               
                    }
                    if (oDivEmailsSmall) {
                        removeChildNodes(oDivEmailsSmall);          
                        getAdressStringLinked(oDivEmailsSmall, newField, true);           
                    } 
                    newField = null;
            	    break;
            	case "received_date" :
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
					newField = formatDate(newField, isToday(newField) ? "time" : "datetime");
					break;
				case "color_label":
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
					if ($('mail.' + view.name + '.detail.flag')) { 
						$('mail.' + view.name + '.detail.flag').src = getFullImgSrc("img/menu/tag_" + (newField||0) + ".gif");
					}
					break;
				case "nested_msgs":
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
				    if(newField.length > 0) { nested_msgs = newField; attachExists = true; }
					break;
				case "flags":
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
					if ($('mail.' + view.name + '.detail.mailflag')) {
                       $('mail.' + view.name + '.detail.mailflag').src = getFullImgSrc("img/mail/"+getMailFlagImage(newField));
					}
					break;
				case "priority" :
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
				    if ("mail." + view.name + ".detail.header.prority") {
				    	var divPrio = $('mail.' + view.name + '.detail.header.prority');
				    	divPrio.style.display = "";
                        if (newField < 3) {
                            divPrio.src = getFullImgSrc("img/mail/email_priohigh.gif");      
                        } else if (newField > 3) {
                            divPrio.src = getFullImgSrc("img/mail/email_priolow.gif");
                        } else {
                        	divPrio.style.display = "none";
                        }
					}
					break;
				case "subject" :
				    $("mail." + view.name + ".detail.content").style.visibility="hidden";
					if (!newField) {
						oDivEmails.firstChild.data = " ";
                        oDivEmailsSmall.firstChild.data = " ";
					}
					break;
			 }
		     if (oDivEmails && newField) {
		         $("mail." + view.name + ".detail.content").style.visibility="hidden";
				 oDivEmails.firstChild.data = newField;	 	
			 }	
		     if (oDivEmailsSmall && newField) {
			 	 $("mail." + view.name + ".detail.content").style.visibility="hidden";
                 oDivEmailsSmall.firstChild.data = newField;
             }
        }
        
        // field organization
        if (message["headers"] && message["headers"]["Organization"]) {
        	$("mail." + view.name + ".detail.header.organization").firstChild.data = message["headers"]["Organization"];
            $("mail." + view.name + ".detail.row.organization").style.display = "";
        } else {
        	$("mail." + view.name + ".detail.row.organization").style.display = "none";
        }

        var mda = $("mail." + view.name + ".detail.attachments");        
        var cnn = "";
        var attachmentParam=null;
        var newMessageTextType=null;
		var mailtextchanged=false;
		if(message["attachments_plain"] && !configGetKey("mail.inlineattachments")) { 
			attachmentParam=message["attachments_plain"]; 
			newMessageTextType="attachments_plain"; 
		} else if (message["attachments_html"] && configGetKey("mail.inlineattachments")) { 
			attachmentParam=message["attachments_html"]; 
			newMessageTextType="attachments_html"; 
		} else if(message["attachments_html_noimage"] && configGetKey("mail.inlineattachments")) { 
			attachmentParam=message["attachments_html_noimage"]; 
			newMessageTextType="attachments_html_noimage"; 
		}
				
		if(!oldMessageTextType || !oldMessage || newMessageTextType!= oldMessageTextType || !equals(message[newMessageTextType], oldMessage[newMessageTextType])) {
			removeChildNodes(mda);
			mailtextchanged=true;
			$("mail." + view.name + ".detail.content").style.visibility="hidden";
			for (idfield in attachmentParam) {
                var conArr = attachmentParam[idfield];
                var ct = conArr["content_type"].toLowerCase();
                var con = conArr["content"];
                if (ct.search(/text\//) != -1 && con != null) {
                    if (ct.search(/text\/plain/) != -1) {
                        var tmpcnn=(configGetKey("mail.emoticons") ? replaceSmilies(con) : con);
                        tmpcnn=replaceLeadingSpaces(tmpcnn);
                        cnn += "<div class=\"plainTextContent\">" + tmpcnn + "</div>";
                    } else {
                        cnn += "<div>" + con + "</div>";
                    }           
                } else { 
                    if(conArr["filename"]) {                    
                        var aimg = getMimeImage(ct).match(/empty.png/g) ? getFullImgSrc("img/mail/attachment.gif") : getMimeImage(ct);
                        attachExists = true;
                        var oDOMDiv = newnode("div", 0, { className: "mailDetailAttachmentsCont" },[
						  newnode("img", {verticalAlign: "middle"}, {src: aimg, padding: "3px"}),
                          newnode("span",0,{className: "nothing"},[ 
						      document.createTextNode(format(_(" %1$s (%2$s); "),conArr["filename"], bytesToString(conArr["size"])))
						  ])
                        ]);  
                        addDOMEvent(oDOMDiv, "mousedown", (function(oDOMDiv, selAttach) {
                            return function(e) { cancelDefault(e); selectAttachment(oDOMDiv, selAttach); };
                        })(oDOMDiv, conArr));   
                        registerContext(oDOMDiv,"attachment");
                        addDOMEvent(oDOMDiv, "dblclick", (function(oDOMDiv, selAttach) {
                            return function(e) { stopEvent(e); selectAttachment(oDOMDiv, selAttach); openAttachment("OPEN"); };
                        })(oDOMDiv, conArr));
                        mda.appendChild(oDOMDiv);
                    } else {
                        removeChildNodes(mda);
                    }
                }               
            }       
		}
		
		if(nested_msgs && nested_msgs != "") {	
		    $("mail." + view.name + ".detail.content").style.visibility="hidden";
			mailtextchanged=true;
			for(var nMessage = 0; nMessage < nested_msgs.length; nMessage++) {
				(function(o) {
					var oNestedMessage = new Array(nested_msgs[o]);
					var textAttachment = addTranslated(nested_msgs[o].filename || nested_msgs[o].subject || "message/rfc822 Part" );
					var blank = document.createTextNode(" ");
					var oDOMDiv = newnode("div", 0, { className: "mailDetailAttachmentsCont" },
						[ newnode("img",0,{ src: getFullImgSrc("img/mail/unread.gif"), align: "top", title: textAttachment.data, padding: "3px"}),
						  	newnode("span",0,{className: "_nothing"},
						  		[ blank ]
						  	),
						  	newnode("span", 0, {className: "_nothing", title: textAttachment.data },
						  		[ textAttachment ]
						  	),
						]
					);
					addDOMEvent(oDOMDiv, "mousedown", (function(oDOMDiv, selNested_msgs) {
						return function(e) {
							cancelDefault(e);	
							selectAttachment(oDOMDiv, selNested_msgs.length ? selNested_msgs[0] : selNested_msgs);
							detailNestedMessage = selNested_msgs;
							detailNestedMessage.sid = nMessage;
						};
					})(oDOMDiv, oNestedMessage));
					registerContext(oDOMDiv,"attachment");
					addDOMEvent(oDOMDiv, "dblclick", (function(oDOMDiv, selNested_msgs) {
						return function(e) {
							cancelBubbling(e);	
							selectAttachment(oDOMDiv, selNested_msgs);
							detailNestedMessage = selNested_msgs;
							detailNestedMessage.sid = nMessage;
							openNestedMessage();	
						};
					})(oDOMDiv, oNestedMessage));
					mda.appendChild(oDOMDiv);
				})(nMessage)
			}	
		}
		
        // do we have to enable pishing protection?
		var showPhishingWarn=false;
		if (configContainsKey("modules.mail.phishingheaders") && message["headers"]) {
			var psa = configGetKey("modules.mail.phishingheaders");
			for (ba in psa) {
				if (message["headers"][psa[ba]]) {
					showPhishingWarn = true;
					break;
				}
			}			
		}		
        if (showPhishingWarn) {
            $("mail."+view.name+".detail.header.phishing_protection").style.display="";
        } else {
            $("mail."+view.name+".detail.header.phishing_protection").style.display="none";
        }
		// do we have to enable image protection?
		if (message["attachments_html_noimage"] && !message["attachments_html"] && message["blocked_images"]) {
			//TODO CHECK IF EXISTS IMAGE WHICH ARE REMOVED IN NOIMAGE-ATTACHMENTS
			$("mail."+view.name+".detail.header.image_protection").style.display="";
		} else {
			$("mail."+view.name+".detail.header.image_protection").style.display="none";
		}
		
		// set attachment display
		if (mailtextchanged) {
			$("mail." + view.name + ".detail.content").style.visibility = "hidden";			
			view.setAttachments(attachExists);
			var ih = getFrameElement("mail." + view.name + ".detail.content");			
			if (ih && ih.document) {
				ih = ih.document;
				ih.open();
				ih.writeln(cnn);
				ih.close();
				setTimeout(function(){	
                    var head = ih.getElementsByTagName("head");
					if (head && head.length) {
						head[0].appendChild(				   
					       newnode("link", null,{ type: "text/css", rel: "stylesheet", href: "themes/"+configGetKey("gui.theme").path+"/css/iframe.css" }, null, ih));
					}
					parseDirectLinksInMails(ih);
				}, 0);
			}
		}
        // do we have to send a disposition notification?
		if (!oldMessage || !equals(message["id"], oldMessage["id"])) {
			var dm = message["disp_notification_to"];			
			if (configGetKey("gui.mail.notifyacknoledge") && 
			     !isStdFolder("drafts") && (dm && dm != null && dm != "")) {
				var cbyes = (function(from, id, folder_id) {
					return function() {
						var mail_pn = getPersonalFullName() ? "\"" + getPersonalFullName() + "\" " : "";
						var mail_sa = configGetKey("mail.sendaddress") ? configGetKey("mail.sendaddress") : "undefined";
						var dispObj = { "id": id, "folder": folder_id, "from": mail_pn + "<" + mail_sa + ">" };
						new JSON().put(AjaxRoot + "/mail?action=receipt_ack"
						   + "&folder=" + encodeURIComponent(folder_id) 
						   + "&session=" + session 
						   + "&id=" + encodeURIComponent(id), dispObj, null, function(result) {});
					   }					   
					})(message.from, message.id, message.folder_id);
				newConfirm(_('Do you want to send a delivery receipt?'), 
				    _("Subject:") + " " + (message["subject"] || ""), 
				    AlertPopup.YESNO, null, null, cbyes, null, null);
				// setting disposition_notif in cache to null to prevent showing this dialog again and again
				OXMailMapping.editObjectsInternal([{"module": "mail", "folder_id": message.folder_id, "id": message.id}], { "disp_notification_to": null });
			}
		}
		detailmessage=new Object();
		detailmessage["whole_message"]=message;
		detailmessage["message_text"]=cnn;
		if(message.from) detailmessage["from"]=getAdressString(message.from, false);
		if(message.to) detailmessage["to"]=getAdressString(message.to, false);
		if(message.cc) detailmessage["cc"]=getAdressString(message.cc, false);
		if(message.bcc) detailmessage["bcc"]=getAdressString(message.bcc, false);
		detailmessage["date"]=message.sent_date;
		detailmessage["subject"]=message.subject;
		detailmessage["priority"]=message.priority;
		detailmessage["color-label"]=message.color_label;
		oldMessageTextType=newMessageTextType;
		oldMessage=clone(message);
		oldView=view;
	    // enable content display
        setTimeout(function() { $("mail." + view.name + ".detail.content").style.visibility="visible"; },0);
	}
	
	function selectAttachment(attachCon, selAttach) {
		if (oSel != -1) {
			oSel.className = "mailDetailAttachmentsCont";
		}
		attachCon.className = "mailDetailAttachmentsContSel background-color-PMG-selection-elements";
		selAttachment = selAttach;
		oSel = attachCon;
		triggerEvent("OX_Selected_Nested",false);
		triggerEvent("SubSelected", 1);	

	}
	
	function openNestedMessage() {
		var detailMail = newWindow("detailMail.html#"
		    + "type=" + encodeURIComponent("isNestedMessage") 
		    + "&id=" + encodeURIComponent(message.id)
			+ "&folder=" + encodeURIComponent(message.folder || message.folder_id)
			+ "&sid=" + encodeURIComponent(detailNestedMessage.sid),
			getWindowOptions(), 
			[ message.id, detailNestedMessage.sid, (message.folder || message.folder_id)]);
		detailMail.window.oNestedMessage = detailNestedMessage;
		detailMail.oNestedMessage = detailNestedMessage;
		if (detailMail) {
			detailMail.focus();
		}
	}
	
	function openAttachment(action) {
		var tF = $("mail." + view.name + ".attachment.save");
		var n_url = AjaxRoot + '/mail?action=attachment'
			 + '&session=' + session + '&folder=' + encodeURIComponent(message.folder || message.folder_id)
			 + '&id=' + encodeURIComponent(message.id)
			 + '&attachment=' + selAttachment.id;
		if (action == "OPEN") {
			var attachWin = newWindow(n_url
			    + "&save=0&filter=1",
				getWindowOptions(),
				[(message.folder || message.folder_id), message.id, selAttachment.id]);
			if (attachWin) {
				attachWin.focus();
			}
			try{
				attachWin.document.title = selAttachment.filename;
			} catch (e) { }
		} else if (action == "SAVE" && tF && tF.src) {
			//tF.location.href=n_url+"&save=1";
			tF.src = n_url+"&save=1";
		} else {
			//#. %s will be replaced with an internal error code
			triggerEvent("OX_New_Error", 4, format(_("Internal Error: Unable to open the Attachment (%s)."), "MA01"));
		}
	}
		
	function MailFunctions() { }
	
	MailFunctions.prototype = {
		showMailSource : function(messageObj) {
			var mailSource = null;
			var mailViewSourceObject = null;
			if (messageObj)
				mailViewSourceObject = messageObj;
			else if (message)
				mailViewSourceObject = message;	
			else
			    mailViewSourceObject = mailSelection.getSelected()[0];						
			
			var showSourceCb = function() {
				json.get(AjaxRoot + "/mail?action=get&session=" + session + "&folder=" 
					+ encodeURIComponent(mailViewSourceObject.folder || mailViewSourceObject.folder_id ) + "&id=" + encodeURIComponent(mailViewSourceObject.id)+"&src=true",
					null,
					function(reply) {
						OXMailMapping.editObjectsInternal([mailViewSourceObject],null,true,[{ flag : 32 , bool : true }]);
						var text = _("Unable to display E-Mail source.");
						if (reply.data) {
							text = reply.data.replace(/[<&]/g, function(a,b,c) {
									return (a == "&" ? "&amp;" : "&lt;");
								});
						}
						if(mailSource && mailSource.document && mailSource.document.getElementsByTagName('body')[0])
							mailSource.document.getElementsByTagName('body')[0].innerHTML = "<pre>"+text+"</pre>";
							
						unregister('OX_Popup_Cb', showSourceCb);
					}
				);
			}
			register('OX_Popup_Cb', showSourceCb);
			mailSource=newWindow("popup_trigger_cb.html#triggerevent=OX_Popup_Cb", getWindowOptions(), 
				{ "folder": encodeURIComponent(mailViewSourceObject.folder), "id": encodeURIComponent(mailViewSourceObject.id) });
		},
		markAsFlag: function(mailFlag) {
            OXMailMapping.setMailFlags(mailFlag,menuselectedobjects);
        },
        /**
         * marks a message as spam
         * @param Object msg - an object containing message information, e.g. folder_id, id and module
         *                     if not set, current selected objects will be taken instead
         */
        markAsSpam: function(msg) {
        	if (msg) {
        		msg = [ OXMailMapping.createKeyFromObject(clone(msg)) ];
        	}
            OXMailMapping.setMailFlags("spam", msg || menuselectedobjects);
        },
        markAsHam: function() {
            OXMailMapping.setMailFlags("ham",menuselectedobjects);
        }
	}
	
	oMailFunctions = new MailFunctions();
	
	/**
	 * Switches between the full mail header and the small mail header in the
	 * current view. Note: the view object must be correctly set!
	 * @param fullHeader true = full mail header, otherwise false
	 */
	switchMailHeaderView = function (fullHeader) {
		var fh = $("mail." + view.name + ".detail.header.table");
		var sh = $("mail." + view.name + ".detail.header.table_small");				
		if (!fh.style.display && fullHeader)
			return; // nothing to do
		
		var img = $("mail." + view.name + ".detail.header.header_switch");
		img.src = fullHeader ? getFullImgSrc("img/minus.gif") : getFullImgSrc("img/plus.gif");
		fh.style.display = fullHeader ? "" : "none";
		sh.style.display = fullHeader ? "none" : "";
		view.setAttachments($("mail." + view.name + ".detail.attachments").style.height != "0px");

		configSetKey("gui.mail.fullmailheader", fullHeader);
	}
	
	loadBlockedImages = function() {
		if (currentpath[1] != "list") {
		  fetchMessage(view, mail_lastSelectedId, true);
		}
	}
	
	/**
	 * Change sort order at the vsplit view
	 */
	function setVsplitSortEntry(field, order) {
		sort_id = field || sort_id;
		if (order) { 
			sort_order = (typeof order == "boolean" ? (sort_order == "asc" ? "desc" : "asc") : sort_order = order);
		}
		$("mail.vsplit.sortOrder").replaceChild(newnode("span",0,0,[sortType[sort_id]]), $("mail.vsplit.sortOrder").firstChild);
		$("mail.vsplit.sortType").firstChild.data=(sort_order == "asc" ? _("ascending") : _("descending"));
		$("mail.vsplit.sortTypeImg").src = getFullImgSrc(sort_order == "asc" ? "img/arrows/sort_up.gif" : "img/arrows/sort_down.gif");

        if (sort_id != view.grid.sort_id || sort_order != view.grid.sort_order) {
        	view.grid.setSort(sort_id, sort_order);
        }
	}
	
	/**
	 * Init sort menu at the vsplit view
	 */
	initVsplitSortMenu = function() {		
		registerContext($("mail.vsplit.sortOrder"),"mail_vsplit_sort",null,null,null,"click",$("mail.vsplit.sortOrder"));
		
		addContextNode(contextmenu_createOnlyDiv("From"), /*i18n*/		
	 			["mail_vsplit_sort"],
				function() {
					setVsplitSortEntry("from"); 
				}, null,
				function() {
					return !(isStdFolder("sent") || isStdFolder("drafts"));
				},
				contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
				
		addContextNode(contextmenu_createOnlyDiv("To"), /*i18n*/
	 			["mail_vsplit_sort"],
				function() {
					setVsplitSortEntry("to"); 
				},null,
				function() {
					return (isStdFolder("sent") || isStdFolder("drafts"));
				},
				contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
	
		addContextNode(contextmenu_createOnlyDiv("Subject"), /*i18n*/
	 			["mail_vsplit_sort"],
				function() {
					setVsplitSortEntry("subject"); 
				},null,null,
				contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
				
		addContextNode(contextmenu_createOnlyDiv("Sent"), /*i18n*/
	 			["mail_vsplit_sort"],
				function() {
					setVsplitSortEntry("sent_date"); 
				},null,
				function() {	
					return (isStdFolder("sent") || isStdFolder("drafts"));
				},
				contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
				
		addContextNode(contextmenu_createOnlyDiv("Received"), /*i18n*/
	 			["mail_vsplit_sort"],
				function() {
					setVsplitSortEntry("received_date");
				},null,
				function() {
					return !(isStdFolder("sent") || isStdFolder("drafts"));
				},
				contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
				
		addContextNode(contextmenu_createOnlyDiv("Size"), /*i18n*/
	 			["mail_vsplit_sort"],
				function() {
					setVsplitSortEntry("size"); 
				},null,null,
				contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
				
		addContextNode(contextmenu_createOnlyDiv("Read/Unread"), /*i18n*/
	 			["mail_vsplit_sort"],
				function() {
					setVsplitSortEntry("flags_sort"); 
				},null,null,
				contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
			
		addDOMEvent($("mail.vsplit.sortType"), "mousedown", function() {
						setVsplitSortEntry(null,true);
					});
	}
	
	function isStdFolder(folder) {
		return (activefolder == configGetKey("mail.folder." + folder));
	}

})();

function updateDraftsFolderCache(delid, newid) {
	if (delid)
		OXMailMapping.deleteObjectsInternal( 
		  [ OXMailMapping.createKeyFromObject(
		      { module: "mail", 
		        folder_id: configGetKey("mail.folder.drafts"), 
		        id: delid }) ], true);
	if (newid)
		OXMailMapping.createObjectsInternal( 
		  [ OXMailMapping.createKeyFromObject(
		      { module: "mail", 
		        folder_id: configGetKey("mail.folder.drafts"), 
		        id: newid }) ], true);
}

/**
 * Updates sytem flags of the given message in object cache
 * @param folder_id - The folder id
 * @param object_id - The object id
 * @param flags - {object} new system flags 
 */
function updateMailFlagsInternal(folder_id, object_id, flags) {
	OXMailMapping.editObjectsInternal([
	       OXMailMapping.createKeyFromObject({ 
	       	       module: "mail", folder_id: folder_id, id: object_id 
	       	   })], null,true, [flags]);
}

function deleteAutosaveMessage(folder, id, harddelete) {
	OXMailMapping.deleteObjects(
	       [ OXMailMapping.createKeyFromObject(
	           { module: "mail", 
	             folder_id: folder, 
	             id: id }) 
	       ], harddelete);
}

function jumpToMailConfiguration(divId){
	if(divId && $(divId))
		$(divId).style.display = 'none';
	triggerEvent("OX_Switch_View","configuration/mail/preferences");
}

function getRefToMainForMailPopup() {
	return window;
}

/**
 * Returns a formatted String of the given Address Array
 * @param Address Array (see HTTP-API specification)
 * @param personal flag, true = only add personal address informations
 */
function getAdressString(addresses, personal) {
	var retVal = "";
	for (a = 0; a < addresses.length; a++) {
		var q1 = "", q2 = "";
		if (addresses[a][0] != null) {
			retVal += addresses[a][0];
			q1 = " <", q2 = ">";
		}
		if ((!personal || addresses[a][0] == null) && addresses[a][1] != null)
			retVal += q1 + addresses[a][1] + q2;
				
		if ((addresses.length-1) > a)
			retVal += ", ";
	}
	return retVal;
}

function sendMailToRecipientMail(recipient) {
	if(recipient && recipient != "") {
		var newMail = newWindow("newMail.html#action=&id=&folder=&to=" + encodeURIComponent(recipient),
		getWindowOptions());
	}
}

function mail_quoteHTMLTags(val) {
	return val || val.replace(/</gi,"&lt;").replace(/"/gi,"&quot;"); 
}

function mail_printDetailMail(messageobject) {	
	if(!messageobject)
		messageobject=detailmessage;
	
	var mailprintarray=new Array();
	mailprintarray.push(Print.createTitle(messageobject.subject));
	mailprintarray.push(Print.createLine("5px"));
	mailprintarray.push(Print.createEmpty());
	if(messageobject.from)
		mailprintarray.push(Print.createContent(_("From:"),mail_quoteHTMLTags(messageobject.from)));
	if(messageobject.to)
		mailprintarray.push(Print.createContent(_("To:"),mail_quoteHTMLTags(messageobject.to)));
	if(messageobject.cc)
		mailprintarray.push(Print.createContent(_("Cc:"),mail_quoteHTMLTags(messageobject.cc)));
	if(messageobject.bcc)
		mailprintarray.push(Print.createContent(_("Bcc:"),mail_quoteHTMLTags(messageobject.bcc)));
	mailprintarray.push(Print.createEmpty());
	if(messageobject.priority) {
		switch(messageobject.priority) {
			case 1:
				mailprintarray.push(Print.createContent(_("Priority:"),_("Very high")));
				break;
			case 2:
				mailprintarray.push(Print.createContent(_("Priority:"),_("High")));
				break;
			case 3:
				mailprintarray.push(Print.createContent(_("Priority:"),_("Normal")));
				break;
			case 4:
				mailprintarray.push(Print.createContent(_("Priority:"),_("Low")));
				break;
			case 5:
				mailprintarray.push(Print.createContent(_("Priority:"),_("Very low")));
				break;
		}
	}
	if(messageobject.date) {
		var datestring=formatDate(new Date(messageobject.date),"datetime");
		mailprintarray.push(Print.createContent(_("Date"),datestring));
	}
	mailprintarray.push(Print.createLine("2px"));
	mailprintarray.push(Print.createEmpty());
	mailprintarray.push(Print.createMail(messageobject.message_text));	
	
	mailprintarray.push({ type: "mailattachments", "mailattachments" : messageobject.message_attachments});
	
	//TODO MAIL
	var mailprint=new Print(messageobject.subject);
	mailprint.printDetail(mailprintarray);
}

register("Loaded", function() {
	registerContext($("arrowForMailListOptions"),"mailOptions",null,null,null,"click");
	registerContext($("arrowForMailVSplitOptions"),"mailOptions",null,null,null,"click");
	registerContext($("arrowForMailHSplitOptions"),"mailOptions",null,null,null,"click");
		
	addContextNode(contextmenu_createImgDiv("Options",/*i18n*/
		getFullImgSrc("img/folder/settings.gif"),getFullImgSrc("img/folder/settings.gif")),
		["mailOptions"],
		function() { 
			var elem=currentpath2.join("/");
			if(elem.indexOf("mail") == 0) {
				triggerEvent("OX_Switch_View","configuration/mail/preferences");
		 	}	
		},null,null,contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);
		
	initVsplitSortMenu();
});

// set some default config options, if not already set
register("OX_Configuration_Loaded_Complete",function () {
	if (!configContainsKey("gui.mail.fullmailheader")) {
		configSetKey("gui.mail.fullmailheader",true);
	}
});

fileloaded();