/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

(function() {
    var team = [];

    getTeamList = function() { return team; };
    
    getTeamMember = function(id) { return team[id]; };
    
    setTeam = function(members, silent) {
        team = [];
        addToTeam(members, silent);
    };

    removeFromTeam = function(members, silent) {
        for (var i in members)
            delete team[members[i].id + ":" + members[i].type];
        if (!silent) triggerEvent("OX_Teammember_Changed", team);
    };
    
    addToTeam = function(members, silent) {
        var groups = [];
        for (var i in members) {
            var member = members[i];
            switch (member.type) {
                case 1:
                case 3:
                    team[member.id + ":" + member.type] = member;
                    break;
                case 2:
                    groups.push(member);
            }
        }
        if (groups.length) {
            internalCache.getObjects(groups, resolvedGroups(silent));
        } else {
            if (!silent) triggerEvent("OX_Teammember_Changed", team);
        }
    };
    
    function resolvedGroups(silent) {
        return function(groups) {
            var set = {};
            for (var i in groups) {
                var members = groups[i].members;
                for (var j in members) set[members[j]] = true;
            }
            var ids = [];
            for (var i in set) ids.push(Number(i));
            internalCache.getUsers(ids, resolvedUsers(silent));
        };
    }
    
    function resolvedUsers(silent) {
        return function(users) {
            for (var i in users) {
                team[i + ":1"] = {
                    id: users[i].id, type: 1,
                    display_name: users[i].display_name
                };
            }
            if (!silent) triggerEvent("OX_Teammember_Changed", team);
        };
    }

})();

var firstteam=true;
function filldefaultteam() { 
	if(firstteam) {
		var teams=new Array();
		if(configContainsKey("gui.calendar.teams")) {
			teams=configGetKey("gui.calendar.teams");
			
		}
        for(var i=0;i<teams.length;i++) {
			if(teams[i].team_default) {
                setTeam(teams[i].children, true);
				break;
			}
		}
		firstteam=false;
	}
}
register("OX_Configuration_Loaded_Complete",
function() {
	var mydivs=$("ctd_timeline_scroller").getElementsByTagName("div");
	for(var i=0;i<mydivs.length-1;i++) {
		
		mydivs[i].firstChild.nodeValue =
            formatDate(new Date(i * 36e5 /* ms/h */), "onlyhour");
	}
	ctd_scroll();
});
var team_participants_selected=new Array();
var ctd_date=new Date();

var ctd_participants = null;
var ctd_storages=new Object();
var ctd_calendar_objects=new Object();
var ctd_myteams=new Array();
function ctd_createKeyfromUserObject(object) {
	return ""+object.id+":"+object.type+"";
}

//TODO 
/** ctd_reset = true if Configuration_Changed */
//register("Loaded",);
register("OX_Calendar_Teammember_Add",team_changeTeammembers);
register("OX_Calendar_Teammember_Remove",team_removeTeammembers);
register("OX_Calendar_Team_Change",team_onchangeTeam);
register("OX_Selected_Member",team_storeSelectedMember);

function team_initContent() {
	team_createParticipantsPopUp();
}
function team_onchangeTeam() {
	popup($("menu_calendar_teammember_teams_popup"));
	var teamtbody=$("menu_calendar_teammember_teams_popup_content");
	removeChildNodes(teamtbody);
	myteams=new Array();
	if(configContainsKey("gui.calendar.teams")) {
		myteams=configGetKey("gui.calendar.teams");
	}
	var newelement;
	for(var i=0;i<myteams.length;i++) {
		newelement=$("cal_teams_template").cloneNode("true");
		newelement.id="cal_new_team-"+i;
		newelement.getElementsByTagName("div")[0].firstChild.nodeValue=myteams[i].name;
		teamtbody.appendChild(newelement);
	}
}
function ctd_selectPermanentTeam(element) {
	$("menu_calendar_teammember_teams_popup").style.display="none";
    team_participants_selected=new Array();
    setTeam(myteams[element.split("-")[1]].children);
}

function team_removeTeammembers() {
	removeFromTeam(team_participants_selected);
}
function team_changeTeammembers() {
	ctd_participants.openAddParticipantsWindow(); 
}
function team_storeSelectedMember(response) {
	team_participants_selected=response;
	triggerEvent("SubSelected",team_participants_selected.length);
}
function team_createParticipantsPopUp() {
	ctd_participants = new ParticipantsSmall(null,addToTeam,true,true,true,false,"Select Users", /*i18n*/
						false,false,false,true); 
}

var template_content_oneline; 

var ctd_reset=true;


/** Execute when display **/
function ctd_startContent() {
	triggerEvent("Selected",0);
	ctd_date = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));
	ctd_updateDateHeader();	
	register("OX_Teammember_Changed",ctd_membersChanged);
	if(ctd_reset) {
		ctd_createTemplates();
		ctd_reset=false;
	}
	ctd_reload();
	ctd_scroll();
}
function ctd_leaveContent() {
	unregister("OX_Teammember_Changed",ctd_membersChanged);
}
function ctd_membersChanged(allmembers) {
	ctd_reloadTeamUsers(allmembers);
}
function goToNextTeamDay(days) {
	ctd_date.setUTCDate(ctd_date.getUTCDate()+days);
	ctd_updateDateHeader();
	ctd_reload();
}
function ctd_updateDateHeader() {
	var d = $("ctd_time");
	activeMonth= ctd_date.getUTCMonth();
	activeYear = ctd_date.getUTCFullYear();
	activeDay = ctd_date.getUTCDate();
	oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
	d.firstChild.nodeValue=formatDate(ctd_date,"dateday");	
}
function ctd_changeTeammember(element) {
	for(i=0;i<team_participants_selected.length;i++) {
		var myid="ctd_"+ctd_createKeyfromUserObject(team_participants_selected[i]);
		if(document.getElementById(myid)) {
			document.getElementById(myid).className="";
		}		
	}
	var elemid=element.id.substring(4,element.id.length);
	var member = getTeamMember(elemid);
    if(member) {
		
		triggerEvent("OX_Selected_Member",[member]);
	}
	for(i=0;i<team_participants_selected.length;i++) {
		var myid="ctd_"+ctd_createKeyfromUserObject(team_participants_selected[i]);
		if(document.getElementById(myid)) {
			document.getElementById(myid).className="background-color-selection-elements font-weight-high font-color-selected";
		}		
	}
}
function ctd_fillTeammemberField(userObject) {
	var tmp;
	if(userObject) {
		tmp=$("ctd_template_users").cloneNode(true);
		tmp.id="ctd_"+ctd_createKeyfromUserObject(userObject);
		tmp.getElementsByTagName("div")[1].firstChild.nodeValue=userObject.display_name;
        tmp.getElementsByTagName("img")[0].src = getFullImgSrc("img/calendar/" +
            ({ 1: "user", 2: "group", 3: "ressourcen" }[userObject.type]
             || "user") + ".gif"); 
	}
	else {
		tmp=$("ctd_template_users_empty").cloneNode(true);
		tmp.id="ctd_empty";
	}
	return tmp;
}
function ctd_reload() {
    addToTeam([]);
}
function ctd_clearView() {
	for (var i in ctd_storages) {
		for(i2=0;i2<ctd_storages[i].divs.length;i2++) {
			var tmp=ctd_storages[i].divs[i2];
			tmp.parentNode.removeChild(tmp);
		}
	}
	ctd_storages=new Object();
	ctd_calendar_objects=new Object();
}

function ctd_reloadTeamUsers(response) {
	ctd_clearView();
	triggerEvent("OX_Selected_Member",new Array());
	var teams=$("ctd_teammembers");
	removeChildNodes(teams);
	var teamsbody=document.createElement("tbody");
	var contents=$("ctd_content");
	removeChildNodes(contents);
	var contentsbody=document.createElement("tbody");
	
	for (key in response) {
		if(response[key].type<5) {
			ctd_storages[key]=new Object();
			ctd_storages[key].userobject=response[key];
			ctd_storages[key].divs=new Array();
			ctd_storages[key].divs[0]=ctd_fillTeammemberField(response[key]);
			ctd_storages[key].divs[1]=template_content_oneline.cloneNode(true);
			teamsbody.appendChild(ctd_storages[key].divs[0]);
			contentsbody.appendChild(ctd_storages[key].divs[1]);	
		} else {
			delete response[key];
		}
	}
	teamsbody.appendChild(ctd_fillTeammemberField(null));
	teams.appendChild(teamsbody);
	contents.appendChild(contentsbody);
	fillFreeBusyRequest(response);
}
var ctd_freebusy_requests=new Object();
function fillFreeBusyRequest(response) {
	var ctd_freebusy_objects=new Object();
	ctd_freebusy_objects["request"] = new Array();
	ctd_freebusy_objects["objects"] = new Array();

	for(zaehler in response)
	{
		var requestObject = new Object();
		requestObject['module'] = "calendar";
		requestObject['action'] = 'freebusy';
		requestObject['id'] = response[zaehler].id;
		requestObject['type'] = response[zaehler].type;
		requestObject['start'] = ctd_date.getTime();
		requestObject['end']= ctd_date.getTime()+(1000*60*60*24);	
		ctd_freebusy_objects["request"].push(requestObject);
		ctd_freebusy_objects["objects"].push(response[zaehler]);
	}
	if(!ctd_freebusy_objects["request"].length>0) {
	 return;
	}
	json.put(AjaxRoot + "/multiple?session=" + session,ctd_freebusy_objects["request"],null,ctd_freeBusyResponse);
	function ctd_freeBusyResponse(response) {
		for(var i=0;i<response.length;i++) {
			ctd_storages[ctd_createKeyfromUserObject(ctd_freebusy_objects["objects"][i])]["freebusy_response"]=response[i].data;
		}
		var requestObject = new Object();
		requestObject["module"] = "calendar";
		requestObject['action'] = 'all';
		requestObject['start'] = ctd_date.getTime();
		requestObject['end']= ctd_date.getTime()+(1000*60*60*24);	
		var calendarwwfields = new Array(1,20, 207, 206, 2, 200, 201, 202, 203, 209, 220, 401, 402, 102, 400, 101);
		requestObject['columns'] = calendarwwfields.toString();		

		var requests=new Array();
		requests.push(requestObject);
		json.put(AjaxRoot + "/multiple?session=" + session,requests,null,ctd_getAllObjects);
	}
	function ctd_getAllObjects(response) {
		var oneresponse=response[0].data;

		for(var i=0;i<oneresponse.length;i++) {
			var tmpdata=oneresponse[i];
			ctd_calendar_objects[tmpdata[0]] = new CalendarWorkWeekObject(tmpdata[0],tmpdata[1],tmpdata[2],tmpdata[3],tmpdata[4],tmpdata[5],tmpdata[6],tmpdata[7],tmpdata[8],tmpdata[9],tmpdata[10],tmpdata[11],tmpdata[12],tmpdata[13],tmpdata[14],tmpdata[15],tmpdata[16]);
		}
		ctd_showObjects();
	}
}
function ctd_showObjects() {
	for (user in ctd_storages) {
		var myappointments=ctd_storages[user].freebusy_response;
		ctd_storages[user].matrix=new Array((Math.round((1000*60*60*24)/(1000*60*15))));
		for(z1=0;z1<ctd_storages[user].matrix.length;z1++)
		{
			ctd_storages[user].matrix[z1]=new Array();
		}
		if(myappointments) {
			for(var i=0;i<myappointments.length;i++) {
				ctd_drawAppointments(user,myappointments[i]);
			}
		}
	} 
}
function ctd_drawAppointments(user,appointmentfreebusy) {
	var myobject=appointmentfreebusy;
	if(ctd_calendar_objects[myobject.id]) {
		myobject=ctd_calendar_objects[myobject.id];
	}
	else
	{
		myobject.start_date=new Date(myobject.start_date);
		myobject.end_date=new Date(myobject.end_date);
	}
	ctd_drawAppointment(user,myobject);
}
var ctd_idcounter=0;
function ctd_drawAppointment(user,calendarobject)
{
	var ctdline=10;
	var myinterval=1000*60*15;
	var oneday=1000*60*60*24;
	var myintervalcounts=Math.round(oneday/myinterval);
	
	var showappointment=true;
	//Object Zaehler

	// Startdate Correction Complete Appointment
	// Setze Startzeit des Termins um , falls er vor meiner Anzeige beginnt
	var sdt=calendarobject["start_date"].getTime();
	if(sdt<ctd_date.getTime()) {
		calendarobject["start_date"]=new Date(ctd_date.getTime());
		sdt=calendarobject["start_date"].getTime();
	}
	// Setze Endzeit des Termins um , falls er nach meiner Anzeige beginnt
	var edt=calendarobject["end_date"].getTime();
	if(edt>ctd_date.getTime()+1*(oneday)) {
		calendarobject["end_date"]=new Date(ctd_date.getTime()+(1*oneday));
		edt=calendarobject["end_date"].getTime();
	}
	var sdttmp=sdt;
	while(sdttmp<edt)
	{
		showappointment=true;
		var longstart  =   (sdttmp % oneday);
		var startpoint =   Math.round(longstart/myinterval);
		var edttmp=edt;
		var longend= (edt % oneday);
		var endpoint   =   Math.round(longend/myinterval);
		// An diesem Tag nicht zu Ende
		if(sdttmp - (sdttmp % oneday) + oneday <= edt) {
			endpoint = myintervalcounts;							
		} 
		// Check Place Allocation
		
		var tiefe=0;  			//Place
		var allelements=0;		//AllElements
	
		for (zaehler=startpoint;zaehler<endpoint;zaehler++) {
			var maxelements = ctd_storages[user].matrix[zaehler].length;
			if(allelements<maxelements) {
				allelements=maxelements;
			} 
			if(ctd_storages[user].matrix[zaehler][tiefe]) {
				tiefe++;
				zaehler=startpoint;
				if(tiefe==2) {
					showappointment=false;	
					break;
				}
			}
		}
		if(!showappointment){
		//	document.getElementById("cwwmoreappointments"+sdd).style.display="";
		} else {
			var myappointment=$("ctd_appointment_template").cloneNode(true);
			myappointment.id=+calendarobject.folder_id +"-"+calendarobject.id+"-"+ctd_idcounter;
			ctd_idcounter++
			var appointmentcontainer=ctd_storages[user].divs[1].getElementsByTagName("div")[0];
		
		//FILL APPOINTMENTS
			var ddivs=myappointment.getElementsByTagName("div");
			// Shown As 
			switch (calendarobject.shown_as) {
				case 1:
					ddivs[0].className="appointmentRESERVED";
					break;
				case 2:
					ddivs[0].className="appointmentTEMPORARY";
					break;
				case 3:
					ddivs[0].className="appointmentABSENT";
					break;
				case 4:
					ddivs[0].className="appointmentFREE";
					break;
			}
			// Title 
			if(calendarobject.title) {
				ddivs[1].firstChild.nodeValue=calendarobject.title;
			}
			else {
				ddivs[1].firstChild.nodeValue="";
			}
			// Recurrence Type 
			if(calendarobject.recurrence_type) {
				if(calendarobject.recurrence_type!=0) {
					ddivs[2].style.paddingLeft="7px";
					ddivs[2].innerHTML="<img src='"+getFullImgSrc("img/calendar/calendar_series.gif")+"'></img>";
				}
			}		
			// Tagging 
			if(calendarobject.color_label && calendarobject.color_label!=0) {
				ddivs[3].style.display = "block";
				ddivs[3].style.paddingLeft="7px";
				ddivs[3].innerHTML="<img src='"+getFullImgSrc("img/menu/tag_"+calendarobject["color_label"]+".gif")+"' alt='tag' />";
			} else 
				ddivs[3].style.display = "none";
			if(calendarobject.private_flag) {
				ddivs[4].style.display = "block";
				ddivs[4].innerHTML="<img src='"+getFullImgSrc("img/private_flag.gif")+"' alt='private' />";
			} else {
				ddivs[4].style.display = "none";
			}	
			//New Element is Latest
			if(allelements<tiefe+1) {
				allelements=tiefe+1;
			}
			appointmentcontainer.appendChild(myappointment);
			for(zaehler=startpoint;zaehler<endpoint;zaehler++)
			{
				ctd_storages[user].matrix[zaehler][tiefe]=new MatrixObject(calendarobject.folder_id,calendarobject.id,calendarobject.recurrence_id,myappointment.id);
				for(superzaehler=allelements;superzaehler>=0;superzaehler--) {
					//REDRAW ALL APPOINTMENTS IF EXISTS
					if(ctd_storages[user].matrix[zaehler][superzaehler])	
					{
						myappointment.style.width=((endpoint-startpoint)*ctdline)-2+"px";	
						myappointment.style.left=startpoint*ctdline+"px";
						ctd_redrawAppointment(allelements,superzaehler,ctd_storages[user].matrix[zaehler][superzaehler].element_id);					
					}						
				}
			}
			
		}
		if(sdt==sdttmp) {
			sdttmp = sdttmp - (sdttmp % oneday);
		}
		sdttmp = sdttmp+oneday;
	}
}
function ctd_redrawAppointment(elementlength,position,elementid) {
	var d=document.getElementById(elementid);
	d.style.height=(Math.round(100/elementlength)-4)+"%";
	d.style.top=(Math.round(100/elementlength)*position)+"%";
}	
function ctd_createTemplates() {
	var startworktime  = 1000*60*60*8;
	var endworktime  = 1000*60*60*18;
	ctd_createCalendarContent(startworktime,endworktime);
}
function ctd_createCalendarContent(startworktime,endworktime) {
	var templateofftime =$("ctd_template_contentofftime");
	var templateworktime=$("ctd_template_contentworktime");
	template_content_oneline=document.createElement("tr");
	for (var i=0;i<24;i++) {
		if(((i*1000*60*60)<startworktime) || ((i*1000*60*60)>=endworktime)) {
			var mytemp=templateofftime.cloneNode(true);
			mytemp.id="";
			if(i==0) {
				mytemp.getElementsByTagName("div")[0].style.position="relative";
			}
			template_content_oneline.appendChild(mytemp);
		} else {
			var mytemp=templateworktime.cloneNode(true);
			mytemp.id="";
			if(i==0) {
				mytemp.getElementsByTagName("div")[0].style.position="relative";
			}
			template_content_oneline.appendChild(mytemp);
		}
	}
}
function ctd_scroll() {
	var scroll1=$("ctd_scroller");
	$("ctd_participants_scroller").scrollTop= (scroll1.scrollTop) ;
	$("ctd_timeline_scroller").scrollLeft=(scroll1.scrollLeft) + 20;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var oTeamWeek;
var TWPartPopup;
function goToNextTeamWeek(nDirection)
{
    if(nDirection>0)
        oTeamWeek.next();
    else
        oTeamWeek.back();
        
    if (oMiniCalendar) oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
}

function teamWeekAddTeammember(oMemberHM)
{
    if(oTeamWeek)
        oTeamWeek.updateMemberList(oMemberHM);
}

function unloadTeamWeek()
{
    unregister("OX_Teammember_Changed",teamWeekAddTeammember);
    resizeEvents.unregister("Resized",resizeTeamWeekHeader);    
}

function loadTeamWeek()
{
    register("OX_Teammember_Changed",teamWeekAddTeammember);
    if(!oTeamWeek)
    {
        oTeamWeek = new teamWeek();
    }
    else
    {
        oTeamWeek.set_current_week();
        oTeamWeek.updateHeader();
    }   
    resizeTeamWeekHeader();
    resizeEvents.register("Resized",resizeTeamWeekHeader);
    
    var team = getTeamList();
    if(team)
    {
        oTeamWeek.updateMemberList (team);
    }
}

function resizeTeamWeekHeader()
{
    var e1=$("teamWeekBody");
    var mywidth=e1.offsetWidth;
    if(!mywidth)
    $("teamWeekTableHead").style.width=mywidth+"px";
}
function clickMemberTeamWeek(obj)
{
    var sTRId = obj.id;
    oTeamWeek.selectMember(sTRId);
    document.getElementById('u_team_week' + '_' + obj.id.split('_')[3]).className += ' background-color-selection-elements font-weight-high font-color-selected';
}

/////////////////////////////////////////////////////////////////////////
function teamWeek()
{
    this.template = $('team_week_row');
    this.container_id = 'teamWeekTableContent';
    this.container = newnode('tbody',0,{width:'100%'});
    this.membercount = 0;
    this.memberlist;
    
    this.selected_member = new Array();
    this.selected_row_id = null;
    
    this.member_assoc = new Object();
    this.app_assoc = new Object();  
    
    this.full_data_aps = new Object();
    
    this.calendar_tool;
    this.kw;
    this.monday;
    this.friday;
    
    this.set_current_week();
    this.updateHeader();
    
    this.app_collector = new Object();
}


teamWeek.prototype = {
set_current_week:function ()
{
    this.calendar_tool = new calendarTool(activeMonth,activeYear);
    this.kw = this.calendar_tool.getKW(activeYear,activeMonth,activeDay);
    var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));
    this.monday = new Date(getDayInSameWeek(oDateLoc, weekStart) * 864e5);
    this.friday = new Date(this.monday.getTime());
    this.friday.setDate(this.friday.getDate()+5);
},
next:function ()
{
    var oDateLoc = new Date();
    oDateLoc.setUTCDate(1);
    oDateLoc.setUTCHours(0);
    oDateLoc.setUTCFullYear(activeYear);
    oDateLoc.setUTCMonth(activeMonth);
    oDateLoc.setUTCDate(activeDay);
    oDateLoc.setUTCDate(oDateLoc.getUTCDate()+7);
    activeDay = oDateLoc.getUTCDate();
    activeMonth = oDateLoc.getUTCMonth();
    activeYear = oDateLoc.getUTCFullYear();
    this.set_current_week();        
    this.updateAppointmentView();
},  
back:function ()
{   
    var oDateLoc = new Date();
    oDateLoc.setUTCDate(1);
    oDateLoc.setUTCHours(0);
    oDateLoc.setUTCFullYear(activeYear);
    oDateLoc.setUTCMonth(activeMonth);
    oDateLoc.setUTCDate(activeDay);
    oDateLoc.setUTCDate(oDateLoc.getUTCDate()-7);
    activeDay = oDateLoc.getUTCDate();  
    activeMonth = oDateLoc.getUTCMonth();
    activeYear = oDateLoc.getUTCFullYear();
    this.set_current_week();    
    this.updateAppointmentView();   

},
updateHeader:function()
{
    removeChildNodes($('teamWeekHead'));
    var oTextNode = document.createTextNode(this.kw + ' ' + this.calendar_tool.curr_date.getFullYear());
    $('teamWeekHead').appendChild(oTextNode);
    var startDate = new Date(this.monday);
    for(var indx=1;indx<=5;indx++)
    {
        var sHeaderId = 'teamWeekCol_header_' + indx;
        removeChildNodes($(sHeaderId));
        var oTextNode = document.createTextNode(formatDate(startDate,"dateday"));       
        $(sHeaderId).appendChild(oTextNode) ;
        startDate.setUTCDate(startDate.getUTCDate()+1);
    }
},
updateAppointmentView:function()
{
    this.clearAppView();
    this.fetchAppointments(this.memberlist);
    this.updateHeader();
},
clearAppView:function ()
{   
    for(var ikey in this.member_assoc)
    {
        for(var indx=1;indx<6;indx++)
        {
            var sId = 'd'+indx + '_team_week_' + ikey.split('_')[3];
            var oParentDiv = document.getElementById(sId);
            while(oParentDiv.childNodes.length>0)
            {
                oParentDiv.removeChild(oParentDiv.firstChild);
            }
            oParentDiv.innerHTML = '&#xa0;';
        }
    }
    this.app_collector = new Object();  
},
drawAppointments:function (oAppointments,nRowId)
{
    var sPostfix = nRowId.split('_')[3];    
    this.app_collector[sPostfix] = new Array();
    function duplicate_app(app) {
        var copyApp = new Object();
        copyApp["id"] = app.id;
        copyApp["start_date"] = app.start_date;
        copyApp["end_date"] = app.end_date;
        copyApp["shown_as"] = app.shown_as;                                                         
        copyApp["full_time"] = app.full_time;
        copyApp["title"] = app.title
        return copyApp;
    }
    for (var indx=0; indx<oAppointments.data.length; indx++) {
        var tApp = duplicate_app(oAppointments.data[indx]);
        var sIdAp = 'app_d_' + nRowId + '_' + indx;
        this.app_assoc[sIdAp] = (this.full_data_aps[tApp.id]==undefined) ? tApp : this.full_data_aps[tApp.id];
        
        /*
         * set appointment start day to the start day of this week
         * if it starts before monday        
         */
        if (tApp.start_date < this.monday.getTime()) {
            tApp.start_date = this.monday.getTime();
        }
        /*
         * set appointment end day to the end day of this week
         * if it ends after this friday      
         */
        if (tApp.end_date > this.friday.getTime()) {
            tApp.end_date = this.friday.getTime();
        }
        
        var oDateStart = new Date(tApp.start_date);
        var oDateEnd = new Date(tApp.end_date); 
        var nStartDay = oDateStart.getUTCDay();
        var nEndDay = oDateEnd.getUTCDay();
        var appDuration = Math.ceil(tApp.end_date/864e5) - Math.floor(tApp.start_date/864e5);       
 
        if (appDuration == 1) {
            tApp.assoc_id = sIdAp;
            this.collectAppointment(nStartDay,sPostfix,tApp);  
            
        } else {
            for (var nNumDay=nStartDay; nNumDay<(nStartDay+appDuration); nNumDay++) {
            	var tApp2 = duplicate_app(tApp);
                if (nNumDay == nStartDay) {
                    var oDateStart = new Date(tApp2.start_date);
                    oDateStart.setUTCHours(0);
                    oDateStart.setUTCMinutes(0);
                    oDateStart.setUTCSeconds(0);    
                    oDateStart.setUTCDate(oDateStart.getUTCDate()+1);
                    tApp2.end_date = oDateStart.getTime();
                    
                } else if (nNumDay == nEndDay && nStartDay < nEndDay) {
                    var oDateStart = new Date(tApp2.end_date);
                    oDateStart.setUTCHours(0);
                    oDateStart.setUTCMinutes(0);
                    oDateStart.setUTCSeconds(0);    
                    tApp2.start_date = oDateStart.getTime();
                    
                } else {                
                    var oDateStart = new Date(tApp2.start_date);
                    var oDateEnd = new Date(tApp2.start_date);                                        
                    oDateStart.setUTCHours(0);
                    oDateStart.setUTCMinutes(0);
                    oDateStart.setUTCSeconds(0);    
                    oDateEnd.setHours(0);
                    oDateEnd.setMinutes(0);
                    oDateEnd.setSeconds(0);                     
                    oDateStart.setUTCDate(oDateStart.getUTCDate()+nNumDay);                 
                    oDateEnd.setUTCDate(oDateStart.getUTCDate()+nNumDay+1);                                     
                    tApp2.start_date = oDateStart.getTime();              
                    tApp2.end_date = oDateEnd.getTime();                                  
                }
                tApp2.assoc_id = sIdAp;
                this.collectAppointment(nNumDay,sPostfix,tApp2);
            }
        }
    }
},
doDraw:function ()
{
    for(var sKey in this.app_collector)
    {
        var aAppointments = this.app_collector[sKey];
        for(var nDay in aAppointments)
        {
            var oList = this.getLineList(aAppointments[nDay]);
            this.drawList(oList,sKey,nDay);
        }
    }
},
getPrio:function (number)
{
    var aPrio = new Array(-1,4,3,1,0,2);    
    for(var indx=0;indx<aPrio.length;indx++)
    {
        if(aPrio[indx] == number)
            return indx;    

    }
},
getLineList:function (aApp)
{   
    var oDataStart = new Object();
    oDataStart.x = 0;
    oDataStart.type = -1;
    oDataStart.appid = -1;      
    var oDataEnd = new Object();    
    oDataEnd.x = 100;
    oDataEnd.type = -1;
    oDataEnd.appid = -1;    
    var oList = new js_list();
    oList.push(oDataStart);
    oList.push(oDataEnd);
    //Sort all appointments by start date
    function sort_fn(a,b){
        if(a.start_date < b.start_date)
            return -1;
        else            
            return 1;   
    }
    aApp.sort(sort_fn);
    for(var nindx=0;nindx<aApp.length;nindx++)
    {

        var currApp = aApp[nindx];
        var sAppId = currApp.assoc_id;
        var oStartDate = new Date(aApp[nindx].start_date);
        var oEndDate = new Date(aApp[nindx].end_date);      

        var nHoursStart = oStartDate.getUTCHours();
        var nMinutesStart = oStartDate.getUTCMinutes();
        var nHoursEnd = oEndDate.getUTCHours();
        var nMinutesEnd = oEndDate.getUTCMinutes();
        if(nHoursStart == 0 && nMinutesStart == 0)
            var currStartX = 0.5;
        else
            var currStartX = Math.round(((nHoursStart * 60 + nMinutesStart) * 100) / (24 * 60));
            
        if(nHoursEnd == 0 && nMinutesEnd == 0)
            var currEndX = 99.5;
        else
            var currEndX = Math.round(((nHoursEnd * 60 + nMinutesEnd) * 100) / (24 * 60));
    

        //find start position       
        var listnode = oList.first;
        while(listnode.data.x <= currStartX)
        {           
            listnode = listnode.next;
        }   
    
        var oDataStart = new Object();
        oDataStart.x = currStartX;
        oDataStart.type = currApp.shown_as; 
        oDataStart.appid = sAppId;
        var nTypeBefore = listnode.previous.data.type;      
        var nAppIdBefore = listnode.previous.data.appid;            

        if(this.getPrio(oDataStart.type) < this.getPrio(nTypeBefore))   
        {
            if(this.getPrio(listnode.data.type) < this.getPrio(oDataStart.type) 
                && listnode.data.x < currEndX)
            {               
                currStartX = listnode.data.x;
                nTypeBefore = listnode.data.type;
                nAppIdBefore= listnode.data.appid;
                oDataStart.x = currStartX;
                listnode = listnode.next;
            }
            else continue;
        }

        //if previous point equal current point, remove it      
        if(listnode.previous.data.x == currStartX)      
        {   
            oList.remove(listnode.previous);
        }
        oList.insert_before(listnode,oDataStart);
        //find end position
        while(listnode.data.x <= currEndX)
        {   
        //  nTypeBefore = listnode.data.type;
            listnode.data.type = oDataStart.type;
            listnode = listnode.next;
        }   
        if(listnode.previous.data.x == currEndX)        
        {   
            oList.remove(listnode.previous);
        }
        var oDataEnd = new Object();
        oDataEnd.x = currEndX;
        if(listnode.data.x == 100)
        {
            nTypeBefore = -1;
        }
        oDataEnd.type = nTypeBefore;    
        oDataEnd.appid = nAppIdBefore;      
        oList.insert_before(listnode,oDataEnd);     
    }
    //this.print_list(oList);
    return oList;
},
print_list:function (oList)
{
    var ocurrNode = oList.first;
    var nC = 0;
    while (ocurrNode.next != null)
    {
        ocurrNode = ocurrNode.next;
        nC++;
    }
},
drawList:function (oList,nId,nDay) {
    var sContainerId = 'd'+nDay+'_team_week_' + nId;
    var oParentDiv =  document.getElementById(sContainerId);
    if(oParentDiv == undefined)
        return;
    removeChildNodes(oParentDiv);
    
    var lItem = oList.first;    
    var nNumItems = oList.number;
    var Coeff = (100 - Math.round(nNumItems/2)-1)/100; // compute with space
    while(lItem.next != null)
    {       
        var appid_l = lItem.data.appid;
        var size = lItem.next.data.x - lItem.data.x;
        size *= Coeff;
        var type = lItem.data.type;
        var oDiv = newnode('div');      
        oDiv.className = 'colorBlockTWV workTimeBackground';
        switch (type) {
	        case 1:
	            oDiv.className += " appointmentRESERVED";
	            break;
	        case 2:
	            oDiv.className += " appointmentTEMPORARY";
	            break;
	        case 3:
	            oDiv.className += " appointmentABSENT";
	            break;
	        case 4:
	            oDiv.className += " appointmentFREE";
	            break;
	        default:
	            //oDiv.className += " appointmentShowAsNone";
	            break;
        }       
        oDiv.style.width = size + "%";
        oDiv.innerHTML = '&#xa0;';
        oDiv.id = appid_l;
        oParentDiv.appendChild(oDiv);
        var oSpacerDiv = newnode('div');
        oSpacerDiv.className = 'colorBlockTWV workTimeBackground';
        oSpacerDiv.style.width = '0.5%';
        oParentDiv.appendChild(oSpacerDiv);     
        lItem = lItem.next;
    }
},
collectAppointment :function (nDay,sPostfix,oApp) {
    if (oApp.start_date < this.monday.getTime() && 
        oApp.end_date < this.monday.getTime() || oApp.start_date > this.friday.getTime() && 
        oApp.end_date > this.friday.getTime()) {
        return;
    }
    //exclude saturday and sunday
    if (nDay==0 || nDay==6) {
        return;
    }
    if(!this.app_collector[sPostfix][nDay]) {
        this.app_collector[sPostfix][nDay] = new Array();
    }
    this.app_collector[sPostfix][nDay].push(oApp);
},
fetchAppointments:function (aUpdtMember)
{
    if (!aUpdtMember || isEmpty(aUpdtMember)) return; // no members requested   
    var Self = this;
    var aJsonArray = new Array();
    for(var sKeyAssoc in aUpdtMember)
    {
        var oRequestObject = new Object();
        oRequestObject['module'] = "calendar";
        oRequestObject['action'] = 'freebusy';
        oRequestObject['id'] = aUpdtMember[sKeyAssoc].id;
        oRequestObject['type'] = aUpdtMember[sKeyAssoc].type;
        oRequestObject['start'] = this.monday.getTime();
        oRequestObject['end']= this.friday.getTime();   
        aJsonArray.push(oRequestObject);
    }

    function callback(responseobj)
    {
        if(responseobj.error)
        {
            newServerError(responseobj,4);
        }
        else
        {
            //fetch full data here
            function sub_callback(arg){
                //prepare and set data
                for(var nFullDataApp=0;nFullDataApp < arg.data.length;nFullDataApp++) {
                    var tmpdata = arg.data[nFullDataApp];
                    Self.full_data_aps[tmpdata[0]] = 
                        new CalendarWorkWeekObject(tmpdata[0],tmpdata[1],tmpdata[2],tmpdata[3],tmpdata[4],tmpdata[5],tmpdata[6],tmpdata[7],tmpdata[8],tmpdata[9],tmpdata[10],tmpdata[11],tmpdata[12],tmpdata[13],tmpdata[14],tmpdata[15],tmpdata[16]);
                }
                var nIndx = 0;
                // iterate through requested member list
                for (var mkey in aUpdtMember) {
                    // iterate through internal member list to map the server response              
                    for (var nkey in Self.member_assoc) {
                        // check if member already in list and (re-)draw appointment
                        if (Self.member_assoc[nkey].id == aUpdtMember[mkey].id) {
                            Self.drawAppointments(responseobj[nIndx],nkey);
                            break;
                        }
                    }
                    nIndx++;
                }
                Self.doDraw();
            }
            var calendarwwfields = new Array(1,20, 207, 206, 2, 200, 201, 202, 203, 209, 220, 401, 402, 102, 400, 101);
            var sAjaxReq = AjaxRoot + "/calendar?action=all&session=" + session + "&start=" + Self.monday.getTime() + "&end=" 
                                                        + Self.friday.getTime() + "&columns=" +calendarwwfields.toString();         
            json.get(sAjaxReq,null,sub_callback);
        }
    }   
    json.put(AjaxRoot + "/multiple?session=" + session,aJsonArray,null,callback);
},
updateMemberList:function (oMemberHM)
{
    var bMemberAddd = false;
    if(oMemberHM)
        this.memberlist = oMemberHM;

    //remove member
    for(var sKeyAssoc in this.member_assoc)     
    {
        if(!this.memberlist[this.member_assoc[sKeyAssoc].id + ':' + this.member_assoc[sKeyAssoc].type])
            this.removeMember(sKeyAssoc);
    }
    //check member
    for(var sKey in this.memberlist)
    {
        var bFound = false;
        //search for members
        for(var sKeyAssoc in this.member_assoc)
        {
            if(this.member_assoc[sKeyAssoc].id == sKey.split(':')[0])
            {
                bFound = true;
                break;
            }
        }
        //add member        
        if(!bFound)
        {
            this.addMember(this.memberlist[sKey]);          
            bMemberAddd = true;
        }
    }
//  if(bMemberAddd)
        this.updateAppointmentView(this.member_assoc);
},

addMember: function (oMember)
{
    var oTeml = this.template.cloneNode(true);
    oTeml.id += '_' + this.membercount; 
    for(var indx=0;indx<oTeml.childNodes.length;indx++)
    {
        for(var indx2 = 0;indx2<oTeml.childNodes[indx].childNodes.length;indx2++)
        {
            if(oTeml.childNodes[indx].childNodes[indx2].id == 'u_team_week')
            {
                var oDOMText = document.createTextNode(oMember.display_name);
                oTeml.childNodes[indx].childNodes[indx2].appendChild(oDOMText);
            }
            oTeml.childNodes[indx].childNodes[indx2].id += '_' + this.membercount;
        }
    }
    this.container.appendChild(oTeml);
    if(!this.membercount)
        $(this.container_id).appendChild(this.container);
    this.member_assoc['team_week_row' + '_' + this.membercount] = oMember;      
    this.membercount++;
    resizeTeamWeekHeader();
},
selectMember:function (sTRId)
{
    if(this.selected_row_id != null)
    {
        document.getElementById('u_team_week' + '_' + this.selected_row_id.split('_')[3]).className
                                                                                         = 'teamWeekColMember background-color-content';
    }
    this.selected_row_id = sTRId;
    this.selected_member[0] = this.member_assoc[this.selected_row_id];
    triggerEvent('OX_Selected_Member',this.selected_member);
},
removeMember: function(row_id)
{
    var oSelTr = document.getElementById(row_id);
    this.container.removeChild(oSelTr);
    delete this.member_assoc[row_id];
    this.selected_row_id = null;
    triggerEvent('OX_Selected_Member',0);
}
}



///////////////////////////////////////////////////////
//Liste

function list_obj()
{
    this.next;
    this.previous;
    this.data;
}
function js_list()
{
    this.first = null;
    this.last = null;
    this.next_ = null;
    this.previous_ = null;
    this.number = 0;    
}
js_list.prototype = {
push:function (aData)
{
    var oItem = new list_obj();
    oItem.next = null;      
    oItem.previous = this.previous_;    
    oItem.data = aData;
    
    if(this.previous_!=null)
        this.previous_.next = oItem;
    this.previous_ = oItem;
    if(!this.first)
        this.first = oItem;
    this.last = oItem;          
    this.number++;  
},
insert_before:function(oBeforeItem,aData)
{
    var oItem = new list_obj(); 
    oItem.previous = oBeforeItem.previous;
    oItem.next = oBeforeItem;       
    oItem.data = aData;
    oBeforeItem.previous.next = oItem;
    oBeforeItem.previous = oItem;
    this.number++;
},
remove:function(oItem)
{
    oItem.previous.next = oItem.next;   
    oItem.next.previous = oItem.previous;
    oItem = null;
    delete oItem;
    this.number--;
}
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan@open-xchange.org>
 * 
 */
register_Calendar();

var activeDate=new Date();
var activeDay=activeDate.getDate();
var activeMonth=activeDate.getMonth();
var activeYear=activeDate.getFullYear();
var calendarFolderPath;

/*********************************************************************************************************************/
var selectedAppointment=new Object();
var calendarSelection = new Selection();

calendar_serializeid = function(x) {
	return x.folder + "." + x.id + "." + x.recurrence_position || 0 
	       + "." + x.recurrence_id || 0 + "." + x.created_by || 0;
};
calendar_makeID = function (x) {
	var mObj = { id: x[0], folder: x[1] };	
	if (x[2] != undefined) { 
		mObj["recurrence_position"]=x[2]; 
	}
	if (x[3] != undefined) {
		mObj["recurrence_id"]=x[3];
	}
	if (x[4] != undefined) {
        mObj["created_by"]=x[4];
    }
	return mObj;
}

addContextNode(contextmenu_createImgDiv("Options",/*i18n*/
	getFullImgSrc("img/folder/settings.gif"),getFullImgSrc("img/folder/settings.gif")),["calendarOptions"],
	function() { 
		var elem=currentpath2.join("/");
		if(elem.indexOf("calendar/calendar") == 0 || elem.indexOf("calendar/detail") == 0 || elem.indexOf("calendar/list") == 0) { 
			triggerEvent("OX_Switch_View","configuration/calendar/preferences");
		} else if(elem.indexOf("calendar/team") == 0) { 
			triggerEvent("OX_Switch_View","configuration/calendar/teams");
		} 	
	},
	null,null,contextmenu_setDisabled,null,null,null,contextmenu_setEnabled);

var calendarhovers=new Object();
function register_Calendar() {
	
	registerView("calendar",null,
	function () { 
		register("OX_New_Search", calendarSearch); 		
	},
	function () { 
		unregister("OX_New_Search", calendarSearch); 
	},
	function () {
		menuclearSearch();
	});
	registerView("calendar/calendar/day",
		function() { showNode("calendarWorkweek"); }, 
		function() { 
			maxappointmentsperday=configGetKey("gui.calendar.day.numberofappointments");
			cwwdaysinweek = 1;
			var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));			    
			startofweek=oDateLoc.getUTCDay();
			if (oMiniCalendar) oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
			
			unregister("OX_Create_Object",default_calendar_create_object);
			register("OX_Create_Object",default_calendar_workweek_create_object);		
 			cwwenable();
            displayNameDayView();       
            calendarFolderPath.drawDOMNode("calendarofworkweekview", activefolder);
			showCalendarWorkweek();
			register("OX_Add_Flag", calendarAddTag);
			if (calendarhovers["daywwcustom"] && configGetKey("gui.effects.hover.calendar")) {
				calendarhovers["daywwcustom"].enable(); calendarhovers["daywwcustom2"].enable(); 
			}			
		 }, 
		 function() {
		 	if(calendarhovers["daywwcustom"]) { calendarhovers["daywwcustom"].disable(); calendarhovers["daywwcustom2"].disable(); }
		 	unregister("OX_Create_Object",default_calendar_workweek_create_object);		 	
 			register("OX_Create_Object",default_calendar_create_object);
 			cwwdisable();
 			calendarFolderPath.clear();
		 	unregister("OX_Add_Flag", calendarAddTag);	
		 },
		function() { 
			hideNode("calendarWorkweek"); 
		},
		function() { 
			var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));	
			startofweek=oDateLoc.getUTCDay();
			displayNameDayView();
			calendarFolderPath.drawDOMNode("calendarofworkweekview", activefolder);		
			showCalendarWorkweek();
		}
	);
	registerView("calendar/calendar/workweek",
		function() { 
			showNode("calendarWorkweek"); 
		}, 
		function() { 
 			maxappointmentsperday=configGetKey("gui.calendar.workweek.numberofappointments");
			cwwdaysinweek = configGetKey("gui.calendar.workweek.countdays");
			startofweek=configGetKey("gui.calendar.workweek.startday");
			unregister("OX_Create_Object",default_calendar_create_object);
			register("OX_Create_Object",default_calendar_workweek_create_object);	
			calendarFolderPath.drawDOMNode("calendarofworkweekview", activefolder);	 	
			displayNameDayView();		
 			cwwenable();
			showCalendarWorkweek();		
			if(calendarhovers["daywwcustom"] && configGetKey("gui.effects.hover.calendar")) { calendarhovers["daywwcustom"].enable(); calendarhovers["daywwcustom2"].enable(); }
			register("OX_Add_Flag", calendarAddTag);
		}, 
		function() {
 			if (calendarhovers["daywwcustom"]) { 
 				calendarhovers["daywwcustom"].disable(); 
 				calendarhovers["daywwcustom2"].disable(); 
 			}
			unregister("OX_Create_Object",default_calendar_workweek_create_object);		 	
 			register("OX_Create_Object",default_calendar_create_object);
 			calendarFolderPath.clear();
			cwwdisable()
		 	unregister("OX_Add_Flag", calendarAddTag);	
		},
        function() { 
			hideNode("calendarWorkweek");
		},
		function() {
			displayNameDayView();
			calendarFolderPath.drawDOMNode("calendarofworkweekview", activefolder);	
			showCalendarWorkweek();
		}
	);
	registerView("calendar/calendar/custom",
		function() { showNode("calendarWorkweek"); }, 
		function() { 
 			maxappointmentsperday=configGetKey("gui.calendar.custom.numberofappointments");
			cwwdaysinweek = configGetKey("gui.calendar.custom.countdays");
			var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));	
			startofweek=oDateLoc.getUTCDay();
			unregister("OX_Create_Object",default_calendar_create_object);
			register("OX_Create_Object",default_calendar_workweek_create_object);
			calendarFolderPath.drawDOMNode("calendarofworkweekview", activefolder);		 	
			displayNameDayView();		
 			cwwenable();
			showCalendarWorkweek();
			if(calendarhovers["daywwcustom"] && configGetKey("gui.effects.hover.calendar")) { calendarhovers["daywwcustom"].enable(); calendarhovers["daywwcustom2"].enable(); }		
			register("OX_Add_Flag", calendarAddTag);
		 }, 
		 function() {
 			if(calendarhovers["daywwcustom"]) { calendarhovers["daywwcustom"].disable(); calendarhovers["daywwcustom2"].disable(); }
			unregister("OX_Create_Object",default_calendar_workweek_create_object);		 	
 			register("OX_Create_Object",default_calendar_create_object);
			cwwdisable()
			calendarFolderPath.clear();
		 	unregister("OX_Add_Flag", calendarAddTag);	
		 },
		function() { 
			hideNode("calendarWorkweek");
		},
		function() {
			var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));	
			startofweek=oDateLoc.getUTCDay();
			calendarFolderPath.drawDOMNode("calendarofworkweekview", activefolder);
			displayNameDayView();		
			showCalendarWorkweek();
		}
	);
	var firstmonthview=false;
	registerView("calendar/calendar/month",
		function() { 
			showNode("calendarMonth");
			$("calendarMonth").style.display="block"; 
		}, 
		function() {
			if(!firstmonthview) { 
				firstmonthview=true;
				var hover=new Hover($("calmain"),OXAppointmentHover.getContent().node);
				calendarhovers["month"]=hover;	
				hover.setSize(OXAppointmentHover.contentobject.node);
				hover.getTarget = function (node) {
					function getNode(actualnode) {
						if(actualnode.oxcalobj) {
							return actualnode;
						}
						return;
					}
					while (node) {
						var element=getNode(node);
						if(element) {
							return element;
						}
						node = node.parentNode;
					}
					return;
				}
				hover.onShow = function (node) {
					if (popupenabled) return false;
					OXAppointmentHover.actualHover=this;
					var splitid=node.oxcalobj.split("-");
					OXAppointmentHover.refillContent(splitid[1],splitid[0],splitid[2]);	
				} 
			} 
			if(configGetKey("gui.effects.hover.calendar") && calendarhovers["month"]) {
				calendarhovers["month"].enable();
			}
			calendarFolderPath.drawDOMNode("calendarofmonthview", activefolder);
			displayNameDayView();	  
			register('OX_Refresh',refreshMonthView);
		  	register("OX_Add_Flag", calendarAddTag);
			resizeEvents.register("Resized",resizeWeekSections);
			unregister("OX_Create_Object",default_calendar_create_object);
			register("OX_Create_Object",default_calendar_workweek_create_object);		
		  	loadMonthView();
		 }, 
		 function() {
		 	if (calendarhovers["month"]) { 
		 		calendarhovers["month"].disable(); 
		 	}
		 	unregister('OX_Refresh',refreshMonthView);
		 	unregister("OX_Add_Flag", calendarAddTag);
			register("OX_Create_Object",default_calendar_create_object);
			unregister("OX_Create_Object",default_calendar_workweek_create_object);		 	
		 	resizeEvents.unregister("Resized",resizeWeekSections);
		 	calendarFolderPath.clear();
		 },
		function() { 
			hideNode("calendarMonth");
			$("calendarMonth").style.display="none";
		},
		function() {
			calendarFolderPath.drawDOMNode("calendarofmonthview", activefolder);
			displayNameDayView();
			refreshMonthView(true);		
            resizeEvents.register("Resized",resizeWeekSections);	
		}
	);
	registerView("calendar/calendar/week",
		function() { 
			showNode("calendarWeek");
			$("calendarWeek").style.display=""; }, 
		function() { 
			calendarFolderPath.drawDOMNode("calendarofweekview", activefolder);
			displayNameDayView(); 	
			unregister("OX_Create_Object",default_calendar_create_object);
			register("OX_Create_Object",default_calendar_workweek_create_object);		
			objWeekCalendarTool.init();
			register("OX_Add_Flag", calendarAddTag);
		 }, 
		 function() {
		 	if(calendarhovers["week"]) { 
		 		calendarhovers["week"].disable(); 
		 	}
			register("OX_Create_Object",default_calendar_create_object);
			unregister("OX_Create_Object",default_calendar_workweek_create_object);	
		 	unregister("OX_Add_Flag", calendarAddTag);
		 	calendarFolderPath.clear(); 	
		},
		function() { 
			hideNode("calendarWeek");
			$("calendarWeek").style.display="none"; },
		function() {
			calendarFolderPath.drawDOMNode("calendarofweekview", activefolder);
			displayNameDayView();
			objWeekCalendarTool.init();
		}
	);
	
	function calendarteamdayrefresh() {
		displayNameDayView();
		ctd_startContent();	
	}
	
	registerView("calendar/team/day",
		function() { 
			showNode("calendarTeamDay");
			if(ctd_participants == null)
				team_initContent();
			$("calendarTeamDay").style.display=""; 
		}, 
		function() { 
			filldefaultteam();
			ctd_startContent();
			register("OX_Refresh", calendarteamdayrefresh);			
			register("OX_Add_Flag", calendarAddTag);
		 }, 
		 function() {
		    ctd_leaveContent();	
			unregister("OX_Refresh", calendarteamdayrefresh);
		    unregister("OX_Add_Flag", calendarAddTag);
		 },
		function() { 
			hideNode("calendarTeamDay");
			$("calendarTeamDay").style.display="none";},
		function() {
			displayNameDayView();
			ctd_startContent();	
		}
	);
	
	function calendarteamweekrefresh() {
		displayNameDayView();
		loadTeamWeek();
	}
	
	registerView("calendar/team/workweek",
		function() { 
			showNode("calendarTeamWeek");
			if(ctd_participants == null)
			{
				$("calendarTeamWeek").style.display=""; 
				team_initContent();
			}}, 
		function() { 
			register("OX_Refresh", calendarteamweekrefresh);
			filldefaultteam();
			displayNameDayView();
			loadTeamWeek();			
		 }, 
		 function() {
		 	unloadTeamWeek();
		 },
		function() { 
			unregister("OX_Refresh", calendarteamweekrefresh);
			hideNode("calendarTeamWeek");
			$("calendarTeamWeek").style.display="none";
		},
		function() { 
			displayNameDayView();
			loadTeamWeek(); 
		}
	);
	registerView("calendar/list",
		function() { 
			showNode("calendarList");
			$("calendarList").style.display=""; 
		}, 
		function() {			
			register("OX_Print",calendar_printList); 
			register("OX_Add_Flag", calendarAddTag);
		}, 
		 function() {
		 	calendarFolderPath.clear();
		 	disableCalendarGrid();
		 	unregister("OX_Print",calendar_printList);
		 	unregister("OX_Add_Flag", calendarAddTag);
		 },
		function() { 
			hideNode("calendarList");
			$("calendarList").style.display="none";
		}
	);
	registerView("calendar/list/day",
		null, 
		function() {
			calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
			cwwdaysinweek = 1; 
			if(!calendarGrid){
				initCalenderLiveGridOnLoad();
			}
			initLiveGridCalendar("day");
		 }, 
		 null,
		 null,
		 function() {
		 	calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
		 	displayNameDayView();
		 	initLiveGridCalendar("day"); 
		 }
	);
	registerView("calendar/list/workweek",
		null, 
		function() {
			calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
			cwwdaysinweek = configGetKey("gui.calendar.workweek.countdays");
            startofweek=configGetKey("gui.calendar.workweek.startday");
			if(!calendarGrid){
				initCalenderLiveGridOnLoad();
			}
			initLiveGridCalendar("workweek");
		 }, 
		 null,
		 null,
		 function() { 
		 	initLiveGridCalendar("workweek");
		 	calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
		 	displayNameDayView(); 
		 }
	);
	registerView("calendar/list/month",
		null, 
		function() {
			calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
			if(!calendarGrid){
				initCalenderLiveGridOnLoad();
			}
			initLiveGridCalendar("month");
		 }, 
		 null,
		 null,
		 function() {
		 	calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
		 	displayNameDayView();
		 	initLiveGridCalendar("month"); 
		 }
	);
	registerView("calendar/list/week",
		null, 
		function() {
			calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
			if(!calendarGrid){
				initCalenderLiveGridOnLoad();
			}
			initLiveGridCalendar("week");
		 }, 
		 null,
		 null,
		 function() {
		 	calendarFolderPath.drawDOMNode("calendaroflistview", activefolder);
		 	displayNameDayView();
		 	initLiveGridCalendar("week"); 
		 }
	);
	registerView("calendar/list/search",
		null, 
		function() { 
			if (!calendarGrid){
				initCalenderLiveGridOnLoad();
			}
			initLiveGridCalendar("search");
			register("OX_Delete_Search", calendarDeleteSearch);			
			if (lastCalendarSearch) {			   
               setTimeout(function() {
               	    calendarFolderPath.nodeId="calendaroflistview";
                	calendarFolderPath.drawSearch(lastCalendarSearch.module, lastCalendarSearch.searchstring);
                },0);
            }			
		 }, 
		 function() {
		 	calendarFolderPath.clear();
			//triggerEvent("OX_Delete_Search");		 	
	 		unregister("OX_Delete_Search", calendarDeleteSearch);
		 },
		 null
	);
	registerView("calendar/detail",
		function() { 
			showNode("calendarAppointmentDetail");
			$("calendarAppointmentDetail").style.display=""; }, 
		function() { 
			register("OX_Refresh",reloadAppDetailView);
			register("OX_AcceptDeny_Changed",reloadAppDetailView);
			register("OX_Confirmation_Change",caldetail_change_Confirm);
			if(selectedAppointment.length && selectedAppointment.length == 1) {
				selectedAppointment = selectedAppointment[0];
			}
			if(selectedAppointment.id)
			{
				detailAppointmentOnload();									
			}
			if(!myAppointmentLinkingObject) {
				myAppointmentLinkingObject = new LinkingObject('a_d_Linking', selectedAppointment.id, 1, 'a_d_count_linking');
				myAppointmentLinkingObject.makeLiveGrid();
			}
			else {
				myAppointmentLinkingObject.id = selectedAppointment.id;
				myAppointmentLinkingObject.getStorage();
			}
			
			myAppointmentLinkingObject.disableLinkingLivegrid();
			
			if(typeof selectedAppointment == 'undefined' || selectedAppointment == '')
			{
				triggerEvent("OX_New_Error", 4, _("No Appointment selected."));
			}
			register("OX_Add_Flag", calendarAddTag);	
		 }, 
		 function() {
		 	//LEAVE
			unregister("OX_Refresh",reloadAppDetailView);
			unregister("OX_AcceptDeny_Changed",reloadAppDetailView);
			unregister("OX_Confirmation_Change",caldetail_change_Confirm);
			unregister("OX_Add_Flag", calendarAddTag);
			objAppDetailParticipants = null;
		 },
		function() { 			
			hideNode("calendarAppointmentDetail");
			$("calendarAppointmentDetail").style.display="none";
		}
	);
	registerView("calendar/detail/overview",
		function() {
			register("OX_Print",calendar_printDetail);
			$("tabAppointmentDetail1").style.display="block";
			$("panelAppointmentDetail1").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";			
		},
		null, 
		null,
		function() {
			unregister("OX_Print",calendar_printDetail);
			$("tabAppointmentDetail1").style.display="none";
			$("panelAppointmentDetail1").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";			
		}
	);
	registerView("calendar/detail/participant",
		function() {
			$("tabAppointmentDetail2").style.display="block";
			$("panelAppointmentDetail2").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";			
		}, 
		function() { 
			refAppDetailParticipantTab.enableGrid();
			currentAppointmentDetailTab = 'PARTICIPANT';
		 }, 
		function() {
			if(a_d_participantGrid && a_d_participantGrid.storage) {
				refAppDetailParticipantTab.disableGrid();
			}
		},
		function() {
			$("tabAppointmentDetail2").style.display="none";
			$("panelAppointmentDetail2").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";			
		}
	);
	var attachmentGridLoaded = false;
	registerView("calendar/detail/attachment",
		function() {
			$("tabAppointmentDetail3").style.display="block";
			$("panelAppointmentDetail3").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";			
		}, 
		function() {
			if(!attachmentGridLoaded)
			{
				makeDetailAppointmentAttachmentGrid();
				attachmentGridLoaded = true;
			}
			else
				gridatt.enableGrid();
			gridatt.getAttachments(selectedAppointment.id,selectedAppointment.folder);				
		}, 
		 function() {
		 	if(attachmentGridLoaded)
				gridatt.disableGrid();
		},
 		function() {
			$("tabAppointmentDetail3").style.display="none";
			$("panelAppointmentDetail3").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";			
		}

	);
	registerView("calendar/detail/links",
		function() {
			$("tabAppointmentDetail4").style.display="block";
			$("panelAppointmentDetail4").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";			
		},
		function() { 
			register("OX_Link_deleted",reloadAppDetailView);
			if(myAppointmentLinkingObject) {
				myAppointmentLinkingObject.enableLinkingLivegrid();
			}
			currentAppointmentDetailTab = 'LINKS';
		 }, 
		 function() {
		 	unregister("OX_Link_deleted",reloadAppDetailView);
		 	if(myAppointmentLinkingObject) {
				myAppointmentLinkingObject.disableLinkingLivegrid();
			}
		 },
		function() {
		 	unregister("OX_Link_deleted",reloadAppDetailView);
			$("tabAppointmentDetail4").style.display="none";
			$("panelAppointmentDetail4").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";			
		}
	);					
}
register("Loaded",function() {
	calendarFolderPath = new FolderPath("calendar");
	registerContext($("arrowForCWVOptions"),"calendarOptions",null,null,null,"click");
	registerContext($("arrowForCWWVOptions"),"calendarOptions",null,null,null,"click");
	registerContext($("arrowForCMVOptions"),"calendarOptions",null,null,null,"click");
	registerContext($("arrowForTDVOptions"),"calendarOptions",null,null,null,"click");
	registerContext($("arrowForTWWVOptions"),"calendarOptions",null,null,null,"click");
	registerContext($("arrowForCLVOptions"),"calendarOptions",null,null,null,"click");
	registerContext($("arrowForCDetailVOptions"),"calendarOptions",null,null,null,"click");
});

/*********************************************************************************************************************/
var calendar_activeallfolders=true;
registerPrintView("calendar/list/day");
registerPrintView("calendar/list/workweek");
registerPrintView("calendar/list/month");
registerPrintView("calendar/list/week");
registerPrintView("calendar/list/search");
registerPrintView("calendar/detail/overview");

function calendar_printList() {
	globalprint.printLiveGrid(calendarGrid);
}

function default_calendar_create_object(module,folder) {
	if(module=="calendar") {
		var d=new Date();
//		var myinterval=configGetKey("gui.calendar.interval");
		var myinterval=15;
		d.setUTCDate(1);
		d.setUTCMonth(activeMonth);
		d.setUTCFullYear(activeYear);
		d.setUTCDate(activeDay);
		d.setUTCHours(d.getHours());
		var mymin=d.getUTCMinutes();
		if(mymin % myinterval) {
			mymin=mymin - (mymin % myinterval)+ myinterval;
		}
		d.setUTCMinutes(mymin);
		calendar_createNewAppointment(d,folder,false);	
	}
}

function calendar_createNewAppointment(startdate,infolder,wholeday,oFromMail) {
	var checkfolder;
	var wholeday=wholeday;
	var folder_id_tocheck  = (infolder)?infolder:((activefolder)?activefolder:config.folder.calendar);
	oMainFolderTree.cache.get_folder(folder_id_tocheck,function (checkfolder){

		calendar_createNewAppointmentCb(checkfolder);
	});

	function calendar_createNewAppointmentCb(myfolder) {
		if(myfolder.oxfolder.data.module != "calendar"){
			triggerEvent("OX_New_Error",4,_("Can not create appointment in a folder other than appointment folder"));
		}
		else {
			var wholeDay=wholeday;
			if(!startdate) {
				startdate=new Date();
			}
			// Private folder or shared then add owner to list of participants
			if(myfolder.oxfolder.data.type == 1 || myfolder.oxfolder.data.type == 3) {
				var userId = myfolder.oxfolder.data.created_by;
			} else {
				var userId = configGetKey('identifier');
			}
			if(!wholeDay){
				var windowRef = newWindow("newAppointment.html#modul=new&folder_id="+infolder+"&view="+currentCalendarView+"&start_date="+startdate.getTime()+"&folderOwner="+userId, getWindowOptions());
				if(oFromMail)
				{
					windowRef.sFromModule = oFromMail.module;										
					windowRef.oFromMail = oFromMail.data;
				}				
			} else {
				newWindow("newAppointment.html#modul=new&folder_id="+infolder+"&view="+currentCalendarView+"&start_date="+startdate.getTime()+"&full_time="+wholeDay+"&folderOwner="+userId, getWindowOptions());
			}				
		}
	}
}

var detailAppointmentLoading = false;
	
function reloadAppDetailView(opt_fn, target_folder) {
	
	function cb_reloadAppDetail() {
		detailAppointmentLoading = false;		
		if(currentCalendarTagProgress)
			endProgressCalendarTagging();
		if(opt_fn)
			opt_fn();
	}
	
	if(!detailAppointmentLoading) {
		detailAppointmentLoading = true;
		if(myAppointmentLinkingObject) {
			myAppointmentLinkingObject.disableLinkingLivegrid();
		}
		/* init Linking */
		if(!myAppointmentLinkingObject) {
			myAppointmentLinkingObject = new LinkingObject('a_d_Linking', selectedAppointment.id, 1, 'a_d_count_linking');
			myAppointmentLinkingObject.makeLiveGrid();
		}
		else {
			myAppointmentLinkingObject.id = selectedAppointment.id;
			myAppointmentLinkingObject.getStorage();
		}
		
		triggerEvent("OX_Switch_View", "calendar/detail/overview");	
		
		if(selectedAppointment.length && selectedAppointment.length == 1) {
			selectedAppointment = selectedAppointment[0];
		}
		if(selectedAppointment.id)
		{			
			if(target_folder && activefolder != target_folder) {
				var cb_setActiveFolder = function(node) {
					
					triggerEvent("Selected", [selectedAppointment]);
					detailAppointmentOnload(cb_reloadAppDetail);
				}
				selectedAppointment.folder = target_folder;
				setActiveFolder(target_folder,cb_setActiveFolder);
			} else {
				detailAppointmentOnload(cb_reloadAppDetail);
			}
												
		}
	}
}

registerModule("calendar", "Calendar",30); /*i18n*/
registerModuleView("calendar","Calendar",5,{x:0,y:0,ww:1,hw:1});
//TODO
register("OX_New_OXObject",function(mymodule,folder) {
	if(mymodule== "calendar") {
		calendar_createNewAppointment(new Date(Date.UTC(activeYear, activeMonth, activeDay,0,0,0)),folder,false);
	}
});
register("OX_Calendar_Edit", openAppointmentPopup);
register("OX_Calendar_Delete", deleteAppointment);
var currentCalendarRange = "";
var currentCalendarView = "CALENDAR";

	//   1 object_id
	//  20 folder_id
	// 100 categories
	// 101 private flag
	// 200 title
	// 201 start_date
	// 202 end_date
	// 203 description
	// 209 recurrence type 0=none 1=daily 2=weekly 3=monthly 4=yearly
	// 217 notification
	// 220 participents
	// 400 location
	// 401 full_time
	// 402 shown_as	
	// 403 colorlabel
	

fieldsToGet = new Array(1, 20, 207, 206, 2, 200, 201, 202, 203, 220, 401, 402, 209, 400, 101, 102);

function calObj(objFromServer){
	
	var count = 0;
	var startDate;
	this.id = objFromServer[count++];	// objectID			
	this.folderID = objFromServer[count++];	// folderID
	
	for(var q = 2; q < fieldsToGet.length; q++){
		switch (fieldsToGet[q]) {
			case 100:
				this.categories = objFromServer[count++];	// categories
				break;
			case 101:
				this.private_flag = objFromServer[count++];
				break;
			case 102:
				this.color = objFromServer[count++];	// color label
				break;
			case 200:
				this.title = objFromServer[count++];	// title				
				break;
			case 201:
				startDate = new Date(objFromServer[count]);
				this.startDate = new Date(objFromServer[count++]);
				this.start = parseInt(((startDate.getUTCHours() * 60) + startDate.getUTCMinutes())/(60/hoursplit));
				this.starthuman = formatDate(startDate, "time");	// human readable start time
				if((this.starthuman.length - (this.starthuman.lastIndexOf(":"))) < 3)
					this.starthuman = this.starthuman + "0";
				if(this.starthuman.length < 5)
					this.starthuman = "0" + this.starthuman;
				break;
			case 202:
				var endDate = new Date(objFromServer[count]);
				this.endDate = new Date(objFromServer[count++]);
				this.endhuman = formatDate(endDate, "time");	// human readable end time
				var activeDate = (new Date(activeYear, activeMonth, activeDay)).getTime();
				var startDateTmp = (new Date(startDate.getUTCFullYear(), startDate.getUTCMonth(), startDate.getUTCDate())).getTime();
				var endDateTmp = (new Date(endDate.getUTCFullYear(), endDate.getUTCMonth(), endDate.getUTCDate())).getTime();
				if(startDateTmp != endDateTmp){
					if(startDateTmp == activeDate && endDateTmp > activeDate){
						endDate.setUTCMonth(activeMonth);
						endDate.setUTCDate(activeDay);
						endDate.setUTCHours(24);
						endDate.setUTCMinutes(0);
					} else if(startDateTmp < activeDate && endDateTmp > activeDate){
							if(startDate.getUTCDate() != 31){
								startDate.setUTCMonth(activeMonth);
								startDate.setUTCDate(activeDay);
							} else {
								startDate.setUTCDate(activeDay);
								startDate.setUTCMonth(activeMonth);
							}
							startDate.setUTCHours(0);
							startDate.setUTCMinutes(0);
							startDate.setUTCSeconds(0);
							if(endDate.getUTCDate() != 31){					
								endDate.setUTCMonth(activeMonth);
								endDate.setUTCDate(activeDay);
							} else {
								endDate.setUTCDate(activeDay);
								endDate.setUTCMonth(activeMonth);
							}
							endDate.setUTCHours(24);
							endDate.setUTCMinutes(0);
							endDate.setUTCSeconds(0);
							this.start = startDate.getUTCHours() + "." + (parseInt((startDate.getUTCMinutes()/15), 10)*25);	// startdate to calculating
					} else if(startDateTmp < activeDate && endDateTmp == activeDate) {
							if(startDate.getUTCDate() != 31){
								startDate.setUTCMonth(activeMonth);
								startDate.setUTCDate(activeDay);
							} else {
								startDate.setUTCDate(activeDay);
								startDate.setUTCMonth(activeMonth);
							}
							startDate.setUTCHours(0);
							startDate.setUTCMinutes(0);
							this.start = startDate.getUTCHours() + "." + (parseInt((startDate.getUTCMinutes()/15), 10)*25);	// startdate to calculating
					}
				}
				this.start = Number(this.start);
				var minutes = ((endDate.getTime() - startDate.getTime())/60000);
				this.end = minutes/(60/hoursplit); // duration for calculating;
				//TODO calculate the correct length dependent on the hoursplit
				if(this.end > 24*hoursplit)
					this.end = 24*hoursplit-this.start;
				if(this.end == 0)
					this.end += 1;
				if((this.endhuman.length - (this.endhuman.lastIndexOf(":"))) < 3)
					this.endhuman = this.endhuman.substring(0, this.endhuman.indexOf(":")) + ":0" + this.endhuman.substring(this.endhuman.indexOf(":")+1);					
				break;
			case 203:
				this.discription = objFromServer[count++];	// discription
				break;
			case 207:
				this.recurrence_position = objFromServer[count++];
				break;				
			case 209:
				this.recurrence_type = objFromServer[count++];
				break;				
			case 217:
				this.notification = objFromServer[count++];
				break;
			case 220:
				this.participants = objFromServer[count++];
				break;
			case 400:
				this.locat = objFromServer[count++];		// location
				break;
			case 401:
				this.fulltime = objFromServer[count++];	// hole day appointment
				break;	
			case 402:
				this.shown = objFromServer[count++];	// 
				break;
			case 206:
                this.recurrence_id = objFromServer[count++]; 
                break;
            case 2:
                this.created_by = objFromServer[count++];
            default:            
				break;
		}
	}
}	

function displayNameDayView(){
	oMainFolderTree.cache.get_folder(activefolder,displayNameDayViewCb);
}

function calendar_getAllFoldersAttribute() {	
	return configGetKey("gui.calendar.allfolders") && calendar_activeallfolders;
}

function displayNameDayViewCb(oFolder) {
	calendar_activeallfolders = false;
	if (oFolder.oxfolder.data.type == 1 || oFolder.oxfolder.data.type == 3){
        calendar_activeallfolders = oFolder.oxfolder.data.type == 1 ? true : false;
    }	
	if (oFolder.oxfolder.data.created_by) {
		internalCache.getUsers([oFolder.oxfolder.data.created_by], function(cbObj){
			if(oFolder.oxfolder.data.type == 1 || oFolder.oxfolder.data.type == 3) {
				if (oFolder.oxfolder.data.type == 1) {
					$("allAppointmentListViewDiv").style.visibility = "visible";
					$("allAppointmentsWeekViewDiv").style.visibility = "visible";
					$("allAppointmentsWorkWeekViewDiv").style.visibility = "visible";
					$("allAppointmentsMonthViewDiv").style.visibility = "visible";
					calendar_activeallfolders=true;
				} else {
					$("allAppointmentListViewDiv").style.visibility = "hidden";
					$("allAppointmentsWeekViewDiv").style.visibility = "hidden";
					$("allAppointmentsWorkWeekViewDiv").style.visibility = "hidden";
					$("allAppointmentsMonthViewDiv").style.visibility = "hidden";
					calendar_activeallfolders=false;
				}
			} else if (oFolder.oxfolder.data.type == 2) {
				$("allAppointmentListViewDiv").style.visibility = "hidden";
				$("allAppointmentsWeekViewDiv").style.visibility = "hidden";
				$("allAppointmentsWorkWeekViewDiv").style.visibility = "hidden";
				$("allAppointmentsMonthViewDiv").style.visibility = "hidden";
				calendar_activeallfolders=false;
			}
		});
	}
}

function showAllAppointments(){
	if(calendar_getAllFoldersAttribute()){
		$("allAppointmentListView").checked = "";
		configSetKey("gui.calendar.allfolders",false);
		if(currentpath2[1] == "list") {
			initLiveGridCalendar(currentpath2[2]);
		}
	} else {
		$("allAppointmentListView").checked = "checked";
		configSetKey("gui.calendar.allfolders",true);
		if(currentpath2[1] == "list") {
			initLiveGridCalendar(currentpath2[2]);
		} 		
	}
}
function openMailToApp(oDate,oMailObjects,sMod)
{
	if(sMod == "contacts")
	{
		var aIds=new Array();
		for(var indx=0;indx< oMailObjects.length;indx++)
		{
			aIds.push({id:oMailObjects[indx].id,folder:oMailObjects[indx].folder});
		}
		json.put(AjaxRoot + '/contacts?action=list&session='+session+"&columns="+"1,20,500,555,524,556,557",aIds,null,function (arg){
			calendar_createNewAppointment(oDate,configGetKey("folder.calendar"),false,{module:sMod,data:arg.data});		
		});
	}
	else
		calendar_createNewAppointment(oDate,configGetKey("folder.calendar"),false,{module:sMod,data:oMailObjects});
}
function openAppointmentPopup(e) {
	triggerEvent("OX_Clear_All_Edit_Lines");	
	var selappoint;

	function edit_whole_series() {
		var app_id = selappoint.recurrence_id || selappoint.id;
		appointmentPopup=newWindow("newAppointment.html#modul=edit&view="+currentCalendarView+"&id="+app_id+"&recurrence_position=0&folder_id="+selappoint.folder, getWindowOptions(), selappoint);
	}
	function edit_single_series() {
		appointmentPopup=newWindow("newAppointment.html#modul=edit&view="+currentCalendarView+"&id="+selappoint.id+"&recurrence_position="+selappoint.recurrence_position+"&folder_id="+selappoint.folder+"&singleappointment=yes", getWindowOptions(), selappoint);
	}
	function edit_single_appointment() {
		appointmentPopup=newWindow("newAppointment.html#modul=edit&view="+currentCalendarView+"&id="+selappoint.id+"&recurrence_position=0&folder_id="+selappoint.folder, getWindowOptions(), selappoint);
	}
	
	if(selectedAppointment.length){
		selappoint=selectedAppointment[0];
	} else {
		selappoint=selectedAppointment;
	}
	if(selappoint.recurrence_position > 0 && selappoint.recurrence_id &&
	   selappoint.recurrence_id == selappoint.id) {
		newConfirm(_("Edit Appointment"),_("Do you want to edit the whole series or a single series appointment?"),AlertPopup.SERIESBUTTON,null,null,null,null,edit_whole_series,edit_single_series);
	} else {
		edit_single_appointment();
	}
	if (e) { stopEvent(e) };
}
function deleteAppointment(){
	if (activemodule == "calendar"){
		if(currentpath2[1] == "list")
			var timestamplocal= calendarGrid.storage.timestamp;
		else if(currentpath2[1] == "calendar")
			var timestamplocal = lastUpdateOfCalendarTimestamp;
		else if(currentpath2[1] == "detail")
			var timestamplocal = lastUpdateOfCalendarTimestamp;
	}
	
	todelete=[];
	if(selectedAppointment.length){
		todelete=selectedAppointment;
	} else { 
		todelete[0]=selectedAppointment;
	}
	for(var i = 0; i<todelete.length;i++){
		if(todelete[i].id.toString().indexOf("_")  != -1)
			todelete[i].id = todelete[i].id.substring(0,todelete[i].id.indexOf("_"));
	}
	var isseries=false;
	for(var x=0; x<todelete.length; x++) {
		if (todelete[x].recurrence_position > 0 && todelete[x].recurrence_id != null) {
			isseries=true;
			break;
		}
	}
	
	var fn_afterDelete_Appoitment = function(cb) {
		triggerEvent("OX_Refresh_Mini_Calendar");
		for(var i=0; i<cb.length;i++){
			if(cb[i] && cb[i].error){
				newServerError(cb[i],4);	
			}
		}
		window.setTimeout(function() {
			if(currentpath[0] == "calendar") {
				if(currentpath2[1] == "calendar") {
					window.setTimeout("storageCache.update()", 300);
				} else if(currentpath2[1] == "list") {
					if(currentpath2[2] != "search") {
						storageCache.update();
					} else {
						calendarSearch(lastCalendarSearch.module, lastCalendarSearch.searchstring, null, null, lastCalendarSearch.folder);
					}
				} else if(currentpath2[1] == "detail") {
					triggerEvent("OX_Switch_View",configGetKey("gui.calendar.view"));
				}
			} 
			selectedAppointment={};	
			triggerEvent("Selected",new Array());
		},0);
	}
	
	function delete_single_series() {
		var multipleArray = [];
		for(var i = 0; i < todelete.length; i++){
			multipleArray[i] = {action : "delete", module : "calendar", timestamp : timestamplocal, data : todelete[i]};
		}
		json.put(AjaxRoot + "/multiple?session="+session +"&continue=true", multipleArray, null, fn_afterDelete_Appoitment);	
	}
	function delete_whole_series() {
		var multipleArray = [];
		var deleteobject=new Object();
		var newtodelete=new Array();
		for(var i = 0; i < todelete.length; i++){	
			if(!deleteobject[todelete[i].folder+":"+todelete[i].id]) {
				deleteobject[todelete[i].folder+":"+todelete[i].id]=true;
				newobject=new Object();
				newobject.id=todelete[i].recurrence_id || todelete[i].id;
				newobject.folder=todelete[i].folder;
				newtodelete.push(newobject);
			}
		}
		for (var i=0; i<newtodelete.length; i++) {	
			multipleArray[i] = { action : "delete", module : "calendar", timestamp : timestamplocal, data : newtodelete[i]};
		}
		json.put(AjaxRoot + "/multiple?session="+session +"&continue=true", multipleArray, null, fn_afterDelete_Appoitment);
	}
	if (todelete.length==1) {
		if (isseries) {
			newConfirm(_("Delete Appointment"),_("Do you want to delete the whole series or a single series appointment ?"),AlertPopup.SERIESBUTTON,null,null,null,null,delete_whole_series,delete_single_series);
		} else {
			newConfirm(_("Delete Appointment"),_("Are you sure you want to delete the selected item?"),AlertPopup.YESNO,null,null,delete_whole_series,null,null);
		}
	} else {
		if (isseries) {
			newConfirm(_("Delete Appointment"),_("Do you want to delete the whole series or a single series appointments?"),AlertPopup.SERIESBUTTON,null,null,null,null,delete_whole_series,delete_single_series);
		} else {
			newConfirm(_("Delete Appointment"),_("Are you sure you want to delete the selected items?"),AlertPopup.YESNO,null,null,delete_whole_series,null,null);
		}
		
	}
}
function cancelConflict(){
	$("appointmentConflictWindow").style.display = "none";
	storageCache.update();
}
function ignoreConflict(){
	if(dragObjDayView){
		dragAppointmentDayView.ignore_conflicts = true;
		json.put(AjaxRoot + "/calendar?action=update&session=" + session + "&id=" + dragObjDayView.id + "&timestamp=" + lastUpdateOfCalendarTimestamp + "&folder=" + dragObjDayView.folder, dragAppointmentDayView, null, function(cb){
				if(!cb.error && !cb.data.conflicts){
					storageCache.update();
				}
			});
	}
	dragObjDayView = null;
	$("appointmentConflictWindow").style.display = "none";
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
 
/**
 * define day
 */
function cDay(nDateParam,nCurrMonthParam,bWeekendParam)
{
	this.nDate = nDateParam;
	this.nCurrMonth = nCurrMonthParam; 		 //flags: 0 last month, 1 current month, next month
	this.bWeekend = bWeekendParam;			 //true, false
}

/**
 * define week
 */
function cWeek()
{
	this.nKW;	
	this.aDays= new Array();	
	this.addDay = function (nDay,oDay)
	{
		this.aDays[nDay] = oDay;
	}
	this.setKW = function (nKWParam)	
	{
		this.nKW = nKWParam;
	}
}

/*
 * defines calender:
 */
function cCalendar(nMonthParam,nYearParam)
{
	this.nMonth = nMonthParam;
	this.nYear = nYearParam;
	this.aWeeks= new Array();
	/*
	 * compute Calendar
	 */
	this.addWeek = function (nNumWeek,oWeekParam)
	{
		this.aWeeks[nNumWeek] = oWeekParam;			
	}	
	 
	this.init = function ()
	{
		var oCalendarTool = new calendarTool(this.nMonth, this.nYear);
		oCalendarTool.init();		
		var nNumWeeks = oCalendarTool.getNumWeeks();
		var	startByDate = oCalendarTool.endDate - oCalendarTool.firstDay+1;			
		var nDayCounter = 0; var nDayNextMonth = 1;var nDayCurrMonth = 1;
		for(nWeek=0;nWeek < nNumWeeks;nWeek++)
		{			
			var oWeek = new cWeek();
			var oThDate = new Date();
			oThDate.setFullYear(oCalendarTool.nYear);
			oThDate.setDate(1);	
			oThDate.setMonth(oCalendarTool.nMonth);				
			
			for(indexDay=0;indexDay<7;indexDay++)
			{				
				if(indexDay > 4)
				 	bWeekend = true;
				else				 	
				 	bWeekend = false;				 	
				if(nDayCounter<oCalendarTool.firstDay)
				{
					var oDay = new cDay(startByDate+nDayCounter,0,bWeekend);
					if(indexDay==3) //th
					{
						oThDate.setDate(startByDate+nDayCounter);
						oThDate.setMonth(oThDate.getMonth()-1);						
					}
				}				
				else if(nDayCounter>=(oCalendarTool.nDays+oCalendarTool.firstDay))
				{
					var oDay = new cDay(nDayNextMonth,2,bWeekend);
					if(indexDay==3) //Th
					{
						oThDate.setDate(nDayNextMonth);
						oThDate.setMonth(oThDate.getMonth()+1);		
					}
					nDayNextMonth++;
				}				
				else
				{
					var oDay = new cDay(nDayCurrMonth,1,bWeekend);
					if(indexDay==3)
					{					
						oThDate.setDate(nDayCurrMonth);
						oThDate.setMonth(oThDate.getMonth());
					}
					nDayCurrMonth++;
				}	
				oWeek.addDay(indexDay,oDay);
				oWeek.setKW(oCalendarTool.getKW(oThDate.getFullYear(),oThDate.getMonth(),oThDate.getDate()));				
				nDayCounter++;
			}
			this.addWeek(nWeek,oWeek);
		}		
	}
	
	this.init();	

}

/*
 * tools for calendar computing
 */
function calendarTool(nMonthParam,nYearParam) {
	this.firstDay;
	this.startWeek;
	this.endDate;
	this.nDays;	
	
	this.nMonth = nMonthParam;	
	this.nYear = nYearParam;	
	this.curr_date;	
	this.init = function () {
		var currDate = new Date();
		currDate.setFullYear(this.nYear);
		currDate.setDate(1);
		currDate.setMonth(this.nMonth);
		currDate.setUTCDate(currDate.getUTCDate()-1);

		this.endDate = currDate.getDate();	
		currDate.setUTCDate(currDate.getUTCDate()+1);	
		this.startWeek =  this.getKW(currDate.getFullYear(),currDate.getMonth(),1);
		this.firstDay = currDate.getDay();
		if(this.firstDay>0) this.firstDay -= 1;	
		else if(this.firstDay==0) this.firstDay=6;		
		//compute num days	
		currDate.setMonth(currDate.getMonth()+1);
		currDate.setUTCDate(currDate.getUTCDate()-1);
		this.nDays = currDate.getDate();		
		this.curr_date = currDate;
	}
	
	this.getNumWeeks = function() {	
		var fullWeeks = parseInt(this.nDays/7);
		var overflow = this.nDays - fullWeeks*7;
		if(this.firstDay > 0)
			fullWeeks++;
		if ((7 - this.firstDay) < overflow || (overflow>0 && this.firstDay==0)) {
			fullWeeks++;
		}
		return fullWeeks;
	}
	
	//private functions
	/*
	 * compute calendar week
	 */
	this.getKW =function (j,m,t) {
		Datum=new Date(j,m,t);
		DoDat=this.donnerstag(Datum);
		kwjahr=DoDat.getFullYear();
		DoKW1=this.donnerstag(new Date(kwjahr,0,4));
		kw=Math.floor(1.5+(DoDat.getTime()-DoKW1.getTime())/86400000/7);
		return kw;
	}
	
	/*
	 * compute first thursday, getKW need it
	 */
	this.donnerstag = function (datum) {
	  var Do=new Date();
	  Do.setTime(datum.getTime() + (3-((datum.getDay()+6) % 7)) * 86400000);
	  return Do;
	}
	
	this.sonntag = function (datum) { 
	  var Do=new Date();
	  Do.setTime(datum.getTime() + (3-((datum.getDay()+6) % 7)) * 86400000);
	  Do.setUTCDate(Do.getUTCDate()-4);
	  return Do;
	}	
	
	this.init();
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Markus Wagner <markus.wagner@open-xchange.com>
 * 
 */

var calendarGrid = null;
var lastUpdateOfCalendarTimestamp = "";
var idsCalendarForSelected = new Array();
var lastCalendarSearch = {};
function calendarDeleteSearch()
{	
	calendarGrid.sort = function(id, order) {
		initLiveGridCalendar(currentpath2[2]);
	};	
	triggerEvent("OX_Switch_View", configGetKey("gui.calendar.view"));
}
function initCalenderLiveGridOnLoad() {
	
	if (calendarGrid) {
		removeChildNodes($("listeCalendar"));
		calendarGrid = null;
	}
	
	calendarGrid = new LiveGrid([
		{	
			text: "&#160;",
			sortable: false,
			width: "16px",
			style: {padding: 0},
			set: function(div, text) {
				if (div.firstChild)
					div.firstChild.src = text > 0 ? getFullImgSrc("img/calendar/calendar_series.gif") : getFullImgSrc("img/calendar/calendar16x16.gif");
				else
					div.appendChild(newnode("img", 0,
						{src: text > 0 ? getFullImgSrc("img/calendar/calendar_series.gif") : getFullImgSrc("img/calendar/calendar16x16.gif"), alt: "Serie"}));
			},
			clear: function(div) {
				if (div.firstChild)
					div.firstChild.src = getFullImgSrc("img/dummy.gif");
				else
					div.appendChild(newnode("img", 0,
						{src: getFullImgSrc("img/dummy.gif"), alt: "Serie", width: "16", height: "16"}));
			},
			index:5
		}, {	
			text: "&#160;",
			sortable: false,
			width: "16px",
			style: {padding: 0},
			set: function(div, text) {
				if(text[12] && text[12].length > 1) {
					var imgSrc = getFullImgSrc("img/calendar/group.gif");
				} else {
					var imgSrc = getFullImgSrc("img/dummy.gif");
				}
				if (div.firstChild) {
					div.firstChild.src = !text[6] ? imgSrc : getFullImgSrc("img/private_flag.gif");
					div.firstChild.alt = !text[6] ? "G" : "P";
				} else {
					div.appendChild(newnode("img", 0,
						{
							src: !text[6] ? imgSrc : getFullImgSrc("img/private_flag.gif"),
							alt: !text[6] ? "G" : "P",
							width: "16", 
							height: "16"							
						}));
				}
			},
			clear: function(div) {
				if (div.firstChild)
					div.firstChild.src = getFullImgSrc("img/dummy.gif");
				else
					div.appendChild(newnode("img", 0,
						{src: getFullImgSrc("img/dummy.gif"), alt: "G", width: "16", height: "16"}));
			}
		}, {
            i18n: "description", /*i18n context*/
			text: "Title", /*i18n*/
			sortable: true,
			id: 200,
			set: LiveGrid.defaultSet,
			clear: LiveGrid.makeClear(""),
			index:7
		}, {
			text: "Start", /*i18n*/
			sortable: true,
			i18n: true,
			id: 201,
			width: "14%",
			set: function(div, data) {
                if (!div.firstChild) {
                    div.appendChild(document.createTextNode(" "));
                }
                if (data) {
                    var dateToShow = data[8];
                    if (data[13] == true) {
                        div.firstChild.data=formatDate(dateToShow, "date");
                    } else {
                        div.firstChild.data=formatDate(dateToShow, "datetime");
                    }           
                } else {
                    div.firstChild.data=""; 
                }               
            },
			clear: LiveGrid.makeClear("")
		}, {
			text: "End", /*i18n*/
			sortable: true,
			i18n: true,
            id: 202,
			width: "14%",
			set: function(div, data) {
				if (!div.firstChild) {
					div.appendChild(document.createTextNode(" "));
				}
				if (data) {
					var dateToShow = data[9];
					/*
					 * if it's a full day appointment it's minus one day
					 */
					if (data[13] == true) {
						dateToShow -= 864e5; /* ms/day */
						div.firstChild.data=formatDate(dateToShow, "date");
					} else {
						div.firstChild.data=formatDate(dateToShow, "datetime");
					}			
				} else {
				    div.firstChild.data="";	
				}				
			},
			clear: LiveGrid.makeClear("")
		}, {
			text: "Location", /*i18n*/
			sortable: true,
			i18n: true,
			id: 400,
			width: "10%",
			set: LiveGrid.defaultSet,
			clear: LiveGrid.makeClear(""),
			index:10
		}, {
			text: "Folder", /*i18n*/
			sortable: false,
			i18n: true,
			id: 20,
			width: "14%",
			set: function(div,text) {
					if(text > 0){
						oMainFolderTree.get_folder_path(text, function(path){
							var tmp = path.split("/");
							if(tmp.length == 1){
								if(div.firstChild)
									div.firstChild.data = tmp[tmp.length-1];
								else
									div.appendChild(document.createTextNode(tmp[tmp.length-1]));
							}
							else {
								if(div.firstChild)
									div.firstChild.data = tmp[tmp.length-2];
								else
									div.appendChild(document.createTextNode(tmp[tmp.length-2]));
							}
						});
					} else {
						if(div.firstChild)
							div.firstChild.data = " ";
						else
							div.appendChild(document.createTextNode(" "));
					}
			},
			clear: LiveGrid.makeClear(""),
			index:1
		}, {
			text: "Flag", /*i18n*/
			sortable: true,
			i18n: true,
			id: 102,
			width: "4em",
			set: function(div,text) {
				if (div.firstChild)
					div.firstChild.src = getFullImgSrc("img/menu/tag_" + (text||0) + ".gif");
				else
					div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/menu/tag_" + (text||0) + ".gif"), alt: "tag"}));
			},
			clear: function(div) {
				if (div.firstChild)
					div.firstChild.src = getFullImgSrc("img/dummy.gif");
				else
					div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/dummy.gif"), alt: "tag", width: "16", height: "16"}));
			},
			index:11
		}
	], calendarSelection, "calendar");
	
	calendarGrid.sort = function(id, order) {
		initLiveGridCalendar(currentpath2[2]);
	};
	
	calendarGrid.sort_id = 201;
	calendarGrid.sort_order = "asc";

	$("listeCalendarHeader").appendChild(calendarGrid.getHeader());
	calendarGrid.getTable($("listeCalendar"));
	
	// livegrid double click 
	calendarGrid.events.register("Activated", function(ids){
		if(ids && ids.length > 0) {
			if(menuhasRight(ids,"WRITE")) {
				selectedAppointment = ids;
				openAppointmentPopup();
			} else {
				triggerEvent("OX_New_Error", 4, _("You do not have write permission for this object."));
			}
		} else {
			triggerEvent("OX_Before_Create_Calendar");
		}
	});
	
	// what to do when select a appointment
	calendarGrid.events.register("Selected", function(ids){
		selectedAppointment = calendarGrid.selection.getSelected();
		triggerEvent("Selected", selectedAppointment);
	});
	
	calendarGrid.events.register("Delete", function(ids){
		if(menucheckRight("DELETE"))
			deleteAppointment();
		else
			triggerEvent("OX_New_Error", 4, _("You do not have write permission for this object."));
	});
	var hover = calendarGrid.addHover(OXAppointmentHover.getContent().node, function(id) {
		OXAppointmentHover.actualHover=hover;
		OXAppointmentHover.refillContent(id.id,id.folder,id.recurrence_position);					
	});
	hover.setSize(OXAppointmentHover.contentobject.node);
}
var cwwcurrentmonday
function initLiveGridCalendar(range) {
	showallappointments=calendar_getAllFoldersAttribute();
	$("allAppointmentListView").checked=showallappointments;
	
	var start = null;
	var end = null;
	switch(range){
		case "day":	
				start = Date.UTC(activeYear, activeMonth, activeDay);
				end = Date.UTC(activeYear, activeMonth, (activeDay+1));
				break;
		case "month":
				start = Date.UTC(activeYear, activeMonth, 1);
				end = Date.UTC(activeYear, activeMonth + 1, 1);
				break;
		case "workweek":
		        start = getDayInSameWeek(new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)), startofweek) * 864e5;		        
				end = start +(cwwdaysinweek*1000*60*60*24);
				break;
		case "week":
				start = getDayInSameWeek(new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)), weekStart) * 864e5;
				end = start + 604800000;
				break;
		case "search":
				calendarGrid.sort = function (sort, order) {
					calendarSearch(lastCalendarSearch.module, 
					       lastCalendarSearch.searchstring,
					       { sort: sort, order: order},
					       null, lastCalendarSearch.folder
                        )};
				calendarGrid.disablehover=!configGetKey("gui.effects.hover.calendar");
				calendarGrid.enable(tmpStorage);
				break;
	}
	if(end != null && start != null){
		if(!calendar_getAllFoldersAttribute()){
				var options = {action: "all", folder: activefolder, start : start, end : end, columns : "1, 20, 207, 206, 2"};
				if (calendarGrid.sort_id) {
					options.sort = calendarGrid.sort_id;
					options.order = calendarGrid.sort_order;
				}
				storageCache.get(
					AjaxRoot + "/calendar",
					options,
					function(storage) {
						calendarGrid.disablehover=!configGetKey("gui.effects.hover.calendar");
						calendarGrid.enable(storage);
						storageCache.update();
					},
					"209,101,200,201,202,400,102,220,401",
					true,
					calendar_serializeid,
					calendar_makeID
				);
		} else {
			var options = {action: "all", start : start, end : end, columns : "1, 20, 207, 206, 2"};
			if (calendarGrid.sort_id) {
				options.sort = calendarGrid.sort_id;
				options.order = calendarGrid.sort_order;
			}
			storageCache.get(
				AjaxRoot + "/calendar",
				options,
				function(storage) {
					calendarGrid.disablehover=!configGetKey("gui.effects.hover.calendar");
					calendarGrid.enable(storage);
					storageCache.update();
				},
				"209,101,200,201,202,400,102,220,401",
				true,
				calendar_serializeid,
				calendar_makeID
			);
		}
	}
	updateHeaderListView();
}

function goToNextListView(direction){
	var tmp = new Date(Date.UTC(activeYear, activeMonth, activeDay));
	var start = null;
	var end = null;
	if(direction > 0){
		switch(currentpath2[2]){
			case "day":
				tmp.setTime(tmp.getTime() + 86400000*1);
				break;
			case "workweek":
				tmp.setTime(tmp.getTime() + 86400000*7);
				break;
			case "week":
				tmp.setTime(tmp.getTime() + 86400000*7);
				break;
			case "month":
				tmp.setUTCDate(1);
				tmp.setUTCMonth(activeMonth+1);
				tmp.setUTCDate(activeDay);
				break;
		}
	} else {
		switch(currentpath2[2]){
			case "day":
				tmp.setTime(tmp.getTime() - 86400000*1);
				break;
			case "workweek":
				tmp.setTime(tmp.getTime() - 86400000*7);
				break;
			case "week":
				tmp.setTime(tmp.getTime() - 86400000*7);
				break;
			case "month":
				tmp.setUTCDate(1);
				tmp.setUTCMonth(activeMonth-1);
				tmp.setUTCDate(activeDay);
				break;
		}
	}
	
	activeYear = tmp.getUTCFullYear();
	activeMonth = tmp.getUTCMonth();
	activeDay = tmp.getUTCDate();
	
	if (oMiniCalendar) oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
		
	switch(currentpath2[2]){
		case "day":	
				start = Date.UTC(activeYear, activeMonth, activeDay);
				end = Date.UTC(activeYear, activeMonth, (activeDay+1));
				break;
		case "month":
				start = Date.UTC(activeYear, activeMonth, 1);
				end = Date.UTC(activeYear, activeMonth+1, 1);
				break;
		case "workweek":
				start = getDayInSameWeek(new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)), startofweek) * 864e5;
				end = start + 435600000;
				break;
		case "week":
				start = getDayInSameWeek(new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)), weekStart) * 864e5;
				end = start + 604800000;
				break;
		case "search":
				calendarGrid.disablehover=!configGetKey("gui.effects.hover.calendar");
				calendarGrid.enable(tmpStorage);
				break;
	}
	if(end != null && start != null){
		if(!$("allAppointmentListView").checked){
				var options = {action: "all", folder: activefolder, start : start, end : end, columns : "1, 20, 207, 206, 2"};
				if (calendarGrid.sort_id) {
					options.sort = calendarGrid.sort_id;
					options.order = calendarGrid.sort_order;
				}
				storageCache.get(
					AjaxRoot + "/calendar",
					options,
					function(storage) {
						calendarGrid.disablehover=!configGetKey("gui.effects.hover.calendar");
						calendarGrid.enable(storage);
						storageCache.update();
					},
					"209,101,200,201,202,400,102,220,401",
					true,
					calendar_serializeid,
					calendar_makeID
				);
		} else {
			var options = {action: "all", start : start, end : end, columns : "1, 20, 207, 206, 2"};
			if (calendarGrid.sort_id) {
				options.sort = calendarGrid.sort_id;
				options.order = calendarGrid.sort_order;
			}
			storageCache.get(
				AjaxRoot + "/calendar",
				options,
				function(storage) {
					calendarGrid.disablehover=!configGetKey("gui.effects.hover.calendar");
					calendarGrid.enable(storage);
					storageCache.update();
				},
				"209,101,200,201,202,400,102,220,401",
				true,
				calendar_serializeid,
				calendar_makeID
			);
		}
	}
	updateHeaderListView();
}

function updateHeaderListView() {
	switch(currentpath2[2]){
		case "day":
			$("calendarlistheaderdiv").style.visibility = "visible";
			$("calendarlistheader").firstChild.data=formatDate(new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)), "dateday");
			break;
		case "week": //No break
		case "workweek":
			$("calendarlistheaderdiv").style.visibility = "visible";		
			var oCalendarTool = new calendarTool(activeMonth,activeYear);
			$("calendarlistheader").firstChild.data = _("CW") + " " + oCalendarTool.getKW(activeYear,activeMonth,activeDay) + " " + activeYear;
			break;
		case "month":
			$("calendarlistheaderdiv").style.visibility = "visible";		
			$("calendarlistheader").firstChild.data = formatDateTime("MM/yyyy", new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)));
			break;
		case "search":
			$("calendarlistheaderdiv").style.visibility = "hidden";
			$("calendarlistheader").firstChild.data = ' ';
			break;
	}
}

function disableCalendarGrid(){
	if(calendarGrid)
		calendarGrid.disable();
	unregister("OX_Add_Flag", calendarAddTag);
}
var currentCalendarTagProgress = false;
function calendarAddTag(tag) {
	if(currentCalendarTagProgress) return;
	currentCalendarTagProgress = true;
	var tmpselected;
	if(currentpath2[0] == "calendar" && currentpath2[1] == "list" && storageCache.current){
		lastUpdateOfCalendarTimestamp = storageCache.current.timestamp;
	}
	function edit_whole_series() {
		for(var i=0;i<tmpselected.length;i++) {
			tmpselected[i] = { id : tmpselected[i].id, folder : tmpselected[i].folder };
		}
		setTag(tag, tmpselected, lastUpdateOfCalendarTimestamp, finalSetTag);
	}
	function edit_single_series() {
		setTag(tag, tmpselected, lastUpdateOfCalendarTimestamp, finalSetTag);			
	}
	if(selectedAppointment.length){
		tmpselected=selectedAppointment;
	} else { 
		tmpselected=[selectedAppointment];
	}
	var isseries=false;
	for(var x=0;x<tmpselected.length;x++) {
		if(tmpselected[x].recurrence_position>0 && tmpselected[x].recurrence_id &&
		   tmpselected[x].recurrence_id == tmpselected[x].id) {
			isseries=true;
			break;
		}
	}
	if(isseries) {
		if(tmpselected.length>1) {
			newConfirm(_("Edit Appointment"),_("Do you want to edit the whole series or single series appointments?"),AlertPopup.SERIESBUTTON,null,null,null,null,edit_whole_series,edit_single_series);			
		} else {
			newConfirm(_("Edit Appointment"),_("Do you want to edit the whole series or a single series appointment?"),AlertPopup.SERIESBUTTON,null,null,null,null,edit_whole_series,edit_single_series);						
		}		
	} else {
		setTag(tag, tmpselected, lastUpdateOfCalendarTimestamp, finalSetTag);
	}
	
	function finalSetTag(timestamp) {	
		lastUpdateOfCalendarTimestamp = timestamp;
		if(currentpath2[0] == "calendar" && currentpath2[1] == "detail")
			reloadAppDetailView();
		else
			updateCalendarViewCbSetTag(timestamp);
	}
}
var tmpStorage;
function endProgressCalendarTagging() {
	window.setTimeout(function(){currentCalendarTagProgress = false;},0);	
}

function updateCalendarViewCbSetTag(currentTagTimestamp) {
	
	if(currentpath2[0] == "calendar" && currentpath2[1] != "detail" && currentpath2[2] != "search"){
	window.setTimeout('endProgressCalendarTagging()',0);
		if(storageCache)
			storageCache.update(endProgressCalendarTagging);
	} else if(currentpath2[2] == "search"){
		if(currentTagTimestamp) {
			if(storageCache && storageCache.current)
				storageCache.current.timestamp = currentTagTimestamp;
		}
		calendarSearch(lastCalendarSearch.module, lastCalendarSearch.searchstring, null, endProgressCalendarTagging, lastCalendarSearch.folder);
	}
}

//var sPatternCalendarsearch;
function calendarSearch(module, searchstring, order, callback, folder) {
	//var sPatternCalendarsearch = searchstring;
	tmpStorage = new Storage(lastUpdateOfCalendarTimestamp, [], "", 0, 0, calendar_serializeid, calendar_makeID);
	lastCalendarSearch.module = module;
	lastCalendarSearch.searchstring = searchstring;
	lastCalendarSearch.folder = folder || (calendar_getAllFoldersAttribute() ? null : activefolder);	
	var sOrderString="";
	if (order) {
		sOrderString = "&sort=" + order.sort + "&order=" + order.order;
	}
	var sObject = { };
	sObject["pattern"] = searchstring;
	if (lastCalendarSearch.folder) {
		sObject["folder"] = lastCalendarSearch.folder;
	}
	json.put(AjaxRoot + "/calendar?action=search&session=" + session 
	       + "&columns=1,20,207,206,2,209,101,200,201,202,400,102,220,401" 
	       + sOrderString, sObject, null, 
				function(cb){
					if(callback) callback();
					tmpArray = new Array();
					for(var i=0; i < cb.data.length; i++){
						tmpArray[i] = [	cb.data[i][0],
										cb.data[i][1],
										cb.data[i][2],
										cb.data[i][3],
										cb.data[i][4],
										cb.data[i][5],
										cb.data[i][6],
										cb.data[i][7],
										cb.data[i][8],
										cb.data[i][9],
										cb.data[i][10],
										cb.data[i][11],
										cb.data[i][12],
										cb.data[i][13]
									]; 
					}
					tmpStorage.append(tmpArray);
					lastUpdateOfCalendarTimestamp = cb.timestamp;
					storageCache.current.timestamp = cb.timestamp;
					if(!calendarGrid){
						triggerEvent("OX_Switch_View", "calendar/list/search");
					} else if(currentpath2[2] != "search"){
						triggerEvent("OX_Switch_View", "calendar/list/search");
					} else {
						calendarGrid.disablehover=!configGetKey("gui.effects.hover.calendar");
						calendarGrid.enable(tmpStorage);
					}					
	});	
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
// TEST DATA
var nNumCharAppointmentView = 10;
var calendarJson = new JSON();
//Global Vars
var monthViewCreated = false;
var calendarObjects;
var nMonthGlob; 
var nYearGlob;
var tmptimeOutDouble = false;
var tmptimeOutSingle = null;
var aAppointmentAssoc = new Object();
var sAssocMonthArray = new Object();
var aSelectedAppArray = new Array();
var oMonthViewObj;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//GUI Actions

function showAllAppointmentsMonth(){
	if(!$("allAppointmentMonthView").checked){
		configSetKey("gui.calendar.allfolders",false);
		oMonthViewObj.refreshMonthView(false);
	} else {
		configSetKey("gui.calendar.allfolders",true);
		oMonthViewObj.refreshMonthView(true);
	}
}

function refreshMonthView(changeFolder) {
	if (changeFolder!=undefined && changeFolder) {
		oMonthViewObj.refreshMonthView(calendar_getAllFoldersAttribute());
	} else {
		function fn() {
			if(!configContainsKey("gui.calendar.allfolders"))	
				oMonthViewObj.refreshMonthView(calendar_getAllFoldersAttribute());
		}
		//oMonthViewObj.getStorage();
	}
}

function resizeWeekSections() {	
	var calendar = $("calmain");
	var numWeeks=oMonthViewObj.oCalendarTool.getNumWeeks();
	var workWeekHeight = 0;
	var weekEndHeight = 0;
	var height = (calendar.offsetHeight - pxPerEm)/numWeeks;
	for(var indx=0;indx<calendar.childNodes.length;indx++)
	{
		var oCurrentNode =calendar.childNodes[indx];
		for(var subIndx=0;subIndx<oCurrentNode.childNodes.length;subIndx++)
		{
			var oCurrentSubNode = oCurrentNode.childNodes[subIndx];
			if(oCurrentSubNode && oCurrentSubNode.tagName == "DIV" && height>0)
			{
				if((height)>0)
				{
					oCurrentSubNode.style.height = (height) + "px";	
					workWeekHeight = (height);
				}

				if(oCurrentSubNode.className.indexOf("weekendInMonthView") != -1)
				{
					for(var subSubIndx=0;subSubIndx<oCurrentSubNode.childNodes.length;subSubIndx++)
					{
						var oCurrentSubSubNode = oCurrentSubNode.childNodes[subSubIndx];
						if(oCurrentSubSubNode && oCurrentSubSubNode.tagName == "DIV")
						{
							if((height/2)>0)
							{
								oCurrentSubSubNode.style.height = (height/2) + "px";	
								weekEndHeight = (height/2);	
							}
						}
					}
				}				
			}				
		}
		var aSplittId = oCurrentNode.id.split("_");
		if(aSplittId[0] == "weekmonth" || true)
		{
			if((height)>0)
				oCurrentNode.style.height = (height) + "px";
		}
	}
	oMonthViewObj.redrawAppointments(workWeekHeight,weekEndHeight);
}

function loadMonthView() {
	if (!oMonthViewObj) {
		oMonthViewObj = new monthView();
		oMonthViewObj.loadMonthView(calendar_getAllFoldersAttribute());
		//resizeEvents.register("Resized",resizeWeekSections);	
	} else {
		if (oMonthViewObj.oCalendarTool.nMonth == activeMonth &&
		    oMonthViewObj.oCalendarTool.nYear == activeYear) {
			function fn() {
				oMonthViewObj.refreshMonthView(calendar_getAllFoldersAttribute());
			}
			//storageCache.update(fn);
			oMonthViewObj.getStorage(fn);
		} else {
			goToActiveMonth();
		}
	}
}

function goToActiveMonth() {
	if (monthViewCreated) {
		aSelectedAppArray = new Array();
		var oDateLoc = new Date();
		oDateLoc.setFullYear(activeYear);
		oDateLoc.setDate(1);	
		oDateLoc.setMonth(activeMonth); 		
		oMonthViewObj.oCalendarTool = new calendarTool(activeMonth, activeYear);	
		oMonthViewObj.updateMonthView();
		refreshMonthView();
	}
}

function goToNextMonth(nDirection) {
	if (monthViewCreated) {
		aSelectedAppArray = new Array();
		var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)); 
		oDateLoc.setUTCDate(1);   
        oDateLoc.setUTCMonth(oDateLoc.getUTCMonth()+(nDirection));
        activeMonth = oDateLoc.getUTCMonth();
        activeYear = oDateLoc.getUTCFullYear();     
        activeDay = oDateLoc.getUTCDate();					
		if (oMiniCalendar) oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
		oMonthViewObj.oCalendarTool = new calendarTool(activeMonth, activeYear);	
		oMonthViewObj.updateMonthView();
		refreshMonthView();
	}
}

function monthAction(evt) {	
	var sId = '';
	var DOMTarget = (evt.target)?evt.target:evt.srcElement;	
	if (DOMTarget.id.substr(0,4) == 'but_') {
		if(evt.type == "click") {
			sId = DOMTarget.id.substr(4) + '_num';
			if (tmptimeOutSingle != null) {
				clearTimeout(tmptimeOutSingle);
				tmptimeOutSingle = null;
				stopEvent(evt);	
				return;
			}
			tmptimeOutSingle = setTimeout(function (){
				        var oDate = new Date();
						oDate.setDate(1);		
						oDate.setFullYear(sAssocMonthArray[sId].year);				
						oDate.setMonth(sAssocMonthArray[sId].month);				
						oDate.setDate(sAssocMonthArray[sId].day.nDate);		
						if (sAssocMonthArray[sId].day.nCurrMonth == 0)
							oDate.setMonth(oDate.getMonth()-1);
						else if (sAssocMonthArray[sId].day.nCurrMonth == 2)			
							oDate.setMonth(oDate.getMonth()+1);
						activeDay = oDate.getDate();
						activeMonth = oDate.getMonth();
						activeYear = oDate.getFullYear();				
						triggerEvent("OX_Switch_View","calendar/calendar/day");
						tmptimeOutSingle = null;				
					}, 300);
			stopEvent(evt);		
			return;
		}
	} else {
		sId = DOMTarget.id;
	}

	if (sId.substr(0,1) == 'd' && sId.split('_')[3] == 'num') {		
		if (evt.type == "dblclick") {
			if (tmptimeOutSingle != null) {
				clearTimeout(tmptimeOutSingle);			
			}
			if (sId.substr(0,1) == 'd' && sId.split('_')[3] == 'num') {
				var oDate = new Date();
				oDate.setUTCDate(1);		
				oDate.setUTCFullYear(sAssocMonthArray[sId].year);				
				oDate.setUTCMonth(sAssocMonthArray[sId].month);					
				if (sAssocMonthArray[sId].day.nCurrMonth == 0) {
					oDate.setUTCMonth(oDate.getUTCMonth()-1);
				} else if(sAssocMonthArray[sId].day.nCurrMonth == 2) {											
					oDate.setUTCMonth(oDate.getUTCMonth()+1);
				}
				oDate.setUTCDate(sAssocMonthArray[sId].day.nDate);						
				activeDay = oDate.getUTCDate();
				activeMonth = oDate.getUTCMonth();
				activeYear = oDate.getUTCFullYear();		
				calendar_activedate=new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));
				calendar_wholeday=true;		
				triggerEvent('OX_Before_Create_Calendar');
				stopEvent(evt);		
			}				
		}
		
	} else if (sId.substr(0,1) == 'd' && sId.split('_')[4] != 'app' && 
	           sId.split('_')[3] != 'title' && sId.split('_')[3] != 'headcontainer') {
		sId = DOMTarget.id+'_num';
		var oDate = new Date();
		oDate.setUTCDate(1);		
		oDate.setUTCFullYear(sAssocMonthArray[sId].year);				
		oDate.setUTCMonth(sAssocMonthArray[sId].month);				
		if (sAssocMonthArray[sId].day.nCurrMonth == 0)
			oDate.setUTCMonth(oDate.getUTCMonth()-1);
		else if (sAssocMonthArray[sId].day.nCurrMonth == 2)			
			oDate.setUTCMonth(oDate.getUTCMonth()+1);
		oDate.setUTCDate(sAssocMonthArray[sId].day.nDate);					
		activeDay = oDate.getUTCDate();
		activeMonth = oDate.getUTCMonth();
		activeYear = oDate.getUTCFullYear();
		var startTime = configGetKey("gui.calendar.starttime") || 8;
		calendar_activedate=new Date(Date.UTC(activeYear,activeMonth,activeDay,startTime,0,0));
		calendar_wholeday=false;		
		triggerEvent('OX_Before_Create_Calendar');
		stopEvent(evt);
		
	} else if (sId.substr(0,1) == 'd' && sId.split('_')[4] != 'app' && 
	           sId.split('_')[3] == 'title' && sId.split('_')[3] != 'headcontainer') {
		var sFakeId = sId.split('_')[0]+'_'+sId.split('_')[1] + '_' + sId.split('_')[2] + '_num';
		var oDate = new Date();
		oDate.setDate(1);		
		oDate.setFullYear(sAssocMonthArray[sFakeId].year);				
		oDate.setMonth(sAssocMonthArray[sFakeId].month);				
		oDate.setDate(sAssocMonthArray[sFakeId].day.nDate);		
		if (sAssocMonthArray[sFakeId].day.nCurrMonth == 0)
			oDate.setMonth(oDate.getMonth()-1);
		else if (sAssocMonthArray[sFakeId].day.nCurrMonth == 2)			
			oDate.setMonth(oDate.getMonth()+1);
		activeDay = oDate.getDate();
		activeMonth = oDate.getMonth();
		activeYear = oDate.getFullYear();		
	    var startTime = configGetKey("gui.calendar.starttime") || 8;
		calendar_activedate = new Date(Date.UTC(activeYear,activeMonth,activeDay,startTime,0,0));
		calendar_wholeday = false;		
		triggerEvent('OX_Before_Create_Calendar');
		stopEvent(evt);
	}
	
	stopEvent(evt);		
}

function selectDayInMonthView(evt) {
	var DOMTarget = (evt.target) ? evt.target : evt.srcElement;    
	var sDOMId = DOMTarget.id || DOMTarget.parentNode.id || null;
	if (sDOMId == null) return;
	var sId = sDOMId.match(/^[a-z]_[0-9]_[0-9]/)[0] + "_num";
	for (var i in sAssocMonthArray) {
	    if (sAssocMonthArray[i].active && sAssocMonthArray[i].active == true) {
	        sAssocMonthArray[i].active=false;
	        $2(i.substr(0,5)+"_headcontainer").className="headerContStyle";
	    } 
	}
	sAssocMonthArray[sId].active=true;
	$2((sDOMId.match(/^[a-z]_[0-9]_[0-9]/)[0]) + "_headcontainer").className = 
	       "headerContStyle background-color-PMG-selection-elements";

	var oDate = new Date();
	oDate.setUTCDate(1);        
	oDate.setUTCFullYear(sAssocMonthArray[sId].year);               
	oDate.setUTCMonth(sAssocMonthArray[sId].month);             
	if (sAssocMonthArray[sId].day.nCurrMonth == 0)
	    oDate.setUTCMonth(oDate.getUTCMonth()-1);
	else if (sAssocMonthArray[sId].day.nCurrMonth == 2)          
	    oDate.setUTCMonth(oDate.getUTCMonth()+1);
	oDate.setUTCDate(sAssocMonthArray[sId].day.nDate);                  
	activeDay = oDate.getUTCDate();
	activeMonth = oDate.getUTCMonth();
	activeYear = oDate.getUTCFullYear();
	var startTime = configGetKey("gui.calendar.starttime") || 8;
	calendar_activedate=new Date(Date.UTC(activeYear,activeMonth,activeDay,startTime,0,0));
	calendar_wholeday=false;
	
	if (!sDOMId.match(/_app$/gi)) {
        if (calendarSelection.count != 0) calendarSelection.reset();
        deselectAppointments();
        triggerEvent("Selected",aSelectedAppArray);
	}
	//stopEvent(evt);
}

function monthView() {
	this.dateIdAssoc = new Object();
	this.aAppointmentAssoc = new Object();
	this.calendarwfields = new Array(200, 201, 202, 203, 209, 220, 401, 402, 102, 400);
	this.oCalendarTool = new calendarTool(activeMonth, activeYear);
	this.oCalendar;
	this.storage = null;	
	this.timestamp = null;
	this.show_all = false;
	this.today = new Date();
	this.calendar_start = null;
	this.calendar_end = null;	
	this.redraw = function (){};
	this.show_we = 1;
	this.show_ww = 2;
}

function moveAppToNewStart(objc, startTimeParam, endTimeParam, fn_opt) {
	if (objc["full_time"])
		editAppointment(objc,{start_date:startTimeParam.getTime(),end_date:endTimeParam.getTime(),full_time:true},fn_opt);
	else
		editAppointment(objc,{start_date:startTimeParam.getTime(),end_date:endTimeParam.getTime()},fn_opt);
}

monthView.prototype = {
	updateHeader: function() {
		$("monthviewheader").firstChild.data = 
		       formatDateTime("MM/yyyy", new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)));
	},
	
	loadMonthView: function(bAll) {
		this.show_all = bAll;
		if(calendar_getAllFoldersAttribute()){
			$("allAppointmentMonthView").checked = true;
		}
		else
			$("allAppointmentMonthView").checked = false;
		this.createMonthView(activeMonth, activeYear);
	},
	
	updateMonthView:function() {
	    //Old, use refresh function
		calendarObjects = new Array();
		this.dateIdAssoc = new Object();
		this.aAppointmentAssoc = new Object();
		sAssocMonthArray = new Object();
		var calendar = $("calmain");
		while (calendar.childNodes.length>0) {
			calendar.removeChild(calendar.firstChild);
		}
		monthViewCreated = false;
		this.createMonthView(activeMonth, activeYear);
	},
	
	createMonthView: function(nMonth, nYear) {
		var Self = this;
		if (!monthViewCreated) {
			for(var i=0;$2("kwnumber_"+i);i++) {
				removeTMPId("kwnumber_"+i);
			}	
			for(var i=0;$2("weekmonth_"+i);i++) {
				removeTMPId("weekmonth_"+i);
			}	
			for(var i=0;$2("d_"+i+"_0");i++) {
				for(var i2=0;$2("d_"+i+"_"+i2);i2++) {
					removeTMPId("d_"+i+"_"+i2);
				}
			}	
			this.updateHeader();
			var numWeeks=this.oCalendarTool.getNumWeeks(); 
			var weektmpl = $("weekmonth_tmpl");
			var calendar = $("calmain");
			var sIdPrefix = weektmpl.id.split('_');
	//		var height = (98 / numWeeks) + "%";
			addDOMEvent(calendar, "selectstart", function(evt) { cancelBubbling(evt); });
			addDOMEvent(calendar, "drag" , function(evt) { cancelBubbling(evt); });
			var height = -1;
			if(calendar.offsetHeight != undefined && calendar.offsetHeight>0)
				height = (((calendar.offsetHeight - pxPerEm) / numWeeks));		
				
			function drawpreviewDragandDrop(evt,type,object) {	
				var subObject = object;
				if(object && object.currentObjects && object.currentObjects.length>0) {
						subObject = object.currentObjects[0]; 
				}
				if(!$2("dnd_div_")) {
					var iconNode = Self.getAppointmentDiv(subObject);			
					iconNode.id = "dnd_div_";
					iconNode.style.left = (evt.clientX + iconOffset) + "px";	
					iconNode.style.top = (evt.clientY + iconOffset)+ "px";	
					body.appendChild(iconNode);
					iconNode.style.width = "120px";
					iconNode.style.position = "absolute";							
					addTMPId(iconNode);
				} else {
					var iconNode = $2("dnd_div_");
					iconNode.style.left = (evt.clientX + iconOffset) + "px";
					iconNode.style.top = (evt.clientY + iconOffset)+ "px";	
				}
				var DOMTarget = (evt.target)?evt.target:evt.srcElement;
				var sId = DOMTarget.id;
				if(!sId) return false;
				if(sId.split('_')[3] != 'num' && sId.split('_')[3] != 'title' 
						&& sId.split('_')[4] != 'app'
								 && sId.split('_')[3] != 'headcontainer')			
					DOMTarget.className += " dndSelectionCalendarBG";
				DOMTarget.style.cursor = "move";
				stopEvent(evt);
				return false;							
			}
			function removeDDPreviewDivs(evt,type,object) {
				if($2("dnd_div_")) {
					body.removeChild($2("dnd_div_"));
					removeTMPId($2("dnd_div_"));
				}
				var DOMTarget = (evt.currentTarget)?evt.currentTarget:evt.srcElement;
				var DOMTarget2 = (evt.target)?evt.target:evt.srcElement;
				DOMTarget2.style.cursor = "default";
				var sId = DOMTarget.id;
				DOMTarget.className = removeClass(DOMTarget.className,"dndSelectionCalendarBG");
			}					
	
			function dropCallBack(evt,dragType,object,mousepos,targetNode) {
				var subObject = object;
				if(object && object.currentObjects && object.currentObjects.length>0) {
						subObject = object.currentObjects[0]; 
				}
				var DOMTarget = targetNode;//(evt.currentTarget)?evt.currentTarget:evt.srcElement;			
				var DOMTarget2 = (evt.target)?evt.target:evt.srcElement;
				DOMTarget2.style.cursor = "default";			
				var sId = DOMTarget.id;	
				if(!sId || !sAssocMonthArray[sId+'_num'])
					return;					
				var oDate = new Date();
				
				//var oDate=new Date(Date.UTC(sAssocMonthArray[sId+'_num'].year,sAssocMonthArray[sId+'_num'].month,sAssocMonthArray[sId+'_num'].day.nDate,0,0,0));
				oDate.setUTCHours(0);		
				oDate.setUTCMinutes(0);					
				oDate.setUTCSeconds(0);								
				oDate.setUTCDate(1);		
				oDate.setUTCFullYear(sAssocMonthArray[sId+'_num'].year);				
				oDate.setUTCMonth(sAssocMonthArray[sId+'_num'].month);				
				if(sAssocMonthArray[sId+'_num'].day.nCurrMonth == 0)
					oDate.setUTCMonth(oDate.getUTCMonth()-1);
				else if(sAssocMonthArray[sId+'_num'].day.nCurrMonth == 2)			
					oDate.setUTCMonth(oDate.getUTCMonth()+1);			
				oDate.setUTCDate(sAssocMonthArray[sId+'_num'].day.nDate);					
				var start_date = new Date(subObject.start_date);
				var end_date = new Date(subObject.end_date);	
				oDate.setUTCHours(start_date.getUTCHours());
				oDate.setUTCMinutes(start_date.getUTCMinutes());
				var changes=oDate.getTime()-start_date.getTime();
				var oDateEnd=new Date(end_date.getTime()+changes);	
				moveAppToNewStart(subObject,oDate,oDateEnd);
				DOMTarget.className = removeClass(DOMTarget.className,"dndSelectionCalendarBG");			
				if($2("dnd_div_") != undefined)
					body.removeChild($2("dnd_div_"));
					removeTMPId($2("dnd_div_"));
			}
			for (ind=0; ind<numWeeks; ind++) {
				//clone
				var nextWeekNumber = ind;
				obj = weektmpl.cloneNode(true);
				obj.style.display = "block";
				if (height > 0) obj.style.height = height + "px";
				obj.id = sIdPrefix[0]+'_'+nextWeekNumber;
				addTMPId(obj);	
				//change Ids here		
				for (numNode=0; numNode<obj.childNodes.length; numNode++) {					
					if (obj.childNodes[numNode].id == "kwnumber_0") {
						newId = 'kwnumber_'+ nextWeekNumber;
						obj.childNodes[numNode].id = newId;
						addTMPId(obj.childNodes[numNode]);	
					} else if (obj.childNodes[numNode].id && obj.childNodes[numNode].id.substr(0,1) == "d") {
						var id = 'd_'+nextWeekNumber+'_'+obj.childNodes[numNode].id.substr(4,1);					
						//set new id d_(currentWeek)_(currentDay)
						obj.childNodes[numNode].id = id;
						addTMPId(obj.childNodes[numNode]);
																	
						addDOMEvent(obj.childNodes[numNode], "click", selectDayInMonthView);
						addDOMEvent(obj.childNodes[numNode], "dblclick", monthAction);
						
						registerTarget(obj.childNodes[numNode],{calendar:dropCallBack},null,null,
							drawpreviewDragandDrop,	//drawpreviewDragandDrop
							drawpreviewDragandDrop,	//drawreviewDragandDrop
							removeDDPreviewDivs );//removeDDPreviewDivs

					} else {						
						for (numSubNode=0; numSubNode<obj.childNodes[numNode].childNodes.length; numSubNode++)	{
							if (obj.childNodes[numNode].childNodes[numSubNode].id && 
							    obj.childNodes[numNode].childNodes[numSubNode].id.substr(0,1)=="d") {
								//set new id d_(currentWeek)_(currentDay)
								addDOMEvent(obj.childNodes[numNode].childNodes[numSubNode], "click", selectDayInMonthView);
								addDOMEvent(obj.childNodes[numNode].childNodes[numSubNode],'dblclick',monthAction);
								obj.childNodes[numNode].childNodes[numSubNode].id 
										= 'd_'+nextWeekNumber+'_'+obj.childNodes[numNode].childNodes[numSubNode].id.substr(4,1);
								addTMPId(obj.childNodes[numNode].childNodes[numSubNode]);																	
								registerTarget(obj.childNodes[numNode].childNodes[numSubNode],
									{ calendar:dropCallBack },null,null,
										drawpreviewDragandDrop,	//drawpreviewDragandDrop
										drawpreviewDragandDrop,	//drawreviewDragandDrop
										removeDDPreviewDivs 
								);
							}
							else if(obj.childNodes[numNode].childNodes[numSubNode].id 
										&& obj.childNodes[numNode].childNodes[numSubNode].id.substr(0,2)=="wd")							
							{
								for(weindex=0;weindex<obj.childNodes[numNode].childNodes[numSubNode].childNodes.length;weindex++)
								{
									if(obj.childNodes[numNode].childNodes[numSubNode].childNodes[weindex].id 
										&& obj.childNodes[numNode].childNodes[numSubNode].childNodes[weindex].id.substr(0,1)=="d")				
										{			
												//set new id d_(currentWeek)_(currentDay)
												addDOMEvent(obj.childNodes[numNode].childNodes[numSubNode],'dblclick',monthAction);
												obj.childNodes[numNode].childNodes[numSubNode].childNodes[weindex].id 
																	= 'd_'+nextWeekNumber+'_'+obj.childNodes[numNode].childNodes[numSubNode].childNodes[weindex].id.substr(4,1);
												addTMPId(obj.childNodes[numNode].childNodes[numSubNode]);																	
												 																
										}
								}
							}
							else if(obj.childNodes[numNode].childNodes[numSubNode].id 
										&& obj.childNodes[numNode].childNodes[numSubNode].id=="kwnumber_0")								
							{
								newId = 'kwnumber_'+ nextWeekNumber;
								obj.childNodes[numNode].id = newId;
								addTMPId(obj.childNodes[numNode]);																	
							}
						}
					}				
				}			
				calendar.appendChild(obj);			
			}				
			this.initMonthView();		
		}	
	},
	
	attachAppointments:function (index,	calendarObjects) {
	/////////////////////////////////////////////////////////////////////////////////////////////////
	//	aAppointments = this.getAppointments(currentDay.nDate,oCalendarTool.nMonth,
	//															currentDay.nCurrMonth,aAllAppointments);
	
		var id = calendarObjects.id;
		var folder_id = calendarObjects.folder;
		var selectedAppointmentWeek={id : id, folder : folder_id};
		var divAppId = 'appInWeekView' + folder_id + "_" + id;
		
		var title = calendarObjects.title;
		var start_date = calendarObjects.start_date;
		var end_date = calendarObjects.end_date;	
		var full_time = calendarObjects.full_time;
		
		// Setze Startzeit des Termins um , falls er vor der Anzeige beginnt
		if (start_date < this.calendar_start.getTime()) {		
	
	//		fulltimeStartBeforeDiff = (this.starttime - start_date)  / 1000 / 60 / 60 / 24;
			start_date=this.calendar_start.getTime();
	//		fulltimeStartBefore = true;
		}
		
		// Setze Endzeit des Termins um , falls er nach der Anzeige endet
		if (end_date > this.calendar_end.getTime()) {
			end_date = this.calendar_end.getTime();		
		}	
	
		var startDate = new Date(start_date);	
		var endDate = new Date(end_date);	
		var MULTstartDate = new Date(start_date);	
		MULTstartDate.setUTCHours(0);
		var MULTendDate = new Date(end_date);		
		MULTendDate.setUTCHours(0)
	
		//Create multiday appointments here
		if(Math.round(((MULTendDate.getTime() - MULTstartDate.getTime())  / 1000 / 60 / 60 / 24)) > 0)
		{
			var nDaysMultiDay = Math.round((((MULTendDate.getTime() - MULTstartDate.getTime()))  / 1000 / 60 / 60 / 24));
	
			if(endDate.getUTCHours() == 0 &&
						endDate.getUTCMinutes() == 0 &&
									endDate.getUTCMilliseconds() == 0)
			{
				nDaysMultiDay--;
			}			
			var oCurrDayIter = new Date(startDate);				
			for(var nNumDay=0;nNumDay<=nDaysMultiDay;nNumDay++)
			{
				//do nothing at start day - that's default case
				if(nNumDay != 0)
				{				
					this.doDrawAppointment(oCurrDayIter,calendarObjects,index,true);				
				}			
				oCurrDayIter.setUTCDate(oCurrDayIter.getUTCDate()+1);
                oCurrDayIter.setTime(Math.floor(oCurrDayIter.getTime() / 864e5)
                    * 864e5); // ms / day
			}
		}	
	
		this.doDrawAppointment(startDate,calendarObjects,index,false);
	},
	
	redrawAppointments: function(workWeekHeight,weekEndHeight) {
		var constHeader = pxPerEm*1.1;
		var constBottom = 7;
		var constBottomBorder = 1;
		var constAppointmentPlusBorderPlusMargin = pxPerEm*1.1 + 4 + 1;	
	    var calc_ww = (workWeekHeight - constHeader - constBottom - constBottomBorder) / constAppointmentPlusBorderPlusMargin
	    var calc_we = (weekEndHeight - constHeader - constBottom - constBottomBorder) / constAppointmentPlusBorderPlusMargin
		this.show_ww = IE6 ? Math.floor(calc_ww) : Math.ceil(calc_ww);
		this.show_we = IE6 ? Math.floor(calc_we) : Math.ceil(calc_we);
		this.redraw();
	},
	
	doDrawAppointment: function(startDate,calendarObjects,index,isMultiday) {
		var isMultiday = isMultiday;
		var id = calendarObjects.id;
		var folder_id = calendarObjects.folder;
		var created_by = calendarObjects.created_by;
		var selectedAppointmentWeek={id : id, folder : folder_id};
		var divAppId = 'appInWeekView' + folder_id + "_" + id;
		var shown_as = calendarObjects.shown_as;
		var title = calendarObjects.title;
		var start_date = calendarObjects.start_date;
        if (startDate.getTime() > start_date) start_date = startDate.getTime();
		var end_date = calendarObjects.end_date;	
		var full_time = calendarObjects.full_time;	
		var nRecPosition = calendarObjects.recurrence_position;	
		var oViewObj = this.dateIdAssoc[startDate.getUTCDate() + '_' + startDate.getUTCMonth() + '_' + startDate.getUTCFullYear()];
	
		if (!oViewObj) return;
		var sCurrId = oViewObj.id;
		
		if (oViewObj.app < this.show_ww && !oViewObj.day.bWeekend || 
		    oViewObj.app < this.show_we && oViewObj.day.bWeekend) {
	            var sAppId = sCurrId + "_" + oViewObj.app + (full_time ? "f_app" : "_app");
				var dAppDiv = this.getAppointmentDiv(				
				     new CalendarWorkWeekObject(
				             calendarObjects.id, calendarObjects.folder, calendarObjects.recurrence_position, 
				             calendarObjects.recurrence_id, calendarObjects.created_by, calendarObjects.title,
				             start_date, calendarObjects.end_date, calendarObjects.note,
				             calendarObjects.recurrence_type, calendarObjects.participants, 
				             calendarObjects.full_time, calendarObjects.shown_as, calendarObjects.color_label, 
				             null, null, null),
	                 sAppId, full_time, isMultiday);
				
				$2(sCurrId).appendChild(dAppDiv);
				addTMPId(dAppDiv);
				calendarObjects["index"] = index;
				this.aAppointmentAssoc[sAppId] = calendarObjects;
				oViewObj.app++;
				
			/*
			} else if(oViewObj.fdapp == 1) {
				var sAppId = sCurrId+'_'+oViewObj.app+'f_app';
				calendarObjects["index"] = index;
				this.aAppointmentAssoc[sAppId] = calendarObjects;			
				var ShowFullTimeDiv = $2(sCurrId+'_title');
				ShowFullTimeDiv.className = 'fullTimeAppointmentMonthTitle';
				var FTDiv = this.getAppointmentDiv(new CalendarWorkWeekObject(calendarObjects[0],calendarObjects[1],
									calendarObjects[2],calendarObjects[3],
									calendarObjects[4],calendarObjects[5],null,calendarObjects[7],null,calendarObjects[9],calendarObjects,null,
																														null,null), sAppId,true,isMultiday);
	
			//	addDOMEvent(FTDiv,"mouseover",viewAppointmentInfo);
				FTDiv.className += ' wholeDayBackground border-color-image';
				ShowFullTimeDiv.appendChild(FTDiv);
				addTMPId(FTDiv);															
			}
			*/
		} else {
			oViewObj.app++;
		}
					
		if (oViewObj.app == (this.show_ww + 1) && !oViewObj.day.bWeekend || 
		    oViewObj.app == (this.show_we + 1) && oViewObj.day.bWeekend ) {
			
			var oButtonDiv = getContentAsDiv('','expandButton','but_'+sCurrId);					
			//var oImgButtD = newnode("img",0,{src:getFullImgSrc("img/arrows/arrow_gray_down.gif")});
			//oButtonDiv.appendChild(oImgButtD);
			addDOMEvent(oButtonDiv,'click',monthAction);
			$2(sCurrId).appendChild(oButtonDiv);
			addTMPId(oButtonDiv)		
			oViewObj.app++;					
		}	
						
		if (oViewObj.day.bWeekend && oViewObj.app > 0) {
			if ($2(sCurrId+'_0_app')) {
				$2(sCurrId+'_0_app').style.height = "1.0em";
				$2(sCurrId+'_0_app').style.lineHeight = "1.0em";		
			}
		}					
	
		var aSelected = calendarSelection.getSelected();
		for (var nindx=0; nindx < aSelected.length; nindx++) {
			if(id == aSelected[nindx].id && folder_id == aSelected[nindx].folder && $2(sAppId)) {			
				$2(sAppId).className = removeClass($2(sAppId).className,
				'border-color-image');			
				$2(sAppId).className += ' selectedAppMonth border-color-selection-elements';
				aSelectedAppArray.push(sAppId);
				break;
			}
		}
	},
	
	getDateFromDay: function(nCurrDay) {
		oCompMonth = new Date();
		oCompMonth.setTime(0);					
		oCompMonth.setUTCDate(1);				
		oCompMonth.setUTCFullYear(this.oCalendarTool.nYear);	
		oCompMonth.setUTCMonth(this.oCalendarTool.nMonth);			
		
		
		if(nCurrDay.nCurrMonth==0)
			oCompMonth.setUTCMonth(oCompMonth.getUTCMonth()-1);
		else if(nCurrDay.nCurrMonth==2)
		{
			var getMonthReturns = oCompMonth.getUTCMonth();
			if(getMonthReturns!=0)
			{
				oCompMonth.setUTCMonth(oCompMonth.getUTCMonth()+1);
			}
			else
				oCompMonth.setUTCMonth(1);		
		}
		oCompMonth.setUTCDate(nCurrDay.nDate);	
		currMonth = oCompMonth.getUTCMonth();	
		currYear = oCompMonth.getUTCFullYear();
		return oCompMonth;	
	},
	//Initialize month view with calendar data, add Appointments
	
	initMonthView: function() {	
		    var Self = this;	
			var aAppointments = new Array();
			this.oCalendar = new cCalendar(this.oCalendarTool.nMonth,this.oCalendarTool.nYear);
			this.aMonthBtAppointments = new Array();
			var aAllAppointments = 	calendarObjects;	
			for (var indexWeek=0; indexWeek<this.oCalendar.aWeeks.length; indexWeek++) {
				var sTableId = 'table_'+indexWeek;	//Nicht mehr benutzt ?				
				var currentWeek = this.oCalendar.aWeeks[indexWeek];
				for(indexDay=0;indexDay<7;indexDay++)
				{
					var nDisplayedAppToday = 0;
					var nAppCount=0;
					var bDisplayFirst = false;
					var sCurrId = 'd_'+indexWeek+'_'+indexDay;
					var currentDay = currentWeek.aDays[indexDay];				
					
					sAssocMonthArray[sCurrId+'_num'] = {day:currentDay,month:this.oCalendarTool.nMonth,
																			year:this.oCalendarTool.nYear};
				
					var currDateObj = this.getDateFromDay(currentDay);
					this.dateIdAssoc[currDateObj.getUTCDate() + '_' + currDateObj.getUTCMonth() + '_' + currDateObj.getUTCFullYear()] 
							= {id:sCurrId, app:0,fdapp:0,day:currentDay};
					//disable			
					if(currentDay.nCurrMonth==0 || currentDay.nCurrMonth==2)
					{
						$2(sCurrId).className += " wholeDayBackground";
					}
					var ShowFullTimeDiv =  newnode('div',0,{id:sCurrId+'_title',
																className:"fullTimeAppointmentMonthTitle"});														
					
					
					if(isToday(currDateObj))
						var bgCurrentDay = " background-color-PMG-selection-elements";
					else 
						var bgCurrentDay = "";
					if(currentDay.bWeekend)
						dDiv =  getContentAsDiv(currentDay.nDate,"dateCalendarFontSize dateAlignMonthView"+bgCurrentDay,sCurrId+'_num');
					else					
						dDiv =  getContentAsDiv(currentDay.nDate,"dateCalendarFontSize dateAlignMonthView"+bgCurrentDay,sCurrId+'_num');
					if(!currentDay.bWeekend)
						var oHeadDiv = newnode('div',0,{className:"headerContStyle",id:sCurrId+"_headcontainer"});
					else					
						var oHeadDiv = newnode('div',0,{className:"headerContStyle",id:sCurrId+"_headcontainer"});					
		
					oHeadDiv.appendChild(ShowFullTimeDiv);
					addTMPId(ShowFullTimeDiv);
					oHeadDiv.appendChild(dDiv);				
					addTMPId(dDiv);
					addDOMEvent(dDiv,"selectstart",function (e) {
						stopEvent(e);
						return false;
					});					
					addDOMEvent(dDiv,"click",monthAction);						
					addDOMEvent(dDiv,"dblclick",monthAction);														
					if(this.today.getUTCFullYear() == currDateObj.getUTCFullYear() &&
									this.today.getUTCMonth() == currDateObj.getUTCMonth() &&
												this.today.getUTCDate() == currDateObj.getUTCDate())
					{
						$2(sCurrId).className += " background-color-content";
					}
					$2(sCurrId).appendChild(oHeadDiv);
					addTMPId(oHeadDiv);
					
					if(indexWeek == this.oCalendar.aWeeks.length-1 &&
																indexDay != 6 && !currentDay.bWeekend)
					{
						try{
							$2(sCurrId).className += " grayBorderCalendarMonth border-color-image";
						}catch(e){}
					}
	
					if(indexWeek == 0 && indexDay == 0)
					{
						//set start date of month				
						this.calendar_start = new Date(currDateObj);
					}				
					if(indexWeek == (this.oCalendar.aWeeks.length-1) && indexDay == 6)
					{	
						//set date date of month
						this.calendar_end = new Date(currDateObj);
						this.calendar_end.setDate(this.calendar_end.getDate()+1)
						try{
							$2(sCurrId).parentNode.style.borderBottom = "1px solid";
							$2(sCurrId).parentNode.className += " border-color-image";
						}catch(e){}					
					}								
					/////////////////////////////////////////////////////////////////////////////////////////////////7
				}				
				myTablePH = getContentAsDiv("","placeHolderKWCenter",'kw_place_'+indexWeek);
				myTable = getContentAsDiv(currentWeek.nKW,"",'kw_month_'+indexWeek);
				$2('kwnumber_'+indexWeek).appendChild(myTablePH);							
				addTMPId(myTablePH);	
				$2('kwnumber_'+indexWeek).appendChild(myTable);	
				
				/* add click and mousover on kw numbers to allow direct jump into week view */
				addDOMEvent($2('kwnumber_'+indexWeek), "click", (function(oCalendar, indexWeek) {
					return function(e) {		
						if (oCalendar == undefined || indexWeek == undefined) {
							return false;
						}
						var mDate = Self.getDateFromDay(oCalendar.aWeeks[indexWeek].aDays[0]);
						activeDay = mDate.getUTCDate();
                        activeMonth = mDate.getUTCMonth();
                        activeYear = mDate.getUTCFullYear();               
						objWeekCalendarTool.init(activeYear, activeMonth, activeDay);
						objWeekCalendarTool.setKW();
                        if (oMiniCalendar) { 
                            oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
                        }
                        $2('kwnumber_'+indexWeek).className = removeClass($2('kwnumber_'+indexWeek).className, "background-color-PMG-selection-elements");
						triggerEvent('OX_Switch_View','calendar/calendar/week');
					}
                })(this.oCalendar, indexWeek));
                addDOMEvent($2('kwnumber_'+indexWeek), "mouseover", (function(indexWeek) {
                	return function(e) {
                        $2('kwnumber_'+indexWeek).className += " background-color-PMG-selection-elements";
                	}
                })(indexWeek));
                addDOMEvent($2('kwnumber_'+indexWeek), "mouseout", (function(indexWeek) {
                	return function(e) {
                        $2('kwnumber_'+indexWeek).className = removeClass($2('kwnumber_'+indexWeek).className, "background-color-PMG-selection-elements");
                	}
                })(indexWeek));
                
											
				addTMPId(myTable);
			}		
			this.getStorage();
	},
	
	buildAppointments: function(index, object) {
		    var newObject = {
		    	id: object[0], // 1
		    	folder: object[1], // 20
		    	recurrence_position: object[2], // 207
		    	recurrence_id: object[3], // 206
		    	created_by: object[4], // 2
		    	title: object[5], // 200
		    	start_date: object[6], // 201
		    	end_date: object[7], // 202
		    	note: object[8], // 203
		        recurrence_type: object[9], // 209
		        participants: object[10], // 220
		        full_time: object[11], // 401
		        shown_as: object[12], // 402
		        color_label: object[13], // 102
		        location: object[14]    			    	
		    }
		    newObject["indxxx"] = index;
		    object["indxxx"] = index;
			this.aMonthBtAppointments[index] = newObject;
	},
	
	sortAppointments: function() {	
		this.aMonthBtAppointments.sort(function(a,b){
			return (a.end_date == b.end_date) ? (a.start_date < b.start_date) ? -1 : 1 : (a.end_date < b.end_date) ? -1 : 1;
		});
		for(var i=0; i<this.aMonthBtAppointments.length;i++) {
			this.attachAppointments(this.aMonthBtAppointments[i]["indxxx"],this.aMonthBtAppointments[i]);
		}
	},
	
	getStorage: function(fnParamComplete) {
		var Self = this;
		function cb_fkt(storage) {
			monthViewCreated = true;		
			if (storage) {			
				Self.storage = storage;
			}		
			monthViewCreated = true;		
			Self.redraw = function() {
				Self.clearMonthView();					
				Self.storage.newIterate(Self.storage.ids, emptyFunction, function(x,y) {
					Self.buildAppointments(x,y);
				},
				function() {
					Self.sortAppointments();
				});
				monthViewCreated = true;				
				Self.timestamp = storage.timestamp;
				lastUpdateOfCalendarTimestamp  = Self.storage.timestamp;
			};
				
			Self.storage.events.register("Changed", Self.redraw);

			storage.newIterate(storage.ids, emptyFunction, function(x,y) {
				Self.buildAppointments(x,y);	
			}, function () {
				//duplicated entries
				Self.sortAppointments();
			 	storageCache.update();		
			});	
			if (fnParamComplete != undefined) {		
				fnParamComplete();	
			}
		}			
		sFolderId = activefolder;		
		var oChDate = this.getDateFromDay(this.oCalendar.aWeeks[0].aDays[0]);
		var starttime = oChDate.getTime();
		oChDate = this.getDateFromDay(this.oCalendar.aWeeks[this.oCalendar.aWeeks.length-1].aDays[6]);
		oChDate.setUTCDate(oChDate.getUTCDate()+1);
		var endtime = oChDate.getTime();
		if (Self.show_all) {
			var oParameters = { action:"all", start:starttime, end:endtime, columns:"1,20,207,206,2" };
		} else {		
			var oParameters = { action:"all", start:starttime, end:endtime, folder:sFolderId, columns:"1,20,207,206,2" };
		}	
	
		storageCache.get(AjaxRoot + "/calendar", oParameters, 
		                function(storage) {
						 	cb_fkt(storage);
							calendarSelection.setStorage(storage);
							calendarSelection.reset();
							Self.timestamp = storage.timestamp;
							lastUpdateOfCalendarTimestamp  = storage.timestamp; 
						},
						 this.calendarwfields.toString(),
						 true,
						 calendar_serializeid,
				         calendar_makeID);	
	},

	clearMonthView: function() {	
		//loop day divs
		for(var nItem in sAssocMonthArray) {
			var aTMP = nItem.split('_');
			var sDayDivId = '';
			//remove postfix of current id
			for (var nIndx=0; nIndx<aTMP.length-1; nIndx++) {
				sDayDivId += aTMP[nIndx];
				if (nIndx < aTMP.length-2) sDayDivId += '_';
			}
			var currentDayDiv = $2(sDayDivId);
	
			//find and remove appointments and expand buttons
			var aNodesToRemove = new Array();
			for (var nNodeX=0; nNodeX < currentDayDiv.childNodes.length; nNodeX++) {
				var currentChild;
				if (currentChild = currentDayDiv.childNodes[nNodeX]) {
					var sPostfix = '';
					var sPrefix = '';
					if (currentChild.id) {
						var aTMP2 = currentChild.id.split('_');
						sPostfix = aTMP2[aTMP2.length-1];	
						sPrefix = aTMP2[0];			
					}
					if (sPostfix == 'app' || sPrefix == 'but') {					
						aNodesToRemove.push(currentChild);
					}
					if (sPostfix == 'headcontainer') {	
						for(var nDivIndx=0; nDivIndx<currentChild.childNodes.length; nDivIndx++) {
							if (currentChild.childNodes[nDivIndx].id.split('_')[3] == 'title') {
								removeChildNodes(currentChild.childNodes[nDivIndx]);					
								currentChild.childNodes[nDivIndx].className = 'fullTimeAppointmentMonthTitle';
							}
							/*
							if(currentChild.childNodes[nDivIndx].id.split('_')[3] == 'num')
							{
								currentChild.childNodes[nDivIndx].className = 'dateCalendarFontSize dateAlignMonthView';
							}	
							*/					
						}
					}
				}
			}
			for(var nNodeTR=0; nNodeTR<aNodesToRemove.length; nNodeTR++) {
				currentDayDiv.removeChild(aNodesToRemove[nNodeTR]);
			}
		}
		aAppointmentAssoc = new Object();
		this.aMonthBtAppointments  = new Array();
		aSelectedAppArray = new Array();
		monthViewCreated = false;	
		for(var i in this.dateIdAssoc) {
			this.dateIdAssoc[i].app = 0;
			this.dateIdAssoc[i].fdapp = 0;
		}
	},
	
	refreshMonthView: function(bAll) {
		this.show_all = bAll;
		if(calendar_getAllFoldersAttribute()){
			$("allAppointmentMonthView").checked = true;
		}
		else
			$("allAppointmentMonthView").checked = false;	
		oMonthViewObj.clearMonthView();
		oMonthViewObj.getStorage();
	},
	
	getAppointments: function(currDate, currMonth, currCurrMonth, aAppointmentsArray) {
		var aAppointmentsToday = new Array();
		var nIndex=0;
		var nLength = parseInt(aAppointmentsArray.length);
		oCompMonth = new Date();
		oCompMonth.setMonth(currMonth);		
		if(currCurrMonth==0)
			oCompMonth.setMonth(oCompMonth.getMonth()-1);
		else if(currCurrMonth==2)
			oCompMonth.setMonth(oCompMonth.getMonth()+1);
		currMonth = oCompMonth.getMonth();	
		for(var nNumAppX=0;nNumAppX < nLength;nNumAppX++)	
		{		
			var aTMP = aAppointmentsArray[nNumAppX].day.split('.');
			var nAppDay = parseInt(aTMP[0]);
			var nAppMonth = parseInt(aTMP[1]);
			if(nAppDay == parseInt(currDate) && nAppMonth == parseInt(currMonth))
			{
				aAppointmentsToday[nIndex] = aAppointmentsArray[nNumAppX];
				nIndex++;
			}
		}
		return aAppointmentsToday;
	},
	
	getAppointmentDiv: function(calendarObjects,sId,fullday,isMultiday) {
		var appointmentDate = new Date(calendarObjects.start_date);
		if (isMultiday) appointmentDate.setUTCMinutes(0);
		var formattedTime = formatDate(appointmentDate, "time");	
		var shownDiv = getShownDiv(calendarObjects.shown_as);
	
		var datDIV = newnode("div", {border: "1px solid"}, 
					{ className: (fullday ? 
						"showFullTimeAppointmentMonth wholeDayBackground border-color-image"	: 
						"appInMonthView background-color-content border-color-image")} );
		var textDiv = newnode("div", { overflow: "hidden" }, 
					{ className: "showAppointmentTextMonth" + (fullday ? "Full" : "") + " dateCalendarFontSize" });
	
		var timeDisplayString = (!fullday ? formattedTime : "") + " " + (calendarObjects.title || "");
		textDiv.appendChild(document.createTextNode(timeDisplayString));
		
		/*
		function disabled(e) {
			var iconNode=$2("cww_node_dd");
			if(iconNode == undefined) {
				iconNode = newnode("img", { position:"absolute", left:(e.clientX + iconOffset) + "px", top:(e.clientY + iconOffset) + "px"},
			    {src: getFullImgSrc("img/dnd_disabled.gif"), alt: ""});
				iconNode.id="cww_node_dd";
				body.appendChild(iconNode);
				addTMPId(iconNode);
			}
			iconNode.style.left = (e.clientX + iconOffset) + "px";
			iconNode.style.top = (e.clientY + iconOffset)+ "px";
			stopEvent(e);
			return false;
		}
			
		function disabledremove(e,targetNode) {
			if($2("cww_node_dd")) {
				$2("cww_node_dd").parentNode.removeChild($2("cww_node_dd"));
			}
		}
		*/
															
		datDIV.appendChild(shownDiv);		
		datDIV.appendChild(textDiv);	
		//datDIV.appendChild(oDOMTableRASTER);
		datDIV.id = sId;	
	
	 	var oInplEdit = new inplaceEdit(textDiv, calendarObjects.title, 
	          function(sStr, oObj){
			      editAppointment(calendarObjects, {title:sStr});
			  }
	    );
	
		registerSource(datDIV, "calendar", function () { 
			objMoveCopy.begin("calendar", [calendarObjects]);
			return objMoveCopy;
		}, null, null, calendardefaultdisabled, defaultdisabledremove);
		oInplEdit.input_height = "1em";
		oInplEdit.input_fontsize = "8pt";
		registerContext(datDIV,"calendar");
	
	    addDOMEvent(datDIV, "click", function(e) {
	        var SelObj = calendarSelection.getID();
	        if (SelObj && SelObj.id == calendarObjects.id &&
	            SelObj.folder == calendarObjects.folder_id &&
	            SelObj.recurrence_position == calendarObjects.recurrence_position) {
	            if (window.event) {
	                e = window.event;
	            }
	            oInplEdit.on();
	            cancelBubbling(e);      
	        } else {
	            getSelectMonthView(e);
	        }
	    });     
	    addDOMEvent(datDIV, "mousedown", function(e) { 
	        if (e.button != undefined && e.button != RightButton) return;                       
	        getSelectMonthView(e);
	    });
	    addDOMEvent(datDIV, "dblclick", openAppointmentPopup);
	
		datDIV.oxcalobj = "" + calendarObjects.folder_id + "-" + calendarObjects.id 
		                  + "-" + calendarObjects.recurrence_position;
		return datDIV;
	}
}

function getShownDiv(shown_as) {
	var shownDiv = newnode('div');
	switch (shown_as) {
		case 1:
			shownDiv.className = "appointmentRESERVED";
			break;
		case 2:
			shownDiv.className = "appointmentTEMPORARY";
			break;
		case 3:
			shownDiv.className = "appointmentABSENT";
			break;
		case 4:
			shownDiv.className = "appointmentFREE";
			break;
		default:
			shownDiv.className = "appointmentNONE";
			break;
	}
	shownDiv.className += " showAppointmentShownMonth";
	return shownDiv;
}

function getContentAsDiv(sContent,CSSClass,sId) {
	sContent = sContent.toString();
	var datDIV = document.createElement("div");
	datDIV.className = CSSClass;
	if(sContent.length > 0) {		
		datDIV.appendChild(document.createTextNode(sContent));
	}
	datDIV.id=sId;		
	addTMPId(datDIV)
	return datDIV;
}

function getSelectMonthView(evt){
	var DOMTarget = (evt.target) ? evt.target : evt.srcElement;	
	var sDOMId = DOMTarget.parentNode.id;
	if(!sDOMId || sDOMId.split('_')[4] != 'app')
		return;	
	var oObj = oMonthViewObj.aAppointmentAssoc[sDOMId];		
	deselectAppointments(oObj.full_time);	
	$2(sDOMId).className = removeClass($2(sDOMId).className, "border-color-image");
	$2(sDOMId).className += " selectedAppMonth border-color-selection-elements";
	$2(sDOMId).style.borderWidth = "2px";
	setTimeout((function(sDOMId) {
        return function() {
            aSelectedAppArray.push(sDOMId);
        }
    })(sDOMId), 20);	
	if (calendarSelection.count != 0) {
		calendarSelection.reset();
	}
	selectedAppointment = { 
        id:oObj.id, folder:oObj.folder, recurrence_position:oObj.recurrence_position, 
        recurrence_id:oObj.recurrence_id, created_by:oObj.created_by
    };
	calendarSelection.click(oMonthViewObj.aAppointmentAssoc[sDOMId].index);
	triggerEvent("Selected", [ selectedAppointment ]);
}

function deselectAppointments(fullday) {
	for (var nSelApp=0; nSelApp < aSelectedAppArray.length; nSelApp++) {
		if($2(aSelectedAppArray[nSelApp])) {
			$2(aSelectedAppArray[nSelApp]).className = 
				removeClass($2(aSelectedAppArray[nSelApp]).className,'border-color-selection-elements');
			$2(aSelectedAppArray[nSelApp]).className = 
				removeClass($2(aSelectedAppArray[nSelApp]).className,'selectedAppMonth');			
			$2(aSelectedAppArray[nSelApp]).className += " border-color-image";
			$2(aSelectedAppArray[nSelApp]).style.borderWidth = "1px";
		}
	}
	aSelectedAppArray = new Array();
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * ,
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */
/* IE FIX */
register("Loaded", function () {
	if((document.all) && (window.offscreenBuffering)) {
		changeClassAttributes(".wwline","height","19px");
	}
});

register("OX_Configuration_Changed", function () {
	if (calendarinittemplates) {
        calendarinittemplates=false;
        createTemplatesWW(getWWInterval(), getWWStartTime(), getWWEndTime());
    }
});

var maxappointmentsperday=3;
var cwwdaysinweek = 5;
var startofweek=0;
var cww_oldvalues=new Object();

function setDaysInWeek(days,start) {
	cwwdaysinweek = days;
	startofweek=start;
	calendarinittemplates=false;
	showCalendarWorkweek();
}

var calendar_activedate;
var calendar_wholeday;
register("_IE_resize_complete",cwwwresizeHeader);

/* Enable/Disable Calendar Workweek Functions */
function cwwenable() {
	resizeEvents.register("Resized",cwwwresizeHeader);
}
function cwwdisable() {
	resizeEvents.unregister("Resized",cwwwresizeHeader);
}

var allcalendarobjects=new Object();
var wwhovers=new Object();
function default_calendar_workweek_create_object(module,folder) {
	
	if(module=="calendar")
	{
		if(!calendar_activedate) {
//			var myinterval=configGetKey("gui.calendar.interval");
			var myinterval=15;
			var d=new Date();			
			d.setUTCDate(1);
			d.setUTCMonth(activeMonth);
			d.setUTCFullYear(activeYear);
			d.setUTCDate(activeDay);
			d.setUTCHours(d.getHours());
			var mymin=d.getUTCMinutes();
			if(mymin % myinterval) {
				mymin=mymin - (mymin % myinterval)+ myinterval;
			}
			d.setUTCMinutes(mymin);
			calendar_createNewAppointment(d,folder,false);	
		} else {
			calendar_createNewAppointment(calendar_activedate,folder,calendar_wholeday);
		}
	}
	calendar_activedate=null;
	calendar_wholeday=null;
}
function CalendarWorkWeekObject(id,folderid,recurrence_position,recurrence_id,created_by,title,start_date,end_date,note,recurrence_type,participants,full_time,shown_as,color_label,location,private_flag)
{
	this.index;
	this.selected=false;
	this.id=id;
	this.folder_id=folderid;
	this.title=title;
	this.start_date=new Date(start_date);
	this.end_date=new Date(end_date);
	this.note=note;
	this.recurrence_type=recurrence_type;
	this.recurrence_position=recurrence_position;
	this.recurrence_id=recurrence_id;
	this.created_by=created_by;
	this.location=location;
	this.participants=participants;
	this.participants_sorted=[[],[],[],[]];
	this.participants_sorted[0]=new Array();
	this.participants_sorted[1]=new Array();
	this.participants_sorted[2]=new Array();
	this.participants_sorted[3]=new Array();
	this.participants_sorted[4]=new Array();
	if(participants)
	{
		for(zaehler=0;zaehler<this.participants.length;zaehler++) {
			this.participants_sorted[ (this.participants[zaehler].type-1)].push(this.participants[zaehler].id);
		}		
	}
	this.full_time=full_time;				
	this.shown_as=shown_as;
	this.color_label=color_label;
	this.number_of_links=1;
	this.private_flag=private_flag;
	this.divs=new Object();
}
CalendarWorkWeekObject.prototype = {
	addDiv : function (id,node) {
		this.divs[id]=node;
	}
}
function MatrixObject(folderid,id,recurrence_id,div_id,startpoint,endpoint) {
	this.folderid=folderid;
	this.id=id;
	this.element_id=div_id;
	this.recurrenceid=recurrence_id;
	this.startpoint = startpoint || 0;
	this.endpoint = endpoint || 0;
}


var currentKW = 0;
var globalinterval = 0;
var globalintervalcounts=0;
var calendarwwfields = new Array(200, 201, 202, 203, 209, 220, 401, 402, 102, 400, 101);
var calendarinittemplates=false;
var firstenter=false;
var cwwstorage;
var wwline=20;

var cwwdays;
var cwwdaysfull;
var cwwactualday;
var showallappointments=true;
function cww_onShowAllAppointmentsChanged(mybool) {
	showallappointments=mybool;
	configSetKey("gui.calendar.allfolders",mybool); 
	var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));	
	updateWWView(oDateLoc);
}

function showCalendarWorkweek() {	
	if(!firstenter) {
		var callbacks=new Object();
		callbacks["CALENDAR_BOTTOM"]=function(event,dragType,data,mouseposition,targetNode) { cww_saveAppointment(data,event,"CALENDAR_BOTTOM");  }
		callbacks["calendar"]=function(event,dragType,data,mouseposition,targetNode) { cww_saveAppointment(data.currentObjects[0],event,"calendar",false);  }
		callbacks["CALENDAR_TOP"]=function(event,dragType,data,mouseposition,targetNode) { cww_saveAppointment(data,event,"CALENDAR_TOP");  }
		callbacks["CALENDAR_NEW"]=function(event,dragType,data,mouseposition,targetNode) { cww_createAppointment(data,event,"CALENDAR_NEW",mouseposition,createPreviewNewAppointmentWW) } 
		registerTarget($("cwwtimecontentall"),callbacks,null,null,
		function(event,type,object,mouseposition) { 
			if(type=="CALENDAR_NEW") {
				drawpreviewnewAppointment(event,type,object,mouseposition)
			} else if (type == "calendar") {
				if(object && object.currentObjects && object.currentObjects.length>0) {
					drawpreviewDragandDrop(event,type,object.currentObjects[0]); 
				}
			}
			else {
				drawpreviewDragandDrop(event,type,object); 
			}
		},
		function(event,type,object,mouseposition) { 
			if(type=="CALENDAR_NEW") {
				drawpreviewnewAppointment(event,type,object,mouseposition)
			} else if (type == "calendar") {
				if(object && object.currentObjects && object.currentObjects.length>0) {
					drawpreviewDragandDrop(event,type,object.currentObjects[0]); 
				}
			} else {
				drawpreviewDragandDrop(event,type,object); 
			}
		},
		function(event,type,object) { removeDDPreviewDivs(); } );
				
		function disabled(e) {
			var iconNode = $2("dragdrop_default_node");
			if(iconNode == undefined) {
				iconNode = newnode("div", {left: (e.clientX + iconOffset) + "px",top: (e.clientY + iconOffset) + "px"},
 			    { className : "dragdropdefaultnode background-color-default border-color-design", id: "dragdrop_default_node"},[
 			    	newnode("table",{ width:"100%" , height: "100%" },{ cellPadding:"0" , cellSpacing :"0" , border : "0" },[
 			    		newnode("tbody",null,null,[
 			    			newnode("tr",null,null,[
 			    				newnode("td",null,null,[
 			    					newnode("img",{},{ src : getFullImgSrc("img/dnd_disabled.gif") },[])
 			    				]),
 			    				newnode("td",{ fontSize : "8pt", whiteSpace : "nowrap" },null,[
 			    					newnode("div",{ overflow: "hidden"},null,[addTranslated("No subject")])
 			    				])
 			    			])
 			    		])
 			    	])
 			    ]);
				body.appendChild(iconNode);
				addTMPId(iconNode);
			}
			iconNode.style.left = (e.clientX + iconOffset) + "px";
			iconNode.style.top = (e.clientY + iconOffset)+ "px";
			stopEvent(e);
			return false;
		}
		function disabledremove(e) {
			if($2("dragdrop_default_node")) {
				$2("dragdrop_default_node").parentNode.removeChild($2("dragdrop_default_node"));
				removeTMPId($2("dragdrop_default_node"));	
			}
			
		}
		registerSource($("cwwcontentresize"),"CALENDAR_NEW",function () { return null; },null,null,disabled,disabledremove);
		firstenter=true;
	}
	function checkChanges() {
        if (cwwdaysinweek != cww_oldvalues.cwwdaysinweek) { 
            return true; 
        }
        return false;
    }

    var tmpinterval=getWWInterval();
    var tmpstarttime=getWWStartTime();
    var tmpendtime=getWWEndTime();        
    
    if (!calendarinittemplates || checkChanges()) {
        createTemplatesWW(tmpinterval,tmpstarttime,tmpendtime);
        cww_oldvalues.cwwdaysinweek=cwwdaysinweek;
        calendarinittemplates=true;
    }
    
    var scrollpoint=tmpstarttime/tmpinterval;
    setTimeout(function() {
        $("cwwtimecontentall").scrollTop=(scrollpoint*20); 
    },0);    
	
	showallappointments=calendar_getAllFoldersAttribute();
	$("cwwshowAllAppointments").checked=showallappointments;
	var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));	
	updateWWView(oDateLoc);
}

function getWWInterval() {
	var tmpinterval=15*60000;
	if (configContainsKey("gui.calendar.interval")) {
        tmpinterval=configGetKey("gui.calendar.interval")*60000;
    }
    return tmpinterval;
}

function getWWStartTime() {
    var tmpstarttime=8*60*60000;
    if (configContainsKey("gui.calendar.starttime")) {
        tmpstarttime=configGetKey("gui.calendar.starttime")*60*60000;
    }
    return tmpstarttime;
}

function getWWEndTime() {
    var tmpendtime=17*60*60000;
    if (configContainsKey("gui.calendar.endtime")) {
        tmpendtime=configGetKey("gui.calendar.endtime")*60*60000;
    }
    return tmpendtime;
}

function clearAppointments()
{
	if(cwwdaysfull) {
		for(var zaehler1=0;zaehler1<cwwdaysfull.length;zaehler1++){ 
			removeChildNodes(cwwdaysfull[zaehler1].node); 
		}
	}
	if(cwwdays) {
		for(var zaehler1=0;zaehler1<cwwdays.length;zaehler1++){
			removeChildNodes(cwwdays[zaehler1].node); 
			for(zaehler2=0;zaehler2<cwwdays[zaehler1].matrix.length;zaehler2++) {
				cwwdays[zaehler1].matrix[zaehler2]=new Array();
			}
		}
	}
	for(var i in allcalendarobjects) {
		for(var i2 in allcalendarobjects[i]["divs"]) {
			removeTMPId(i2);
		}
	}
	allcalendarobjects=new Object();
	if(calendarSelection.count != 0) {
		calendarSelection.reset();
	}
	triggerEvent("Selected",[]);
	for(var i=0;$2("cwwmoreappointments"+i);i++) {
		if($2("cwwmoreappointments"+i).style.display!="none") { $2("cwwmoreappointments"+i).style.display="none" }
	}
}
function cwwchangeView(days,view){
	cwwactualday.setUTCDate(cwwactualday.getUTCDate()+days);
	activeMonth = cwwactualday.getUTCMonth();
	activeYear = cwwactualday.getUTCFullYear();		
	activeDay = cwwactualday.getUTCDate();	
	if(view == "list") {
		menuswitchCalendarView(view);
	}
	if(view == "day") {
		menuswitchCalendarTimerange(view);
	}
}
function goToNextWeek(nDirection)
{
	var step=1;
	if(currentpath2.join("/") == "calendar/calendar/workweek"  || currentpath2.join("/") == "calendar/list/workweek")  { step = 7 }
	if(currentpath2.join("/") == "calendar/calendar/custom"  || currentpath2.join("/") == "calendar/list/custom")  { step = configGetKey("gui.calendar.custom.countdays") }
	var oDateLoc = new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0));	
	oDateLoc.setUTCDate(oDateLoc.getUTCDate()+(nDirection*step));	
	activeMonth = oDateLoc.getUTCMonth();
	activeYear = oDateLoc.getUTCFullYear();		
	activeDay = oDateLoc.getUTCDate();	
	if(currentpath2.join("/") == "calendar/calendar/workweek"  || currentpath2.join("/") == "calendar/list/workweek") {
		
	} else {
		startofweek=oDateLoc.getUTCDay(); 
	}
	oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
	updateWWView(oDateLoc);
}
function updateWWView(oDateLoc) {		
	clearAppointments();
    cwwactualday = new Date(getDayInSameWeek(oDateLoc, startofweek) * 864e5);      
	updateHeaderWW(oDateLoc);
	getCalendarObjectsWW(cwwactualday);
}
function updateHeaderWW(oDateLoc)
{
	var oHeader = $("wwViewHeader");
	var oCalendarTool = new calendarTool(activeMonth,activeYear);
	currentKW = oCalendarTool.getKW(activeYear,activeMonth,activeDay);
	if(currentpath2.join("/") == "calendar/calendar/workweek") {
		$("wwViewHeader").parentNode.parentNode.parentNode.parentNode.parentNode.style.width="200px";
		oHeader.style.width="160px";
		oHeader.firstChild.nodeValue = _("CW") + " " + currentKW + " " + activeYear;		
	} else if (currentpath2.join("/") == "calendar/calendar/day"){
		$("wwViewHeader").parentNode.parentNode.parentNode.parentNode.parentNode.style.width="200px";
		oHeader.style.width="160px";
		oHeader.firstChild.nodeValue = formatDate(oDateLoc,"dateday");
	} else {
		if(cwwdaysinweek!=1) {
			var myenddate=new Date(oDateLoc.getTime());
			myenddate.setUTCDate(oDateLoc.getUTCDate() + (cwwdaysinweek-1) );
			$("wwViewHeader").parentNode.parentNode.parentNode.parentNode.parentNode.style.width="300px";
			oHeader.style.width="260px";
			oHeader.firstChild.nodeValue = formatDate(oDateLoc,"date") +" - "+ formatDate(myenddate,"date");
		} else {
			$("wwViewHeader").parentNode.parentNode.parentNode.parentNode.parentNode.style.width="200px";
			oHeader.style.width="160px";
			oHeader.firstChild.nodeValue = formatDate(oDateLoc,"dateday");
		}
	}
	oMonday= new Date(cwwactualday);
	for(indDay=0;indDay<cwwdaysinweek;indDay++) {
		if(currentpath2.join("/") == "calendar/calendar/workweek" || currentpath2.join("/") == "calendar/calendar/custom") {
			
			var sId = 'singleDay'+(indDay)+'stWw';
			var nCurrHeader  = $2(sId);
			if(isToday(oMonday))
				nCurrHeader.className = "font-color-default background-color-PMG-selection-elements";
			else 
				nCurrHeader.className = "font-color-default";
				
			nCurrHeader.innerHTML = formatDate(oMonday,"dateday"); 
			if( nCurrHeader.style.display!="") { nCurrHeader.style.display=""; }
			oMonday.setDate(oMonday.getDate()+1);

		} else {
			var sId = 'singleDay'+(indDay)+'stWw';
			var nCurrHeader  = $2(sId);
			removeChildNodes(nCurrHeader);
			var document1=document.createTextNode(".");
			nCurrHeader.className += " font-color-selected";
			nCurrHeader.appendChild(document1); 
			//if( nCurrHeader.style.display!="none") { nCurrHeader.style.display="none"; }
		}
	}
}
function getCalendarObjectsWW(actualmonday) {
	var start = actualmonday;
	var end = new Date(start.getTime());
	end.setDate(start.getDate()+cwwdaysinweek);
	var starttime=start.getTime();
	var endtime=end.getTime();
	var params=new Object();
	params.action="all";
	params.start=starttime;
	params.end=endtime;
	params.columns="1,20,207,206,2";
	if(!showallappointments) {
		params.folder= activefolder;
	}
	storageCache.get(AjaxRoot + "/calendar", params, initCalendarObjectsWW,
        calendarwwfields.toString(), true,
		function (x) { 
			return x.folder + "." + x.id + "." + x.recurrence_position 
                + "." + x.recurrence_id + "." + x.created_by;
		},
		function (x) { 
		 	var mObj = { id: x[0], folder: x[1], recurrence_position: x[2],
		 	    recurrence_id: x[3], created_by: x[4] }; 
		    return mObj;
		}
	);
	storageCache.update();	
}
function cwwwupdateView()
{
	if(lastUpdateOfCalendarTimestamp<cwwstorage.timestamp) {
		lastUpdateOfCalendarTimestamp=cwwstorage.timestamp;
	}
	clearAppointments();
	cwwstorage.newIterate(cwwstorage.ids, emptyFunction, showCalendarObject,
		function(){ 
			redrawAppointment();
		 });
}
var cww_myboolean=true;

function initCalendarObjectsWW(storage) {
	cww_activehovers=new Object();
	if(cww_myboolean) {
		cww_myboolean=false;
	}
	cwwstorage=storage;
	calendarSelection.setStorage(cwwstorage);
	if(lastUpdateOfCalendarTimestamp<cwwstorage.timestamp) {
		lastUpdateOfCalendarTimestamp=cwwstorage.timestamp;
	}
	
	cwwstorage.newIterate(cwwstorage.ids, emptyFunction, showCalendarObject,
		function() {
			redrawAppointment();
		 });
	storage.events.register("Changed", cwwwupdateView);
}
function showCalendarObject(index,object) {
	var calendarobject = new CalendarWorkWeekObject(object[0],object[1],object[2],object[3],object[4],object[5],object[6],object[7],object[8],object[9],object[10],object[11],object[12],object[13],object[14],object[15],object[16]);
	calendarobject.index=index;
	allcalendarobjects[""+calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position]=calendarobject;		
	cwwdrawAppointment(calendarobject);
}
function cwwchangeSelected(elementid) {
	if(calendarSelection.count != 0) {
		calendarSelection.reset();		
	}
	for(var myzaehler in allcalendarobjects) {
		for(var myzaehler2 in allcalendarobjects[myzaehler].divs) {
			var tds = allcalendarobjects[myzaehler].divs[myzaehler2].getElementsByTagName("td");
			var divs = allcalendarobjects[myzaehler].divs[myzaehler2].getElementsByTagName("div");			
			var wholeDayEl = !(tds[1] && tds[2]);
			if(wholeDayEl)
			{ 
				divs[2].className = removeClass(divs[2].className,"background-color-selection-elements");
				divs[2].className = removeClass(divs[2].className,"font-color-selected");		
				divs[2].className = removeClass(divs[2].className,"font-weight-high");									
			}
			if(tds[2])
			{
				tds[2].className = removeClass(tds[2].className,"appointmentTitleBG");
				tds[2].className = removeClass(tds[2].className,"background-color-selection-elements");
				tds[2].className = removeClass(tds[2].className,"font-color-selected");
				tds[2].className = removeClass(tds[2].className,"font-weight-high");
			}
			if(tds[1])			
			{
				tds[1].className = removeClass(tds[1].className,"border-color-content-default");				
				tds[1].className = removeClass(tds[1].className,"border-color-selection-elements");
			}
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"border-color-selection-elements");
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"background-color-selection-elements");								
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 			
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"selectedAppointmentWW");				
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"deselectedAppointmentWW");							
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"border-color-image");											
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"appointmentBGWW");					
			if(elementid == myzaehler)
			{
				allcalendarobjects[myzaehler].divs[myzaehler2].className += " selectedAppointmentWW background-color-selection-elements border-color-selection-elements";
				if(tds[1])
					tds[1].className += " border-color-selection-elements";	
				if(tds[2])
					tds[2].className += " background-color-selection-elements font-color-selected font-weight-high";
				if(wholeDayEl)
				{
					divs[2].className += " background-color-selection-elements font-color-selected font-weight-high";
					//divs[2].className = removeClass(divs[2].className,"background-color-selection-elements");					
				}
			}
			else
			{
				allcalendarobjects[myzaehler].divs[myzaehler2].className += "  border-color-image deselectedAppointmentWW appointmentBGWW";
				if(tds[1])
					tds[1].className += " border-color-content-default";									
				if(tds[2])				
					tds[2].className += " appointmentTitleBG";
			}
		}
	}
	
	calendarSelection.toggle(allcalendarobjects[elementid].index);
	selectedAppointment = { 
		id: allcalendarobjects[elementid].id, folder: allcalendarobjects[elementid].folder_id, 
		recurrence_position: allcalendarobjects[elementid].recurrence_position, 
		recurrence_id: allcalendarobjects[elementid].recurrence_id, 
		created_by: allcalendarobjects[elementid].created_by 
	};
	triggerEvent("Selected", calendarSelection.getSelected());
}
function cwwchangeSelectedFull(elementid) {
	if(calendarSelection.count != 0)
		calendarSelection.reset();
	for(var myzaehler in allcalendarobjects) {
		for(var myzaehler2 in allcalendarobjects[myzaehler].divs) {
			/*
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"border-color-selection-elements");
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"background-color-selection-elements");				
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"wholeDayBackground");
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"selectedAppointmentWW");				
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"deselectedAppointmentWW");											
			allcalendarobjects[myzaehler].divs[myzaehler2].className = 
				removeClass(allcalendarobjects[myzaehler].divs[myzaehler2].className,"appointmentTitleBG");
			*/
			if(elementid == myzaehler)
				allcalendarobjects[myzaehler].divs[myzaehler2].className += " selectedAppointmentWW background-color-selection-elements border-color-selection-elements";
//			else
//				allcalendarobjects[myzaehler].divs[myzaehler2].className += " deselectedAppointmentWW wholeDayBackground";
				
		}
	}
	if(calendarSelection.count != 0) {
		calendarSelection.toggle(allcalendarobjects[elementid].index);		
	}
	selectedAppointment = { 
		id: allcalendarobjects[elementid].id, folder: allcalendarobjects[elementid].folder_id,
		recurrence_position: allcalendarobjects[elementid].recurrence_position, 
        recurrence_id: allcalendarobjects[elementid].recurrence_id, 
        created_by: allcalendarobjects[elementid].created_by
	};
	triggerEvent("Selected",calendarSelection.getSelected());
}

function cwwdrawAppointment(calendarobject) {
	function cww_doDblClick (event) {
		if(!event) {
			event=window.event;
		}
		triggerEvent('OX_Calendar_Edit');
		stopEvent(event);
	}
	//Check Full Time Object
	//Check Time
	var oneday=1000*60*60*24;
	var showappointment=true;
	var zaehler3=0;

	// Startdate Correction Complete Appointment
	// Setze Startzeit des Termins um , falls er vor meiner Anzeige beginnt
	var sdt=calendarobject["start_date"].getTime();
	if(sdt<cwwactualday.getTime()) {
		//calendarobject["start_date"]=new Date(cwwactualday.getTime());
		sdt=new Date(cwwactualday.getTime()).getTime();
	}
	// Setze Endzeit des Termins um , falls er nach meiner Anzeige beginnt
	var edt=calendarobject["end_date"].getTime();
	if(edt>cwwactualday.getTime()+(cwwdaysinweek*(oneday))) {
		//calendarobject["end_date"]=new Date(cwwactualday.getTime()+(5*oneday));
		edt=new Date(cwwactualday.getTime()+(cwwdaysinweek*oneday)).getTime();
	}
	var sdttmp=sdt;
	// IST es ein Ganztagstermin
	if(calendarobject.full_time){		
		// Kann Termin angezeigt werden???
		showappointment=true;
		while(sdttmp<edt) {
			if(!document.getElementById(calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position+"-"+zaehler3))	{
				// Hol mir den Tag der Woche
				var sdd=(new Date(sdttmp).getUTCDay()-new Date(cwwactualday.getUTCDay()) +7) % 7;
				// Hat dieser Tag schon einen Ganztagstermin, wenn ja Listenbild einblenden
				if(cwwdaysfull[sdd].node.hasChildNodes()) {
					showappointment=false;
					if($2("cwwmoreappointments"+sdd).style.display!="") $2("cwwmoreappointments"+sdd).style.display="";
				}
				else {
					//Zeichne Ganztagstermin
					showappointment=true;
					var appointmentcontainer = cwwdaysfull[sdd].node;
					var myappointment=$("cww_appointment_template_full_time").cloneNode(true);
					var	paramObj = { 
						id: calendarobject.id, folder_id: calendarobject.folder_id,
					    recurrence_position: calendarobject.recurrence_position,
					    recurrence_id: calendarobject.recurrence_id, created_by: calendarobject.created_by
					};	
					var divs = myappointment.getElementsByTagName("div");			
					
					var oInplEdit  = new inplaceEdit(divs[2], calendarobject.title, function (sStr,oObj) {
						editAppointment(paramObj,{title:sStr});
					});
					oInplEdit.input_fontcolor = "#FFFFFF";
					oInplEdit.input_fontsize = "8pt";
					oInplEdit.input_height = "1.2em";
						//fixed bug with auto selection													
					calendarSelection.reset();	
					var myfunc1 = function(oInplEdit) {
						return function(e) {
							var SelObj = calendarSelection.getID();
							if(SelObj && SelObj.id == paramObj.id &&
								SelObj.folder == paramObj.folder_id &&
								SelObj.recurrence_position == paramObj.recurrence_position)
								{
									if(window.event) {
										e = window.event;
									}
									oInplEdit.on();
									stopEvent(e);
							}
						} 
					};
					addDOMEvent(myappointment,"mousedown",function (e) {
						if (e.button != undefined && e.button != RightButton) return;						
						cwwchangeSelected(calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position); 
					});
                    var tds = myappointment.getElementsByTagName("td");
                    var title = tds[1].getElementsByTagName("span")[0];
					addDOMEvent(title, "click", myfunc1(oInplEdit));		
					addDOMEvent(myappointment, "click", function(e) {
						var SelObj = calendarSelection.getID();
						if(SelObj && SelObj.id == paramObj.id &&
							SelObj.folder == paramObj.folder_id &&
							SelObj.recurrence_position == paramObj.recurrence_position) {} else {
								cwwchangeSelected(calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position); 
							}
						});								
			
					/* Drag & Drop Source */
					registerSource(myappointment,"calendar",function () { 
						var mymove=new MoveCopy(); 
						mymove.begin("calendar",[calendarobject]); 
						return mymove; 
					},null,null,calendardefaultdisabled,defaultdisabledremove);
					myappointment.id=calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position+"-"+zaehler3;
					myappointment.oxcalobj=calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position+"-"+zaehler3;
					addTMPId(myappointment,"calendar/calendar/workweek");
					zaehler3++
					addDOMEvent(myappointment,"dblclick",cww_doDblClick);
					 					
					registerContext(myappointment,"calendar");
					allcalendarobjects[calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position].addDiv(myappointment.id,myappointment);
					/** Shown As **/
					switch (calendarobject.shown_as) {
						case 1:
							tds[0].className = "appointmentRESERVED";
							break;
						case 2:
							tds[0].className = "appointmentTEMPORARY";
							break;
						case 3:
							tds[0].className = "appointmentABSENT";
							break;
						case 4:
							tds[0].className = "appointmentFREE";
							break;
					}
					if(!calendarobject.title) { calendarobject.title="";}
					title.firstChild.nodeValue = calendarobject.title;
					appointmentcontainer.appendChild(myappointment);
				}
			}
			//Zaehle Temp Startzaehler um 24 Stunden hoch
			sdttmp = sdttmp+oneday;
		}	
	}
	else
	{
		if(sdttmp==edt && edt != new Date(cwwactualday.getTime()+(cwwdaysinweek*oneday)).getTime() ) {
			edt++;
		}
		//Hier alle nicht Ganztagstermine	
		while(sdttmp<edt)
		{
			if(!document.getElementById(calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position+"-"+zaehler3)) {
				showappointment=true;
				var sdd        = (new Date(sdttmp).getUTCDay()-new Date(cwwactualday.getUTCDay()) +7) % 7;
				var longstart  = (sdttmp % oneday);
				var startpoint = Math.floor((longstart/globalinterval)+0.0000001);
				var edttmp     = edt;
				var longend    = (edt % oneday);
				var endpoint   =   Math.ceil((longend/globalinterval)-0.0000001);
				// An diesem Tag nicht zu Ende
				if(sdttmp - (sdttmp % oneday) + oneday <= edt) {
					endpoint   = globalintervalcounts;							
				}
				if(startpoint  ==  endpoint) {
					endpoint++;
				}
				/** Check Place Allocation*/
				
				var tiefe=0;  			//Place
				var allelements=0;		//AllElements
			
				for (var zaehler=startpoint;zaehler<endpoint;zaehler++) {
					var maxelements = cwwdays[sdd].matrix[zaehler].length;
					if(allelements<maxelements) {
						allelements=maxelements;
					} 
					if(cwwdays[sdd].matrix[zaehler][tiefe]) {
						tiefe++;
						zaehler=startpoint-1; //Zaehler is added after loop
						if(tiefe==maxappointmentsperday) {
							showappointment=false;	
							break;
						}
					}
				}
				if(!showappointment){
					$2("cwwmoreappointments"+sdd).style.display="";
				} else {
					var myappointment=$("cww_appointment_template").cloneNode(true);
					myappointment.id=+calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position+"-"+zaehler3;
					myappointment.oxcalobj=calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position+"-"+zaehler3;
					addTMPId(myappointment,"calendar/calendar/workweek");
					zaehler3++
					addDOMEvent(myappointment,"mousedown",function (e) {
						if (e.button != undefined && e.button != RightButton) return;						
						cwwchangeSelected(calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position); 
					});				
					var	paramObj = { 
						id: calendarobject.id, folder_id: calendarobject.folder_id,
						recurrence_position: calendarobject.recurrence_position, recurrence_id: calendarobject.recurrence_id,
						created_by: calendarobject.created_by
					};	
					var tds = myappointment.getElementsByTagName("td");			
						var oInplEdit  = new inplaceEdit(tds[2].getElementsByTagName("div")[0], calendarobject.title, function (sStr,oObj){
						editAppointment(paramObj,{title:sStr});
						});
	
					oInplEdit.input_fontcolor = "#FFFFFF";
					oInplEdit.input_fontsize = "8pt";
					oInplEdit.input_height = "1.2em";
											//fixed bug with auto selection													
					calendarSelection.reset();
					var myfunc1 = function(oInplEdit) {
						return function(e) {
							var SelObj = calendarSelection.getID();
							if(SelObj && SelObj.id == paramObj.id &&
							SelObj.folder == paramObj.folder_id &&
							SelObj.recurrence_position == paramObj.recurrence_position)
							{
								oInplEdit.on();
								stopEvent(e);
							}
						} 
					};
                    var tds = myappointment.getElementsByTagName("td");
                    var title = tds[2].getElementsByTagName("span")[0];
					addDOMEvent(title, "click", myfunc1(oInplEdit));		
					addDOMEvent(myappointment, "click", function(e) {
						var SelObj = calendarSelection.getID();
						if(SelObj && SelObj.id == paramObj.id &&
							SelObj.folder == paramObj.folder_id &&
							SelObj.recurrence_position == paramObj.recurrence_position) {} else {
								cwwchangeSelected(calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position); 
							}
						});								
	
					//addDOMEvent(myappointment,"click",function (e){cancelBubbling(e);});							
					addDOMEvent(myappointment,"dblclick",cww_doDblClick);
					var domdivs=myappointment.getElementsByTagName("div");
					/* Cursor fuer Drag&Drop */
					addDOMEvent(domdivs[1], "mouseover",
						(function(obj){
							return function(){ 
								obj.style.cursor = "move"; };
						})(domdivs[1]));
					addDOMEvent(domdivs[0], "mouseover",
						(function(obj){
							return function(){ obj.style.cursor = "n-resize"; };
						})(domdivs[0]));
					addDOMEvent(domdivs[4], "mouseover",
						(function(obj){ return function(){ obj.style.cursor = "s-resize"; }; })(domdivs[4]));
					
					registerContext(myappointment,"calendar");
					function disabled(e) {
						var iconNode=$2("cww_node_dd");
						if(iconNode == undefined) {
							iconNode = newnode("img", {position:"absolute", left:(e.clientX + iconOffset) + "px", top:(e.clientY + iconOffset) + "px"},
			 			    {src: getFullImgSrc("img/dnd_disabled.gif"), alt: ""});
							iconNode.id="cww_node_dd";
							body.appendChild(iconNode);
							addTMPId(iconNode);
						}
						iconNode.style.left = (e.clientX + iconOffset) + "px";
						iconNode.style.top = (e.clientY + iconOffset)+ "px";
						stopEvent(e);
						return false;
					}
					function disabledremove(e) {
						
						if($2("cww_node_dd")) {
							$2("cww_node_dd").parentNode.removeChild($2("cww_node_dd"));
							removeTMPId($2("cww_node_dd"));
						}
					}				
					registerSource(domdivs[0],"CALENDAR_TOP",function () { return calendarobject; }, null,null,disabled,disabledremove);
					registerSource(domdivs[4],"CALENDAR_BOTTOM",function () { return calendarobject; },null,null,disabled,disabledremove);
					registerSource(domdivs[1],"calendar",function () { 
						var mymove=new MoveCopy(); 
						mymove.begin("calendar",[calendarobject]); 
						return mymove; 
					},null,null,calendardefaultdisabled,defaultdisabledremove);
					allcalendarobjects[calendarobject.folder_id+"-"+calendarobject.id+"-"+calendarobject.recurrence_position].addDiv(myappointment.id,myappointment);			
					
						
				
					var appointmentcontainer=cwwdays[sdd].node;
				//FILL APPOINTMENTS
						/** Shown As **/
						switch (calendarobject.shown_as) {
							case 1:
								tds[0].className="appointmentRESERVED";
								break;
							case 2:
								tds[0].className="appointmentTEMPORARY";
								break;
							case 3:
								tds[0].className="appointmentABSENT";
								break;
							case 4:
								tds[0].className="appointmentFREE";
								break;
						}
						/** Title & Time **/
						if(!calendarobject.title) { calendarobject.title=""; }
						title.firstChild.data = calendarobject.title;
	
						/** Recurrence Type **/
						if(calendarobject.recurrence_type && calendarobject.recurrence_type!=0)
							tds[3].getElementsByTagName("img")[0].style.display = "inline";
						else 
							tds[3].getElementsByTagName("img")[0].style.display = "none";
								
						/** Private or Group **/
						if(calendarobject.participants && calendarobject.participants.length>1) {
							tds[3].getElementsByTagName("img")[1].style.display = "inline";
							tds[3].getElementsByTagName("img")[1].src=getFullImgSrc("img/calendar/group.gif");							
						}
						else {
							tds[3].getElementsByTagName("img")[1].style.display = "none";
						}
		
						/** Tagging **/
						if(calendarobject.color_label && calendarobject.color_label!=0) {
							tds[3].getElementsByTagName("img")[2].style.display = "inline";
							tds[3].getElementsByTagName("img")[2].src=getFullImgSrc("img/menu/tag_"+calendarobject["color_label"]+".gif");
						}				
						else 
							tds[3].getElementsByTagName("img")[2].style.display = "none";
							
						if(calendarobject.private_flag) {
							tds[3].getElementsByTagName("img")[3].style.display = "inline";
							tds[3].getElementsByTagName("img")[3].src=getFullImgSrc("img/private_flag.gif");
						}
						else {
							tds[3].getElementsByTagName("img")[3].style.display = "none";
						}
						
						/** Links **/	
	
					//TODO PARTICIPANTS	
				/**		for(zaehler=0;zaehler<4;zaehler++) 
						{
							if(calendarobject.participants_sorted[zaehler].length>0) 
							{
								if(zaehler==0) 
								{
									//ddivs[5+zaehler].innerHTML=calendarobject.participants_sorted[zaehler][0];
								}	
							}
						}
				**/
				//New Element is Latest
					if(allelements<tiefe+1) {
						allelements=tiefe+1;
					}
					myappointment.style.height=((endpoint-startpoint) * wwline) + "px";
					myappointment.getElementsByTagName("div")[1].style.height = (((endpoint-startpoint) * wwline)-4) + "px";
					myappointment.style.top=startpoint*wwline+"px";							
					appointmentcontainer.appendChild(myappointment);
					
					for(var zaehler=startpoint;zaehler<endpoint;zaehler++)
					{
						cwwdays[sdd].matrix[zaehler][tiefe]=new MatrixObject(calendarobject.folder_id,calendarobject.id,calendarobject.recurrence_position,myappointment.id,startpoint,endpoint);
					}
					allredrawelements=new Object();
				}
			}
			if(sdt==sdttmp) {
				sdttmp = sdttmp - (sdttmp % oneday);
			}
			sdttmp = sdttmp+oneday;
		}
	}
}
var allredrawelements=new Object();
function redrawAppointment(elementlength,position,elementid) {
	var allobjects=new Object();
	for(var tagezaehler=0;tagezaehler<cwwdaysinweek;tagezaehler++) {  //<7
		var currentday=cwwdays[tagezaehler].matrix;
		for(var intervalzaehler=0;intervalzaehler<currentday.length;intervalzaehler++) { // 24,48,96,144,288
			var currentinterval=currentday[intervalzaehler];
			var elementsperline=currentinterval.length;
			var tmpobjects=new Array();
			for(var i=0;i<currentinterval.length;i++) { //<max appointments
				var element=currentinterval[i] 
				if(element) {
					tmpobjects.push(element.element_id);
					if(!allobjects[element.element_id]) { 
						allobjects[element.element_id]=new Object(); 
						allobjects[element.element_id]["name"]=element.element_id; 
						allobjects[element.element_id]["nodes"]=new Object();
						allobjects[element.element_id]["plength"]=currentinterval.length;
						allobjects[element.element_id]["pposition"]=i;
					} else if(allobjects[element.element_id]["plength"]<currentinterval.length) {
						allobjects[element.element_id]["plength"]=currentinterval.length;
						allobjects[element.element_id]["pposition"]=i;
					}
				}				
			}
			//Fill childnodes
			for(var i=0;i<tmpobjects.length;i++) {
				var element=allobjects[tmpobjects[i]];
				for(var i2=0;i2<tmpobjects.length;i2++) {
					if(!element["nodes"][tmpobjects[i2]] && (tmpobjects[i2]!=tmpobjects[i])) {
						element["nodes"][tmpobjects[i2]]=true;
					}
				}
			}
		}
	}
	for(var myelements in allobjects) {
		if(!allobjects.highest) {
			var highest=0;
			var checked=new Object();
			var tocheck=new Array();
			var zaehler=0;
			function checkNext() {
				for(zaehler=0;zaehler<tocheck.length;zaehler++) {
					var curobj=tocheck[zaehler];
					if(!checked[curobj.name]) {
						if(highest<curobj.plength) { highest=curobj.plength }
						checked[curobj.name]=true;
						for(var i in curobj.nodes) {
							if(!checked[i]) {
								tocheck.push(allobjects[i]);
							}
						}					
					}
				}
			}
			var myobject=allobjects[myelements];		
			tocheck.push(myobject)
			checkNext();
			
			for(var i1 in checked) {
				allobjects[i1].highest=highest;
			}
		}
	}
	for(var last in allobjects) {
		var d=$2(allobjects[last].name);
		d.style.width=(Math.round(100/allobjects[last].highest)-2)+"%";
		d.style.left=(Math.round(100/allobjects[last].highest)*allobjects[last].pposition)+"%";
	}
}						
/**** Templates Creation *******************************************************************************************/
/**
* Create Matrix
* Create Template Timeline
* Create Template Background Calendar Main Content
*/
function createTemplatesWW(interval,startworktime,endworktime) {
	this.globalinterval=interval;
	var completetime=1000*60*60*24;
	this.globalintervalcounts=Math.round(completetime/interval);
	
	createNewTimeLine(interval);
	createCalendarContentFullTime();
	createCalendarContentWW(interval,startworktime,endworktime);
	cwwdays=new Array();	
	for(var zaehler=0;zaehler<cwwdaysinweek;zaehler++) {
		cwwdays[zaehler]=new Object();
		cwwdays[zaehler].node=$2("cww-line-"+zaehler);
		cwwdays[zaehler].matrix=new Array(globalintervalcounts);
		for(i=0;i<cwwdays[zaehler].matrix.length;i++)
		{
			cwwdays[zaehler].matrix[i]=new Array();
		}
	}
	cwwdaysfull=new Array();
	for(var zaehler=0;zaehler<cwwdaysinweek;zaehler++) {
		cwwdaysfull[zaehler]=new Object();
		cwwdaysfull[zaehler].node=$2("cwwheaderfull:"+zaehler);
	}
}
function createCalendarContentFullTime() {
	function getfunction(list,i) {
		return function() {
			cwwchangeView(i,list);
		}
	}
	for(var i=0;$2("cwwmoreappointments"+i);i++) {
		removeTMPId("singleDay"+(i)+"stWw");
		removeTMPId("cwwmoreappointments"+(i));
		removeTMPId("cwwwholeday_dnd:"+i);
		removeTMPId("cwwheaderfull:"+i);
		removeTMPId("cww_wholeday:"+i);	
	}
	
	var tbody=newnode("tbody",null,null,[]);
	var firsttr=newnode("tr",null,null,[]);
	var secondtr=newnode("tr",null,null,[]);
	for(var i=0;i<cwwdaysinweek;i++) {
		var onetd=
		newnode("td",{ width: Math.floor(100/cwwdaysinweek)+"%", borderRight: "1px solid", paddingLeft : "5px" },{className: "border-color-design"},[
			newnode("table",{ width: "100%"},{ cellPadding: 0 , cellSpacing : 0 , border : 0 },[
				newnode("tbody",null,null,[
					newnode("tr",null,null,[
						newnode("td",{ width: "100%"},null,[
							newnode("div",{ overflow: "hidden" },null,[
								newnode("div",{ whiteSpace :"nowrap" ,cursor: "pointer" },{id: "singleDay"+(i)+"stWw"},[
									newnode("img",{},{src: getFullImgSrc("img/dummy.gif")},[])
								])
							])
						]),
						newnode("td",null,{ id : "cwwmoreappointments"+(i), title : _("Click here for further appointments") },[
							newnode("div", { paddingRight : "7px", height: "16px" , cursor : "pointer" }, null,[
								newnode("img",null,{ src : getFullImgSrc("img/menu/weiterzuListe.gif") },[])
							])
						])
					])
				])
			])
		]);
		addTMPId(onetd.getElementsByTagName("div")[1]);
		addTMPId(onetd.getElementsByTagName("td")[1]);
		addDOMEvent(onetd.getElementsByTagName("td")[0],"click",getfunction("day",i));
		addDOMEvent(onetd.getElementsByTagName("td")[1],"click",getfunction("list",i));
		firsttr.appendChild(onetd);
		
		var secondtd=newnode("td",{ width: Math.floor(100/cwwdaysinweek)+"%", borderRight: "1px solid" },{className: "border-color-design",vAlign : "top", id: "cwwwholeday_dnd:"+i},[
			newnode("div",{ height:"0px", lineHeight:"0px", width:"100%", position:"relative"},{ id: "cwwheaderfull:"+i },[]),
			newnode("table",{ width:"100%", height:"100%" },{ cellPadding: 0, cellSpacing : 0, border: 0, id: "cww_wholeday:"+i },[
				newnode("tbody",null,null,[
					newnode("tr",null,null,[
						newnode("td",{ width: "5px", height : "1.6em" },null,[
						]),
						newnode("td",null,{ className : "wholeDayBackground" },[
							newnode("img",null,{ src : getFullImgSrc("img/dummy.gif") },[])
						])
					])
				])
			])
		]);
		function getfunction2(node) {
			return function() {
				cww_createNewWholeAppointment(node);
			}
		}
		addTMPId(secondtd);
		addTMPId(secondtd.getElementsByTagName("div")[0]);
		addTMPId(secondtd.getElementsByTagName("table")[0]);
		addDOMEvent(secondtd.getElementsByTagName("div")[0],"dblclick",getfunction2(secondtd.getElementsByTagName("div")[0]));	
		addDOMEvent(secondtd.getElementsByTagName("table")[0],"dblclick",getfunction2(secondtd.getElementsByTagName("table")[0]));	
		secondtr.appendChild(secondtd);
	}
	tbody.appendChild(firsttr);
	delete calendarhovers["daywwcustom"];
	calendarhovers["daywwcustom"]=new Hover(secondtr,OXAppointmentHover.getContent().node);
	calendarhovers["daywwcustom"].setSize(OXAppointmentHover.contentobject.node);
	calendarhovers["daywwcustom"].getTarget = function (node) {
		
		function getNode(actualnode) {
			if(actualnode.oxcalobj) {
				return actualnode;
			}
			return;
		}
		while (node) {
			var element=getNode(node);
			if(element) {
				return element;
			}
			node = node.parentNode;
		}
		return;
		
	}
	calendarhovers["daywwcustom"].onShow = function (node) {
		if (popupenabled) return false;		
		OXAppointmentHover.actualHover=this;
		var splitid=node.oxcalobj.split("-");
		OXAppointmentHover.refillContent(splitid[1],splitid[0],splitid[2]);
		
	}
	tbody.appendChild(secondtr);
	var d=$("cwwheader");
	removeChildNodes(d);
	d.appendChild(tbody);
	var i=0;
	while($2("cwwwholeday_dnd:"+i)) {
		var mynode=$2("cwwwholeday_dnd:"+i);
		var mycallback=new Object();
		mycallback["calendar"]=returni(i);
		registerTarget(mynode,mycallback,null,null,
			function(event,type,object,mouseposition) {
				drawpreviewDragandDropWholeDay(event,type,object.currentObjects[0]); 
			},
			function(event,type,object,mouseposition) { 
				drawpreviewDragandDropWholeDay(event,type,object.currentObjects[0]); 
			},
			function(event,type,object) { cww_lastdateddwholeday=null; removeDDPreviewDivs(); } 
		);
		i++;
	}
	function returni(i) {
		return function(event,dragType,data,mouseposition,targetNode) { cww_saveAppointment(data.currentObjects[0],event,"calendar",true,i);  }
	}
}
function cww_createNewAppointment(clickedobject) {
	var day=clickedobject.id.split(":")[1];
	var time=clickedobject.parentNode.id.split("-")[2];

	var mydate=new Date(Date.UTC(cwwactualday.getUTCFullYear(),cwwactualday.getUTCMonth(),cwwactualday.getUTCDate()+parseInt(day),0,0,0));
	mydate.setTime(mydate.getTime()+parseInt(time));
	calendar_activedate=mydate;
	calendar_wholeday=false;
	triggerEvent("OX_Before_Create_Calendar");
}
function cww_createNewWholeAppointment(clickedobject) {
	var day=clickedobject.id.split(":")[1];
	var mydate=new Date(Date.UTC(cwwactualday.getUTCFullYear(),cwwactualday.getUTCMonth(),cwwactualday.getUTCDate()+parseInt(day),0,0,0));
	mydate.setTime(mydate.getTime());
	calendar_activedate=mydate;
	calendar_wholeday=true;
	triggerEvent("OX_Before_Create_Calendar");
}
function createCalendarContentWW(interval,startworktime,endworktime){
	var mytable=$("cwwtimecontent");
	for(var zaehler=0;$2("cww-line-"+zaehler);zaehler++) {
		removeTMPId("cww-line-"+zaehler);
	}
	var completetime =1000*60*60*24; 
	var timehour =1000*60*60;
	var templateofftimenohour=$("cwww_calendar_offtime_nohour");
	templateofftimenohour.style.width=Math.floor(100/cwwdaysinweek)+"%";
	var templateofftimehour=$("cwww_calendar_offtime_hour");
	templateofftimehour.style.width=Math.floor(100/cwwdaysinweek)+"%";
	var templateworktimenohour=$("cwww_calendar_worktime_nohour");
	templateworktimenohour.style.width=Math.floor(100/cwwdaysinweek)+"%";
	var templateworktimehour=$("cwww_calendar_worktime_hour");
	templateworktimehour.style.width=Math.floor(100/cwwdaysinweek)+"%";	
	var comtemplateofftimenohour =document.createElement("tr");
	var comtemplateofftimehour =document.createElement("tr");
	var comtemplateworktimenohour =document.createElement("tr");
	var comtemplateworktimehour =document.createElement("tr");
	for (i=0;i<cwwdaysinweek;i++) {
		var tmp1=templateofftimenohour.cloneNode(true);
		tmp1.id="App-ONH:"+i;
		comtemplateofftimenohour.appendChild(tmp1);
		var tmp2=templateofftimehour.cloneNode(true);
		tmp2.id="App-OH:"+i;
		comtemplateofftimehour.appendChild(tmp2);
		var tmp3=templateworktimenohour.cloneNode(true);
		tmp3.id="App-WNH:"+i;
		comtemplateworktimenohour.appendChild(tmp3);
		var tmp4=templateworktimehour.cloneNode(true);
		tmp4.id="App-WH:"+i;
		comtemplateworktimehour.appendChild(tmp4);
	}
	var mytable2=mytable.cloneNode(false);
	var mytable2tbody=document.createElement("tbody");
    var numOfLines = 0;
	for (currenttime=0;currenttime<completetime;numOfLines++) {
		var temp1;
		if((currenttime % timehour) == 0) {
			if(currenttime >= startworktime && currenttime < endworktime) {
				temp1 = comtemplateworktimehour.cloneNode(true);
				temp1.id="cww-tr-"+currenttime;
			}
			else {
				temp1 = comtemplateofftimehour.cloneNode(true);
				temp1.id="cww-tr-"+currenttime;
			}
		}
		else {
			if(currenttime >= startworktime && currenttime < endworktime) {
				temp1 = comtemplateworktimenohour.cloneNode(true);
				temp1.id="cww-tr-"+currenttime;
			}
			else {
				temp1 = comtemplateofftimenohour.cloneNode(true);
				temp1.id="cww-tr-"+currenttime;
			}
		}
		if(currenttime==0)
		{
			for (var zaehler=0;zaehler<temp1.childNodes.length;zaehler++)
			{
				var shorttmp=temp1.childNodes[zaehler];
				var table1=shorttmp.getElementsByTagName("table");
				//var appointmentinsert=table1[0].getElementsByTagName("td")[0];
				var appointmentinsert = document.createElement("div");
				appointmentinsert.id="cww-line-"+zaehler;
				addTMPId(appointmentinsert);
				appointmentinsert.style.width="100%";
				appointmentinsert.style.height="0px";
				appointmentinsert.style.lineHeight="0px";
				appointmentinsert.style.fontSize="0pt";
				appointmentinsert.style.position="relative";
//				appointmentinsert.style.overflow="hidden";
				shorttmp.insertBefore(appointmentinsert,table1[0]);
			}
		}
		mytable2tbody.appendChild(temp1);
		currenttime=currenttime+interval;
	}
	mytable2.appendChild(mytable2tbody);
	replace$(mytable2);	
	
	mytable.parentNode.replaceChild(mytable2,mytable);
	mytable=$("cwwtimecontent");
	calendarhovers["daywwcustom2"]=new Hover(mytable,OXAppointmentHover.getContent().node);
	calendarhovers["daywwcustom2"].setSize(OXAppointmentHover.contentobject.node);
	calendarhovers["daywwcustom2"].getTarget = function (node) {
		function getNode(actualnode) {
			if(actualnode.oxcalobj) {
				return actualnode;
			}
			return;
		}
		while (node) {
			var element=getNode(node);
			if(element) {
				return element;
			}
			node = node.parentNode;
		}
		return;
	}
	calendarhovers["daywwcustom2"].onShow = function (node) {
		if (popupenabled) return false;
		OXAppointmentHover.actualHover=this;
		var splitid=node.oxcalobj.split("-");
		OXAppointmentHover.refillContent(splitid[1],splitid[0],splitid[2]);	
	}
	
	cwwwresizeHeader();
    wwline = (temp1.offsetTop + temp1.offsetHeight) / numOfLines;
}
function cwwwresizeHeader() {
	var e1=$("cwwcontentresize");
	var mywidth=e1.offsetWidth;
	$("cwwheaderresize").style.width=mywidth+"px";
}
/* Create TimeLine */
function createNewTimeLine(interval) {
	$("cwwcontentresize").className = "interval" + (interval/60000);
	var template5min=$("cww_timeline_minutes5_template");
	var time5min = 1000*60*5;
	var template15min=$("cww_timeline_minutes15_template");
	var time15min = time5min*3;
	var template60min=$("cww_timeline_onehour_template");
	var time60min = time15min*4;
	var templateonehourcomplete;
	var node=$("cww_timeline");
	var node2=node.cloneNode(false);
	removeChildNodes(node2);
	var nodetbody=document.createElement("tbody");
	var templateonehourcomplete = new Array();
	var currenttime=0;
	var hourzaehler=0;
	var completetime=1000*60*60; //Zeit einer Stunde
	var rowsperhour=Math.round(time60min/interval);
	for(;currenttime<completetime;) {
		var tmp;
		var modulo=currenttime % time15min;
		if((currenttime % time15min == 0)) 
		{
			if((currenttime % time60min == 0)) 
			{
				tmp=template60min.cloneNode("true");
				if(rowsperhour>1) 
				{
					var bigtext=tmp.getElementsByTagName("td")[0];
					//bigtext.setAttribute("rowspan",rowsperhour);
					bigtext.rowSpan=rowsperhour;
				}
			}
			else  
			{
				tmp=template15min.cloneNode("true");
				tmp.id="T"+currenttime;
				var smalltext=tmp.getElementsByTagName("td")[0];
				if(interval<time15min) 
				{
					var minutes=currenttime / (1000*60);
					smalltext.firstChild.nodeValue=""+minutes; 
				}
			}
		}
		else 
		{
			tmp=template5min.cloneNode("true");
			tmp.id="T"+currenttime;
		}
		templateonehourcomplete.push(tmp);
		currenttime=currenttime+interval;
	}

	/*** Create TimeLine ***/

	for(i=0;i<24;i++)
	{
		for(var zaehler=0;zaehler<templateonehourcomplete.length;zaehler++)
		{
			var myelement=templateonehourcomplete[zaehler].cloneNode(true);
			if(zaehler==0)
			{
				var d1 = new Date(i * 36e5); // ms/h
				if(interval>=time60min)
				{
					myelement.getElementsByTagName("td")[0].style.fontSize="0pt"
					myelement.getElementsByTagName("td")[1].firstChild.nodeValue =formatDate(d1, "hour");
				}			
				else
				{
					myelement.getElementsByTagName("td")[0].firstChild.nodeValue = formatDate(d1, "prefix");
					myelement.getElementsByTagName("td")[1].firstChild.nodeValue = formatDate(d1, "suffix");
				}
			}
			myelement.id="cwwtimeline_"+((i*time60min)+((zaehler*interval) % time60min));
			if(i==23 && (zaehler+1) == templateonehourcomplete.length)	{
				//TODO: BORDER BOTTOM
			}
			nodetbody.appendChild(myelement);
		}
		
	}
	node2.appendChild(nodetbody);
	replace$(node2);
	node.parentNode.replaceChild(node2,node);
	
}
var scrollit=false;
var scrolltimeoutww;
function getDragandDropPointWholeDay(e) {
	var node = e.currentTarget || e.srcElement || false;
	var myday=node.id.split(":")[1];
	if(myday) {
		myday=parseInt(myday);
		return new Date(Date.UTC(cwwactualday.getUTCFullYear(),cwwactualday.getUTCMonth(),cwwactualday.getUTCDate()+myday,0,0,0));	
	}
}
function getDragandDropPoint(e) {
	var coreelement=$("cwwtimecontent");
	var scrollposition= $("cwwtimecontentall").scrollTop;
	var posx=getAbsolutePositionLeft(coreelement);
	var posy=getAbsolutePositionTop(coreelement)-scrollposition;
	var poscontent=e.clientY-getAbsolutePositionTop(coreelement);
	var posheight= $("cwwtimecontentall").offsetHeight;
	var fieldposx=e.clientX-posx;
	var fieldposy=e.clientY-posy;
	if(fieldposx<0 || fieldposx>coreelement.offsetWidth) {
		return null;
	}
	if(fieldposy<0 || fieldposy>coreelement.offsetHeight) {
		return null;
	}
	if(poscontent<40 && $("cwwtimecontentall").scrollTop>0) {
		if(!scrollit) {
			function scrollworkweekup() {
				var newscroll=scrollposition-80;
				if(newscroll>0) {
					$("cwwtimecontentall").scrollTop=newscroll;
				} else {
					$("cwwtimecontentall").scrollTop=0;
				}
				scrollit=false;
			}
			scrolltimeoutww=setTimeout(scrollworkweekup,100);
		}
		scrollit=true;
	} 
	else if((posheight-poscontent)<40 && $("cwwtimecontentall").scrollTop<coreelement.offsetHeight-posheight) {
		if(!scrollit) {
			function scrollworkweekdown() {
				var newscroll=scrollposition+80;
				if(newscroll<coreelement.offsetHeight-posheight) {
					$("cwwtimecontentall").scrollTop=newscroll;
				} else {
					$("cwwtimecontentall").scrollTop=coreelement.offsetHeight-posheight;
				}
				scrollit=false;
			}
			scrolltimeoutww=setTimeout(scrollworkweekdown,100);
		}
		scrollit=true;
	} 
	var daylength=coreelement.offsetWidth/cwwdaysinweek;
	var day=Math.floor(fieldposx/daylength);
	var intervalcount=Math.floor(fieldposy/wwline)*configGetKey("gui.calendar.interval")*60000;
	var mydate=new Date(intervalcount);
	return new Date(Date.UTC(cwwactualday.getUTCFullYear(),cwwactualday.getUTCMonth(),cwwactualday.getUTCDate()+day,mydate.getUTCHours(),mydate.getUTCMinutes(),0));
	 
}
var cww_lastdatedd;
var cww_lastdatestart;
var cww_lastdateend;
function drawpreviewnewAppointment(event,target,object,mouseposition) {
	var startdate;
	if(!mouseposition.startdate) {
		startdate = getDragandDropPoint(mouseposition);
		mouseposition.startdate=startdate;
	} else {
		startdate=mouseposition.startdate;
	}
	var enddate = getDragandDropPoint(event);
	if((startdate && enddate) && (!cww_lastdatestart || cww_lastdateend || (cww_lastdatestart.getTime() != startdate.getTime() && enddate.getTime() != enddate.getTime()))) {
		cww_lastdatestart = startdate;
		cww_lastdateend = enddate;
		if(startdate.getTime()<=enddate.getTime()) {
			createDDPreviewDivs(startdate,enddate);
		} else {
			createDDPreviewDivs(enddate,startdate);
		}
	}
}
var cww_lastdateddwholeday;
function drawpreviewDragandDropWholeDay(event,target,object) {
	var newdate=getDragandDropPointWholeDay(event);
	if((cww_lastdateddwholeday && !newdate) || (!cww_lastdateddwholeday && newdate) || (cww_lastdateddwholeday && newdate && (cww_lastdateddwholeday.getTime() != newdate.getTime()))) {
		cww_lastdateddwholeday = newdate;
		var starttime=object.start_date;
		var endtime=object.end_date;
		if(newdate) {
			var oneday=1000*60*60*24;
			var changes=newdate.getTime()-starttime.getTime();
			starttime=new Date(starttime.getTime()+changes);
			endtime=new Date(endtime.getTime()+changes);
			if(endtime.getTime % oneday) {
				endtime.setUTCDate(endtime.getUTCDate()+1);
			}
		}
		createDDPreviewDivsWholeDay(starttime,endtime);	
	}
}
function drawpreviewDragandDrop(event,target,object) {
	var newdate = getDragandDropPoint(event);
	if((cww_lastdatedd && !newdate) || (!cww_lastdatedd && newdate) || (cww_lastdatedd && newdate && (cww_lastdatedd.getTime() !=newdate.getTime()))) {
		cww_lastdatedd = newdate;
		var starttime=object.start_date;
		var endtime=object.end_date;
		var oneintervaltime=configGetKey("gui.calendar.interval")*60000;
		switch (target) {
			case "CALENDAR_BOTTOM":
				if(newdate) {
					if(newdate.getTime()<=starttime.getTime()) {
						endtime=new Date(starttime.getTime()+oneintervaltime);
					} else {
						endtime=newdate;
					}								
				}
				break;
			case "CALENDAR_TOP":
				if(newdate) {
					if(newdate.getTime()>=endtime.getTime()) {
						starttime=new Date(endtime.getTime()-oneintervaltime);
					} else {
						starttime=newdate;
					}								
				}
				break;
			case "calendar":
				if(newdate) {
					var changes=newdate.getTime()-starttime.getTime();
					starttime=new Date(starttime.getTime()+changes);
					endtime=new Date(endtime.getTime()+changes);
				}
				
				break;
			default:
				break;
		}
		createDDPreviewDivs(starttime,endtime);
	}
}
function removeDDPreviewDivs() {
	var zaehler3=0;
	while($2("cwwpreview"+zaehler3)) {
		if($2("cwwpreview"+zaehler3).parentNode) {
			$2("cwwpreview"+zaehler3).parentNode.removeChild($2("cwwpreview"+zaehler3));
		}
		removeTMPId($2("cwwpreview"+zaehler3));
		zaehler3++;
	}
	if($2("dnd_div_") != undefined) {
		body.removeChild($2("dnd_div_"));
		removeTMPId($2("dnd_div_"));
		
	}
	
}
function createDDPreviewDivsWholeDay(starttime,endtime) {
	removeDDPreviewDivs();
	var oneday=1000*60*60*24;
	var sdt=starttime.getTime();
	if(sdt<cwwactualday.getTime()) {
		sdt=new Date(cwwactualday.getTime()).getTime();
	}
	var edt=endtime.getTime();
	if(edt>cwwactualday.getTime()+cwwdaysinweek*(oneday)) {
		edt=new Date(cwwactualday.getTime()+(cwwdaysinweek*oneday)).getTime();
	}
	var sdttmp=sdt;
	var zaehler3=0;
	while(sdttmp<edt) {
		var sdd  = (new Date(sdttmp).getUTCDay()-new Date(cwwactualday.getUTCDay()) +7) % 7;
		myappointment=document.createElement("div");
		myappointment.className="dndSelectionCalendarBG dndAbsoluteSelection";
		myappointment.id="cwwpreview"+zaehler3;
		addTMPId(myappointment);
		myappointment.style.height="19px";
		myappointment.style.top="0px";
		myappointment.style.width="98%";
		var appointmentcontainer=$2("cwwheaderfull:"+sdd);
		appointmentcontainer.appendChild(myappointment);
		zaehler++;
		if(sdt==sdttmp) {
			sdttmp = sdttmp - (sdttmp % oneday);
		}
		sdttmp = sdttmp+oneday;
	}
}
function createDDPreviewDivs(starttime,endtime) {
	removeDDPreviewDivs();
	zaehler3=0;
	var oneday=1000*60*60*24;
	
	var sdt=starttime.getTime();
	if(sdt<cwwactualday.getTime()) {
		sdt=new Date(cwwactualday.getTime()).getTime();
	}
	var edt=endtime.getTime();
	if(edt>cwwactualday.getTime()+cwwdaysinweek*(oneday)) {
		edt=new Date(cwwactualday.getTime()+(cwwdaysinweek*oneday)).getTime();
	}
	var sdttmp=sdt;
	while(sdttmp<edt)
	{
		var sdd        = (new Date(sdttmp).getUTCDay()-new Date(cwwactualday.getUTCDay()) +7) % 7;
		var longstart  = (sdttmp % oneday);
		var startpoint = Math.floor((longstart/globalinterval)+0.0000001);
		var edttmp     = edt;
		var longend    = (edt % oneday);
		var endpoint   =   Math.ceil((longend/globalinterval)-0.0000001);
		// An diesem Tag nicht zu Ende
		if(sdttmp - (sdttmp % oneday) + oneday <= edt) {
			endpoint   = globalintervalcounts;							
		}
		if(startpoint  ==  endpoint) {
			endpoint++;
		}
		var myappointment=document.createElement("div");
		myappointment.className="dndSelectionCalendarBG dndAbsoluteSelection";
		myappointment.id="cwwpreview"+zaehler3;
		addTMPId(myappointment);
		myappointment.style.height=((endpoint-startpoint) * wwline) + "px";
		myappointment.style.top=startpoint*wwline+"px";
		myappointment.style.width="98%";
		zaehler3++
		var appointmentcontainer=cwwdays[sdd].node;
		appointmentcontainer.appendChild(myappointment);
		if(sdt==sdttmp) {
			sdttmp = sdttmp - (sdttmp % oneday);
		}
		sdttmp = sdttmp+oneday;
	}
}
function cww_saveAppointment(object,event,target,wholeday,i) {
	var myappointmentobj;
	if(!wholeday) {
		var newdate=getDragandDropPoint(event);
	} else {
		var newdate=new Date(Date.UTC(cwwactualday.getUTCFullYear(),cwwactualday.getUTCMonth(),cwwactualday.getUTCDate()+parseInt(i),0,0,0));
	}
	var starttime=object.start_date;
	var endtime=object.end_date;
	var oneintervaltime=configGetKey("gui.calendar.interval")*60000;
	switch (target) {
		case "CALENDAR_BOTTOM":
			if(newdate) {
				if(newdate.getTime()<=starttime.getTime()) {
					endtime=new Date(starttime.getTime()+oneintervaltime);
				} else {
					endtime=newdate;
				}								
			}
			break;
		case "CALENDAR_TOP":
			if(newdate) {
				if(newdate.getTime()>=endtime.getTime()) {
					starttime=new Date(endtime.getTime()-oneintervaltime);
				} else {
					starttime=newdate;
				}								
			}
			break;
		case "calendar":
			if(newdate) {
				var changes=newdate.getTime()-starttime.getTime();
				starttime=new Date(starttime.getTime()+changes);
				endtime=new Date(endtime.getTime()+changes);
				if(wholeday) {
					var oneday=1000*60*60*24;
					if(endtime.getTime() % oneday) {
						endtime.setUTCDate(endtime.getUTCDate()+1);
					}
				}
			}
			break;
	}
	if((starttime.getTime() == object.start_date.getTime()) && (endtime.getTime() == object.end_date.getTime())) {
		removeDDPreviewDivs();
		return;
	}
	if(!wholeday) {
		wholeday=false;
	}
	myappointmentobj = { start_date : starttime.getTime(), end_date : endtime.getTime(), full_time: wholeday };
	editAppointment(object,myappointmentobj);
	removeDDPreviewDivs();
}

function cww_createAppointment(object,event,type,mouseposition,cb) {
	if(!object) {
		object=new Object();
	} 
	if(!object.folder_id) {
		object.folder_id=activefolder;
	}
	var startdate;
	if(!mouseposition.startdate) {
		startdate = getDragandDropPoint(mouseposition);
		mouseposition.startdate=startdate;
	} else {
		startdate=mouseposition.startdate;
	}
	var enddate = getDragandDropPoint(event);
	if(startdate && enddate) {
		if(startdate.getTime() <= enddate.getTime()) {
			object.start_date=startdate.getTime();
			object.end_date=enddate.getTime();
		} else {
			object.end_date=startdate.getTime();
			object.start_date=enddate.getTime();
		}
		removeDDPreviewDivs();
		if(configGetKey("gui.calendar.openpopup")) {
			openNewAppointmentWindow(object);
		} else {
			if(object.end_date!=object.start_date) {
				setTimeout(function (){openImplaceEdit(object,cb);},0);
			}
		}
	}
}
function openImplaceEdit(object,cb) {
	removeDDPreviewDivs();
	if(cb) cb(object);
}
function createPreviewNewAppointmentWW(object) {
	function dounregister() {
		removeDDPreviewDivs();
		unregister("OX_Dummy",dounregister);
	}
	zaehler3=0;
	var oneday=1000*60*60*24;
	var sdt=object.start_date;
	if(sdt<cwwactualday.getTime()) {
		sdt=new Date(cwwactualday.getTime()).getTime();
	}
	var edt=object.end_date;
	if(edt>cwwactualday.getTime()+cwwdaysinweek*(oneday)) {
		edt=new Date(cwwactualday.getTime()+(cwwdaysinweek*oneday)).getTime();
	}
	var sdttmp=sdt;
	while(sdttmp<edt)
	{
		var sdd        = (new Date(sdttmp).getUTCDay()-new Date(cwwactualday.getUTCDay()) +7) % 7;
		var longstart  = (sdttmp % oneday);
		var startpoint = Math.floor((longstart/globalinterval)+0.0000001);
		var edttmp     = edt;
		var longend    = (edt % oneday);
		var endpoint   =   Math.ceil((longend/globalinterval)-0.0000001);
		// An diesem Tag nicht zu Ende
		if(sdttmp - (sdttmp % oneday) + oneday <= edt) {
			endpoint   = globalintervalcounts;							
		}
		if(startpoint  ==  endpoint) {
			endpoint++;
		}
		var myappointment=$("cww_appointment_template").cloneNode(true);
		myappointment.id="cwwpreview"+zaehler3;
		addTMPId(myappointment);
		var appointmentcontainer=cwwdays[sdd].node;
		var tds = myappointment.getElementsByTagName("td");					
		tds[0].className="appointmentShowAsReserved";
		tds[2].getElementsByTagName("div")[0].firstChild.data = "tre";
		tds[3].getElementsByTagName("img")[0].style.display = "none";
		tds[3].getElementsByTagName("img")[1].style.display = "none";
		tds[3].getElementsByTagName("img")[2].style.display = "none";
		tds[3].getElementsByTagName("img")[3].style.display = "none";
		myappointment.style.height=((endpoint-startpoint) * wwline) + "px";
		myappointment.getElementsByTagName("div")[1].style.height = (((endpoint-startpoint) * wwline)-4) + "px";
		myappointment.style.top=startpoint*wwline+"px";		
		myappointment.style.width="98%";
		appointmentcontainer.appendChild(myappointment);					
		
		if(sdt==sdttmp) {
			sdttmp = sdttmp - (sdttmp % oneday);
		}
		sdttmp = sdttmp+oneday;
		zaehler3++;
	}
	var implElem=$2("cwwpreview0");
	var oInplEdit  = new inplaceEdit(implElem.getElementsByTagName("div")[2], _("New appointment"), function (sStr,oObj){
			object.title=sStr;
			createAppointment(object);
			removeDDPreviewDivs();
			storageCache.update();
 	});		
 	oInplEdit.really_edit_check = false;
	oInplEdit.input_fontcolor = "#000000";
	oInplEdit.input_fontsize = "8pt";
	oInplEdit.input_height = "1.2em";
	oInplEdit.on();
	register("OX_Dummy",dounregister);
}
function editAppointment(object,changes, fn_opt) {
    changes.notification = true;
	function edit_whole_series(id) {
		var app_id = id || object.recurrence_id || object.id;
		json.put(AjaxRoot + "/calendar?action=update&session=" + session + "&id=" + app_id + "&timestamp=" + lastUpdateOfCalendarTimestamp + "&folder=" + object.folder_id, changes, null, 
		function(cb){
			if(cb && cb.data && cb.data.conflicts){
				function cbignore() {
					changes.ignore_conflicts=true;
					json.put(AjaxRoot + "/calendar?action=update&session=" + session + "&id=" + app_id + "&timestamp=" + lastUpdateOfCalendarTimestamp + "&folder=" + object.folder_id, changes, null,
					function(response) {
						if(response && response.data && response.data.id) {	
							storageCache.update(triggerEvent("OX_Refresh_Mini_Calendar"));	
							
							if(fn_opt)
								fn_opt();							
						} 		
					});
				}
				ConflictsPopup.open(changes,cb.data.conflicts,null,null,cbignore);
				
			} else {
				storageCache.update(triggerEvent("OX_Refresh_Mini_Calendar"));
				if(fn_opt)
					fn_opt();
			}
		});		
	}
	function edit_single_series() {
		changes.recurrence_position = object.recurrence_position;
		edit_whole_series(object.id);
	}
	function cancel_edit() {
		storageCache.update();
	}
	if(menuhasRightandLoad([object],"WRITE",
		function () {
			if(object.recurrence_position>0 && object.recurrence_id && 
			   object.recurrence_id == object.id) {
				function isSameDate(date1,date2) {
					var diff= date1.getTime() - date2.getTime();
					if((diff < 1000*60*60*24) && (diff > -(1000*60*60*24))) {
						if(date1.getUTCDate() == date2.getUTCDate()) {
							return true;
						}
					}
					return false;
				}
				if(!object.start_date | !changes.start_date || isSameDate(object.start_date,new Date(changes.start_date))) {
					newConfirm(_("Edit Appointment"),_("Do you want to edit the whole series or a single series appointment?"),AlertPopup.SERIESBUTTON,null,cancel_edit,null,null,edit_whole_series,edit_single_series,cancel_edit);					
				} else {
					newConfirm(_("Edit Appointment"),
                        _("By changing the date of this appointment you are creating an appointment exception to the series. Do you want to continue?"),
                        AlertPopup.CONTINUECANCEL, edit_single_series,
                        cancel_edit, null, null, edit_whole_series, null,
                        cancel_edit, null, edit_single_series);
				}
			} else {
				edit_whole_series(object.id);
			}	
		}
	)); 
} 	
function createAppointment(object) {
	json.put(AjaxRoot + "/calendar?action=new&session=" + session, object, null, 
	function(response){
		function cbignore() {
			object.ignore_conflicts=true;
			json.put(AjaxRoot + "/calendar?action=new&session=" + session, object, null,
			function(responseinternal) {
				if(responseinternal && responseinternal.data && responseinternal.data.id) {	
					storageCache.update();	
				} 		
			});
		}
		if(response && response.data && response.data.id) {	
			storageCache.update();	
		} 
		else if(response && response.data && response.data.conflicts) {
			ConflictsPopup.open(object,response.data.conflicts,null,null,cbignore);
		}
	});
}
function openNewAppointmentWindow(object) {
	function createAppyes() {
		function myok() {
			object.title=$("create_window_text_field").value;
			createAppointment(object);
		}
		function myadvanced() {
			newWindow("newAppointment.html#modul=new&folder_id="+object.folder_id+"&start_date="+object.start_date+"&end_date="+object.end_date+"", getWindowOptions());
		}
		removeDDPreviewDivs();
		newAppointmentObject(object,myok,function() {},myadvanced,null);
	}
	rightshandler.checkRights("calendar",null , object, createAppyes, function() {}); 
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

var weekStorage;
var allcalendarWeekObjects=new Object();

function openNewAppointmentInWeek(date) {
	calendar_activedate=date;
	calendar_wholeday=false;
	triggerEvent("OX_Before_Create_Calendar");
}

function WeekCalendarTool() {
	this.firstinit=false;
	this.oCalendarTool = new calendarTool(activeMonth,activeYear);
	this.switchedToNext = 0;
	this.oCalendarTool1970 = new calendarTool(1,1970);
	this.calendarwfields = new Array(200, 201, 202, 203, 207, 220, 401, 402, 102, 400, 101, 206, 2);
	//title, startdate, enddate, note, seq(0-4), participants, fulltime(true|false), shownas, tag
	this.calendarWeekTimer = null;
	this.timer = 700;
	this.showallappointments = true;
	this.aAppointmentAssoc = new Object();
	this.divIdCurrentDay = "";
	this.aDateForNewWindow = new Object();
	this.aMonthForNewWindow = new Object();
	this.registeredEvents = new Array();
	this.registeredEventsAdd = new Array();
	this.displayedWeekLinks = new Array();
	this.appendetFirstChilds = new Array();	
}

WeekCalendarTool.prototype = {
	
	init: function(paramYear, paramMonth, paramDay) {
		//fixed text selection bug in IE
		if(!this.firstinit) {
			addDOMEvent($("weekcontainer"), "selectstart", function() { return false; });
			addDOMEvent($("weekcontainer"), "drag" , function() { return false; });
			this.firstinit=true;
			var hover=new Hover($("weekcontainer"),OXAppointmentHover.getContent().node);
			calendarhovers["week"]=hover;
			
			hover.setSize(OXAppointmentHover.contentobject.node);
			hover.getTarget = function (node) {
				function getNode(actualnode) {
					if(actualnode.oxcalobj) {
						return actualnode;
					}
					return;
				}
				while (node) {
					var element=getNode(node);
					if(element) {
						return element;
					}
					try {
					   node = node.parentNode;
					} catch (e) { 
						node = null;
					} 
				}
				return;
			}
			hover.onShow = function (node) {
				if (popupenabled) return false;
				OXAppointmentHover.actualHover=this;
				var splitid=node.oxcalobj.split("-");
				OXAppointmentHover.refillContent(splitid[1],splitid[0],splitid[2]);	
			}
		}
		
		if (configGetKey("gui.effects.hover.calendar") && calendarhovers["week"]) {
			calendarhovers["week"].enable();
		}
		
		for (var t = 1; t< 8; t++) {
			$("imageList"+t).style.display = "none";
		}
		
		if (paramYear && (paramMonth != undefined) && paramDay) {			
			activeYear = paramYear;
			activeMonth = paramMonth;
			activeDay = paramDay;
			this.oDateLoc = new Date(Date.UTC(paramYear, paramMonth, paramDay, 0, 0, 0));
		} else {
			this.oDateLoc = new Date(Date.UTC(activeYear, activeMonth, activeDay, 0, 0, 0));
		}
		
		this.setKW();
		this.setDays();
		
		if(calendar_getAllFoldersAttribute()) {
			this.showallappointments=true;
			$("allAppointmentWeekView").checked = true;
		} else { 
			this.showallappointments=false;
			$("allAppointmentWeekView").checked = false;
		}
			
		this.getStorageCache();
		this.getData = 0;		
	},
	setKW: function() {
		this.currentKW = this.oCalendarTool.getKW(this.oDateLoc.getUTCFullYear(),
															this.oDateLoc.getUTCMonth(),
																	this.oDateLoc.getUTCDate());
		
		
		this.testToday();
	},
	testToday: function() {
		if(this.divIdCurrentDay != "") {
			/* reset background-color */
			$(this.divIdCurrentDay).className = "weekViewDivContent font-color-default workTimeBackground border-color-design";
		}
		this.oDateAct = new Date();
		this.nKW = this.oCalendarTool.getKW(this.oDateAct.getUTCFullYear(),this.oDateAct.getUTCMonth(),this.oDateAct.getDate());
		if(this.currentKW == this.nKW && activeYear == this.oDateAct.getUTCFullYear()) {
			this.divIdCurrentDay = 'weekDayContent'+this.oDateAct.getDay();
			$(this.divIdCurrentDay).className = "weekViewDivContent background-color-content todaySelectionBorder";
		}
		
	},
	openNewCalendar: function(evt,clicked) {
		var DOMTarget = (evt.target) ? evt.target : evt.srcElement;
		var oDate = new Date();
		activeDay = oDate.getUTCDate();
		activeMonth = oDate.getUTCMonth();
		activeYear = oDate.getUTCFullYear();
		if (clicked == "dblclick") {
			triggerEvent('OX_Before_Create_Calendar');
		} else if (clicked == "click") {
			window.setTimeout(function() {
				menuswitchCalendarTimerange("day")
			}, 20);
		}
	},
	setDays: function() {
		this.oMonday = new Date(getDayInSameWeek(new Date(Date.UTC(activeYear,activeMonth,activeDay,0,0,0)), weekStart) * 864e5);
		var Self = this;
		
		function drawpreviewDragandDrop(evt,type,object) {
			var subObject = object;
			if(object && object.currentObjects && object.currentObjects.length>0) {
					subObject = object.currentObjects[0]; 
			}			
			var DOMTarget = (evt.target)?evt.target:evt.srcElement;	
			DOMTarget.style.cursor = "move";
			if(!$2("dnd_div_")) {				
				var iconNode = Self.getAppointmentDiv(subObject);					
				iconNode.id = "dnd_div_";
				iconNode.style.left = (evt.clientX + iconOffset) + "px";
				iconNode.style.top = (evt.clientY + iconOffset)+ "px";	
				body.appendChild(iconNode);
				addTMPId(iconNode);
				iconNode.style.width = "320px";
				iconNode.style.position = "absolute";				
			} else {
				var iconNode = $2("dnd_div_");
				iconNode.style.left = (evt.clientX + iconOffset) + "px";
				iconNode.style.top = (evt.clientY + iconOffset)+ "px";	
			}
			var sId = DOMTarget.id;
			if(sId.slice(0,14) != "weekDayContent")
				return;
			DOMTarget.className = removeClass(DOMTarget.className,"dndSelectionCalendarBG");			
			DOMTarget.className += " dndSelectionCalendarBG";
		}
		
		function removeDDPreviewDivs(evt,type,object) {
			var DOMTarget = (evt.currentTarget)?evt.currentTarget:evt.srcElement;
			var DOMTarget2 = (evt.target)?evt.target:evt.srcElement;
			DOMTarget2.style.cursor = "default";
			DOMTarget.className = removeClass(DOMTarget.className,"dndSelectionCalendarBG");
			if($2("dnd_div_")) {
				body.removeChild($2("dnd_div_"));
				removeTMPId($2("dnd_div_"));
			}
		}					

		function dropCallBack(evt,dragType,object,mousepos,targetNode,dropNode){
			var subObject = object;
			if (object && object.currentObjects && object.currentObjects.length > 0) {
				subObject = object.currentObjects[0]; 
			}						
			var DOMTarget = targetNode;//(evt.target)?evt.target:evt.srcElement;
			var sId = DOMTarget.id;	

			var nNum = (parseInt(sId.slice(sId.length-1, sId.length)) == 0)
			     ? 7 : parseInt(sId.slice(sId.length-1, sId.length));

			var sKey = "weekviewDay" + nNum;
			if (Self.aDateForNewWindow[sKey] == undefined
			    || Self.aMonthForNewWindow[sKey] == undefined) return;

			DOMTarget.className = removeClass(DOMTarget.className,"dndSelectionCalendarBG");			

			var oDate = new Date();
			oDate.setUTCHours(0);		
			oDate.setUTCMinutes(0);					
			oDate.setUTCSeconds(0);								
			oDate.setUTCDate(1);		
			oDate.setUTCFullYear(activeYear);				
			oDate.setUTCMonth((Self.aMonthForNewWindow[sKey]-1));				
			oDate.setUTCDate(Self.aDateForNewWindow[sKey]);			
			var start_date = new Date(subObject.start_date);
			var end_date = new Date(subObject.end_date);			
			oDate.setUTCHours(start_date.getUTCHours());
			oDate.setUTCMinutes(start_date.getUTCMinutes());
			var changes=oDate.getTime()-start_date.getTime();
			var oDateEnd=new Date(end_date.getTime()+changes);
			
			// drop only allowed if destination date != current date	
			if (formatDate(start_date, "date") != formatDate(oDate, "date"))
			     moveAppToNewStart(subObject,oDate,oDateEnd);
			     
			if($2("dnd_div_")) {
				body.removeChild($2("dnd_div_"));
				removeTMPId($2("dnd_div_"));
			}
			var DOMTarget2 = (evt.target)?evt.target:evt.srcElement;
			DOMTarget2.style.cursor = "default";						
		}
		
		for (var inWeekDay=0; inWeekDay<7; inWeekDay++) {
			(function (inWeekDayIndex) {
				
				if (inWeekDayIndex == 6) {
					var dayContentId = 'weekDayContent0';
				} else {
					var dayContentId = 'weekDayContent'+(inWeekDayIndex +1);
				}
				
				var sId = 'weekviewDay'+(inWeekDayIndex+1);			
				var nCurrHeader  = $(sId);
				var nCurrContent  = $(dayContentId);				
								
				if (Self.registeredEvents.length == 7)
					removeDOMEvent(nCurrContent,'dblclick',Self.registeredEvents[inWeekDayIndex]);
				
				if (Self.registeredEventsAdd.length == 7)
					removeDOMEvent(nCurrHeader,'dblclick',Self.registeredEventsAdd[inWeekDayIndex]);
				
				var nDisplayMonth = Self.oMonday.getUTCMonth()+1;
				Self.aMonthForNewWindow[sId] = nDisplayMonth;
				
				if (nDisplayMonth < 10)	nDisplayMonth = '0' + nDisplayMonth;
				var nDisplayDate = Self.oMonday.getUTCDate();
				Self.aDateForNewWindow[sId] = nDisplayDate;
				
				if(nDisplayDate < 10) nDisplayDate = '0' + nDisplayDate;		

				var date=new Date();
				date.setUTCDate(1);
				date.setUTCFullYear(Self.oMonday.getUTCFullYear());
				date.setUTCMonth(Self.oMonday.getUTCMonth());
				date.setUTCDate(Self.oMonday.getUTCDate());
				date.setUTCHours(configGetKey("gui.calendar.starttime") || 8);
				
				function openNewAppointmentInWeek(e) {
					calendar_activedate=date;
					calendar_activedate.setUTCMinutes(0);					
					calendar_wholeday=false;
					triggerEvent("OX_Before_Create_Calendar");
				}
				
				function openNewWholeAppointmentInWeek(e) {		
					var date2=date;
					date2.setUTCHours(0);
					date2.setUTCMinutes(0);
					calendar_activedate=date2;
					calendar_wholeday=true;
					triggerEvent("OX_Before_Create_Calendar");
				}
				
				Self.registeredEvents[inWeekDayIndex] = openNewAppointmentInWeek;
				Self.registeredEventsAdd[inWeekDayIndex] = openNewWholeAppointmentInWeek;
				
				addDOMEvent($(dayContentId), 'dblclick', openNewAppointmentInWeek);	
				addDOMEvent(nCurrHeader, 'dblclick', openNewWholeAppointmentInWeek);
				
				Self.yearUTC=Self.oMonday.getUTCFullYear();	
				nCurrHeader.className = isToday(Self.oMonday) 
				        ? "background-color-PMG-selection-elements" : "";

				nCurrHeader.firstChild.nodeValue = formatDate(Self.oMonday,"dateday");
				Self.oMonday.setUTCDate(Self.oMonday.getUTCDate()+1);
				
				registerTarget(nCurrContent,{calendar:dropCallBack},null,null,
						drawpreviewDragandDrop,	//drawpreviewDragandDrop
						drawpreviewDragandDrop,	//drawreviewDragandDrop
						removeDDPreviewDivs );//removeDDPreviewDivs				
			})(inWeekDay)
		}
		$('weekviewheader').firstChild.nodeValue = _("CW") /*i18n*/ 
										+ " " + this.currentKW + " " + this.yearUTC;
		
	},
	goToNextWeek: function(nDirection) {		
		this.clearContentFields();
		this.getData = 1;
		this.nDirection = nDirection;
		this.oDateLoc.setUTCDate(this.oDateLoc.getUTCDate()+(nDirection*7));	
		activeMonth = this.oDateLoc.getUTCMonth();
		activeYear = this.oDateLoc.getUTCFullYear();		
		activeDay = this.oDateLoc.getUTCDate();	
		this.setKW();
		this.setDays();
		var Self = this;
		
		Self.calendarWeekTimer  = window.setTimeout(
									function() 	{
											Self.goToNextWeek(Self.nDirection); 
											Self.switchedToNext++;
									}, Self.timer);
		if (this.switchedToNext>4) {
			Self.timer = 400;
		} else {
			Self.timer = 700;
		}
		
		if (oMiniCalendar) oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);
	},
	clearTimer: function() {
		this.switchedToNext = 0;
		window.clearTimeout(this.calendarWeekTimer);
		if(this.getData >0) {
			this.getData = 0;
			this.getStorageCache();
		}		
	}, 
	clearContentFields: function() {
		for (var t = 1; t< 8; t++)
		 		$("imageList"+t).style.display = "none";
		allcalendarWeekObjects = {};
		this.weekAppointments = new Array()
		for(var i=0; i<7;i++) {
			removeChildNodes($('weekDayContent'+i));
			var fullTimeDIV = newnode('div');
			fullTimeDIV.className = 'containerFullTimeWeek';
			$('weekDayContent'+i).appendChild(fullTimeDIV);
		}		
	},
	updateView: function() {
		this.clearContentFields();
		this.iterateStorage();
		lastUpdateOfCalendarTimestamp = storageCache.current.timestamp;
	},
	showAllAppointments: function(mybool) {
		this.showallappointments=mybool;
		configSetKey("gui.calendar.allfolders",mybool)
		this.getStorageCache();
	},
	getStorageCache: function() {
		if (weekStorage) {
            weekStorage.events.unregister("Changed", function() {
                Self.updateView();
            });
        }
		this.clearContentFields();
		var start = new Date(getDayInSameWeek(this.oDateLoc, weekStart) * 864e5);		
		var end = new Date(start.getTime());
		end.setUTCDate(start.getUTCDate()+7);
		this.starttime=start.getTime();
		var endtime=end.getTime();
		var Self = this;
		Self.params=new Object();
		Self.params.action="all";
		Self.params.start=Self.starttime;
		Self.params.end=endtime;		
		Self.params.columns="1,20,207";
		if(!Self.showallappointments) {
			Self.params.folder= activefolder;
		}
		storageCache.get(AjaxRoot + "/calendar",
		 Self.params ,
		 function(storage) {
		 	Self.weekAppointments = new Array()
		 	for (var t = 0; t< Self.displayedWeekLinks.length; t++)
		 		Self.displayedWeekLinks[t].style.display = "none";
		 		
		 		
		 	storageCache.current = storage;		 	
			calendarSelection.setStorage(storage);
		 	storageCache.update();
		 	Self.iterateStorage(storage);
			lastUpdateOfCalendarTimestamp = storage.timestamp;
		 },
		 Self.calendarwfields.toString(),
		 true,
		 function(x) { return x.folder + "." + x.id + "." + x.recurrence_position; } ,
		 function(x) { return { id: x[0], folder: x[1], recurrence_position : x[2] } }
		);
	},
	iterateStorage: function(storage) {		
		var Self = this;
		Self.displayedWeekLinks = [];
		this.appendetFirstChilds = [];
		if (storage) {
			weekStorage = storage;
			storage.events.register("Changed", function() {
				Self.updateView();
			});
		}
		weekStorage.newIterate(weekStorage.ids, emptyFunction, function(x,y) {
			Self.buildAppointments(x,y);
		},function(){
			Self.sortAppointments();
		});
	}, 
	buildAppointments: function(index, object) {
		this.weekAppointments[index] = object;
		object["indxxx"]  = index;
	},
	sortAppointments: function() {
		this.weekAppointments.sort(function(a,b){
			return (a[4] == b[4]) ? (a[3] < b[3]) ? -1 : 1 : (a[4] < b[4]) ? -1 : 1;
		});
		for(var i=0; i<this.weekAppointments.length;i++) {
			this.generateCalendarObjects(this.weekAppointments[i]["indxxx"],this.weekAppointments[i]);
		}
	},
	getAppointmentDiv:function (object) {
		var appointmentDate = new Date(object.start_date);
		var appointmentDateEnd = new Date(object.end_date);
		var formatForStart = (appointmentDate.getUTCMinutes()<10)? "0":"";
		var formatForEnd = (appointmentDateEnd.getUTCMinutes()<10)? "0":"";
		if(!object.title) {
			object.title="";
		}
		var textToView = appointmentDate.getUTCHours() + ":" + formatForStart + appointmentDate.getUTCMinutes() + " - ";
		textToView += appointmentDateEnd.getUTCHours() + ":" + formatForEnd + appointmentDateEnd.getUTCMinutes() + " ";
		textToView += object.title;		
		var shownDiv = getShownDiv(object.shown_as);
		
		var divIconParticipant = newnode("div", {},{ className: "showAppointmentSeqWeek"});
		if(object.participants && object.participants.length > 1) {
			var imageGroupFlag=document.createElement("img");
			imageGroupFlag.setAttribute("src",getFullImgSrc("img/calendar/group.gif"));
			divIconParticipant.appendChild(imageGroupFlag);
		}
		
		var divIconPrivate = newnode("div", {},{ className: "showAppointmentSeqWeek"});
		if(object.private_flag) {
			var imagePrivatFlag=document.createElement("img");
			imagePrivatFlag.setAttribute("src",getFullImgSrc("img/private_flag.gif"));
			divIconPrivate.appendChild(imagePrivatFlag);
		}
		
		var divIconTag = newnode("div", {}, { className: "showAppointmentSeqWeek"});
		if(object.color_label && object.color_label > 0) {
			var imageColorLabel=document.createElement("img");
			imageColorLabel.setAttribute("src",getFullImgSrc("img/menu/tag_" + object.color_label + ".gif"));
			divIconTag.appendChild(imageColorLabel);
		}		
		
		if(!object.full_time) {	
			shownDiv.appendChild(document.createTextNode(" "));
			var datDIV = newnode('div');
			datDIV.className = 'appInWeekView borderDefault background-color-content border-color-design';
			var textDiv = newnode('div');
			textDiv.className = "showAppointmentTextWeek mozSelected";
			
			textDiv.appendChild(document.createTextNode(textToView));
			datDIV.appendChild(shownDiv);	
			datDIV.appendChild(textDiv);
			
			if (divIconParticipant.firstChild) datDIV.appendChild(divIconParticipant);
			if (divIconPrivate.firstChild) datDIV.appendChild(divIconPrivate);
			if (divIconTag.firstChild) datDIV.appendChild(divIconTag);
			
			if(object.recurrence_type > 0) {
				var image=document.createElement("img");
				image.setAttribute("src",getFullImgSrc("img/calendar/calendar_series.gif"));
				var seqDiv = newnode('div', {}, { className: "showAppointmentSeqWeek"});
				seqDiv.className = "showAppointmentSeqWeek";	
				seqDiv.appendChild(image);
				datDIV.appendChild(seqDiv);	
			}
		} else {	
			shownDiv.appendChild(document.createTextNode(" "));
			var datDIV = newnode('div');
			datDIV.className = 'textFullTimeWeek wholeDayBackground border-color-design borderDefault';
			var textDiv = newnode("div", {flt:"left", width: "80%"}, null, [document.createTextNode(textToView)])
			textDiv.className="mozSelected"
			datDIV.appendChild(shownDiv);	
			datDIV.appendChild(textDiv);

            if (divIconParticipant.firstChild) datDIV.appendChild(divIconParticipant);
            if (divIconPrivate.firstChild) datDIV.appendChild(divIconPrivate);
            if (divIconTag.firstChild) datDIV.appendChild(divIconTag);

			if(object.recurrence_type > 0) {
				var image=document.createElement("img");
				image.setAttribute("src",getFullImgSrc("img/calendar/calendar_series.gif"));
				var seqDiv = newnode('div');
				seqDiv.className = "showAppointmentSeqWeek";	
				seqDiv.appendChild(image);
				datDIV.appendChild(seqDiv);	
			}
			datDIV.style.height = 1.9 + "em";
		}
		return datDIV;						
	},
	generateCalendarObjects: function(index, object) {
		this.index = index;
		this.object = object;
		var id = this.object[0];
		var folder_id = this.object[1];
		var nRecPosition = this.object[2];
		var nRecId = this.object[14];
		var created_by = this.object[15];
		this.object.index = index;
		allcalendarWeekObjects[""+folder_id+"-"+id + "-"+nRecPosition]=this.object;
		
		var selectedAppointmentWeek = { 
			id:id, folder:folder_id, recurrence_position:nRecPosition, 
			recurrence_id:nRecId, created_by:created_by };
		var divAppId = 'appInWeekView' + folder_id + "_" + id+"_"+nRecPosition;
		
		var title = this.object[3];
		var start_date = this.object[4];
		var end_date = this.object[5];
		var note = this.object[6];
		var recurrence_type = this.object[7];
		var participants = this.object[8];
		var full_time = this.object[9];
		var shown_as = this.object[10];
		var color_label = this.object[11];
		var private_flag = this.object[13];
		var appointmentDate = new Date(start_date);
		var appointmentDateEnd = new Date(end_date);
		var formatForStart = (appointmentDate.getUTCMinutes()<10)? "0":"";
		var formatForEnd = (appointmentDateEnd.getUTCMinutes()<10)? "0":"";
		var timeWeekpart1 = appointmentDate.getUTCHours() + ":" + formatForStart + appointmentDate.getUTCMinutes();
		var timeWeekpart2 = appointmentDateEnd.getUTCHours() + ":" + formatForEnd + appointmentDateEnd.getUTCMinutes();
		
		var textToView = timeWeekpart1 + " - " + timeWeekpart2 + " ";
		if(!title) title="";
		textToView += title;
		
		var divId = "weekDayContent" + appointmentDate.getUTCDay();
		
		this.aAppointmentAssoc[divAppId] = this.object;
		var divIconFlags = newnode("div", {flt:"right", marginLeft : "5px"});
       		
		var divIconParticipant = newnode("div", {},{ className: "showAppointmentSeqWeek"});
		if(participants && participants.length > 1) {
			var imageGroupFlag=document.createElement("img");
			imageGroupFlag.setAttribute("src",getFullImgSrc("img/calendar/group.gif"));
			divIconParticipant.appendChild(imageGroupFlag);
		}
		
		var divIconPrivate = newnode("div", {},{ className: "showAppointmentSeqWeek"});
		if(private_flag) {
			var imagePrivatFlag=document.createElement("img");
			imagePrivatFlag.setAttribute("src",getFullImgSrc("img/private_flag.gif"));
			divIconPrivate.appendChild(imagePrivatFlag);
		}
		
		var divIconTag = newnode("div", {}, { className: "showAppointmentSeqWeek"});
		if(color_label && color_label > 0) {
			var imageColorLabel=document.createElement("img");
			imageColorLabel.setAttribute("src",getFullImgSrc("img/menu/tag_" + color_label + ".gif"));
			divIconTag.appendChild(imageColorLabel);
		}
		
		var oneday=1000*60*60*24;
		var showappointment=true;		
		var fulltimeStartBefore = false;
		var fulltimeStartBeforeDiff = 0;
		
		// Setze Startzeit des Termins um , falls er vor der Anzeige beginnt
		if (start_date < this.starttime) {
			fulltimeStartBeforeDiff = (this.starttime - start_date)  / 1000 / 60 / 60 / 24;
			start_date=this.starttime;
			fulltimeStartBefore = true;
		}
		
		if (fulltimeStartBefore && !full_time) {
			end_date = end_date + oneday;
		}
		
		// Setze Endzeit des Termins um , falls er nach der Anzeige endet
		if (end_date > this.starttime + (7 * oneday)) {
			end_date = this.starttime + (7 * oneday)
		}
		
		/*
		 * ms / d
		 * calculating appointment duration in days
		 */
		var d_end = Math.ceil(end_date / 864e5);
        var d_start = Math.floor(start_date / 864e5);
		days = d_end-d_start;
		
		var titlesMultidays = [];
		if (days > 1) {
			textToView = titlesMultidays[0] = timeWeekpart1 + " - 24:00 " + title;
			titlesMultidays[1] = "0:00 - 24:00 " + title;
			titlesMultidays[2] = "0:00 - " + timeWeekpart2 + " " + title;
		}

		var Self = this;
		
		var shownDiv = newnode('div');
		switch (shown_as) {
			case 1:
				shownDiv.className = "appointmentRESERVED";
				break;
			case 2:
				shownDiv.className = "appointmentTEMPORARY";
				break;
			case 3:
				shownDiv.className = "appointmentABSENT";
				break;
			case 4:
				shownDiv.className = "appointmentFREE";
				break;
			default:
				shownDiv.className = "appointmentNONE";
				break;
		}
		shownDiv.className += ' showAppointmentShownWeek';
		
		var	paramObj = { id: Self.object[0], folder: Self.object[1], 
		                 folder_id: Self.object[1], recurrence_position: (Self.object[7]) ? Self.object[7] : 0
		               };

		function disabled(e) {
			var iconNode=$2("cww_node_dd");
			if (iconNode == undefined) {
				iconNode = newnode("img", 
				        { position:"absolute", left:(e.clientX + iconOffset) + "px", 
				          top:(e.clientY + iconOffset) + "px" },
			            { src: getFullImgSrc("img/dnd_disabled.gif"), alt: "" });
				iconNode.id="cww_node_dd";
				body.appendChild(iconNode);
				addTMPId(iconNode);
			}
			iconNode.style.left = (e.clientX + iconOffset) + "px";
			iconNode.style.top = (e.clientY + iconOffset)+ "px";
			stopEvent(e);
			return false;
		}
		
		function disabledremove(e,targetNode) {
			if ($2("cww_node_dd")) {
				$2("cww_node_dd").parentNode.removeChild($2("cww_node_dd"));
			}
		}
		
	    if (!full_time) {
			shownDiv.appendChild(document.createTextNode(" "));
			var datDIV = newnode('div',0,{className:"appInWeekView background-color-content border-color-design borderDefault"});
			if (selectedAppointmentWeekView == divAppId) {
				datDIV.className = removeClass(datDIV.className,"borderDefault");
				datDIV.className += ' selectedAppMonth border-color-selection-elements';
			}
			datDIV.id = divAppId;
			datDIV.oxcalobj=""+folder_id + "-" + id + "-" + nRecPosition;
			var textDiv = newnode('div');
			textDiv.className = "showAppointmentTextWeek";
			
			textDiv.appendChild(document.createTextNode(textToView));
			datDIV.appendChild(shownDiv);	
			datDIV.appendChild(textDiv);
			
			if (divIconParticipant.firstChild) {
				datDIV.appendChild(divIconParticipant);
			}
            if (divIconPrivate.firstChild) {
            	datDIV.appendChild(divIconPrivate);
            }
            if (divIconTag.firstChild) {
            	datDIV.appendChild(divIconTag);
            }
			
			if (recurrence_type > 0) {
				var image=document.createElement("img");
				image.setAttribute("src",getFullImgSrc("img/calendar/calendar_series.gif"));
				var seqDiv = newnode('div');
				seqDiv.className = "showAppointmentSeqWeek";	
				seqDiv.appendChild(image);
				datDIV.appendChild(seqDiv);	
			}			
						
			registerSource(datDIV, "calendar",
			     function () {
			     	objMoveCopy.begin("calendar",
			     	[ new CalendarWorkWeekObject(
			     	       object[0], object[1], object[2], object[14], object[15], object[3], object[4], 
			     	       object[5], null, object[7], null, object[9], object[10],
			     	       null,null,null)
			     	]);
				    return objMoveCopy;
				     
				 }, null,null, calendardefaultdisabled, defaultdisabledremove);
			
		 	var oInplEdit  = new inplaceEdit(textDiv, title, 
		 	                    function (sStr,oObj) {
		 	                    	editAppointment(paramObj,{title:sStr});
								});

			//fixed bug with auto selection													
			if (calendarSelection) {
				calendarSelection.reset();
			}
				
			addDOMEvent(datDIV, "click", function(e) {
				var SelObj = calendarSelection.getID();
				if (SelObj && SelObj.id == paramObj.id &&
							SelObj.folder == paramObj.folder_id &&
									SelObj.recurrence_position == paramObj.recurrence_position) {
					if (window.event) {
						e = window.event;
					}
					oInplEdit.on();
					stopEvent(e);		
				} else {					
						setSelectionWeekView(selectedAppointmentWeek);
						selectAppointmentWeekView(divAppId,1);
				}
	
			});	
			registerContext(datDIV,"calendar");										

			addDOMEvent(datDIV, "mousedown", function(e) {
														if (e.button != undefined && e.button != RightButton) return;						
														setSelectionWeekView(selectedAppointmentWeek);
														selectAppointmentWeekView(divAppId,1);
													});									
			addDOMEvent(datDIV, "dblclick", function(e) {
														setActivatedWeekView(selectedAppointmentWeek, e);
														selectAppointmentWeekView(divAppId,1);
														});
			/*
			 * draw the first appointment
			 */																		
			if (!fulltimeStartBefore) {
				$(divId).appendChild(datDIV);
				addTMPId(datDIV);
			}
			
			/*
			 * if appointment lasts longer then 1 day draw the rest
			 */
			for (i=1;i<days;i++) {
				var ccweek_template_app_time = datDIV.cloneNode(true);
				if (i+1 == days) {
					ccweek_template_app_time.childNodes[1].firstChild.nodeValue = titlesMultidays[2];
				} else {
					ccweek_template_app_time.childNodes[1].firstChild.nodeValue = titlesMultidays[1];
				}

				var	paramObj = {id:Self.object[0],folder:Self.object[1], folder_id:Self.object[1],
												recurrence_position:(Self.object[7])?Self.object[7]:0};
				if(!fulltimeStartBefore) {
					start_date += oneday;
				}
				var newId = new Date(start_date).getUTCDay();
				divId = "weekDayContent" + newId;
				ccweek_template_app_time.id = datDIV.id + "-"+i;
				ccweek_template_app_time.oxcalobj=""+folder_id + "-" + id + "-" + nRecPosition;
				
				addDOMEvent(ccweek_template_app_time, "click", function(e) {
					var SelObj = calendarSelection.getID();
					if (SelObj && SelObj.id == paramObj.id &&
					    SelObj.folder == paramObj.folder_id &&
						SelObj.recurrence_position == paramObj.recurrence_position) {
						if(window.event) {
							e = window.event;
						}
						oInplEdit.on();
						stopEvent(e);		
					} else {
						setSelectionWeekView(selectedAppointmentWeek);
						selectAppointmentWeekView(divAppId,1);
					}
		
				});	
				registerContext(ccweek_template_app_time,"calendar");	

				addDOMEvent(ccweek_template_app_time, "mousedown", function(e) {
													if (e.button != undefined && e.button != RightButton) return;						
													setSelectionWeekView(selectedAppointmentWeek);
													selectAppointmentWeekView(divAppId,1);
											});
				addDOMEvent(ccweek_template_app_time, "dblclick", function(e) {
															setActivatedWeekView(selectedAppointmentWeek);
															selectAppointmentWeekView(divAppId,1);
															});

				$(divId).appendChild(ccweek_template_app_time);	
				addTMPId(ccweek_template_app_time);
				if(fulltimeStartBefore) {
					start_date += oneday;
				}
			}
			
		} else {
			var ftDiv = newnode('div',0,{className:"textFullTimeWeek wholeDayBackground border-color-design borderDefault"});
			ftDiv.className = removeClass(ftDiv.className,"border-color-selection-elements");
			
			if(selectedAppointmentWeekView == divAppId) {
				ftDiv.className = removeClass(ftDiv.className,"borderDefault");
				ftDiv.className +=  ' selectedAppMonth border-color-selection-elements';
			}
			ftDiv.id = divAppId;
			ftDiv.oxcalobj=""+folder_id + "-" + id + "-" + nRecPosition;
			ftDiv.appendChild(shownDiv);
			addTMPId(ftDiv);
			if(!title) { title=""; }
			var fullTextDiv = newnode("div", {flt:"left", width: "80%"}, null, [document.createTextNode(title)])
			ftDiv.appendChild(fullTextDiv);

            if (divIconParticipant.firstChild) ftDiv.appendChild(divIconParticipant);
            if (divIconPrivate.firstChild) ftDiv.appendChild(divIconPrivate);
            if (divIconTag.firstChild) ftDiv.appendChild(divIconTag);
			
			if(recurrence_type > 0) {
				var image=document.createElement("img");
				image.setAttribute("src",getFullImgSrc("img/calendar/calendar_series.gif"));
				var seqDiv = newnode('div');
				seqDiv.className = "showAppointmentSeqWeek";	
				seqDiv.appendChild(image);
				ftDiv.appendChild(seqDiv);
			}
			
			registerContext(ftDiv, "calendar");		

			addDOMEvent(ftDiv, "mousedown", function(e) {
														if (e.button != undefined && e.button != RightButton) return;						
														setSelectionWeekView(selectedAppointmentWeek);
														selectAppointmentWeekView(divAppId,2);
													});
			addDOMEvent(ftDiv, "dblclick", function(e) {
														setActivatedWeekView(selectedAppointmentWeek);
														selectAppointmentWeekView(divAppId,2);
														});
			
		
			
			for(i=0;i<days;i++) {
					var ccweek_template_full_time =ftDiv.cloneNode(true);

					var newId = new Date(start_date).getUTCDay();
					divId = "weekDayContent" + newId;
					
					ccweek_template_full_time.id = ftDiv.id + "-"+i;
					ccweek_template_full_time.oxcalobj=""+folder_id + "-" + id + "-" + nRecPosition;
					
					/////////////////// 					
			
			var divs = ccweek_template_full_time.getElementsByTagName("div");
			var oInplEdit  = new inplaceEdit(divs[1], title, function (sStr,oObj){
														editAppointment(paramObj,{title:sStr});
													});
			addDOMEvent(ccweek_template_full_time, "click", function(e) {
				var SelObj = calendarSelection.getID();
				if(SelObj && SelObj.id == paramObj.id &&
							SelObj.folder == paramObj.folder &&
									SelObj.recurrence_position == paramObj.recurrence_position)
				{
					if(window.event)
					{
						e = window.event;
					}
					oInplEdit.on();
					stopEvent(e);		
				}
				else
				{
						setSelectionWeekView(selectedAppointmentWeek);
						selectAppointmentWeekView(divAppId,2);
				}
	
			});	
			///////////////////
		
		registerSource(ccweek_template_full_time,"calendar",function () {
		 							objMoveCopy.begin("calendar",[new CalendarWorkWeekObject(object[0],object[1],
								object[2],object[14],object[15],object[3],
								object[4],object[5],null,object[7],null,object[9],object[10],null,null,null)]);
									return objMoveCopy; },
															 null,null,calendardefaultdisabled,defaultdisabledremove);
		
					registerContext(ccweek_template_full_time,"calendar");	
					addDOMEvent(ccweek_template_full_time, "mousedown", function(e) {
														if (e.button != undefined && e.button != RightButton) return;						
														setSelectionWeekView(selectedAppointmentWeek);
														selectAppointmentWeekView(divAppId,2);
													});
					addDOMEvent(ccweek_template_full_time, "dblclick", function(e) {
																setActivatedWeekView(selectedAppointmentWeek, e);
																selectAppointmentWeekView(divAppId,2);
																});		
					
					var idSuffix = divId.substr(divId.length - 1,1);
					if(idSuffix == 0) idSuffix = 7;
					
					var appendet = false;
					
					for (var v = 0; v< Self.appendetFirstChilds.length; v++) {
						if(divId == Self.appendetFirstChilds[v])
							appendet = true;
					}
					
					if(appendet) {
						$("imageList" + idSuffix).style.display = "inline";
						this.displayedWeekLinks.push($("imageList" + idSuffix));
					} else {
						this.appendetFirstChilds.push(divId);
						$(divId).firstChild.appendChild(ccweek_template_full_time);
						addTMPId(ccweek_template_full_time);	
					}

					start_date += oneday;
				}

		}
	}
}

function setSelectionWeekView(selectedAppointmentWeek) {
	selectedAppointment = selectedAppointmentWeek;
	var arrId = new Array();
	arrId.push(selectedAppointment);
	var arrayIndex = selectedAppointmentWeek.folder+"-"+selectedAppointmentWeek.id+"-"+selectedAppointmentWeek.recurrence_position;
	calendarSelection.click(allcalendarWeekObjects[arrayIndex].index);
	triggerEvent("Selected", arrId);
}

function setActivatedWeekView(selectedAppointmentWeek, evt) {
	selectedAppointment = selectedAppointmentWeek;
	openAppointmentPopup(evt);
}
var selectedAppointmentWeekView = '';
var selectedAppointmentWeekViewModus = 0;
function selectAppointmentWeekView(divAppId, app) {
	if($2(divAppId)) {
		$2(divAppId).className = removeClass($2(divAppId).className,"border-color-selection-elements");
		$2(divAppId).className = removeClass($2(divAppId).className,"borderDefault");
		$2(divAppId).className += ' selectedAppMonth border-color-selection-elements';
	}
	
	for(var i = 0; i<=7;i++) {
		if($2(divAppId + "-" + i)) {
			$2(divAppId + "-" + i).className = removeClass($2(divAppId + "-" + i).className,"border-color-selection-elements");
			$2(divAppId + "-" + i).className = removeClass($2(divAppId + "-" + i).className,"borderDefault");			
			$2(divAppId + "-" + i).className += ' selectedAppMonth border-color-selection-elements';
		}
	}
	
				
	if(selectedAppointmentWeekView != '' && $2(selectedAppointmentWeekView) && selectedAppointmentWeekView != divAppId) {
		$2(selectedAppointmentWeekView).className = (selectedAppointmentWeekViewModus == 1) ? 'appInWeekView background-color-content border-color-design borderDefault' : 'textFullTimeWeek wholeDayBackground border-color-design borderDefault';
	}
	if(selectedAppointmentWeekView != '' && selectedAppointmentWeekView != divAppId) {
		for(var i = 0; i<=7;i++) {
			if($2(selectedAppointmentWeekView + "-" + i)) {
				$2(selectedAppointmentWeekView + "-" + i).className = (selectedAppointmentWeekViewModus == 1) ? 'appInWeekView background-color-content border-color-design borderDefault' : 'textFullTimeWeek wholeDayBackground border-color-design borderDefault';
			}
		}
	}
					
	selectedAppointmentWeekView = divAppId;
	selectedAppointmentWeekViewModus = app;
	
}

var objWeekCalendarTool = new WeekCalendarTool();
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * @author Markus Wagner <markus.wagner@open-xchange.com>
 * 
 */

var completedetailappointment;
var aDetailFieldsToClear = {};
var idsAppParticipantForSelected = new Array();
var a_d_timestamp = 0;
var a_d_participantGrid = null;	
var objAppDetailParticipants = null;
var refAppDetailParticipantTab = null;
var gridatt = null;
var myAppointmentLinkingObject;
var currentAppointmentDetailTab = 'appointment';
var aPrintDetailApp = new Array();
function caldetail_change_Confirm() {
	var calconfirm=new AcceptDeny(true);
	calconfirm.showConfirmation(new AcceptDenyObject("calendar",completedetailappointment));
}
/********************************** Tab Appointment *****************************************************************/
register("OX_Calendar_Switch_Detail",function(param) { menuswitchCalendarDetail(param) });
function detailAppointmentOnload(callback)
{
	/********************************** Tabs *****************************************************************/

	/**
	 * global vars for detail appointment view
	 */
	a_d_tabsList = new Array('tabAppointmentDetail1','tabAppointmentDetail2', 'tabAppointmentDetail3', 'tabAppointmentDetail4');
	a_d_panelsList = new Array('panelAppointmentDetail1','panelAppointmentDetail2', 'panelAppointmentDetail3', 'panelAppointmentDetail4');
	a_d_eventList =
			new Array(	['OX_Calendar_Switch_Detail','overview'],
						['OX_Calendar_Switch_Detail','participant'],
						['OX_Calendar_Switch_Detail','attachment'],
						['OX_Calendar_Switch_Detail','links']);
	
	//register tabs
	setTabLists(a_d_tabsList, a_d_panelsList, a_d_eventList);
	//var eventList =	null;
	//changeTab('tabAppointmentDetail1', 'panelAppointmentDetail1');
	

//	/* Grid for Attachments */
//	gridatt = makeDetailAppointmentAttachmentGrid();

	var json = new JSON();
	var recurrencePosition = (selectedAppointment.recurrence_position) ? selectedAppointment.recurrence_position : 0;
	
	json.get(AjaxRoot + "/calendar?action=get&session=" + session 
									+"&id="+selectedAppointment.id
									+"&folder="+selectedAppointment.folder
									+"&recurrence_position="+recurrencePosition+"&"
		,
		null,
		function(fieldsToGet) {
			if (fieldsToGet) {				
				objAppDetailParticipants = new AppDetailParticipants();
				if(!refAppDetailParticipantTab) {
					refAppDetailParticipantTab = new ObjAppDetailParticipantTab();
					refAppDetailParticipantTab.makeGrid();
				}
				if(storageCache && storageCache.current)
					storageCache.current.timestamp = fieldsToGet.timestamp;
				completedetailappointment=fieldsToGet.data;
				triggerEvent("Confirmation_Changed",0);
				for(var i=0;i<completedetailappointment.users.length;i++) {
					if(completedetailappointment.users[i].id==configGetKey("identifier")) {
						triggerEvent("Confirmation_Changed",1);
					}
				}
				//clear all fields
				var tmpDivToClear = null;
				for (idDetailFieldsToClear in aDetailFieldsToClear) 
				{
					if(aDetailFieldsToClear[idDetailFieldsToClear] == "set" && $(idDetailFieldsToClear).firstChild)
						$(idDetailFieldsToClear).firstChild.data = " "; 
					else if(aDetailFieldsToClear[idDetailFieldsToClear] == "setInput")	
						$(idDetailFieldsToClear).value = " "; 	
				}
				removeChildNodes($("a_d_note")); // clean-up notes
				
				var participantTabDiv = $("a_d_count_participants");
				
				if(!fieldsToGet.data['participants']) {
					participantTabDiv.firstChild.data = "0";
				}
				
				//hide next button for participants
				$("a_d_participants_more").style.display = 'none';
				
				//reset fields
				aDetailFieldsToClear = {};
		
				a_d_timestamp = fieldsToGet.timestamp;
				lastUpdateOfCalendarTimestamp = fieldsToGet.timestamp;
				aPrintDetailApp = [];
				if (fieldsToGet.data.number_of_attachments)
				{
					$('a_d_count_attachment').firstChild.nodeValue = fieldsToGet.data.number_of_attachments;
				} else {
					$('a_d_count_attachment').firstChild.nodeValue = "0";
				}
				
				if (fieldsToGet.data.color_label) {
					$("tagImgAppointmentDetail").src = getFullImgSrc("img/menu/tag_"+fieldsToGet.data.color_label+".gif");
				} else {
					$("tagImgAppointmentDetail").src = getFullImgSrc("img/menu/tag_0.gif");
				}
				if (fieldsToGet.data.private_flag) {
					$("privateflagImgAppointmentDetail").src = getFullImgSrc("img/private_flag.gif");
				} else {
					$("privateflagImgAppointmentDetail").src = getFullImgSrc("img/dummy.gif");
				}
				var myseries=new SeriesObject(fieldsToGet.data,true);
				$("a_d_series").firstChild.data = myseries.getSeriesString();
				if (fieldsToGet.data.recurrence_type > 0) {
					$("seriesflagImgAppointmentDetail").src = getFullImgSrc("img/calendar/calendar_series.gif");		
				} else {
					$("seriesflagImgAppointmentDetail").src = getFullImgSrc("img/dummy.gif");
				}
				
				var sText = "";
				var nText = "";
				for(a_d_data in fieldsToGet.data){
					switch (a_d_data) {
						case 'title':
							$("a_d_title").firstChild.data = fieldsToGet.data[a_d_data];	
							aDetailFieldsToClear["a_d_title"] = "set"; //for deleting the next time, when show detail								
							aPrintDetailApp[0] = Print.createTitle(fieldsToGet.data[a_d_data]);
							aPrintDetailApp[1] = Print.createLine("5px");
							aPrintDetailApp[2] = Print.createEmpty();
							break;
						case 'location':
							$("a_d_location").firstChild.data = fieldsToGet.data[a_d_data];
							aDetailFieldsToClear["a_d_location"] = "set";						
							aPrintDetailApp[3] = Print.createContent(_("Location:"),fieldsToGet.data[a_d_data]);
							break;
						case 'note':
						    removeChildNodes($("a_d_note"));
                            var nText = fieldsToGet.data[a_d_data] ? fieldsToGet.data[a_d_data].split("\n") : "";
			                for (var i in nText) {
			                    $("a_d_note").appendChild(document.createTextNode(nText[i]));
			                    $("a_d_note").appendChild(newnode("br"));
			                }
			                nText = null;
							aDetailFieldsToClear["a_d_note"] = "set";	
							aPrintDetailApp[6] = Print.createContent(_("Description:"),fieldsToGet.data[a_d_data]);
							break;
						case 'start_date':	
							var startDate = new Date(fieldsToGet.data[a_d_data]);
							this.start = startDate.getUTCHours() + "." + (parseInt((startDate.getUTCMinutes()/15), 10)*25);	// startdate for calculating
							
							if (fieldsToGet.data['full_time']) {
								this.starthuman = formatDate(startDate, "date");
							} else {
								this.starthuman = formatDate(startDate, "datetime");//startDate.getUTCHours() + ":" + parseInt(startDate.getUTCMinutes()/15, 10)*15;	// human readable start time
								if((this.starthuman.length - (this.starthuman.lastIndexOf(":"))) < 3)
									this.starthuman += "0";
							}
							
							sText = this.starthuman;
							$("a_d_begins").firstChild.data = sText;
							aPrintDetailApp[4] = Print.createContent(_("Start date:"),sText);
							var sStartText = (fieldsToGet.data["title"] ? fieldsToGet.data["title"] : "") + " - " + this.starthuman;
							aDetailFieldsToClear["a_d_begins"] = "set";
							
							activeYear = startDate.getUTCFullYear();
							activeMonth = startDate.getUTCMonth();
							activeDay = startDate.getUTCDate();
							if (oMiniCalendar) oMiniCalendar.setSelectedByDate(activeYear, activeMonth, activeDay);

							break;
						case 'end_date':
							var endDate = new Date(fieldsToGet.data[a_d_data]);
							
							if(fieldsToGet.data['full_time']) {
								var endDateNew = endDate - 86400000;
								this.endhuman = formatDate(endDateNew, "date");
							} else {
								this.endhuman = formatDate(endDate, "datetime");//endDate.getUTCHours() + ":" + parseInt(endDate.getUTCMinutes()/15)*15;	// human readable end time
							}
							var sText = this.endhuman;
							$("a_d_ends").firstChild.data = sText;	
							aPrintDetailApp[5] = Print.createContent(_("End:"),this.endhuman);
							
							var sEndText = " "  + _("to") + " " + this.endhuman;
							
							aDetailFieldsToClear["a_d_ends"] = "set";	
							aDetailFieldsToClear["a_d_headline"] = "set";	
							break;
							
						case 'participants':
							(callback) ? objAppDetailParticipants.callback = callback : objAppDetailParticipants.callback = null;
							objAppDetailParticipants.oParticipantResources = fieldsToGet.data[a_d_data];	
							objAppDetailParticipants.writeCountParticipants();
							objAppDetailParticipants.pushArray();
							var ids=clone(objAppDetailParticipants.idUserArr);
							internalCache.getUsers(ids,transit_a_d_fnSetUserColumn);															
							break;
							
						case 'folder_id':
						
							function cb_fdrpath(sText)
							{
								$("a_d_folder").firstChild.data = sText;
							}
							oMainFolderTree.get_folder_path(fieldsToGet.data[a_d_data],cb_fdrpath);
							break;
							
						case 'shown_as':
							var newClassName = "";
							var sShownAs = "";
							switch (fieldsToGet.data[a_d_data]) {
								case 1	:	newClassName = "appointmentRESERVED";
											sShownAs = _("reserved");
											aPrintDetailApp[7] = Print.createContent(_("Display as:"),_("reserved"));
											break;
											
								case 2	:	newClassName = "appointmentTEMPORARY";
											sShownAs = _("temporary");
											aPrintDetailApp[7] = Print.createContent(_("Display as:"),_("temporary"));
											break;
											
								case 3	:	newClassName = "appointmentABSENT";
											sShownAs = _("absent on business");
											aPrintDetailApp[7] = Print.createContent(_("Display as:"),_("absent on business"));
											break;
											
								case 4	:	newClassName = "appointmentFREE";
											sShownAs = _("free");
											aPrintDetailApp[7] = Print.createContent(_("Display as:"),_("free"));
											break;			
									
								default	:	newClassName = "appointmentNONE";
											break;		
											
							}
							
							$("a_d_show_as_color").className = newClassName;
							$("a_d_show_as").firstChild.data = sShownAs;	
							aDetailFieldsToClear["a_d_show_as"] = "set";	
							break;
							
						case 'alarm':
							if(fieldsToGet.data[a_d_data] >= 0) {									
								var sConvertedTime = getInterval(fieldsToGet.data[a_d_data] * 60 * 1000);
								$("a_d_alarm").firstChild.data = sConvertedTime;		
								aDetailFieldsToClear["a_d_alarm"] = "set";
							}
							break;
							
						case 'categories':
							$("a_d_categories").firstChild.data = fieldsToGet.data[a_d_data];
							aPrintDetailApp[8] = Print.createContent(_("Tags:"),fieldsToGet.data[a_d_data]);	
							aDetailFieldsToClear["a_d_categories"] = "set";
							break;
							
						case 'users':
							objAppDetailParticipants.usersD = fieldsToGet.data[a_d_data];
							break;
						case 'created_by':
							internalCache.getUsers([fieldsToGet.data[a_d_data]],	function (arg)
							{
								if(fieldsToGet.data[a_d_data] && arg[fieldsToGet.data[a_d_data]]) {
									$("a_d_created_by").firstChild.data = arg[fieldsToGet.data[a_d_data]].display_name;	
									aDetailFieldsToClear["a_d_created_by"] = "set";
								} else if(arg) {
									for(i in arg) {
										$("a_d_created_by").firstChild.data = arg[i].display_name;	
										aDetailFieldsToClear["a_d_created_by"] = "set";
									}
								}
							});
							break;
							
						default:
							break;
					}
				}

				writeBottomString(fieldsToGet.data,"app_detail_bot");
				$("a_d_headline").firstChild.data = sStartText + sEndText;
			}
			
		}
	); 
}

/* Participant object */
function AppDetailParticipants() {
	this.oParticipantResources = null;
	this.idUserArr = new Array();
	this.idGroupArr = new Array();
	this.idResourceArr = new Array();
	this.sText = "";
	this.nText = null;
	this.nPart = 0;
	this.gridData = new Array();
	this.gridIndex = 0;
	this.idForExternal = 1;
	this.usersD = null;
	this.callback = null;
}

AppDetailParticipants.prototype = {
	writeCountParticipants : function () {
		this.sText = this.oParticipantResources.length;
		$("a_d_count_participants").firstChild.data = this.sText;
	},
	pushArray : function () {
		for(i=0; i < this.oParticipantResources.length; i++)
		{
				/*
				 * type 1 user
				 * type 2 user group
				 * type > 2 resource
				 * */
			switch (this.oParticipantResources[i].type) {
				case 1:		this.idUserArr.push(this.oParticipantResources[i].id);
							break;
							
				case 2: 	this.idGroupArr.push(this.oParticipantResources[i].id);
							break;
							
				case 3: 	this.idResourceArr.push(this.oParticipantResources[i].id);
							break;
							
				case 5: 	this.idUserArr.push(this.oParticipantResources[i]);
							break;
			}						
		}
	},
	writeMoreButton : function() {
		$("a_d_participants_more").style.display = 'inline';
		$("a_d_participants_more").style.display = 'block';
	},
	writeMoreButtonResource : function() {
		$("a_d_participants_more_resources").style.display = 'inline';
		$("a_d_participants_more_resources").style.display = 'block';
	},
	a_d_fnSetUserColumn : function (arg) {
		
		for(var i=0; i < this.idUserArr.length; i++) {
			if(this.nPart < 6 ) {	
				if(arg[this.idUserArr[i]]) {
					this.sText = arg[this.idUserArr[i]].display_name;										
					$("a_d_participants_" + (this.nPart+1)).firstChild.data = this.sText										
					aDetailFieldsToClear["a_d_participants_" + (this.nPart+1)] = "set";						
					this.nPart++;				
				} else if(typeof this.idUserArr[i] == "object") {	
					this.sText = this.idUserArr[i].display_name || this.idUserArr[i].mail || _("unkown");										
					$("a_d_participants_" + (this.nPart+1)).firstChild.data = this.sText										
					aDetailFieldsToClear["a_d_participants_" + (this.nPart+1)] = "set";	
					this.nPart++;
				}					
			} else {
				this.writeMoreButton();
			}
			
			if(typeof this.idUserArr[i] == "number") {
				this.gridData[this.gridIndex] = new Array();
				this.gridData[this.gridIndex].push(arg[this.idUserArr[i]].id);
				this.gridData[this.gridIndex].push("user");
				this.gridData[this.gridIndex].push(arg[this.idUserArr[i]].display_name);		
				this.gridIndex++;
				aPrintDetailApp.push(Print.createContent(_("Participant:"),arg[this.idUserArr[i]].display_name || arg[this.idUserArr[i]].mail));	
			} else {
				this.gridData[this.gridIndex] = new Array();
				this.gridData[this.gridIndex].push(this.idForExternal + "ext");
				this.gridData[this.gridIndex].push("user_extern");
				this.gridData[this.gridIndex].push(this.idUserArr[i].display_name || this.idUserArr[i].mail);		
				this.gridIndex++;
				this.idForExternal ++;
				aPrintDetailApp.push(Print.createContent(_("Participant:"),this.idUserArr[i].display_name || this.idUserArr[i].mail));
			}			
		}

		this.gridData.sort(function(a,b){
			if (a[2] && b[2]) {
				return a[2].toLowerCase() < b[2].toLowerCase() ? -1 : 1;
			} else {
				return -1;
			}
		});
		
		var Self = this;
		
		setTimeout(
			function() {
				if(Self.usersD)
				refAppDetailParticipantTab.users= Self.usersD;
				//refAppDetailParticipantTab.appendToStorage(); Moved to enableGrid
			},20
		);
		setTimeout(
			function(){
				internalCache.getGroups(objAppDetailParticipants.idGroupArr,transit_a_d_fnSetGroupColumn)
			}, 0
		);
	},
	a_d_fnSetGroupColumn : function (arg)
	{
		var tmp_grouplength = new Array();
		var tmp_userToGet = new Array();
		for(var i=0; i < this.idGroupArr.length; i++)
		{
			if(this.nPart < 6 ) 
			{										
				this.sText = arg[this.idGroupArr[i]].display_name;								
				$("a_d_participants_" + (this.nPart+1)).firstChild.data = this.sText										
				aDetailFieldsToClear["a_d_participants_" + (this.nPart+1)] = "set";		
				this.nPart++;									
			}
			else
			{
				this.writeMoreButton();
			}
			this.gridData[this.gridIndex] = new Array();
			this.gridData[this.gridIndex].push(arg[this.idGroupArr[i]].id);
			this.gridData[this.gridIndex].push("group");
			this.gridData[this.gridIndex].push(arg[this.idGroupArr[i]].display_name);	
			this.gridData[this.gridIndex].push("group");
			this.gridData[this.gridIndex].push("");
			tmp_grouplength[this.idGroupArr[i]] = this.gridIndex + 1;
			this.gridIndex += (arg[this.idGroupArr[i]].members.length + 1);
			for(tz in arg[this.idGroupArr[i]].members)
				tmp_userToGet.push({id : arg[this.idGroupArr[i]].members[tz], type : 1});
		}
		var Self = this;
		internalCache.getObjects(tmp_userToGet, function(cb){
			for(gr in tmp_grouplength){
				var tmp_members = new Array();
				var start = tmp_grouplength[gr];
				for(me in arg[gr].members){
					tmp_members[tmp_grouplength[gr]] = new Array();
					tmp_members[tmp_grouplength[gr]].push(arg[gr].members[me] + "gm" + arg[gr].id);
					tmp_members[tmp_grouplength[gr]].push("groupMember");
					tmp_members[tmp_grouplength[gr]].push(cb[arg[gr].members[me]].display_name);
					tmp_grouplength[gr]++;
				}
				tmp_members.sort(function(a,b){
					if (a[2] && b[2]) {
						return a[2].toLowerCase() < b[2].toLowerCase() ? -1 : 1;
					} else {
						return -1;
					}
				});
				for(var z=0; z<tmp_members.length;z++){
					if(tmp_members[z]) {
						Self.gridData[start] = tmp_members[z];
						start++;
					}
				}
			}
		});
		setTimeout(
			function(){
				if(objAppDetailParticipants && objAppDetailParticipants.idResourceArr) {
					internalCache.getRessources(objAppDetailParticipants.idResourceArr,transit_a_d_fnSetResourceColumn)
				}
			}, 0
		);
	},
	a_d_fnSetResourceColumn : function (arg)
	{
		for(var i=0; i < this.idResourceArr.length; i++)
		{
			if(i < 2 ) 
			{										
				this.sText = arg[this.idResourceArr[i]].display_name;									
				$("a_d_resources_" + (i+1)).firstChild.data = this.sText										
				aDetailFieldsToClear["a_d_resources_" + (i+1)] = "set";		
			}
			else
			{
				this.writeMoreButtonResource();
			}
		this.gridData[this.gridIndex] = new Array();
		this.gridData[this.gridIndex].push(arg[this.idResourceArr[i]].id);
		this.gridData[this.gridIndex].push("ressourcen");	
		this.gridData[this.gridIndex].push(arg[this.idResourceArr[i]].display_name);	
		this.gridData[this.gridIndex].push("ressourcen");	
		this.gridData[this.gridIndex].push("");
		this.gridIndex++;
		}
		var Self = this;
		if(Self.callback) {
			setTimeout(
				function() {
					Self.gridIndex = 0;
					Self.callback();
				},50
			);
		}
	}
}

function transit_a_d_fnSetUserColumn(arg) {
	objAppDetailParticipants.a_d_fnSetUserColumn(arg);
}
function transit_a_d_fnSetGroupColumn(arg) {
	objAppDetailParticipants.a_d_fnSetGroupColumn(arg);
}
function transit_a_d_fnSetResourceColumn(arg) {
	objAppDetailParticipants.a_d_fnSetResourceColumn(arg);
}

/********************************** Tab Participants *****************************************************************/

function ObjAppDetailParticipantTab() {
	this.users = null;
	this.list = $("a_d_listParticipants");
	this.listHeader = $("a_d_listParticipantsHeader");
	this.myAppPStorage = null;
	this.myAppPStorage = new Storage(0, []);
}

ObjAppDetailParticipantTab.prototype = {
	
	makeGrid : function () {		
	
		if (a_d_participantGrid) {
			removeChildNodes(this.list);
			a_d_participantGrid = null;
		}
		
		a_d_participantGrid = new LiveGrid([
					{	
						text: "&#160;",
						sortable: false,
						width: "16px",
						style: {padding: 0},
						set: function(div,text) 
							{
								if (div) {
									removeChildNodes(div);
									if(text != "groupMember") {
										div.appendChild(newnode("img", 0, {src : getFullImgSrc("img/calendar/" + text + ".gif"), alt : "participant"}));
									}
									else
										div.appendChild(newnode("img", 0, {src : getFullImgSrc("img/dummy.gif"), alt : "participants", width: "16", height: "16"}));
								}
							},
						clear: LiveGrid.makeClear("..."),
						index:1
					},{	
						text: _("Participants"),
						sortable: false,
						width: "30%",
						set: function(div, text){
							if(div){
								if(text[1] == "groupMember"){
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/user.gif"), alt: "Group Member"}));
									div.appendChild(document.createTextNode("\u00a0" + text[2]));
								} else {
									removeChildNodes(div);
									div.appendChild(document.createTextNode(text[2]));
								}
							}
						},
						clear: LiveGrid.makeClear("...")
					}, {
						text: _("Status"),
						sortable: false,
						width: "10%",
						set: function(div,text) {
							if (div) {
								removeChildNodes(div);
								switch(text) {
									case 0	:	div.appendChild(document.createTextNode(_("waiting")));
													break;
													
									case 1	:	div.appendChild(newnode("span", 0, {className : "appointmentACCEPTED"}, [document.createTextNode(_("accepted"))]));
													break;
													
									case 2	:	div.appendChild(newnode("span", 0, {className : "appointmentDECLINED"}, [document.createTextNode(_("declined"))])); 
													break;
													
									case 3	:	div.appendChild(newnode("span", 0, {className : "appointmentTENTATIVE"}, [document.createTextNode(_("tentative"))]));
													break;
													
									default	:	div.appendChild(document.createTextNode("\u00a0"));
													break;
								}
							}
						},
						clear: LiveGrid.makeClear("..."),
						index: 3
					}, {
						text: _("Comment"),
						sortable: false,
						set: LiveGrid.defaultSet,
						clear: LiveGrid.makeClear("..."),
						index: 4
					}
		], new Selection());

		this.listHeader.appendChild(a_d_participantGrid.getHeader());
		a_d_participantGrid.getTable(this.list);
	},
	
	appendToStorage : function() {	
		for(var i = 0; i < objAppDetailParticipants.gridData.length; i++) {
			for (var t = 0; t < this.users.length; t++) {
				
				if(objAppDetailParticipants.gridData[i][0].toString().indexOf("gm") < 0){
					if(this.users[t].id == objAppDetailParticipants.gridData[i][0]) {
						objAppDetailParticipants.gridData[i].push(this.users[t].confirmation);
						objAppDetailParticipants.gridData[i].push(this.users[t].confirmmessage || "");	
					}
				} else {
					if(this.users[t].id == objAppDetailParticipants.gridData[i][0].split("gm")[0]) {
						objAppDetailParticipants.gridData[i].push(this.users[t].confirmation);
						objAppDetailParticipants.gridData[i].push(this.users[t].confirmmessage || "");	
					}
				}
			}			
		}
	},
	
	enableGrid : function () {
		this.appendToStorage();
		// copy to an array, because the gridData is a hashmap!!!
		var tmp_participants = new Array();
		for(var i=0; i<objAppDetailParticipants.gridData.length;i++) {			
			tmp_participants[i] = objAppDetailParticipants.gridData[i];
		}
		this.myAppPStorage.append(tmp_participants);
		//enable the grid
		a_d_participantGrid.enable(this.myAppPStorage); 
	},
	
	disableGrid	: function() {
		this.myAppPStorage.remove(0,objAppDetailParticipants.gridData.length);
		a_d_participantGrid.disable(); 
	}
}

var gridAttachmentAppDetail = null;
function makeDetailAppointmentAttachmentGrid() {
		var nId = selectedAppointment.id;
		var nFolder = selectedAppointment.folder;
		gridatt = new attachmentGrid("a_d_Attachments",nId,nFolder,1);	
}

/*
 * Print Detail Appointment
 * 
 * */
function calendar_printDetail(){
	var title = aPrintDetailApp[0] && aPrintDetailApp[0].title ? aPrintDetailApp[0].title : "";
	var detailCalendarPrint = new Print(title);
	detailCalendarPrint.printDetail(aPrintDetailApp);
}

fileloaded();
